package roboforge;

import roboforge.animation.alpha.*;

import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import javax.swing.tree.*;

import java.awt.Color;

import roboforge.advertising.*;



public class BArenaOrnament extends BComponent implements BArenaObject
{

  static final long serialVersionUID = -1L;

   BArenaObjectPosition position;
   transient TransformGroup  displacementGroup,  arenaRotateGroup;
   private Vector channels;  // A clone of the channels that where passed in the last move request
   private boolean lightingOff = false;

   private String advertID;
   private BAdvert advert;

  public BArenaOrnament(String newName, String filename)
  {
    super(newName, filename);
    position = new BArenaObjectPosition();
  }

  protected void displayColor(Color theColor,  float shine)
  {
  //  super.displayColor( Color.white,  shine);
  }

  // Implementing the BArenaObject

  public void initArenaDetails(BArena arena)
  {
    //channels = new Vector();
  }

  public void init()
  {
    super.init(false);
    setEnableLighting(!lightingOff);
  }

  // set the arena object advert ID
  public void setAdvertID(String advertID)
  {  this.advertID = advertID;  }

  // get the arena object advert ID
  public String getAdvertID()
  {  return advertID;  }

  // set the arena object advert
  public void setAdvert(BAdvert advert)
  {
    this.advert = advert;
    setTexture("advert", false);
  }

  protected void setAppearance()
  {

    /*
    cAtrib =new ColoringAttributes();
    cAtrib.setCapability(ColoringAttributes.ALLOW_SHADE_MODEL_WRITE);
    cAtrib.setCapability(ColoringAttributes.ALLOW_COLOR_WRITE);

    componentMaterial = new Material();
    componentMaterial.setCapability(Material.ALLOW_COMPONENT_WRITE);
    TextureAttributes newTexA = new TextureAttributes();
    newTexA.setTextureMode(TextureAttributes.REPLACE);

    normalAppearance = new Appearance();
    normalAppearance.setMaterial(componentMaterial);
    normalAppearance.setTextureAttributes(newTexA);
    //normalAppearance.setLineAttributes(componentLine);

    normalAppearance.setCapability(Appearance.ALLOW_MATERIAL_WRITE);
    normalAppearance.setCapability(Appearance.ALLOW_COLORING_ATTRIBUTES_READ);
    normalAppearance.setCapability(Appearance.ALLOW_MATERIAL_READ);
    normalAppearance.setCapability(Appearance.ALLOW_LINE_ATTRIBUTES_READ);
    normalAppearance.setCapability(Appearance.ALLOW_POINT_ATTRIBUTES_READ);
    normalAppearance.setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_READ);
    normalAppearance.setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_WRITE);
    normalAppearance.setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_READ);
    normalAppearance.setCapability(Appearance.ALLOW_TEXGEN_READ);
    normalAppearance.setCapability(Appearance.ALLOW_TEXTURE_READ);
    normalAppearance.setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_READ);
    normalAppearance.setCapability(Appearance.ALLOW_TEXTURE_WRITE);
    normalAppearance.setCapability(Appearance.ALLOW_TEXTURE_ATTRIBUTES_READ);
    normalAppearance.setCapability(Appearance.ALLOW_TEXGEN_WRITE);
    normalAppearance.setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_WRITE);
    normalAppearance.setCapability(Appearance.ALLOW_COLORING_ATTRIBUTES_WRITE);
    normalAppearance.setCapability(Appearance.ALLOW_LINE_ATTRIBUTES_WRITE);
    normalAppearance.setCapability(Appearance.ALLOW_POINT_ATTRIBUTES_WRITE);
    normalAppearance.setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_WRITE);       */

    normalAppearance = new Appearance();


    componentMaterial = new Material();
    TextureAttributes newTexA = new TextureAttributes();
    if ( this.getTransparency() == 0)
      newTexA.setTextureMode(TextureAttributes.REPLACE);
    else
    {

      newTexA.setTextureMode(TextureAttributes.MODULATE);
    }

    normalAppearance.setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_WRITE);
    normalAppearance.setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_READ);
    normalAppearance.setMaterial(componentMaterial);
    normalAppearance.setTextureAttributes(newTexA);
    normalAppearance.setCapability(Appearance.ALLOW_TEXTURE_WRITE);





  }

  /*
  
public void setTransparency(float newT, boolean updateDefault)
{

  //BDebug.print(this + ".setTransparency " + newT);
  if (updateDefault)
    transparency = newT;

 // try {
    if (newT == 0.0)
    {
      normalAppearance.setTransparencyAttributes(null );

    }
    else
    {
      if (BGlobal.USE_TRANSPARENCY)
      {
        TransparencyAttributes tranA;
        tranA = normalAppearance.getTransparencyAttributes();

        if (tranA == null)
        {
          tranA =  new TransparencyAttributes(TransparencyAttributes.BLENDED , newT, TransparencyAttributes.BLEND_SRC_ALPHA, TransparencyAttributes.BLEND_ONE_MINUS_SRC_ALPHA) ;
          tranA.setCapability(TransparencyAttributes.ALLOW_VALUE_WRITE);
          normalAppearance.setTransparencyAttributes(tranA);




        }
        else
        {
          tranA.setTransparency(newT);



        }

      }
    }
//  }
//  catch (Exception e){ BDebug.print("BComponent.setTransparency :Error " + e.getMessage()); }

}

*/

  protected Texture getTexture()
  {
    if(advert != null)
      return advert.getTexture();

    if (getTextureName() == null)
      return null;
    else
      return BTextures.getTexture(BGlobal.TEXTUREPATH + getTextureName(), true);
  }


  public void setEnableLighting(boolean on)
  {
    super.setEnableLighting(false);
  }

  public boolean getEnableLighting()
  { return !lightingOff; }


  public BArenaObjectPosition getArenaMovePosition(float timeSliceIn, Vector channelsIn)
  {
    return new BArenaObjectPosition();
  }

  public void setArenaMovePosition(BArenaObjectPosition arenaObjectposition)
  {

  }
  public BArenaObjectPosition getSpecialMovePosition(float timeSlice, Vector channels, String specialMove)
  {
    return new BArenaObjectPosition();
  }

    public BArenaObjectPosition getArenaPosition()
  {
    return position;

  }

   public void move(float timeSliceIn, Vector channelsIn)
  {
    BDebug.print("BArenaOrnament SHOULD NOT BE CALLED ");

  }

  public void cleanseLiveNodes()
  {
    super.cleanseLiveNodes();
    displacementGroup = null;
    arenaRotateGroup = null;

  }

  public void setLiveNodes(BranchGroup wrapperBranch, TransformGroup newDisplacementGroup, TransformGroup newArenaRotateGroup)
  {
    super.setLiveBotNode(wrapperBranch);
    displacementGroup = newDisplacementGroup;
    arenaRotateGroup = newArenaRotateGroup;
  }


  private static Vector3f applyPosition_translateV = new Vector3f();
  private static Transform3D applyPosition_tempT = new Transform3D();


 private void applyPosition()
 {

    if (  ( displacementGroup != null) && (arenaRotateGroup != null )  )
    {  // translation
      applyPosition_translateV = new Vector3f (position.x,position.y, position.z);
      applyPosition_tempT .set(applyPosition_translateV);
      displacementGroup.setTransform(applyPosition_tempT);

      // rotation
      applyPosition_tempT.rotY(position.facing);
      arenaRotateGroup.setTransform(applyPosition_tempT);
    }
 }


 public void mouseMove(int x,int z,int x_last,int z_last)
 {

      float STEPSCALE = 3.0f;

      float xstep = (x_last - x )* STEPSCALE;
      float zstep = ( z_last - z) * STEPSCALE;


      position.x = position.x - xstep;
      position.z = position.z - zstep;

      applyPosition();

      // Y is reset to zero, so user can use move as a way of resetting the object
      // to floor level.


 }


 
  public void mouseRotate(int x,int z,int x_last,int z_last)
 {

      float STEPSCALE = 0.02f;
     // float xstep = (x_last - x )* STEPSCALE;
      float zstep = ( z_last - z) * STEPSCALE;

      position.facing = position.facing +  zstep;

      applyPosition();

 }

 public void mouseElevate(int y,int y_last)
 {

      float STEPSCALE = 2.0f;

      //float xstep = (x_last - x )* STEPSCALE;
      float ystep = ( y_last - y) * STEPSCALE;

      ystep = -ystep;

      //position.x = position.x - xstep;
      position.y = position.y - ystep;

      Vector3f translateV = new Vector3f (position.x,position.y,position.z);

      Transform3D tempT = new Transform3D();
      tempT.set(translateV);

      displacementGroup.setTransform(tempT);

 }

  public boolean startMove(float timeSlice)
 {
  BDebug.print(getName() + "Start Move");
  return false;

 }

   public boolean victoryMove(float timeSlice)
 {
  BDebug.print(getName() + "victory Move");
  return false;

 }



 public void resetStartMove()
 {


 }

  public void resetVictoryMove()
 {


 }

 public void setNegateNode(TransformGroup negateNode)
 {

 }


 public void setArenaPosition(BArenaObjectPosition newPos)
 {

    position = newPos;
    applyPosition();




  }

 public Vector getChannels ()
 {
    return channels;
 }

 public Enumeration getComponents()
 {
    Vector tempV = new Vector();
    DefaultMutableTreeNode tempN = new DefaultMutableTreeNode(this);

    tempV.add(tempN);
    return tempV.elements();
 }

 public void testCollisions (BComponent armingComponent, Vector collisionList ,  javax.media.j3d.Locale myLocale, Vector ignoreList, boolean checkZones)
 {
  BDebug.print("BArenaOrnament.testCollisions NOT IMPLEMENTED ");

 }

 public Bounds getBounds()
 {
  return getLiveNode().getBounds();

 }

 public BranchGroup getStructure3D(boolean addZones, boolean addSensors)
 {

  return super.getStructure3D();

 }

 public Vector getArenaComments()
 {
  return new Vector();
 }

  public void setArenaComments(String comment)
  {
  }

  /*
  public void upgrade()
 {
    // DON'T UPGRADE
 }

 public void setTransparency(float newT)
  {
  }

  public void setTransparency(float newT, boolean updateDefault)
  {
    if (updateDefault)
      super.transparency = newT;
  }   */



  public void setHighlight(Color3f c)
 {
    normalAppearance.setTexture(null);
 }



  // BAlphaAcceptor implementation...
  // -------------------------------------------------------------
  // SJS [23/03/2001].

  public void setAlphaValue(BAlphaValue value)
  {
    BArenaObjectPosition p
      = (BArenaObjectPosition) value;

    setArenaPosition(p);
  }



}
