package roboforge;


import java.util.*;
import java.io.*;
import javax.vecmath.*;
//import javax.media.j3d.*;


//public class BArenaTimeSlice extends Vector
public class BArenaTimeSlice implements Serializable
{
/*

* Description:
  Stores BBotShots

* Example:
* Modification History ( Name, Date, Notes )
  Created HSC, 21 May.
  Changed DJG 20 Sep to contain more members

  COMPLETE REWRITE - 10 Nov 99 - YLY

*/

  static final long serialVersionUID = -1L;

  private Matrix4f botAChassisOrientation;
  private Matrix4f botBChassisOrientation;

  private BArenaObjectPosition botAArenaPosition;
  private BArenaObjectPosition botBArenaPosition;

  byte botADamageLevel;
  byte botAEnergyLevel;

  byte botBDamageLevel;
  byte botBEnergyLevel;

  short destroyedComponentStartIndex = -1;    // -1 means there are no destroyued components this slice.
  short destroyedComponentEndIndex = -1;

  short collisionStartIndex = -1;
  short collisionEndIndex = -1;

  private BJointTransform[] optimisedJointTransforms;

  // a complete snap of all transforms ( Only set every X frames )
  private transient BJointTransform[] criticalSnap;



  public BArenaTimeSlice()
  {
    botAChassisOrientation = new Matrix4f();
    botBChassisOrientation = new Matrix4f();

    botAArenaPosition = new BArenaObjectPosition();
    botBArenaPosition = new BArenaObjectPosition();

  }

  private static Vector3f constructor_MixHeightVector = new Vector3f();

  public BArenaTimeSlice(BBot botA, BBot botB, int destroyedStart, int destroyedEnd , int collisionStart, int collisionEnd  ,  BArenaTimeSlice lastSlice)
  {


        // get Orientation
        // mix in height into the matrix
        botAChassisOrientation = botA.getChassis().getOrientationSnap();

        constructor_MixHeightVector.x = 0;
        constructor_MixHeightVector.y = botA.getChassis().height;
        constructor_MixHeightVector.x = 0;
        botAChassisOrientation.setTranslation(constructor_MixHeightVector);

        if (lastSlice.botAChassisOrientation.equals(botAChassisOrientation) )
          botAChassisOrientation = lastSlice.botAChassisOrientation;

        // get bot B
        botBChassisOrientation = botB.getChassis().getOrientationSnap();
        constructor_MixHeightVector.x = 0;
        constructor_MixHeightVector.y = botB.getChassis().height;
        constructor_MixHeightVector.x = 0;
        botBChassisOrientation.setTranslation(constructor_MixHeightVector);

        if (lastSlice.botBChassisOrientation.equals(botBChassisOrientation) )
          botBChassisOrientation = lastSlice.botBChassisOrientation;


        //botAArenaPosition.set(  botA.getArenaPosition() );
        if (lastSlice.botAArenaPosition.equals(botA.getArenaPosition() ))
          botAArenaPosition =lastSlice.botAArenaPosition;
        else
          botAArenaPosition =  new BArenaObjectPosition( botA.getArenaPosition());

        //botBArenaPosition.set(  botB.getArenaPosition() );
        if (lastSlice.botBArenaPosition.equals(botB.getArenaPosition() ))
          botBArenaPosition =lastSlice.botBArenaPosition;
        else
          botBArenaPosition =  new BArenaObjectPosition( botB.getArenaPosition());



        //botBChassisHeight = botB.getChassis().height;

        // Get damage and Energy Information
        botADamageLevel = (byte)botA.getPercentageDamageLevel();
        botAEnergyLevel = (byte)botA.getPercentageEnergyLevel();
        botBDamageLevel = (byte)botB.getPercentageDamageLevel();
        botBEnergyLevel = (byte)botB.getPercentageEnergyLevel();

        // temp Vector
        Vector jointTransforms;


        // get the joint transforms of the 2 bots and combine into one vector
        BSnapshot tempS = botA.getSnapFromSimulation();
        if (tempS != null)
                jointTransforms = tempS.getComponentTransforms();
        else
                jointTransforms = new Vector();

        tempS = botB.getSnapFromSimulation();

        if (tempS != null)
                jointTransforms.addAll(tempS.getComponentTransforms());



        optimisedJointTransforms = new BJointTransform[jointTransforms.size() ];

        for (int i = 0; i < jointTransforms.size(); i ++)
        {
          BComponentTransform componentTransform = (BComponentTransform)jointTransforms.get(i);
          optimisedJointTransforms[i] = new BJointTransform(componentTransform.getJoint(),componentTransform.getJointPosition());
        }

        // destroyed components and collision indexes
        destroyedComponentStartIndex =  (short)destroyedStart ;
        destroyedComponentEndIndex = (short)destroyedEnd ;

        collisionStartIndex = (short)collisionStart;
        collisionEndIndex = (short)collisionEnd;




  }

  public int indexof ( BJoint j)
  {
    int index = -1;

    for (int i = 0; i < optimisedJointTransforms.length && (index == -1) ; i++)
    {
      if (optimisedJointTransforms[i].joint == j)
        index = i;
    }

    return index;


  }


  public boolean isColliding()
  {
    return (collisionStartIndex != collisionEndIndex );
  }


  public void setCriticalSnap(Vector completed)
  {

        criticalSnap = new BJointTransform[completed.size() ];
        //BDebug.print ("BArenaTimeSlice.sertCritiocalSnape items : " + completed.size() );
        
        for (int i = 0; i < completed.size(); i ++)
        {
          criticalSnap[i] = ( BJointTransform) completed.get(i);
        }

  }



  public void  preprocessForPlayer(int frame)
  {

    // Get All Joint Transforms here
    // turn all componenet trransfoms to tranform3ds

     //for (int i = 0; i < optimisedJointTransforms.length; i ++)
   // {
      // init all to false, then set to true when a joint is found
    //  optimisedJointTransforms[i] .joint.lastFrameMoved = frame;



   // }









  }


  public void fillCompleteVector(Vector jointsToGetTransformsFor, Vector completedSlice )
  //PRE preprocessforplayer has been set
  {
    //BDebug.print ( "fillCompleteVector looking for " + jointsToGetTransformsFor );

    
    BJointTransform[] listToUse;

    if (criticalSnap == null)
      listToUse =  optimisedJointTransforms;
    else
      listToUse = criticalSnap;

    for (int i = listToUse.length -1; i >= 0 ; i -- )
    {

      if ( jointsToGetTransformsFor.indexOf(  listToUse[i].joint ) != -1 )
      {
        //BDebug.print (" BArenaCanvas.fillCompleteVector found transform for " + listToUse[i].joint );
        jointsToGetTransformsFor.remove(listToUse[i].joint );
        completedSlice.add(listToUse[i] );


      }


    }



  }

  public void apply(BBot botA, BBot botB, Vector completedJointList, boolean applyPosition)
  {
    for (int i = 0; i < completedJointList.size(); i ++)
    {
      BJointTransform jTransform = (BJointTransform)completedJointList.get(i);
      jTransform.joint.applyTransform(jTransform.transform);
    }

    if (applyPosition)
      botA.getChassis().applyArenaPositionForBattlPlayer(botAArenaPosition);
    botA.getChassis().setHeightAndOrientation( botAChassisOrientation);

    if (applyPosition)
      botB.getChassis().applyArenaPositionForBattlPlayer(botBArenaPosition);
    botB.getChassis().setHeightAndOrientation( botBChassisOrientation);
  }


  public void constructMultipleFrameVector(Vector fillV)
  {
    //BDebug.print ("Construct Multiple Frame Vector Called" );

    if (fillV.isEmpty())
    {
      for (int i = optimisedJointTransforms.length -1 ; i >=0; i-- )
        fillV.add(optimisedJointTransforms[i]);
    }
    else
      for (int i = optimisedJointTransforms.length -1 ; i >=0; i-- )
        if (!fillV.contains(optimisedJointTransforms[i])  )
          fillV.add(optimisedJointTransforms[i]);



  }


  public void apply(BBot botA, BBot botB, boolean applyPosition)
  //PRE preprocessforplayer has been set
  {

    BJointTransform[]  listToUse;
    BChassis chassis;

    if (criticalSnap == null)
      listToUse =  optimisedJointTransforms;
    else
      listToUse = criticalSnap;


    for (int i = 0; i < listToUse.length; i ++)
    {
      //BJointTransform jTransform = (BJointTransform)optimisedJointTransforms.get(i);
      listToUse[i].joint.applyTransform(listToUse[i].transform);
    }


    chassis = botA.getChassis();
    chassis.setHeightAndOrientation( botAChassisOrientation);

    if (applyPosition)
      chassis.applyArenaPositionForBattlPlayer(botAArenaPosition);

    chassis = botB.getChassis();
    chassis.setHeightAndOrientation(botBChassisOrientation);

    if (applyPosition)
      chassis.applyArenaPositionForBattlPlayer(botBArenaPosition);
  }


  public void interpolate(BBot botA, BBot botB, float t, boolean applyPosition)
  {
    // SJS [15/03/2001] - Interpolate from last timeslice to this one.
    // When t is 0, the last timeslice is fully applied.
    // When t is 1, this slice is fully applied.

    BJointTransform[] listToUse;
    BChassis chassis;

    // Decide which list to use - if we're on a critical
    // snapshot (a la MPEG), use the appropriate list.
    listToUse = (criticalSnap == null) ?
      optimisedJointTransforms : criticalSnap;

    // Interpolate the position of moved joints...
    int n = listToUse.length;
    for (int i=0; i<n; i++)
      listToUse[i].joint.interpolate(listToUse[i].transform, t);


    // Interpolate bot A position & orientation...
    chassis = botA.getChassis();
    chassis.interpolateHeightAndOrientation(botAChassisOrientation, t);

    if (applyPosition)
      chassis.interpolateArenaPosition(botAArenaPosition, t);

    // Interpolate bot B position & orientation...
    chassis = botB.getChassis();
    chassis.interpolateHeightAndOrientation(botBChassisOrientation, t);

    if (applyPosition)
      chassis.interpolateArenaPosition(botBArenaPosition, t);
  }

}