package roboforge;



public class BAutoRotateJoint extends BRotateJoint
{
  int direction = 1; // clockwise

  static final long serialVersionUID = -1L;
  //private transient BJointPosition endPosition;



  public BAutoRotateJoint(String nameIn, String filename)
  {
    super(nameIn, filename);
  }

  private transient boolean performedResultantMove = false;

  public  boolean move(BJointPosition endPosition, float timeSlice, float power, float maxVelocityMutiplier, boolean deccelerate)
  {
    if (deccelerate)
    {
      performedResultantMove = true;
      return super.move(endPosition, timeSlice, power, maxVelocityMutiplier, deccelerate);

    }
    else
        return false;
  }

  public void initForArena(BChassis theChassis, BBot owner)
  {
    performedResultantMove = false;
    super.initForArena(theChassis, owner);
  }

  
  public void clearVelocity()
  {
    //BDebug.print("Clear Velocity Called");
    this.currentVelocity = 0f;
  }

  public  boolean move( float timeSlice, float power)
  {
    return move(  timeSlice,  power, false);
  }

  public  boolean move( float timeSlice, float power, boolean demoOnly)
  // Power = 0 to 1
  // Must pass in endPosition so that we can overrider the BRotateJoint Move()
  {
    /*
    //BDebug.print (getName() + " this.getDestroyed() " + this.getDestroyed() + " this.getBot().getEnergy()  " + this.getBot().getEnergy() );
    if (this.getDestroyed() || (this.getBot().getEnergy() <= 0  ))
      return false;

    if (endPosition == null)
      endPosition = new BJointPosition(99999999);

    boolean construct = BGlobal.CONSTRUCTING_CHASSISBOT;
    boolean chassisLock = getChassisLock();
    setChassisLock(false);
    BGlobal.CONSTRUCTING_CHASSISBOT = false;

    super.move(endPosition, null,  timeSlice, power, false);
    BGlobal.CONSTRUCTING_CHASSISBOT = construct;
    setChassisLock(chassisLock);

    return false;


    */
    if (performedResultantMove)
    {
      performedResultantMove = false;
      return false;
    }

    if ( standDown(pauseTime) )
    {
      return true;
    }

    if (maxAcceleration == 0)
      maxAcceleration = 1.5f;

    if (!demoOnly)
      if (this.getDestroyed() || (this.getBot().getEnergy() <= 0  ))
        return false;


    //BDebug.print (getName() + " Executed ");
    // Joints velocity
    float oldVelocity = currentVelocity;
    float deltaVelocity;
    float jointCapability = ((float)damageMax-(float)getDamageCurrent())/(float)damageMax;

    float netLimbLoad = this.getNetLimbLoad(this.limbLoad, power);
    float acceleration = jointPowerOutput * BPhysics.POWER_ACCELERATION_RATIO;

    if ( (this.limbLoad == 0.0f) ||  (this.limbLoad == Float.NaN) )
          deltaVelocity = ( direction *  (acceleration * jointCapability * timeSlice * power) );
        else
          deltaVelocity = ( direction *  ( (acceleration * jointCapability * timeSlice * power) / netLimbLoad ) );


    if ( maxVelocityExceededCtr > 0 )
    {
              deltaVelocity = 0.0f; // No Acceleration
              if ( maxVelocityExceededCtr > 1 ) // Decelerate
              {
                float decelerationRate = (timeSlice/BGlobal.CALC_TIMESLICE) * ((maxVelocityForLimb-BPhysics.MAX_VELOCITY_CAP) / maxVelocityForLimb);
                deltaVelocity = ( direction * java.lang.Math.abs(currentVelocity) * decelerationRate ) * -1;
              }

              currentVelocity =  java.lang.Math.min( java.lang.Math.abs(currentVelocity + deltaVelocity),  getMaxVelocity());
              currentVelocity = direction * java.lang.Math.abs(currentVelocity);

              //DJG
    }
    else if (deltaVelocity > 0)
    {
      deltaVelocity = java.lang.Math.min( deltaVelocity , maxAcceleration * timeSlice );
      currentVelocity = java.lang.Math.min( maxVelocity , currentVelocity +  deltaVelocity );

    }
    else
    {
      deltaVelocity = java.lang.Math.max( deltaVelocity ,-maxAcceleration * timeSlice );
      currentVelocity = java.lang.Math.max( -maxVelocity , currentVelocity +  deltaVelocity );

    }

        // placed in for demo joints
    if (currentVelocity == Float.NaN)
      currentVelocity = 0;


    if (currentVelocity == oldVelocity)
      deltaVelocity = 0f;


    // delta x as a derivative of ut + 1/2at^2
    // x = ut + 1/2vt
    float distanceInThisSlice = oldVelocity * timeSlice + ( ( deltaVelocity / 2.0f ) * timeSlice  )  ;

    //BDebug.print ("AutoRotateJoint distanceInThisSlice " + distanceInThisSlice + " timeslice " + timeSlice );
    

    //setPreviousJointPosition(getJointPosition());
    float oldPosition =  getJointPosition().getAngle();
    float newPosition = 0;

    newPosition = oldPosition + distanceInThisSlice;


    /*
    BDebug.print("AutoJoint  jointCapability :" + jointCapability);

    BDebug.print("AutoJoint  currentVelocity :" + currentVelocity);
    BDebug.print("AutoJoint  maxVelocity :" + maxVelocity);
    BDebug.print("AutoJoint  distanceInThisSlice :" + distanceInThisSlice);

    BDebug.print("AutoJoint  acceleration :" + acceleration);
    BDebug.print("AutoJoint  jointCapability :" + jointCapability);
    BDebug.print("AutoJoint  timeSlice :" + timeSlice);

    BDebug.print("AutoJoint  oldPos :" + oldPosition);
    BDebug.print("AutoJoint  newPos :" + newPosition);  */
    

    currentPosition.setAngle(newPosition);
    applyTransform();

    //if (!demoOnly && !getChassisLock() )
    //  getBot().totalEnergy -= ((jointEnergyUsage * (java.lang.Math.abs(currentVelocity) * limbLoad)) * timeSlice) / 1000f;

    
    return false;

  }


  public float workOutProcessingTime(BJointPosition endPosition, BComponentTransform bComponentTransform, float power)
  {
    // alway skip this
    return 0.0f;
  }

  public boolean mouseMove(int x, int y, int x_last, int y_last, boolean useDefaultJointPosition)
  {
    return false;

  }


  public static String COMPONENT_TYPE = "Rotator";
  public String getComponentType()
  { return COMPONENT_TYPE; }

  /*
  // DJG June 2001
  public void setCappedJointPosition(BJointPosition jointPos, float posFloat)
  {
    jointPos.setAngle( posFloat );
  }
  */


}