package roboforge;

import java.awt.Color;

public class BComponentAppearance
{

  // Encapsulates information about a bot component's visual elements.

  // Constants
  // -------------------------------------------------------------

  public static final Color DEFAULTCOLOR = new Color(0.5f,0.5f,0.5f);
  public static final float DEFAULTSHINE = 10.0f;
  public static final int   DEFAULTDEPTH = 100;
  public static final float DEFAULTTRANS = 0.0f;

  public static final float MIN_SHINE    = 0.0f;
  public static final float MAX_SHINE    = 12.0f;

  public static final int   MIN_DEPTH    = 1;
  public static final int   MAX_DEPTH    = 100;
  

  // Internal variables
  // -------------------------------------------------------------
  
  protected Color color;
  protected int colorDepth;
  protected float shine;
  protected String textureName;
  protected float transparency;

  public BComponentAppearance()
    { this(DEFAULTCOLOR, DEFAULTDEPTH, DEFAULTSHINE, null, DEFAULTTRANS); }

  public BComponentAppearance(
    Color color,
    int colorDepth,
    float shine,
    String textureName,
    float transparency)
  {
    this.color         = color;
    this.colorDepth    = colorDepth;
    this.shine         = shine;
    this.textureName   = textureName;
    this.transparency  = transparency;
  }

  public BComponentAppearance(BComponentAppearance ca)
  {
    this.color        = ca.color;
    this.colorDepth   = ca.colorDepth;
    this.shine        = ca.shine;
    this.textureName  = ca.textureName;
    this.transparency = ca.transparency;
  }

  // Accessor methods
  // -------------------------------------------------------------

  public Color getColor()
    { return color; }

  public void setColor(Color c)
    { color = c; }


  public int getColorDepth()
    { return colorDepth; }

  public void setColorDepth(int cd)
    { colorDepth = cd; }


  public float getShine()
    { return shine; }

  public void setShine(float s)
    { shine = s; }


  public String getTexture()
    { return textureName; }

  public void setTexture(String tn)
    { textureName = tn; }


  public float getTransparency()
    { return transparency; }

  public void setTransparency(float t)
    { transparency = t; }

}
