package roboforge;

import java.util.*;
import java.awt.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.behaviors.mouse.*;
//import com.sun.j3d.utils.geometry.ColorCube;
//import com.sun.j3d.utils.geometry.Sphere;
//import com.sun.j3d.utils.image.*;
import javax.vecmath.*;
import com.sun.j3d.utils.universe.*;
import roboforge.animation.*;


public class BComponentCanvas
 extends Canvas3D implements BMouseListenerCanvas{
/**
	 * 
	 */
	private static final long serialVersionUID = -1L;
/*
* Description:  The Canvas3d for vieweing the Component in

* Modification History ( Name, Date, Notes ):
                          YLY, 30 Mar 99,  Added ConnectPoint Support
                          YLY, 31 Mar 99,  Added Componenet/ConnectPoint Support
                          YLY, 3 Apr 99, Fixed Lights,
                          YLY, 6 Apr 99, Changed LoadComponent, Added cursors
                                          Added BAckground Image
                          YLY, 7 Apr 99, Added refreshSelectedConnectPoint , removeComponent, setAmbientColor, made pickHilightBehaiour member
                          YLY, 21 Apr 99,  Fixed a few Memory holes
                          YLY, 30 Apr 99, Cleanup
                          AWH, 11 Jan 01, Animations via BManualAnimator instead of Vector
*/

// Universe Objects
   private SimpleUniverse universe;  // the canvas 3d universe
   private TransformGroup scaledScene;
   private TransformGroup orientationGroup;
   private BranchGroup scene;
   private TransformGroup tg;  // Viewer Translate Group

// Universe appearance members
   private Background bg;
   private BPickHighlightBehavior connectPointsPick;
   private Color3f ambientColor ;
   private AmbientLight AMB_LIGHT;


   static BoundingSphere bounds = BGlobal.INFINITE_BOUNDS;

  // Cache live objects for disposal.  (BUG HACK)
  private Vector shapeList;
  private Vector connectShapeList;

  //private boolean setPriority = false; // flag to set the priority of the render thread to max

  //private boolean wait = false;

 // Vector animations = new Vector();
  private BManualAnimator animations = new BManualAnimator();

  boolean bPlayNextAnimationFrames = false;

  BComponent theComponent;





  public BComponentCanvas(java.awt.GraphicsConfiguration graphicsConfiguration)
  {
        this(null, null);




  }
// CONSTRUCTOR
  public BComponentCanvas(java.awt.GraphicsConfiguration graphicsConfiguration, Behavior behNew) {

      super(null);

      shapeList = new Vector();
      setCursor(new Cursor(Cursor.HAND_CURSOR));

        // Universe root ( BG between universe and scene)
      BranchGroup sceneRootG = new BranchGroup();

        // Ambient Light
      ambientColor = new Color3f(BGlobal.AMBIENTCOLOR);
      AMB_LIGHT = new AmbientLight(ambientColor);
      AMB_LIGHT.setInfluencingBounds(bounds);
      AMB_LIGHT.setCapability(Light.ALLOW_COLOR_WRITE);
      sceneRootG.addChild(AMB_LIGHT);

        // Create the directional light
     Vector3f dir = new Vector3f(-1.0f, -1.0f, -1.0f);
     DirectionalLight dirLight = new DirectionalLight(BGlobal.CANVASLIGHT, dir);
     dirLight.setInfluencingBounds(bounds);
     sceneRootG.addChild(dirLight);

     /*
     Vector3f dir2 = new Vector3f(1.0f, 1.0f, -1.0f);
     DirectionalLight dirLight2 = new DirectionalLight(BGlobal.CANVASLIGHT, dir2);
     dirLight2.setInfluencingBounds(bounds);
     sceneRootG.addChild(dirLight2);

     Vector3f dir3 = new Vector3f(1.0f, -1.0f, -1.0f);
     DirectionalLight dirLight3 = new DirectionalLight(BGlobal.CANVASLIGHT, dir3);
     dirLight3.setInfluencingBounds(bounds);
     sceneRootG.addChild(dirLight3);

     */
     bg = new Background(0.0f, 0.0f, 0.0f);
     bg.setApplicationBounds(bounds);
     bg.setCapability(Background.ALLOW_IMAGE_WRITE);
     sceneRootG.addChild(bg);

     if( behNew  != null)
        sceneRootG.addChild(behNew);


      // The Node that Handles all mouse behaviours
    orientationGroup = new TransformGroup();
    orientationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    orientationGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
    sceneRootG.addChild(orientationGroup);

    // Add the behaviours to the orientation Group
    // Create the rotate behavior node

	  // MouseRotate behavior = new MouseRotate();
	  // behavior.setTransformGroup(orientationGroup);
	  // orientationGroup.addChild(behavior);
	  // behavior.setSchedulingBounds(bounds);


    // Add Mouse Behaviours to the Mouse behaviour node
    //  Rotate

    BMouseDrag behavior = new BMouseDrag(this, true, false, false);
    behavior.setTransformGroup(orientationGroup);
    orientationGroup.addChild(behavior);
    behavior.setSchedulingBounds(bounds);


	  // Create the zoom behavior node
	  MouseZoom behavior2 = new MouseZoom();
	  behavior2.setTransformGroup(orientationGroup);
	  orientationGroup.addChild(behavior2);
	  behavior2.setSchedulingBounds(bounds);

	  // Create the translate behavior node
	 // MouseTranslate behavior3 = new MouseTranslate();
	 // behavior3.setTransformGroup(orientationGroup);
	 // orientationGroup.addChild(behavior3);
	 // behavior3.setSchedulingBounds(bounds);



    // Create a Transformgroup to scale all objects so they
    // appear in the scene.
    scaledScene = new TransformGroup();
    Transform3D t3d = new Transform3D();
    t3d.setScale(BGlobal.COMPONENT_SCALE);
    scaledScene.setTransform(t3d);
    orientationGroup.addChild(scaledScene);

    scaledScene.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    scaledScene.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
    scaledScene.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);

    // Create the scene branchgroup.
    // Separate from sceneRootG because you cannot detach a group from a universe
    scene = createDefaultScene3D();
    scaledScene.addChild(scene);

    // Create a universe with the Java3D universe utility.


    ViewingPlatform newP = new  ViewingPlatform();
    // Set the universe Transform3D object.
    tg = newP.getViewPlatformTransform();
    tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    Transform3D transform = new Transform3D();
    transform.set( new Vector3f(0.0f, 0.0f, 5) );
    tg.setTransform(transform);

    Viewer newV = new Viewer(this);


    // The Universe
    universe = new SimpleUniverse(newP, newV);
    universe.addBranchGraph(sceneRootG);

  }


  private BranchGroup createDefaultScene3D()
  {

  // create a simple detachable node
      BranchGroup objRoot = new BranchGroup();
      objRoot.setCapability(BranchGroup.ALLOW_DETACH);
      objRoot.setCapability(BranchGroup.ALLOW_BOUNDS_READ);
      return objRoot;
  }


  public void loadComponent(BComponent newComponent)
  {

    loadComponent(newComponent, true);

  }


  public void loadComponent(BComponent newComponent, boolean useConnectPoints )
  {
/*

* Description:  Loads the Convas stuff
	* Parameters: only the currently Select Component
	* Results: Displays the component and all their connect piints
* Example:
* Modification History ( Name, Date, Notes ):
                        YLY, 31 Mar, first time I placed Comments
                                   - Optimised Capability bits
                                   - Changed to use the boolean Pasramenter useConnectPoints
*/



    setCursor(new Cursor(Cursor.WAIT_CURSOR));

    theComponent = newComponent;


    removeComponent();

    // reset the orientation
    orientationGroup.setTransform(new Transform3D());

    // Set different view points for components and chassis
    Transform3D t3d = new Transform3D();

    //if (newComponent instanceof BChassis)
    //  t3d.setScale(BGlobal.COMPONENT_CHASSIS_SCALE);
   // else
    t3d.setScale(BGlobal.COMPONENT_SCALE);
    scaledScene.setTransform(t3d);


    // Create the root of the branch graph
    BranchGroup objRoot = new BranchGroup();
    objRoot.setCapability(BranchGroup.ALLOW_DETACH);
    objRoot.setCapability(Node.ALLOW_BOUNDS_READ);

    //ADDCONNECTPOINTS ///////////////////////
    BranchGroup connectBranch = new BranchGroup();
    connectBranch.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    connectBranch.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);


    objRoot.addChild(connectBranch);
    if (useConnectPoints)
      addConnectPointsToScene(newComponent, connectBranch);

    // Orientation
    if ( newComponent.getLiveNode() != null  )
    {
        Transform3D t = new Transform3D();
        Matrix3d rotationComponent = new Matrix3d();

        newComponent.getLiveNode().getLocalToVworld(t);
        t.get(rotationComponent);
        t.set(rotationComponent);
        orientationGroup.setTransform(t);
    };


    BranchGroup tempB =  newComponent.cloneStructure3D(true, false);
    if (!tempB.isLive() && !tempB.isCompiled() )
    {
      tempB.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
      tempB.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
    }

    //ADD ALL SHAPES TO THE SHAPELIST SO WE CAN DESTROY THE APPEARANCE NODES WHEN THE OBJECT IS UNLOADED
    // TO FIX BUG!!!! IN J3D

    extractShapes(tempB);
    objRoot.addChild(tempB);

    //COMPILE AND ADD
    scene =  objRoot;
    scene.compile();
    scaledScene.addChild(scene);

    Bounds sceneBounds = scene.getBounds();

    if (sceneBounds instanceof BoundingSphere)
    {
        BoundingSphere sceneSphere = (BoundingSphere)sceneBounds;
        Transform3D transform = new Transform3D();
        float dist =  ((float)sceneSphere.getRadius()* 3.0f  * BGlobal.COMPONENT_SCALE );
        if (dist < 1.0f)
          dist =1.0f;
        transform.set( new Vector3f(0.0f, 0.0f, dist ) );
        tg.setTransform(transform);

    }





    setCursor(new Cursor(Cursor.HAND_CURSOR));




   }

  public void addConnectPointsToScene(BComponent newComponent, BranchGroup attachNode)
  {

        // Create Behaviour
        connectPointsPick = new BPickHighlightBehavior(this, attachNode, bounds, true );
        connectShapeList = newComponent.addConnectPointsToScene(attachNode, true);

        //   attachNode.addChild(objScale);

  }

  public void setBackgroundImage (ImageComponent2D bgImage)
/*

* Description: Sets the Background of the Canvas
	* Parameters:  The GIF,
	* Results: displays the image
* Example:

            import com.sun.j3d.utils.image.*;

            TextureLoader loader = new TextureLoader("bgGif.gif" ,new Panel()  );
            ImageComponent2D bgImage = loader.getImage();
            componentCanvas.setBackgroundImage (bgImage);

* Modification History ( Name, Date, Notes ):

*/
 {
    bg.setImage( bgImage );
 }

 public void setAmbientColour ( Color3f newColour)
 {

  AMB_LIGHT.setColor(newColour);
 }


 public void removeComponent  (BComponent theComponent)
 // ONLY HERE FOR MOUSELISTENERCANVAS INTERFACE
 {
  removeComponent();

 }

 public void removeComponent()
 {
 try{
        if (theComponent != null)
          theComponent.removeConnectPointsFromScene(  ) ;

        // Detach Scene
        if (scene != null)
        {
	          scene.detach();
        }

        scene = null;
        //Shape3D current;



        // Null all appearance nodes to double handle j3d BUG
       // for (int a = 0 ; a < shapeList.size() ; a++ )
        //{
       //         current = (Shape3D)shapeList.get(a);
                //current.setAppearance(null);
                //current.setGeometry(null);

        //        if ( current instanceof BShape3D)
        //          ((BShape3D)current).cleanse();
        //}    // for loop

        shapeList.removeAllElements();

       // FOR CONNECT POINTS
       // Null all appearance nodes to double handle j3d BUG
       // BConnectPointShape currentC;

        if (connectShapeList != null)
        {
               // for (int a = 0 ; a < connectShapeList.size() ; a++ )
               // {
               //         currentC = (BConnectPointShape)connectShapeList.get(a);
                //        currentC.setAppearance(null);
                //        currentC.setGeometry(null);
                //        currentC.cleanse();

                //}    // for loop

                connectShapeList.removeAllElements();
        }

        if (connectPointsPick != null )
                connectPointsPick.setLastSelected(null);

    }catch(Exception e){BDebug.print("BComponentCanvas.remove Error:" +e.getMessage());}
 }


 public void refreshSelectedConnectPoint()
 {
   connectPointsPick.getLastSelected().setHighlight(false);
 }



public Transform3D getOrientation()
{

  Transform3D tempTrans = new Transform3D();
  orientationGroup.getTransform(tempTrans);
  return tempTrans;

}



private void extractShapes ( Node oldBranch )
 {

 if ( oldBranch instanceof Group )
    {
    Group currentGroup = (Group) oldBranch;
    for (Enumeration e = currentGroup.getAllChildren(); e.hasMoreElements();)
        {
        Node newGroup =(Node)e.nextElement();
        extractShapes(newGroup);
        }   // loop
    }   // if
 else
  {
   if ( (oldBranch instanceof Shape3D )  )

         shapeList.add(oldBranch);
  } // else


 }




/*
  public void paint(Graphics g)
  {

    if (BGlobal.BOT_CANVAS_LOCK)
      {
        BDebug.print("BOT_CANVAS_LOCK preventing paint " + toString() );
        //Thread.currentThread().yield();
      }
   else
      {
       BDebug.print ("Component Canvas paint " + toString() );
       super.paint(g);

      }

  }
*/



 public void  preRender()
 {




 }



  public void exitWireFrame()
  {
  if (BGlobal.WIREFRAME_ON_MOVE)
   {
    try{

        if( !shapeList.isEmpty() )
        {
          BShape3D current = (BShape3D)shapeList.get(0);
          current.getComponent().setNormalAppearance();
        }



      }catch(Exception e){BDebug.print("BComponentCanvas.exitWireFrame Error:" +e.getMessage());}
   }
  }




  public void setWireFrame(BComponent theComponent)
  {
    BDebug.print("BComponent Canvas.setWireFrame(theComponent) Should not be used .. Use setWireFrame()");

  }



  public void setWireFrame()
  {

  if (BGlobal.WIREFRAME_ON_MOVE)
  {
    try{

        if( !shapeList.isEmpty() )
        {
          BShape3D current = (BShape3D)shapeList.get(0);
          current.getComponent().setWireFrame();
        }



      }catch(Exception e){BDebug.print("BComponentCanvas.setWireFrame Error:" +e.getMessage());}
   }

  }

  public BHighlightShape getLastSelected()
  {
   BShape3D current = null;


   if( !shapeList.isEmpty() )
          current = (BShape3D)shapeList.get(0);


   return current;


  }



  public int getMode()
  {
   return BGlobal.CANVAS_MODE_ORIENTATE;
  }

  public void modeMethod(BHighlightShape shape)
  {
    shape.setActiveArea();
    connectPointsPick.pick(shape);
  }


  public void takeSnapshot()
  {
   BDebug.print("BComponent Canvas . taheSnapShot NOT Implemented ");
  }

    public boolean waitingForSnap()
  {
    return false;

  }


  public void postSwap()
  {

  // Traversing the Vector backwards so we can safely remove objects
 /*
    if ( (animations.size() > 0)  && bPlayNextAnimationFrames )
    {
      bPlayNextAnimationFrames = false;

      for (int i = animations.size()-1; i >=0 ; i-- )
        {
                ((B2dAnimation) animations.get(i)).playNext();

                if (   !((B2dAnimation) animations.get(i)).swapFrames() )
                {
                        B2dAnimation temp =  (B2dAnimation) animations.get(i) ;
                        animations.remove(i);
                        temp.cleanse();
                }
                        //((B2dAnimation) animations.get(i)).reset();
        }
    }
  */
    if (animations != null)
    {
      if (animations.getSize() == 0)
        bClearAnimations = false;

      if (bPlayNextAnimationFrames)
      {
        bPlayNextAnimationFrames = false;
        animations.animate();
      }
    }
  }

  boolean bClearAnimations = false;

  public void removeAllAnimations()
  {

    animations.clear();


    /*
    for (int i = animations.size()-1; i >=0 ; i-- )
      { ((B2dAnimation) animations.get(i)).remove(); }

    animations.removeAllElements();
*/
  }


 public javax.media.j3d.Locale getLocale3d()
 {
    BDebug.print ("BComponentCanvas getLocale NOT IMPLEMENTED ");
    return null;

 }

 public void load2dAnimation(B2dAnimation theAni )
 {
        theAni.setPosition(scaledScene, null, false);
        theAni.reset();
        animations.add(theAni);


 }
 public void waitForFrame()
 {
        BDebug.print ("BComponentCanvas.waitForFrame not implemented ");
 }

 public void playNextAnimationFrames()
  {
        bPlayNextAnimationFrames = true;
  }



}  // COMPONENT CANVAS