package roboforge;


import javax.vecmath.*;
import java.io.*;
import javax.media.j3d.*;

public class BConnectPoint extends Object implements Serializable {

 static final long serialVersionUID = -1L;

 public Vector3d position;    // The vector displacement from the centre of the locale
 public Vector3d facing;
 public boolean active;
 protected transient BConnectPointShape shape = null;

  BConnectPoint(    Vector3d newPosition,
                    Vector3d newFacing   )
  {
    position = newPosition;
    facing = newFacing;
    active = true;

  }

    BConnectPoint(  Vector3d newPosition,
                    Vector3d newFacing,
                    boolean newActive   )
  {
    position = newPosition;
    facing = newFacing;
    active =  newActive  ;

  }

  BConnectPoint(){}

public String toString()
  {
    return "Position:" + position.toString() + " Vector: " + facing.toString();
  }


 public Object clone()
 {

  BConnectPoint o = new BConnectPoint(this.position, this.facing, this.active);

  // SJS [17/02/2000] - Remember associated shape.
  // TODO: Need to clone this too?
  // o.shape = this.shape;

  return o;

  }

  public boolean equals (Object obj)
  {
    boolean e = false;

    if (obj instanceof BConnectPoint)
    {

      BConnectPoint oc = (BConnectPoint) obj;

      e = oc.facing.equals(facing) && oc.position.equals(position);

    }


    return e;

  }


  public boolean isActive()
    { return active; }

  public void setActive(boolean isActive)
    { this.active = isActive; }

  public Vector3d getFacing()
    { return facing; }


  /* SJS [17/02/2000] - Added several methods:
     - setShape
     - setSelected
     - cleanse

     These move responsibility from BConnectPointShape to this class.
  */


  public void setShape(BConnectPointShape shape)
    { this.shape = shape; }

  public BConnectPointShape getShape()
    { return shape; }
    
  public void cleanse()
  {
    if (shape != null)
      shape.cleanse();
    
    shape = null;
  }

  public void removeAnimation()
  {
     if (shape != null)
      shape.removeAnimation();
  }

  public void setSelected(boolean selected)
  {
    // setActive(selected); GeometryG    

    // Shape should always be non-null.  (in the new interface )
    if (shape != null)
      shape.setSelected(selected);
  }

  private static Transform3D localT = new Transform3D();
  private static Vector3f localV = new Vector3f();


  public float getLocalToVWorldDistance()
  {
    if (shape == null)
      return 0f;

    Vector3f v = getLocation();
    return v.length();

  }

  public Vector3f getLocation()
  {
    shape.getLocalToVworld(localT);
    localT.get(localV);
    return localV;
  }

  public Vector3d getPosition()
    { return position; }


}


