package roboforge;

import java.awt.*;
//import java.io.*;
import javax.swing.*;
import java.awt.event.*;
//import javax.swing.border.*;
//import java.awt.image.MemoryImageSource;


class BHuePicker extends JPanel
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;

private BSBPicker holder;

  private double hue = 0.0;

  public BHuePicker(BSBPicker holder)
  {
    this.holder = holder;
    this.addMouseListener(new MyMouseListener());
    this.addMouseMotionListener(
        new MouseMotionAdapter()
        {
                public void mouseDragged(MouseEvent e)
                {

                        processMouse (e);
                }

        }

        );



  }

  class MyMouseListener extends MouseAdapter
  {
    public void mousePressed(MouseEvent e)
    {
     processMouse( e);
    }

  }


  public void setHue(double h)
  {
    hue = h;
    repaint();
  }

 public void processMouse(MouseEvent e)
  {

      //int x = e.getX();
      int y = e.getY();
      int height = getSize().height;

      hue = (double) y / (double) (height-1);

      if (y < 0)
        y = 0;
      else if (y >= height)
        y = height - 1;

      holder.setHue(hue);
      repaint();
  }


  public Dimension minimumSize() {
    return new Dimension(10, 50);
  }
  public Dimension preferredSize() {
    return minimumSize();
  }

  public void paint(Graphics g)
  {
    Dimension dimensions = getSize();
    int width = dimensions.width;
    int height = dimensions.height;

    for (int i=0; i < height; i++)
    {

      g.setColor(Color.getHSBColor((float)((double)i / (double)height),
                                   (float)1.0, (float)1.0));
      g.drawLine(0, i, width-1, i);

    }

    int H_HEIGHT = 1;

    int y = (int) (hue * (height-1)) ;
    g.setColor(Color.white);
    g.drawRect(0, y - H_HEIGHT , width-1,  H_HEIGHT * 2);
  }

}


