package roboforge;

import com.sun.j3d.utils.behaviors.mouse.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;
//import com.sun.j3d.utils.behaviors.picking.*;


public class BMouseDrag extends MouseRotate{
/*

* Description: Controls the Mouse Rotate Behaviour of the BotCanvas
	* Parameters:
	* Results:
* Example:
* Modification History ( Name, Date, Notes ):
                          YLY 21 Apr 99 -
                          YLY 30 Apr 99 - Wire Frame only works for small stuff;
                          YLY 20 Oct 99 - Changed to MouseDrag and Cleaned up format
                          SJS 19 Jan 00 - Added an alternative rotation method.
*/

  private static double STEPSCALE = 0.02;
  private BMouseListenerCanvas parent;

  private double x_angle, y_angle;
  private double x_factor = .03;
  private double y_factor = .03;

  // absolute x, y position for recording movement of bots
  private double abs_x;
  private double abs_y;

  // if the limb has been moved (flag
  private boolean moved;
  private boolean useDefaultJointPosition;

  // flag to indicate that the control button must be held down for the behavior to activate
  // control down indicates that you are using abs movenment
  private boolean useControl;

  // flag to indicate that the bahavior is part oif the viewplatform branch instead opf the universe branch
  private boolean isInViewingPlatformBranch;

  // invert input
  private boolean invertLocal = false;

  // SJS 19/01/2000 - vars to keep track of orientation between drags.
  private double totalXrot  = 0.0;
  private double totalYrot  = 0.0;

  public BMouseDrag(BMouseListenerCanvas newParent, boolean useDefaultJoint, boolean newUseControl, boolean isVBranch )
  {

        super();
        parent = newParent;
        useControl = newUseControl;
        moved = false;
        isInViewingPlatformBranch = isVBranch;
        useDefaultJointPosition = useDefaultJoint;
  }


  public void setInvert(boolean i)
  {
        invertLocal = i;
  }


 public void processStimulus (Enumeration criteria)
 {

          WakeupCriterion wakeup;
          AWTEvent[] event;
          int id;

          while (criteria.hasMoreElements())
          {
            wakeup = (WakeupCriterion) criteria.nextElement();
            if (wakeup instanceof WakeupOnAWTEvent)
            {
              event = ((WakeupOnAWTEvent)wakeup).getAWTEvent();
              for (int i=0; i<event.length; i++)
              {
	              processMouseEvent((MouseEvent) event[i]);
                id = event[i].getID();

                // If the event id mouse realeased and the object was moved then exit the wire frame
                if (id == MouseEvent.MOUSE_RELEASED)
                {
                  if (moved)
                  {
                    exitWireFrame();
                  } // if moved
                  moved = false;
                } // else released


                if (((buttonPress)&&((flags & MANUAL_WAKEUP) == 0))
                        || ((wakeUp)&&((flags & MANUAL_WAKEUP) != 0)))
                {

                // If mouse was dragged the do the drag
                  if (id == MouseEvent.MOUSE_DRAGGED)
                  {
                     try
                     {

                        // If Canvas is MODE_ORIENTATE,  The user is using the right button or NUll is Selected  ... Wireframe the whole thing

                        if (!moved)
                        {

                          if((parent.getLastSelected() == null) || (parent.getMode() == BGlobal.CANVAS_MODE_ORIENTATE ) ||  ((MouseEvent)event[i]).isMetaDown()  || ((MouseEvent)event[i]).isControlDown()      )
                                parent.setWireFrame();
                          else  if (  parent.getLastSelected() instanceof BShape3D) 
                                parent.setWireFrame(    ((BShape3D) parent.getLastSelected()).getComponent());
                        }


                        moved = true;

                        // ONLY DO THE ROTATE IF ALT AND RIGHT MOUSE ARE NOT ACTIVE
                        // CHECKS TO SEE IF CONTROL IS ACTIVE

                        if (   !((MouseEvent)event[i]).isMetaDown()
		                            && !((MouseEvent)event[i]).isAltDown()
                                && ( (!useControl && !((MouseEvent)event[i]).isControlDown() )
                                      || ( useControl && ((MouseEvent)event[i]).isControlDown() )
                                   )
                            )
                        {

                                int x = ((MouseEvent)event[i]).getX();
                                int y = ((MouseEvent)event[i]).getY();


                                if ( useControl && ((MouseEvent)event[i]).isControlDown() )
                                  rotateWholeScene(x,y, true);

                                // hack bit to get BZones interface working. gonna be re-written by stevo
                                // TODO stevo change


                                else if ( parent.getMode() == BGlobal.CANVAS_MODE_ZONE_SCALE  )
                                {

                                  if (parent.getLastSelected() == null)
                                      rotateWholeScene(x,y, false);
                                  else
                                    ((BZoneShape)parent.getLastSelected()).getZone().deltaScale(  (y - y_last)  / 100.0 );

                                   x_last = x;
                                   y_last = y;


                                }
                                else if ( parent.getMode() == BGlobal.CANVAS_MODE_ZONE_X  )
                                {

                                  if (parent.getLastSelected() == null)
                                      rotateWholeScene(x,y, false);
                                  else
                                    ((BZoneShape)parent.getLastSelected()).getZone().deltaX(  (y - y_last) );

                                   x_last = x;
                                   y_last = y;


                                }

                                else if ( parent.getMode() == BGlobal.CANVAS_MODE_ZONE_Y  )
                                {

                                  if (parent.getLastSelected() == null)
                                      rotateWholeScene(x,y, false);
                                  else
                                    ((BZoneShape)parent.getLastSelected()).getZone().deltaY(  -(y - y_last)   );

                                   x_last = x;
                                   y_last = y;


                                }

                                else if ( parent.getMode() == BGlobal.CANVAS_MODE_ZONE_Z  )
                                {

                                  if (parent.getLastSelected() == null)
                                      rotateWholeScene(x,y, false);
                                  else
                                    ((BZoneShape)parent.getLastSelected()).getZone().deltaZ(  (y - y_last) );

                                   x_last = x;
                                   y_last = y;


                                }

                                else if (parent.getMode() == BGlobal.CANVAS_MODE_CONNECTROTATE )
                                {

                                         if (parent.getLastSelected() == null)
                                                rotateWholeScene(x,y, false);
                                        else if (  ! ((BShape3D)parent.getLastSelected()).getComponent().getChassisLock()  )
                                                rotateConnect(x,y);
                                }
                                else if (parent.getMode() == BGlobal.CANVAS_MODE_JOINTMOVE )
                                {

                                        if (parent.getLastSelected() == null)
                                                rotateWholeScene(x,y, false);
                                        else if (   ((BShape3D)parent.getLastSelected()).getComponent() instanceof BJoint )
                                                ((BJoint)        ((BShape3D)parent.getLastSelected()).getComponent()).mouseMove(x,y,x_last, y_last, useDefaultJointPosition);

                                        x_last = x;
                                        y_last = y;


                                }
                                // Arena Object
                                else if (parent.getMode() == BGlobal.CANVAS_MODE_ARENAMOVE )
                                {




                                  if (parent.getLastSelected() == null)
                                    rotateWholeScene(x,y, false);
                                  else
                                  {
                                    transformGroup.getTransform(currXform);


                                    Vector3f origView = new Vector3f(0,0,1f);
                                    currXform.transform(origView);
                                    origView.y = 0;

                                    Vector3f zAxis = new Vector3f(0,0,1f);

                                    Vector3f cross = new Vector3f();

                                    cross.cross(zAxis, origView);

                                    float angle = zAxis.angle(origView);

                                    //BDebug.print("angle " + angle);


                                    if (cross.y > 0)
                                      currXform.rotZ(angle);
                                    else
                                      currXform.rotZ(-angle);

                                    Point3f xy = new Point3f(x,y,0);
                                    currXform.transform(xy);
                                    int mappedx = java.lang.Math.round(xy.x);
                                    int mappedy = java.lang.Math.round(xy.y);

                                    xy = new Point3f(x_last,y_last,0);
                                    currXform.transform(xy);
                                    int lastmappedx = java.lang.Math.round(xy.x);
                                    int lastmappedy = java.lang.Math.round(xy.y);


                                    if (   ((BShape3D)parent.getLastSelected()).getComponent() instanceof BChassis )
                                      ((BChassis)        ((BShape3D)parent.getLastSelected()).getComponent()).mouseMove(mappedx,mappedy,lastmappedx, lastmappedy);
                                    else if (   ((BShape3D)parent.getLastSelected()).getComponent() instanceof BArenaOrnament )
                                      ((BArenaOrnament)     ((BShape3D)parent.getLastSelected()).getComponent()).mouseMove(mappedx,mappedy,lastmappedx, lastmappedy);


                                  }


                                  x_last = x;
                                  y_last = y;



                                }
                                else if (parent.getMode() == BGlobal.CANVAS_MODE_ARENAROTATE )
                                {




                                        if (parent.getLastSelected() == null)
                                          rotateWholeScene(x,y, false);
                                        else if (   ((BShape3D)parent.getLastSelected()).getComponent() instanceof BChassis )
                                            ((BChassis)    ((BShape3D)parent.getLastSelected()).getComponent()).mouseRotate(x,y,x_last, y_last);
                                        else if (   ((BShape3D)parent.getLastSelected()).getComponent() instanceof BArenaOrnament )
                                            ((BArenaOrnament)     ((BShape3D)parent.getLastSelected()).getComponent()).mouseRotate(x,y,x_last, y_last);

                                        x_last = x;
                                        y_last = y;


                                }
                                else if (parent.getMode() == BGlobal.CANVAS_MODE_ARENAELEVATE )
                                {
                                        if (parent.getLastSelected() == null)
                                          rotateWholeScene(x,y, false);
                                        else if (   ((BShape3D)parent.getLastSelected()).getComponent() instanceof BChassis )
                                            ((BChassis)       ((BShape3D)parent.getLastSelected()).getComponent()).mouseElevate(y,y_last);
                                        else if (   ((BShape3D)parent.getLastSelected()).getComponent() instanceof BArenaOrnament )
                                            ((BArenaOrnament)      ((BShape3D)parent.getLastSelected()).getComponent()).mouseElevate(y,y_last);

                                        x_last = x;
                                        y_last = y;


                                }
                                else if (parent.getMode() == BGlobal.CANVAS_MODE_ROTATESCENE )
                                        rotateWholeScene(x,y, false);
                                else
                                        rotateWholeScene(x,y, false);




                        }


                     } catch (Exception e) { BDebug.print(" ERROR BMouseDrag.processStimulus : " + e.getMessage() ); }


                  //BDebug.print(id);

                  } // if id is dragged
                  else if (id == MouseEvent.MOUSE_PRESSED)
                  {
                        x_last = ((MouseEvent)event[i]).getX();
                        y_last = ((MouseEvent)event[i]).getY();

                  } // else pressed  ;




                } // if
              } // for
             } // if wakeup
           } //while hasmoreevents

        wakeupOn (mouseCriterion);
 }



private void exitWireFrame()
// exits the wire frame
    {


     parent.exitWireFrame();


    }



  private void rotateWholeScene(int x, int y, boolean controlDown )
    // Rotates the whole scene
  {

    int dx, dy;

    // control down indicates that you are using abs movenment
    if (controlDown)
       rotateWholeScene_ABS(x,y);
    else if (!reset)
    {
      dx = x - x_last;
      dy = y - y_last;

      // invert input if the flags are set
      if (invertLocal)
      {
        dy = -dy;
        dx = -dx;
      }

		x_angle = dy * y_factor;
		y_angle = dx * x_factor;

    // Keep track of the rotation angles over multiple drags.
    totalXrot += x_angle;
    totalYrot += y_angle;

		transformGroup.getTransform(currXform);

    // SJS 20/01/2000: Remember old translational components.
    Vector3d oldTrans = new Vector3d();
    currXform.get(oldTrans);

    // SJS 20/01/2000: Remember old scaling components.
    Vector3d oldScale = new Vector3d();
    currXform.getScale(oldScale);

		// if the behavior is part of the main universe translate the branch to the origin
    // so we get a orientation centred around the branch
    // else rotate around the origin

    if (!isInViewingPlatformBranch)
      {
        // Temporarily move component to the origin.
        currXform.setTranslation(new Vector3d(0.0,0.0,0.0));

        if (BGlobal.USE_ALTERNATE_ROTATION)
        {

          // Clamp rotation about X to +90, -90 degrees.
          if (totalXrot < -BPhysics.HALF_PI)
            totalXrot = -BPhysics.HALF_PI;

          if (totalXrot > BPhysics.HALF_PI)
            totalXrot = BPhysics.HALF_PI;

          // Update using alternative rotation method.
  	    	transformY.rotY(totalYrot);
          transformX.rotX(totalXrot);

          currXform.setIdentity();
          currXform.setScale(oldScale);

          // Compose the tranforms.
  	  		currXform.mul(transformY, currXform);
  	  		currXform.mul(transformX, currXform);
        }
        else
        {
          // Update using standard rotation method.
  	    	transformY.rotY(y_angle);
          transformX.rotX(x_angle);

          // Compose the tranforms.
  	  		currXform.mul(transformX, currXform);
  	  		currXform.mul(transformY, currXform);
        }

        // Restore original translation.
        currXform.setTranslation(oldTrans);
      }
    else
      {
        // Update using standard rotation method.
  	    transformY.rotY(y_angle);
        transformX.rotX(x_angle);

        // if the behavior is part of the viewer branch then rotate based on
        // total movement in the y axis, or else your movement will warp
        Vector3f xAxis = new Vector3f(1.0f,0,0);

        Transform3D totalYTran = new Transform3D();
        totalYTran.rotY(totalYrot);
        totalYTran.transform(xAxis);

        AxisAngle4f xRot = new AxisAngle4f(xAxis.x, xAxis.y, xAxis.z, (float)x_angle);
        transformX.set(xRot);

        // Compose the tranforms.
        currXform.mul(transformX, currXform);
  	  	currXform.mul(transformY, currXform);
      }

      // Update xform
		  transformGroup.setTransform(currXform);
		  transformChanged( currXform );
    }

    else
    {
		    reset = false;
		}


      if(!controlDown)
      {
        x_last = x;
        y_last = y;
       }

  }



  private void rotateConnect(int x, int y)
  // Only rotates around the connect point
  // This method should be moved to BComponent

    {


      BComponent selectedComponent = ((BShape3D) parent.getLastSelected()).getComponent() ;
      TransformGroup rotateNode = selectedComponent.getConnectRotateNode();
      Vector3d baseFacing= selectedComponent.getConnectPointBase().facing;
      double theZ = selectedComponent.getZAlignment();

      //double xstep = (x_last - x )* STEPSCALE;
      double ystep = ( y_last - y) * STEPSCALE;

      theZ = theZ + ystep;

      selectedComponent.setZAlignment(theZ);

      AxisAngle4d connectRotate = new AxisAngle4d(baseFacing.x, baseFacing.y, baseFacing.z, theZ );
      Transform3D tempT = new Transform3D();
      tempT.setRotation(connectRotate);
      rotateNode.setTransform(tempT);


       x_last = x;
       y_last = y;
    }




  // METHODS FOR THE ABSOLUTE XY FUNCTION


  public double getX()
 {
  return abs_x;
 }

  public double getY()
 {
  return abs_y;
 }

 public void set_ABS(double x, double y)
 {

  abs_x = x;
  abs_y = y;

  changeTransform_ABS();

 }


  private void changeTransform_ABS()
  // PRE: abs x and y are set
  //POST: transforms the node to be absx and y
  {
        transformX.rotX(abs_x);
        transformY.rotZ(abs_y);



        // Remember old translation

        Vector3d translation = new Vector3d();
        //Matrix3f rotation = new Matrix3f();
        Matrix4d mat = new Matrix4d();

        transformGroup.getTransform(currXform);
        currXform.get(mat);


        // Set Rotation
        currXform.mul(transformX, transformY);

        // Set old translation back
        translation = new Vector3d(mat.m03, mat.m13, mat.m23);
        currXform.setTranslation(translation);

        // Update xform
        transformGroup.setTransform(currXform);

        transformChanged( currXform );

  }


  private void rotateWholeScene_ABS(int x, int y )
// Rotates the whole scene
  {

    int dx, dy;



    if (!reset)
    {


       // calculate Rotation
        dx = x - x_last;
        dy = y - y_last;

        y_angle = dx * x_factor;
        x_angle = dy * y_factor;


        abs_x = abs_x +  x_angle;
        abs_y = abs_y +  y_angle;

        changeTransform_ABS();

     }
     else
     {
         reset = false;
     }

      x_last = x;
      y_last = y;

}





}