package roboforge;

import javax.media.j3d.Transform3D;



public interface BRenderer
{

  // A BRenderer is an entity maintains a set of BRenderables.
  // Typically, the BRenderer also calls BRenderable.render()
  // periodically to perform rendering.

  // Currently implemented by BConsoleCanvas.


  public void addRenderable(BRenderable r);
    // Add r to the set of BRenderables.

  public boolean removeRenderable(BRenderable r);
    // Remove r from the set of BRenderables.

  public void getCameraTransform(Transform3D t);
    // Sets t to this renderer's camera transform.

}