package roboforge;

import javax.media.j3d.*;
import javax.vecmath.*;
//import java.awt.Color;
import java.awt.event.*;
import java.util.Vector;
import com.sun.j3d.utils.geometry.*;
//import roboforge.CHull.*;




public class BShape3D extends Shape3D implements BHighlightShape{

  private BComponent theComponent;
 // private BoundingBox boundingBox;
  private BoundingPolytope bPolyTope;


  // SJS [16/02/2000] - Added support for mulitple selection listeners.
  static private Vector listeners = new Vector();

  static private float vMinX;
  static private float vMinY;
  static private float vMinZ;

  static private float vMaxX;
  static private float vMaxY;
  static private float vMaxZ;

  // DJG June 2001
  static public float boundingRadius = 0.0f; // Metres - For Bounds Test Optimisation

  public static void addActionListener(ActionListener a)
  {
    listeners.add(a);
  }

  public void cleanse()
  {
  //  BDebug.print ("BShape3D cleanse called for shape of " + theComponent);
    theComponent = null;
    bPolyTope = null;
    setAppearance(null);


  }


  public static void removeActionListener(ActionListener a)
  {
    listeners.remove(a);
  }

  protected void fireActionEvent()
  {
    int n = listeners.size();

    ActionListener target = null;

    // SJS [17/02/2000] - Changed object in action evt from node to component.


    // added clause to noy fire if the tree node is null,
    // for old code compatibility
    if (theComponent.getTreeNode() != null)
    {

      ActionEvent e = new ActionEvent(theComponent.getTreeNode(), 1, "Set Component Active");

      for (int i=0; i<n; i++)
      {
        target = (ActionListener) listeners.get(i);


        target.actionPerformed(e);
      }
    }
  }

  public BShape3D(Geometry geometry, Appearance appearance, BComponent newComponent  )
  {
  super(geometry, appearance);

  this.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);

  //BDebug.print("BShape3D component assigned called for " + this + " " + newComponent);
  theComponent = newComponent;

  this.setCapability(Shape3D.ALLOW_GEOMETRY_READ);

  vMinX = Float.MAX_VALUE;
  vMinY = Float.MAX_VALUE;
  vMinZ = Float.MAX_VALUE;

  vMaxX = Float.MIN_VALUE;
  vMaxY = Float.MIN_VALUE;
  vMaxZ = Float.MIN_VALUE;


   if ( geometry instanceof GeometryArray)
   {
      GeometryArray theGA = (GeometryArray) geometry;

      boolean containsTextures = true;


      if ( !(  (theGA.getVertexFormat() & GeometryArray.TEXTURE_COORDINATE_2) != 0 )  )
      {
        BDebug.print ( "BShape3d.constructor WARNING WARNING!!!!! " + newComponent.getName() + " Has No Texture Co-ordinates Defined " );
        containsTextures = false;
      }


        // STRIP CODE
      //BDebug.print ("BShape3D geo is " +   theGA);


      if (geometry instanceof TriangleArray )
      {

        //BDebug.print ("Converting triangle Array to triangle strip array");

        float[]  coords = new float[ theGA.getVertexCount() * 3 ];

        theGA.getCoordinates(0, coords);

        float[] normals = new float[theGA.getVertexCount() * 3 ];
        theGA.getNormals(0, normals);

        GeometryInfo gi = new GeometryInfo(GeometryInfo.TRIANGLE_ARRAY);
        gi.setCoordinates(coords);
        gi.setNormals(normals);

        if (containsTextures)
        {
          float[] texA = new float[theGA.getVertexCount() * 2 ];
          theGA.getTextureCoordinates(0,0, texA);
          gi.setTextureCoordinates2(texA);
        }


        Stripifier st = new Stripifier();
        st.stripify(gi);

        this.setGeometry(gi.getGeometryArray());
      }
      // END STRIP STUFF



      if (!theGA.isLive()  && !theGA.isCompiled())
      {
        theGA.setCapability(GeometryArray.ALLOW_FORMAT_READ);
        theGA.setCapability(GeometryArray.ALLOW_NORMAL_READ);
      }
      int count = theGA.getVertexCount();

      // DJG June 2001
      // Find the outermost point and set bounding radius
      Point3f point = new Point3f();

      // for every point in the Object
      for (int i = 0; i < count ; i++)
      {

        theGA.getCoordinate(i,point);

        vMinY = java.lang.Math.min(vMinY,point.y);
        vMaxY = java.lang.Math.max(vMaxY,point.y);

        vMinX = java.lang.Math.min(vMinX,point.x);
        vMaxX = java.lang.Math.max(vMaxX,point.x);

        vMinZ = java.lang.Math.min(vMinZ,point.z);
        vMaxZ = java.lang.Math.max(vMaxZ,point.z);

      }

      boundingRadius = java.lang.Math.max(vMaxX,vMaxY);
      boundingRadius = java.lang.Math.max(boundingRadius,vMaxZ) * BGlobal.CANVAS_TO_WORLD_SCALE;

      //BDebug.print("BShape3D: Component="+theComponent.toString()+" radius="+boundingRadius);

      /*
      boundingBox = new BoundingBox (new Point3d(vMinX, vMinY, vMinZ) , new Point3d(vMaxX, vMaxY, vMaxZ) );  
      */
      // initial init taken out for BBattleplayer 
      //getConvexHull();



   } // if geoArray
   else
        BDebug.print ("BShape3D.Constructor Assersion faliure :: Geometry is NOT  GeometryArray ");



  }

  /*
  public BoundingBox getBoundingBox()
  {
    return boundingBox;
  }  */


  public boolean getIsPartOfSameBot( BShape3D other )
  {
    return (theComponent.getTreeNode().getRoot() == other.getComponent().getTreeNode().getRoot() ) ;

  }

  public BoundingPolytope  getConvexHull()
  {

   if (bPolyTope == null)
   {


   //   if(!getComponent().getIsConvex())
    //  {
        GeometryArray geo = (GeometryArray)this.getGeometry();
        Point3d pointd = new Point3d();
        int count = geo.getVertexCount();

        geo.getCoordinate(0, pointd);

        BoundingSphere bSp = new BoundingSphere(pointd,0.0001);
        bPolyTope = new BoundingPolytope(bSp);

        for (int i = 0; i < count ; i++)
        {
          geo.getCoordinate(i, pointd);
          bPolyTope.combine(pointd);
        }
   }
/*      }

      else {

        TriangleStripArray geo = (TriangleStripArray)this.getGeometry();

        Point3d point1 = new Point3d();
        Point3d point2 = new Point3d();
        Point3d point3 = new Point3d();
        Point3d point4 = new Point3d();

        Point3d pointd = new Point3d();

        int stripCount = geo.getNumStrips();
        int [] stripVertCounts = new int[stripCount];

        geo.getStripVertexCounts(stripVertCounts);

        int count = geo.getVertexCount();
        int totalPolys = getPolyCount();

        Vector4d [] linearEq = new Vector4d[totalPolys];

        for (int i = 0; i < totalPolys; i++)
          linearEq[i] = new Vector4d();

        geo.getCoordinate(0, pointd);

        int cv = 0; // the current vertex
        int cp = 0; // the current poly
        int cn = 0; // the wind counter

        //BDebug.print("BShape3D - totalPolys = " + totalPolys);
        //BDebug.print("BShape3D - stripCount = " + stripCount);

        //for(int i = 0 ; i < stripCount; i++)
          //BDebug.print("BShape3D - stripvertcount - " + i + " =  " + stripVertCounts[i]);

        for (int i = 0; i < stripCount; i++)
        {
          for(int j = 0; j < stripVertCounts[i]-2; j++)
          {
            geo.getCoordinate(cv, point1);
            geo.getCoordinate(cv, point2);
            geo.getCoordinate(cv+1, point3);
            geo.getCoordinate(cv+2, point4);

            geo.getCoordinate(cv, pointd);

            point1.sub(point3);
            point2.sub(point4);

            Vector3f v1 = new Vector3f(point1);
            Vector3f v2 = new Vector3f(point2);

            Vector3f norm = new Vector3f();

            if(cn % 2 == 0)
              norm.cross(v1,v2);
            else
              norm.cross(v2,v1);

            norm.normalize();

           //BDebug.print("BShape3D - array index = " + cv);
           //BDebug.print("BShape3D - coord = " + pointd.x + ", " + pointd.y + ", " + pointd.z);
           //BDebug.print("BShape3D - vec1 = " + v1.x + ", " + v1.y + ", " + v1.z);
           //BDebug.print("BShape3D - vec2 = " + v2.x + ", " + v2.y + ", " + v2.z);
           //BDebug.print("BShape3D - normals = " + norm.x + ", " + norm.y + ", " + norm.z);
            float d = (norm.x * (float)pointd.x) +
                      (norm.y * (float)pointd.y) +
                      (norm.z * (float)pointd.z);

            //BDebug.print("BShape3D - d = "  + d);

            if(v1.length() == 0.0f || v2.length() == 0.0f)
            {
              linearEq[cp] = linearEq[cp-1];
            }
            else
            {
              linearEq[cp].x = norm.x;
              linearEq[cp].y = norm.y;
              linearEq[cp].z = norm.z;
              linearEq[cp].w = -d;
            }
            cv++;
            cn++;
            cp++;
          }
          cv+=2;
          cn = 0;
        }
        bPolyTope = new BoundingPolytope(linearEq);
      }
      //BDebug.print("BShape3D - actual shape " + geo);
      //BDebug.print("BShape3D - polytope " + (BoundingPolytope)bPolyTope.clone());
    }                    */
    return  bPolyTope;
  }



  // local variables for getConvelHull;

  //private static Point3d p1 = new Point3d();
  //private static Point3d p2 = new Point3d();
  //private static Point3d p3 = new Point3d();

  //private static Vector3d n1 = new Vector3d();
  //private static Vector3d n2 = new Vector3d();
  //private static Vector3d planeNormal = new Vector3d();



    /*
  public BShape3D getConvexShape()
  {
      BDebug.print ("BShape3D.getConvexShape entered " );

     GeometryArray geo = (GeometryArray)this.getGeometry();
     Point3d[] pts = new Point3d[geo.getVertexCount() ];

     for (int i = 0; i < pts.length; i++ )
     {
      pts[i] = new Point3d();
     }

     geo.getCoordinates(0, pts);

     BGiftWrapHull gw = new  BGiftWrapHull(pts)  ;
     TriangleArray ta = gw.build();

     BDebug.print ("BShape3D.getConvexShape exit " );


     return new BShape3D(ta, new Appearance(), theComponent);



  }  */



  /*
   public BoundingPolytope  getConvexHull()
   // pre the BShape3d geometry is guarrenteed to be a trianglestrip aaray
  {

    GeometryArray geo = (GeometryArray)this.getGeometry();
    int count = geo.getVertexCount() /3;
    Vector4d[]  planes = new Vector4d[count];
    BDebug.print("Bshape3D getConvexHull() pre " );


    // for each triangle
    for (int i = 0; i < count; i++)
    {
      // get a point and the 3 normals
      geo.getCoordinate(i * 3, p1);
      geo.getCoordinate(i * 3 + 1, p2);
      geo.getCoordinate(i * 3 + 2, p3);

      // get 2 Vectors on the plane
      n1.sub(p3, p2);
      n2.sub(p2, p1);

      n1.normalize();
      n2.normalize();

      // create the normal for the plane
      planeNormal.cross(  n2, n1);
      planeNormal.normalize();

      // create the plane equation of the plane
      n1.set(p1);
      double dotP =   planeNormal.dot(n1);
      planes[i] = new Vector4d(planeNormal.x, planeNormal.y, planeNormal.z, dotP);



    }

    BoundingPolytope tempP = new BoundingPolytope(planes);

    BDebug.print("Bshape3D " + theComponent + " getConvexHull() planes "  + planes.length);



    return tempP;

  }   */

  //private static Vector3f calculateHeight_tempV = new Vector3f();
  private static Transform3D calculateHeight_tempT = new Transform3D();
  private static Point3f calculateHeight_point = new Point3f();
  private static Point3f calculateHeight_pointOut = new Point3f();
  //private static Transform3D calculateHeight_myT  = new Transform3D();
  //private static Vector3f calculateHeight_myV = new Vector3f();

  public float getLowestY()
  //pre must be Live
  // returns the lowest Y values in canvas units   (Under the scale transform )

  {

    Geometry theFootGeo = getGeometry();
    float minY = Float.MAX_VALUE;

    if (isLive() )
    
    getLocalToVworld(calculateHeight_tempT);


    if ( theFootGeo instanceof GeometryArray)
    {

      GeometryArray theFootGeoArray = (GeometryArray) theFootGeo;
      int count = theFootGeoArray.getVertexCount();

      // for every point in the Object
      for (int i = 0; i < count ; i++)
      {
        theFootGeoArray.getCoordinate(i,calculateHeight_point);

        // Apply the world transform to the point
        calculateHeight_tempT.transform(calculateHeight_point,  calculateHeight_pointOut);

        //get the minimum y value of all the points in this component
        minY = java.lang.Math.min(minY,calculateHeight_pointOut.y);

        //  BDebug.print(" vertex " +  pointOut.toString() );

      }

    }


    return minY;

  }

  private static Transform3D getIsBelowGround_tempT = new Transform3D();
  private static Point3d getIsBelowGround_point = new Point3d();
  private static Point3d getIsBelowGround_pointOut = new Point3d();


   public boolean getIsBelowGround()
  //pre must be Live
  // returns the lowest Y values in canvas units   (Under the scale transform )

  {

    Geometry geo = getGeometry();
    getLocalToVworld(getIsBelowGround_tempT);


    if ( geo instanceof GeometryArray)
    {

      GeometryArray theFootGeoArray = (GeometryArray) geo;
      int count = theFootGeoArray.getVertexCount();

      // for every point in the Object
      for (int i = 0; i < count ; i++)
      {
        theFootGeoArray.getCoordinate(i,getIsBelowGround_point);

        // Apply the world transform to the point
        getIsBelowGround_tempT.transform(getIsBelowGround_point,  getIsBelowGround_pointOut);

        if(getIsBelowGround_pointOut.y < 0)
        {
          getComponent().setCollisionCache( getIsBelowGround_point, null , this ,null );
          return true;
        }
      }

    }
    else
      BDebug.print("BShape3D.getIsBelowGround ASSERTION FALIURE, SHAPE NOT GEO ARRAY ");


    return false;

  }

  private static Point3d outOfBounds_point = new Point3d();
  private static Point3d outOfBounds_point_out = new Point3d();
  private static Transform3D outOfBounds_tempT = new Transform3D();

   public boolean outOfBounds(double distance)
  //pre must be Live
  // returns the lowest Y values in canvas units   (Under the scale transform )

  {

    Geometry geo = getGeometry();
    getLocalToVworld(outOfBounds_tempT);


    if ( geo instanceof GeometryArray)
    {

      GeometryArray theFootGeoArray = (GeometryArray) geo;
      int count = theFootGeoArray.getVertexCount();

      // for every point in the Object
      for (int i = 0; i < count ; i++)
      {
        theFootGeoArray.getCoordinate(i,outOfBounds_point);

        // Apply the world transform to the point
        outOfBounds_tempT.transform(outOfBounds_point,  outOfBounds_point_out);

        if (outOfBounds_point_out.y < BArena.WALL_HEIGHT )
        {
          //double oldY = outOfBounds_point_out.y;
          //outOfBounds_point_out.y = 0;

          //BDebug.print ("BShape3D " +getComponent() + " " + (outOfBounds_point_out.distance(BPhysics.CENTEROFUNIVERSE_D ) * BGlobal.CANVAS_TO_WORLD_SCALE) );

          if (outOfBounds_point_out.distance(BPhysics.CENTEROFUNIVERSE_D )  > distance)
          {
            //outOfBounds_point_out.y = oldY;
            getComponent().setCollisionCache( outOfBounds_point, null , this ,null );

            return true;
          }
         }
         
      }

    }
    else
      BDebug.print("BShape3D.outOfBounds ASSERTION FALIURE, SHAPE NOT GEO ARRAY ");


    return false;

  }





  public void setHighlight(boolean turnOn) {


    if (turnOn)
       {
          //if (connectPoint.active)
          theComponent.setHighlight();

       }
    else
        {
            theComponent.setNormalAppearance();
        }
}



public boolean setActiveArea()
{
  fireActionEvent();
  return true;
}


public BComponent getComponent()
{
  return theComponent;

}


public void setComponent(BComponent newComponent)
{
  //BDebug.print ("setComponent called for " + this + newComponent );
  theComponent = newComponent;

}


/*
 protected void finalize() throws Throwable
  {
    BDebug.print ( "BShape3D.finalize called for Shape3D" );
  }  */

/*
public BBox getBoundingBox()
{
        return boundingBox;
}    */


  public int getPolyCount()
  {

    TriangleStripArray geo = (TriangleStripArray) getGeometry();
   // BDebug.print (theComponent + " geo.getVertexCount() " + geo.getVertexCount() + "geo.getNumStrips() " + geo.getNumStrips());
    return geo.getVertexCount() - ( geo.getNumStrips() * 2);

  }


}