package roboforge;

import javax.media.j3d.*;
//import javax.vecmath.*;

import com.sun.j3d.utils.universe.*;


public class BUniverse extends VirtualUniverse
{

  protected Locale locale;
  protected Viewer viewer;
  protected ViewingPlatform viewingPlatform;

  //protected OrderedGroup  renderGroup;
  protected BranchGroup  renderGroup;

  protected BranchGroup   sceneGroup;
  protected BranchGroup   viewGroup;
  protected BranchGroup   localeGroup;

  // protected BranchGroup   viewTransform;

  public BUniverse(ViewingPlatform vp, Viewer v)
  {
    super();

    viewingPlatform = vp;
    viewer = v;

    locale = new Locale(this);

    renderGroup   = new BranchGroup();
    renderGroup.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
    //renderGroup   = new OrderedGroup();

    sceneGroup    = new BranchGroup();
    //sceneGroup.setCapability(BranchGroup.ALLOW_DETACH);

    localeGroup   = new BranchGroup();
    localeGroup.setCapability(BranchGroup.ALLOW_DETACH);

    // viewGroup     = new BranchGroup();
    // viewTransform = new TransformGroup();

    sceneGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);

    // viewTransform.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    // viewTransform.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);

    localeGroup.addChild(renderGroup);
    renderGroup.addChild(sceneGroup);
    renderGroup.addChild(viewingPlatform);

    // renderGroup.addChild(viewGroup);
    // viewGroup.addChild(viewTransform);
    // viewTransform.addChild(viewingPlatform);

    viewer.setViewingPlatform(viewingPlatform);

    // Finally, add scene-graph to the locale.
    locale.addBranchGraph(localeGroup);
  }

  public void addBranchGraph(BranchGroup bg)
    { sceneGroup.addChild(bg); }

  public Locale getLocale()
    { return locale; }

  public Viewer getViewer()
    { return viewer; }

  public ViewingPlatform getViewingPlatform()
    { return viewingPlatform; }

  public void cleanse()
  {
    sceneGroup = null;
    locale = null;
    viewer = null;
    viewingPlatform = null;
    renderGroup = null;
    sceneGroup = null;
    viewGroup = null;
    localeGroup = null;



  }
}
