package roboforge.ai.actions;

import roboforge.*;

public class BChassisContinualAction implements BAction
{
  private BChassis myChassis;

    public BChassisContinualAction(BChassis myChassis)
    {
      this.myChassis = myChassis;
    }


    public void start()
    {}

    public boolean execute(float s)
    {
      return myChassis.execute(s, 1.0f);

    }

    public void stop()
    {
      myChassis.terminateChassisMove(false);
    }

    public boolean conflictsWith(BAction a)
    {

      if (a instanceof BChassisContinualAction)
      {
        BChassisContinualAction cA =  (BChassisContinualAction) a;
        if (cA.myChassis == this.myChassis)
          return true;
      }

      return false;

    }


  public boolean overrides(BAction a)
  { return false; }

  public String getName()
  {
    return new String( "continual chassis move for " + myChassis );
  }

  public boolean isValid()
  {
    return true;
  }

} 