package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BDiv extends BNumericBinaryOp
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  public BDiv()
    { super(); }

  public BDiv(BDiv o)
    { super(o); }

  public BDiv(BExpression l, BExpression r)
    { super(l, r); }

  public Object clone()
    { return new BDiv(this); }

  public BValue combine(BValue l, BValue r)
  {
    if (l.isNumber() && r.isNumber())
    {
      double lv = ((BNumber) l).getValue();
      double rv = ((BNumber) r).getValue();

      if (rv == 0.0)
        // TODO: throw new BEvaluationException("Divide by 0");
        return BValue.UNDEFINED;

      value.setValue(lv / rv);
      return value;
    }
    else
      return BValue.UNDEFINED;
  }

  public String getName()
    { return "/"; }

}

