package roboforge.ai.expressions;

import roboforge.ai.values.*;
import java.io.Serializable;


public abstract class BExpression
  implements BType, Cloneable, Serializable
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  public BExpression()
    { init(); }

  public abstract BValue evaluate();
    // Request that the expression be evaluated.
    // Returns the result of evaluation.

  public abstract int getType();
    // Calculates the type of this expression.

  public void init()
    // Initializes the expression.
    // Must be called after de-serialization.
    { }


  public Object clone()
    // Makes a clone of the given expression.
  {
    try
      { return super.clone(); }
    catch (CloneNotSupportedException e)
      { return null; }
  }

}
