package roboforge.ai.expressions;

import roboforge.ai.values.*;


public abstract class BUnaryOp extends BNonTerminal
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;


  protected BExpression operand;


  public BUnaryOp()
    { super(); }

  public BUnaryOp(BUnaryOp o)
  {
    super();
    this.operand = (o.operand != null) ?
      (BExpression) o.operand.clone() : null;
  }

  public BUnaryOp(BExpression operand)
  {
    super();
    this.operand = operand;
  }

  public void init()
  {
    super.init();

    if (operand != null)
      operand.init();
  }

  public BExpression getOperand()
    { return this.operand; }

  public void setOperand(BExpression operand)
    { this.operand = operand; }


  public BValue evaluate()
  {
    BValue o = operand.evaluate();
    return apply(o);
  }

  protected abstract BValue apply(BValue o);


  public int getType()
  {
    int o = operand.getType();
    return applyType(o);
  }

  protected abstract int applyType(int o);


  public String toString()
  {
    if (operand == null)
      return getName();
    else
      return getName()+ " "+ operand;
  }

  public abstract String getName();

}
