package roboforge.ai.orient;

import roboforge.*;


public class BSearch_RotateTowardsCenter extends BOrientSearchPattern
{
  static final long serialVersionUID = -1L;

  public BSearch_RotateTowardsCenter()
    { }

  public String getName()
    { return "Rotate towards center of arena"; }

  public boolean stopOrient()
    { return false; }

  public boolean executeOrient()
    { return false; }

  public void executeSearch ( float s, BBot theBot )
  {
      float angleToCenter = BPhysics.angleFrom( theBot.getArenaPosition(), BPhysics.CENTREOBJECTPOSITION );

      int rotateDir;
      if (angleToCenter > 180)
        rotateDir = BMoveList.CHASSIS_ROTATE_LEFT;
      else
        rotateDir = BMoveList.CHASSIS_ROTATE_RIGHT;

      theBot.getChassis().setNewChassisMove(theBot.getChassis().getChassisMoveList().getMove(rotateDir), 360,   BChassis.ADD_MODE_PASSIVE, null );

  }

  public boolean equals(Object o)
    { return (o instanceof BSearch_RotateTowardsCenter); }


}


