package roboforge.animation;

public class BAnimationLoop extends BAbstractAnimation
{

  public static final int FOREVER = Integer.MAX_VALUE;


  protected BAnimation animation;
  protected int n, current;


  public BAnimationLoop()
    { this(null, FOREVER); }

  public BAnimationLoop(BAnimation animation)
    { this(animation, FOREVER); }


  public BAnimationLoop(BAnimation animation, int n)
  {
    this.animation = animation;
    this.n         = n;
  }

  public void setAnimation(BAnimation animation)
	  { this.animation = animation; }

  public void start()
  {
    super.start();
    current = 0;

    if (animation != null)
	    animation.start();
  }

  public boolean animate()
  {
  	if (animation == null)
    	return false;

    if (current >= n)
      return false;

    if (animation.animate())
      return true;
    else
    {
      animation.stop();
      current++;

      if (current >= n)
        return false;

      animation.start();
      return true;
    }
  }

  public void stop()
  {
    super.stop();

    if (current < n)
      animation.stop();
  }


}