package roboforge.animation;

import java.util.*;



public class BAnimationSet extends BAnimationCollection
{

  // BAnimationSet keeps track of a set of animations,
  // and issues the correct messages to each animation.

  public BAnimationSet()
    { super(); }

  public BAnimationSet(int n)
    { super(n); }


  protected void startSlot(BAnimationSlot slot, int i)
  {
    slot.isActive = true;
    slot.animation.start();
  }

  protected boolean animateSlot(BAnimationSlot slot, int i)
  {
    if (!slot.isActive)
      return false;
    else if (slot.animation.animate())
      return true;
    else
    {
      slot.animation.stop();
      slot.isActive = false;
      return false;
    }
  }

  protected void stopSlot(BAnimationSlot slot, int i)
  {
    if (slot.isActive)
    {
      slot.animation.stop();
      slot.isActive = false;
    }
  }


}