package roboforge.animation;



import roboforge.*;

public class BSleepingThreadAnimator extends BAbstractAnimatorAdapter implements  Runnable
{
  private int sleepTime;
  private int priority ;

   public BSleepingThreadAnimator( int sleepTime)
  {
    this(sleepTime, false);
  }

  public BSleepingThreadAnimator( int sleepTime, boolean autoActive)
  {
    super(autoActive);
    this.sleepTime = sleepTime;
  }

  public void run()
  {

    while (active)
    {
        animate();

        try{ Thread.currentThread().sleep(sleepTime); }
          catch (Exception e) { e.printStackTrace(); }

    }

  }

  public void setThreadPriority(int priority)
  {
    this.priority = priority;
  }

  public void start()
  {
    if(!active)
    {
      super.start();
      Thread runner = new Thread(this);
      if(priority > 0)
        runner.setPriority(priority);
      runner.start();
    }
  }


}

/*
  public void start();  // start the animations

  public void stop();  // stop the animations

  public void add( BAnimation a); // add a animation

  public void remove( BAnimation b); // remove the animation

  public void clear(); // clear all animations
*/