package roboforge.btree;


import roboforge.*;
import java.util.*;

public class BComponentNode extends BTreeNode
// DO NOT SERIALIZE
{

  private BComponent component;

  public BComponentNode()
  {};
  
  public BComponentNode(BComponent c)
  {
     setComponent(c);
  }

  public void setState (Object s )
  {
    if (s instanceof BComponent )
      setComponent((BComponent) s);
    else
      BDebug.print ("BComponentNode ASSERTION FALIURE :: setSate is not instance of BComponent ");
  }

  public Object getState ()
  { return component; }

  public void setComponent(BComponent c)
  {
    component = c;

    // Set the component to point to its TreeNode.
    c.setTreeNode(this);

    super.setUserObject(c);
  }

  public BComponent getComponent()
  { return component ; }


  public Object clone()
  {
    BComponent c = (BComponent) component.clone();

    if (component.getBot() != null)
      c.setName(c.getName().substring(c.getName().indexOf(" "))   );

    return  new  BComponentNode( c );

  }


} 