package roboforge.btree;

import javax.swing.tree.*;
import roboforge.*;


import java.io.*;

public class BComponentTree extends BSerializableTree implements Serializable
{
  static final long serialVersionUID = -1L;
  private int componentCount = 0;

  public BComponentTree(BComponent component)
  {
    this(new BComponentNode(component) );
  }

   public BComponentTree(BComponentNode node)
  {
    super(node );
    componentCount++;
  }


  public void addComponent(BComponent componentToAdd, BComponentNode parentTreeNode)
  {
    if (componentToAdd != null)
    {
      componentToAdd.setName("C" + componentCount + " " + componentToAdd.getName().trim()   );
      componentCount ++;


      BComponentNode branch = new BComponentNode(componentToAdd);
      parentTreeNode.add(branch);
    }
  }

  public void deleteComponent(DefaultMutableTreeNode nodeToDelete)
  {
    nodeToDelete.removeFromParent();
  }











}


