package roboforge.btree;

import roboforge.*;

import java.io.*;
import javax.swing.tree.*;
import java.util.*;

public class BSerializableTree implements Serializable
{
  protected transient BTreeNode root;
  private Vector seralizedVector;  // a Vector of
  static final long serialVersionUID = -1L;

  public BSerializableTree()
    { }

  public BSerializableTree(BTreeNode root)
    { this.root = root; }

  public void setRoot(BTreeNode root)
    { this.root = root; }

  public BTreeNode getRoot()
    { return root;}

  private static HashMap items = new HashMap();
  // the hashmap is static so if you have the subtree's in separate places,
  // the tree nodes are still the same


  private void writeObject (ObjectOutputStream stream) throws IOException
  {

   seralizedVector = new Vector();
   BTreeNode rootNode = root;

   Object item, parentItem;
   String className;

   for (Enumeration children = rootNode.breadthFirstEnumeration(); children.hasMoreElements() ;)
   {
        BTreeNode child  = (BTreeNode) children.nextElement();
        BTreeNode parent = (BTreeNode) child.getParent();

        className = child.getClass().getName();
        item = child.getState();
        items.put(child, item);

        if (parent != null)
          parentItem = items.get(parent);
        else
          parentItem = null;

        seralizedVector.add(new BTreePair(item, parentItem, className));
   }

   stream.defaultWriteObject();
  }

  private static HashMap processedNodes = new HashMap();
  // the hashmap is static so if you have the subtree's in separate places,
  // the tree nodes are still the same
  private void readObject (ObjectInputStream stream) throws Exception
  {
    stream.defaultReadObject();

    Class c;
    BTreePair savedPair;
    BTreeNode node, parentNode;



    // create the tree
    for (int i = 0; i < seralizedVector.size(); i++)
    {
      // create Node
      savedPair =  (BTreePair) seralizedVector.get(i);

      // check the cache to see if this item has been processed
      node = (BTreeNode) processedNodes.get(savedPair.getItem() );

      if (node != null)
      {
        if (i == 0)
          root = node;
        else
        {
          if (node.getParent() != null)
          {
            parentNode = (BTreeNode) processedNodes.get(savedPair.getParent());
            parentNode.add(node);
          }
        }

      }
      else
      {
        c = Class.forName(savedPair.getTreeClassName());
        node = (BTreeNode)c.newInstance();
        node.setState( savedPair.getItem() );

        // add to parent
        if (i == 0)
          root = node;
        else
        {
          parentNode = (BTreeNode) processedNodes.get(savedPair.getParent());
          parentNode.add(node);
        }

        //add to processList
        processedNodes.put(savedPair.getItem(), node);
      }


    }

    seralizedVector = null;
  }


  public static void clearCache()
  {
    items.clear();
    processedNodes.clear();
  }


}