package roboforge.geometry;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.Color;
import java.awt.event.*;
import java.util.*;


public class BBox extends Shape3D
{

   double diagonalDistance;

   // 2 diagonals
   Point3d lowerPt ;
   Point3d upperPt ;

   public BBox(double xsize, double ysize, double zsize)
   {
        this( -xsize/2.0,  -ysize/2.0,  -zsize/2.0,xsize/2.0,  ysize/2.0,  zsize/2.0);
   }


    public BBox(double xmin, double ymin, double zmin, double xmax, double ymax, double zmax)
    {
	      super();

        // the 2 diagonals
        lowerPt = new Point3d(xmin, ymin, zmin);
        upperPt = new Point3d(xmax, ymax, zmax);
        //pC = new Point3d(xmin, ymin, zmax);
        // = new Point3d(xmax, ymax, zmin);


        //QuadArray box = new QuadArray(24, QuadArray.COORDINATES | QuadArray.TEXTURE_COORDINATE_2 | QuadArray.NORMALS | QuadArray.COLOR_3 );

	      QuadArray box = new QuadArray(24, QuadArray.COORDINATES | QuadArray.TEXTURE_COORDINATE_2 | QuadArray.NORMALS );




        float noBoarder = 0.3f;

        TexCoord2f texCoord[] = {
                          new TexCoord2f(0.0f, 0f),
                          new TexCoord2f(1.0f , 0.0f),
                          new TexCoord2f(1.0f , 1.0f),
                          new TexCoord2f(0f, 1.0f)
                           };
       /*

        // 0.18f;
        float border = 0.12f;
        Point2f texCoord[] = {
                          new Point2f(border, border),
                          new Point2f(1.0f - border, border),
                          new Point2f(1.0f- border, 1.0f- border) ,
                          new Point2f(border, 1.0f - border)
                           };   */

	      Point3d verts[] = new Point3d[24];
        Vector3f[] normals = new Vector3f[6];


	      // front face
	      verts[0] = new Point3d(xmax, ymin, zmax);
	      verts[1] = new Point3d(xmax, ymax, zmax);
	      verts[2] = new Point3d(xmin, ymax, zmax);
	      verts[3] = new Point3d(xmin, ymin, zmax);
        normals[0] = new Vector3f(0,0,1f);

	        // back face
	      verts[4] = new Point3d(xmin, ymin, zmin);
	      verts[5] = new Point3d(xmin, ymax, zmin);
	      verts[6] = new Point3d(xmax, ymax, zmin);
	      verts[7] = new Point3d(xmax, ymin, zmin);
        normals[1] = new Vector3f(0,0,-1f);
	      // right face
        verts[8] = new Point3d(xmax, ymin, zmin);
	      verts[9] = new Point3d(xmax, ymax, zmin);
	      verts[10] = new Point3d(xmax, ymax, zmax);
	      verts[11] = new Point3d(xmax, ymin, zmax);
        normals[2] = new Vector3f(1f,0,0);
	      // left face
	      verts[12] = new Point3d(xmin, ymin, zmax);
	      verts[13] = new Point3d(xmin, ymax, zmax);
	      verts[14] = new Point3d(xmin, ymax, zmin);
	      verts[15] = new Point3d(xmin, ymin, zmin);
        normals[3] = new Vector3f(-1f,0,0);

	      // top face
	      verts[16] = new Point3d(xmax, ymax, zmax);
      	verts[17] = new Point3d(xmax, ymax, zmin);
	      verts[18] = new Point3d(xmin, ymax, zmin);
	      verts[19] = new Point3d(xmin, ymax, zmax);
        normals[4] = new Vector3f(0,1f,0);

	      // bottom face
	      verts[20] = new Point3d(xmin, ymin, zmax);
	      verts[21] = new Point3d(xmin, ymin, zmin);
	      verts[22] = new Point3d(xmax, ymin, zmin);
	      verts[23] = new Point3d(xmax, ymin, zmax);
        normals[5] = new Vector3f(0,-1f,0);

	      box.setCoordinates(0, verts);
        box.setNormals(0, normals);


        setGeometry(box);
        box.setCapability(Geometry.ALLOW_INTERSECT);
        box.setCapability(QuadArray.ALLOW_COUNT_READ);
        box.setCapability(GeometryArray.ALLOW_COORDINATE_READ);

        for (int i = 4; i < 24; i++)
        {
            box.setTextureCoordinate(0,i, texCoord[i%4]);

         }

         box.setTextureCoordinate(0,0, texCoord[0]);
         box.setTextureCoordinate(0,1, texCoord[0]);
         box.setTextureCoordinate(0,2, texCoord[0]);
         box.setTextureCoordinate(0,3, texCoord[0]);



        //

    }


    public void cleanse()
      { setAppearance(null); }

    public double getDiagonalDistance()
    {

      return diagonalDistance;

    }

    public Point3d getUpper()
      { return upperPt; }

    public Point3d getLower()
      {return lowerPt; }

}