package roboforge.internal;

import java.awt.*;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import javax.swing.border.*;
import javax.swing.plaf.metal.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.applet.*;  // For Audio Clip playing
import java.net.*;     // for URL processing
import java.util.*;
import javax.swing.text.JTextComponent;
import javax.swing.text.PlainDocument;

import javax.swing.BorderFactory;

import javax.swing.tree.*;
import roboforge.btree.*;
import roboforge.ai.*;
import roboforge.ai.memory.*;

import roboforge.ui.components.BFloatField;
import roboforge.ui.components.*;
import roboforge.ui.*;

import roboforge.BGlobal;
import roboforge.BDebug;
import roboforge.BBotWizardCanvas;
import roboforge.BWizardTemplateBot;
import roboforge.BBot;
import roboforge.BWizardMemoryOptions;
import roboforge.BWizardBlockOptions;
import roboforge.BWizardLimbOptions;
import roboforge.BWizardLimb;
import roboforge.BShape3D;
import roboforge.BComponent;
import roboforge.BFileFilter;
import roboforge.BTextures;
import roboforge.BTheme;

public class BWizEditor  extends JPanel implements ActionListener, ListSelectionListener, MouseListener, KeyListener, ChangeListener, FocusListener
{

  protected BUIResources res = new BUIResources( new Object[]
  {
    "newWizButton.text",                "New Wizard",
    "newWizButton.width",               new Integer(170),
    "newWizButton.height",              new Integer(20),

    "loadWizButton.text",               "Load Wizard",
    "loadWizButton.width",              new Integer(170),
    "loadWizButton.height",             new Integer(20),

    "saveWizButton.text",               "Save Wizard",
    "saveWizButton.width",              new Integer(170),
    "saveWizButton.height",             new Integer(20),

    "saveRecBotButton.text",            "Save Rec. Bot",
    "saveRecBotButton.width",           new Integer(170),
    "saveRecBotButton.height",          new Integer(20),

    "moveUpButton.text",                "Move Up",
    "moveUpButton.width",               new Integer(150),

    "moveDownButton.text",              "Move Down",
    "moveDownButton.width",             new Integer(150),

    "remLimbButton.text",               "Rem Limb",
    "remLimbButton.width",              new Integer(95),

    "addLimbButton.text",               "Add Limb",
    "addLimbButton.width",              new Integer(95),

    "addCatButton.text",                "Add Cat.",
    "addCatButton.width",               new Integer(95),

    "remCatButton.text",                "Rem Cat.",
    "remCatButton.width",               new Integer(95),

    "remBehaviorButton.text",           "Remove from Wizard",
    "remBehaviorButton.width",          new Integer(200),

    "allowNoLimbsCheck.text",           "Allow no limbs",
    "allowNoLimbsCheck.width",          new Integer(150),

    "catField.width",                   new Integer(200),

    "limbField.width",                  new Integer(200),

    "limbAreaScroll.width",             new Integer(200),
    "limbAreaScroll.height",            new Integer(84),

    "catScroll.width",                  new Integer(200),
    "catScroll.height",                 new Integer(154),

    "limbScroll.width",                 new Integer(200),
    "limbScroll.height",                new Integer(154),

    "behaviorScroll.width",             new Integer(200),
    "behaviorScroll.height",            new Integer(154),

    "addedBehaviorScroll.width",        new Integer(200),
    "addedBehaviorScroll.height",       new Integer(118),

    "titleLabel.text",                  "Wizard Editor",
    "titleLabel.width",                 new Integer(250),
    "titleLabel.fontname",              "Arial",
    "titleLabel.fontsize",              new Integer(24),
    "titleLabel.fontstyle",             new Integer(2),
    "titleLabel.height",                new Integer(28),
    "titleLabel.antialiased",           Boolean.TRUE,

    "savedLabel.text",                  "",
    "savedLabel.width",                 new Integer(150),
    "savedLabel.fontname",              "Arial",
    "savedLabel.fontsize",              new Integer(18),
    "savedLabel.fontstyle",             new Integer(1),
    "savedLabel.height",                new Integer(28),
    "savedLabel.antialiased",           Boolean.TRUE,

    "addBlockButton.text",              "Add bloc",
    "addBlockButton.width",             new Integer(95),

    "remBlockButton.text",              "Rem bloc",
    "remBlockButton.width",             new Integer(95),

    "addBlockCatButton.text",           "Add Cat.",
    "addBlockCatButton.width",          new Integer(95),

    "remBlockCatButton.text",           "Rem Cat.",
    "remBlockCatButton.width",          new Integer(95),

    "moveUpBlockButton.text",           "u",
    "moveUpBlockButton.width",          new Integer(42),
    "moveUpBlockButton.height",         new Integer(50),

    "moveDnBlockButton.text",           "d",
    "moveDnBlockButton.width",          new Integer(42),
    "moveDnBlockButton.height",         new Integer(50),

    "blockScroll.width",                new Integer(200),
    "blockScroll.height",               new Integer(118),

    "blockCatScroll.width",             new Integer(200),
    "blockCatScroll.height",            new Integer(154),

    "blockDescScroll.width",            new Integer(145),
    "blockDescScroll.height",           new Integer(95),

    "blockCatField.width",              new Integer(200),
  });


 BBotWizardCanvas bot3dCanvas;

 BWizardTemplateBot currentBot ;

 TitledBorder catBorder = BorderFactory.createTitledBorder("Limb Categories");
 TitledBorder limbBorder = BorderFactory.createTitledBorder("Limbs");
 TitledBorder blockBorder = BorderFactory.createTitledBorder("Blocks");
 TitledBorder optionsBorder = BorderFactory.createTitledBorder("Options");
 TitledBorder viewBorder = BorderFactory.createTitledBorder("3D View");

 BLabel titleLabel = new BLabel(res, "titleLabel");
 BLabel savedLabel = new BLabel(res, "savedLabel");

 BButton newWizButton = new BButton(res, "newWizButton");
 BButton loadWizButton = new BButton(res, "loadWizButton");
 BButton saveWizButton = new BButton(res, "saveWizButton");
 BButton saveRecBotButton = new BButton(res, "saveRecBotButton");
 BButton moveUpButton = new BButton(res, "moveUpButton");
 BButton moveDownButton = new BButton(res, "moveDownButton");
 BButton addCatButton = new BButton(res, "addCatButton");
 BButton remCatButton = new BButton(res, "remCatButton");
 BButton remLimbButton = new BButton(res, "remLimbButton");
 BButton addLimbButton = new BButton(res, "addLimbButton");
 //BButton remBehaviorButton = new BButton(res, "remBehaviorButton");

 BButton addBlockButton = new BButton(res, "addBlockButton");
 BButton remBlockButton = new BButton(res, "remBlockButton");
 BButton addBlockCatButton = new BButton(res, "addBlockCatButton");
 BButton remBlockCatButton = new BButton(res, "remBlockCatButton");
 BButton moveUpBlockButton = new BButton(res, "moveUpBlockButton");
 BButton moveDnBlockButton = new BButton(res, "moveDnBlockButton");

 BCheckBox allowNoLimbsCheck = new BCheckBox(res, "allowNoLimbsCheck");

 BList catList = new BList();
 BList limbList = new BList();
 BList behaviorList = new BList();
 BList addedBehaviorList = new BList();

 BList blockList = new BList();
 BList blockCatList = new BList();

 BScrollPane catScroll = new BScrollPane(res, "catScroll");
 BScrollPane limbScroll = new BScrollPane(res, "limbScroll");
 BScrollPane limbAreaScroll = new BScrollPane(res, "limbAreaScroll");
 BScrollPane behaviorScroll = new BScrollPane(res, "behaviorScroll");
 BScrollPane addedBehaviorScroll = new BScrollPane(res, "addedBehaviorScroll");

 BScrollPane blockScroll = new BScrollPane(res, "blockScroll");
 BScrollPane blockCatScroll = new BScrollPane(res, "blockCatScroll");
 BScrollPane blockDescScroll = new BScrollPane(res, "blockDescScroll");

 BTextField catField = new BTextField(res, "catField");
 BTextField limbField = new BTextField(res, "limbField");
 BTextField blockCatField = new BTextField(res, "blockCatField");
 BTextArea limbArea = new BTextArea(res, "limbArea");
 BTextArea blockDescArea = new BTextArea(res, "blockDescArea");

 private int FILEBUTTONWIDTH = 200;
 private int FILEBUTTONHEIGHT = 30;

 private static int COLUMNWIDTH = 200;
 private static int COLUMN1  = 610;
 private static int COLUMN2  = COLUMN1 + COLUMNWIDTH;
 private static int LISTBOXSIZE = 150;

 private boolean addedCanvas = false;


  // constructor
  public BWizEditor()
  {
    bot3dCanvas = new BBotWizardCanvas(true, null, null);
    bot3dCanvas.setCursor(new Cursor(Cursor.HAND_CURSOR));
    bot3dCanvas.setBackground(new Color(51, 51, 102));

    layoutWizEditorChildren();
    configWizEditorChildren();
  }


  // layout the components
  private void layoutWizEditorChildren()
  {

    int strutSize = 5;  // set the strut size

    BBoxPanel mainBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel leftBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel rightBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel viewBoxX = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel viewBoxY = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel optionsBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel optionsLBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel optionsRBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel labelBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel catBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel catOptBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel catButtonBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel limbBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel limbOptBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel limbButtonBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel blockBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel blockLBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel blockRBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel blockConBox = new BBoxPanel(BoxLayout.X_AXIS);

    mainBox.add(leftBox);
    mainBox.addHStrut(strutSize*2);
    mainBox.add(rightBox);

    leftBox.add(viewBoxY);
    leftBox.addVStrut(strutSize*2);
    leftBox.add(optionsBox);
    leftBox.addVStrut(strutSize*2);
    leftBox.add(labelBox);

    viewBoxY.addVStrut(strutSize);
    viewBoxY.add(viewBoxX);
    viewBoxY.addVStrut(strutSize);
    viewBoxY.setBorder(viewBorder);

    viewBoxX.addHStrut(strutSize);
    viewBoxX.add(bot3dCanvas);
    viewBoxX.addHStrut(strutSize);

    optionsBox.addHStrut(strutSize*8);
    optionsBox.add(optionsLBox);
    optionsBox.addHStrut(strutSize*4);
    optionsBox.add(optionsRBox);
    optionsBox.addHStrut(strutSize*8);
    optionsBox.setBorder(optionsBorder);

    labelBox.add(titleLabel);
    labelBox.add(savedLabel);

    rightBox.add(catBox);
    rightBox.addVStrut(strutSize);
    rightBox.add(limbBox);
    rightBox.addVStrut(strutSize);
    rightBox.add(blockBox);

    catScroll.getViewport().setView(catList);
    catBox.addHStrut(strutSize);
    catBox.add(catScroll);
    catBox.addHStrut(strutSize*2);
    catBox.add(catOptBox);
    catBox.addHStrut(strutSize);
    catBox.setBorder(catBorder);

    catOptBox.add(catField);
    catOptBox.addVStrut(strutSize*2);
    catOptBox.add(moveUpButton);
    catOptBox.add(moveDownButton);
    catOptBox.addVStrut(strutSize*2-2);
    catOptBox.add(allowNoLimbsCheck);
    catOptBox.addVStrut(strutSize*2-3);
    catOptBox.add(catButtonBox);
    catOptBox.addVStrut(strutSize);

    catButtonBox.add(addCatButton);
    catButtonBox.addHStrut(strutSize*2);
    catButtonBox.add(remCatButton);


    limbScroll.getViewport().setView(limbList);
    limbBox.addHStrut(strutSize);
    limbBox.add(limbScroll);
    limbBox.addHStrut(strutSize*2);
    limbBox.add(limbOptBox);
    limbBox.addHStrut(strutSize);
    limbBox.setBorder(limbBorder);

    limbAreaScroll.getViewport().setView(limbArea);
    limbOptBox.add(limbField);
    limbOptBox.addVStrut(strutSize*2);
    limbOptBox.add(limbAreaScroll);
    limbOptBox.addVStrut(strutSize*2);
    limbOptBox.add(limbButtonBox);
    limbOptBox.addVStrut(strutSize);

    limbButtonBox.add(addLimbButton);
    limbButtonBox.addHStrut(strutSize*2);
    limbButtonBox.add(remLimbButton);


/*
    behaviorScroll.getViewport().setView(behaviorList);
    addedBehaviorScroll.getViewport().setView(addedBehaviorList);
    behaviorBox.addHStrut(strutSize);
    behaviorBox.add(behaviorScroll);
    behaviorBox.addHStrut(strutSize*2);
    behaviorBox.add(behaviorRBox);
    behaviorBox.setBorder(behaviorBorder);
    behaviorBox.addHStrut(strutSize);

    behaviorRBox.add(addedBehaviorScroll);
    behaviorRBox.addVStrut(strutSize);
    behaviorRBox.add(remBehaviorButton);
    behaviorRBox.addVStrut(strutSize);
*/
    blockScroll.getViewport().setView(blockList);
    blockCatScroll.getViewport().setView(blockCatList);
    blockDescScroll.getViewport().setView(blockDescArea);

    blockBox.setBorder(blockBorder);
    blockBox.add(blockLBox);
    blockBox.add(blockCatScroll);
    blockBox.add(blockRBox);

    blockLBox.add(blockScroll);
    blockLBox.addSmallMargin();
    blockLBox.addLinear(addBlockButton, blockLBox.getSmallMargin(), remBlockButton);
    blockLBox.addTinyMargin();

    blockRBox.add(blockCatField);
    blockRBox.addSmallMargin();
    blockRBox.add(blockConBox);
    blockRBox.addSmallMargin();
    blockRBox.addLinear(addBlockCatButton, blockRBox.getSmallMargin(), remBlockCatButton);
    blockRBox.addTinyMargin();

    blockConBox.addLinear(moveUpBlockButton, blockConBox.getSmallMargin(), moveDnBlockButton);
    blockConBox.add(blockDescScroll);

    optionsLBox.addVStrut(strutSize);
    optionsLBox.add(newWizButton);
    optionsLBox.addVStrut(strutSize);
    optionsLBox.add(loadWizButton);
    optionsLBox.addVStrut(strutSize);
    optionsLBox.add(saveWizButton);
    optionsLBox.addVStrut(strutSize);
    optionsLBox.add(saveRecBotButton);
    optionsLBox.addVStrut(strutSize);

/*
    optionsRBox.addVStrut(strutSize);
    optionsRBox.add(saveWizButton);
    optionsRBox.addVStrut(strutSize);
    optionsRBox.add(saveRecBotButton);
    optionsRBox.addVStrut(strutSize);
*/
    this.add(mainBox);
  }

  // configure the components
  private void configWizEditorChildren()
  {
    limbArea.setBackground(new Color(51, 51, 102));
    catList.setBackground(new Color(51, 51, 102));
    limbList.setBackground(new Color(51, 51, 102));
    behaviorList.setBackground(new Color(51, 51, 102));
    addedBehaviorList.setBackground(new Color(51, 51, 102));
    catField.setBackground(new Color(51, 51, 102));
    limbField.setBackground(new Color(51, 51, 102));

    limbArea.setForeground(new Color(200, 200, 220));
    catList.setForeground(new Color(200, 200, 220));
    limbList.setForeground(new Color(200, 200, 220));
    behaviorList.setForeground(new Color(200, 200, 220));
    addedBehaviorList.setForeground(new Color(200, 200, 220));
    catField.setForeground(new Color(200, 200, 220));
    limbField.setForeground(new Color(200, 200, 220));
    catField.setCaretColor(new Color(200, 200, 220));
    limbField.setCaretColor(new Color(200, 200, 220));
    limbArea.setCaretColor(new Color(200, 200, 220));

    blockList.setBackground(new Color(51, 51, 102));
    blockList.setForeground(new Color(200, 200, 220));
    blockCatList.setBackground(new Color(51, 51, 102));
    blockCatList.setForeground(new Color(200, 200, 220));

    blockCatField.setBackground(new Color(51, 51, 102));
    blockCatField.setForeground(new Color(200, 200, 220));
    blockCatField.setCaretColor(new Color(200, 200, 220));

    blockDescArea.setBackground(new Color(51, 51, 102));
    blockDescArea.setForeground(new Color(200, 200, 220));
    blockDescArea.setCaretColor(new Color(200, 200, 220));

    limbArea.setLineWrap(true);
    limbArea.setWrapStyleWord(true);

    blockDescArea.setLineWrap(true);
    blockDescArea.setWrapStyleWord(true);

    newWizButton.addActionListener(this);
    loadWizButton.addActionListener(this);
    saveWizButton.addActionListener(this);
    saveRecBotButton.addActionListener(this);

    moveUpButton.addActionListener(this);
    moveDownButton.addActionListener(this);
    addCatButton.addActionListener(this);
    remCatButton.addActionListener(this);

    addLimbButton.addActionListener(this);
    remLimbButton.addActionListener(this);

    //remBehaviorButton.addActionListener(this);

    catList.addListSelectionListener(this);
    catField.addActionListener(this);
    catField.addFocusListener(this);

    behaviorList.addMouseListener(this);
    addedBehaviorList.addMouseListener(this);

    allowNoLimbsCheck.addChangeListener(this);

    limbList.addListSelectionListener(this);
    limbField.addActionListener(this);
    limbField.addFocusListener(this);
    limbArea.addFocusListener(this);

    blockCatField.addActionListener(this);
    blockCatField.addFocusListener(this);

    blockDescArea.addFocusListener(this);

    moveUpBlockButton.addActionListener(this);
    moveDnBlockButton.addActionListener(this);

    addBlockButton.addActionListener(this);
    remBlockButton.addActionListener(this);

    addBlockCatButton.addActionListener(this);
    remBlockCatButton.addActionListener(this);

    blockList.addListSelectionListener(this);
    blockCatList.addListSelectionListener(this);
  }

  // mouseListener methods
  public void mouseClicked(MouseEvent e)
  {
    //if(e.getSource() == behaviorList)
     // chooseBehavior(e);
    //if(e.getSource() == addedBehaviorList)
    //  editBehavior(e);
  }
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}


  // focusListener methods
  public void focusGained(FocusEvent e) {}
  public void focusLost(FocusEvent e)
  {
    if(e.getSource() == catField)
      catNameChanged();
    if(e.getSource() == limbField)
      limbNameChanged();
    if(e.getSource() == limbArea)
      limbDescChanged();
    if(e.getSource() == blockCatField)
      blockCatNameChanged();
    if(e.getSource() == blockDescArea)
      blockDescChanged();
  }

  // listSelectionListener methods
  public void valueChanged(ListSelectionEvent e)
  {
    if(e.getSource() == catList)
      chooseLimbCat();
    if(e.getSource() == limbList)
      chooseLimb();
    if(e.getSource() == blockCatList)
      chooseBlockCat();
  }

  // keyListener methods
  public void keyTyped(KeyEvent e) {}
  public void keyPressed(KeyEvent e) {}
  public void keyReleased(KeyEvent e) {}

  // changeListener methods
  public void stateChanged(ChangeEvent e)
  {
    if(e.getSource() == allowNoLimbsCheck)
      setAllowNoLimb();
  }

  // actionListener methods
  public void actionPerformed(ActionEvent e)
  {

    if(e.getSource() == newWizButton)
      newWizard();
    if(e.getSource() == loadWizButton)
      loadWizard();
    if(e.getSource() == saveWizButton)
      saveWizard();
    if(e.getSource() == saveRecBotButton)
      saveRecBot();
    if(e.getSource() == addLimbButton)
      addLimb();
    if(e.getSource() == remLimbButton)
      remLimb();
    if(e.getSource() == moveUpButton)
      moveCatUp();
    if(e.getSource() == moveDownButton)
      moveCatDown();
    if(e.getSource() == addCatButton)
      addCat();
    if(e.getSource() == remCatButton)
      remCat();
  //  if(e.getSource() == remBehaviorButton)
  //    remBehavior();
    if(e.getSource() == catField)
      catNameChanged();
    if(e.getSource() == limbField)
      limbNameChanged();

    if(e.getSource() == addBlockButton)
      addBlock();

    if(e.getSource() == remBlockButton)
      remBlock();

    if(e.getSource() == addBlockCatButton)
      addCatBlock();

    if(e.getSource() == remBlockCatButton)
      remCatBlock();
    if(e.getSource() == moveUpBlockButton)
      moveCatBlockUp();
    if(e.getSource() == moveDnBlockButton)
      moveCatBlockDn();

  }

  // the limb description has altered
  private void limbDescChanged()
  {
    BWizardLimb currentLimb = (BWizardLimb)limbList.getSelectedValue();
    if (limbList != null) {
      currentLimb.setDescription(limbArea.getText() );
    }
  }

  // makes choosing a limb not necessary
  private void setAllowNoLimb()
  {
    BWizardLimbOptions l = (BWizardLimbOptions) catList.getSelectedValue();
    l.setAllowNoSelection(allowNoLimbsCheck.isSelected());
  }

  // Limb name changed
  private void limbNameChanged()
  {
    BWizardLimb l = (BWizardLimb)limbList.getSelectedValue();
    if (l != null)
    {
      l.setName (limbField.getText());
      limbList.repaint();
    }
  }

  // Category name changed
  private void catNameChanged()
  {
    BWizardLimbOptions l = (BWizardLimbOptions) catList.getSelectedValue();
    if (l != null)
    {
      l.setName (catField.getText());
      catList.repaint();
    }
  }

  private void blockCatNameChanged()
  {
    BWizardBlockOptions b = (BWizardBlockOptions) blockCatList.getSelectedValue();
    if(b != null)
    {
      b.setName(blockCatField.getText());
      blockCatList.repaint();
    }
  }

  private void blockDescChanged()
  {
    BWizardBlockOptions b = (BWizardBlockOptions) blockCatList.getSelectedValue();
    if(b != null)
      b.setDescription(blockDescArea.getText());
  }

  // choose a limb category
  private void chooseLimbCat()
  {
    BWizardLimbOptions l = (BWizardLimbOptions) catList.getSelectedValue() ;
    if (l != null)
    {
      catField.setText(l.toString());
      allowNoLimbsCheck.setSelected(l.getAllowNoSelection() );
      Vector loadVector = l.getLimbs();
      limbList.setListData(loadVector);
    }
  }

  private void chooseBlockCat()
  {
    BWizardBlockOptions b = (BWizardBlockOptions) blockCatList.getSelectedValue();
    if(b != null)
    {
      blockCatField.setText(b.toString());
      blockDescArea.setText(b.getDescription());
      Vector loadVector = b.getBlocks();
      blockList.setListData(loadVector);
    }
  }

  // choose a limb from the list of limbs and add it to the canvas
  private void chooseLimb()
  {
    BWizardLimb l = (BWizardLimb) limbList.getSelectedValue();
    BWizardLimbOptions category = (BWizardLimbOptions) catList.getSelectedValue();
    if (  (l != category.getSelectedLimb() ) && ( l != null)  )
    {
      if (l != null)
        limbField.setText(l.toString());

      // remove the old
      bot3dCanvas.removeLimb(category.getSelectedLimb() );

      // add the new
      category.setSelected(l);
      bot3dCanvas.addLimb(l);

      // Stuff
      if (l.getDescription() != null)
        limbArea.setText(l.getDescription());
      else
        limbArea.setText(new String());
    }
    bot3dCanvas.setCursor(new Cursor(Cursor.HAND_CURSOR));
 }

  // start a new wizard
  private void newWizard()
  {
    BotLoader bl = new BotLoader(true);
    bl.start();
  }

  // load a wizard
  private void loadWizard()
  {
    BotLoader bl = new BotLoader(false);
    bl.start();
  }

  // save a wizard
  private void saveWizard()
  {
    if(saveBot(true, currentBot))
      savedLabel.setText("Wizard Saved");
    else
      savedLabel.setText("");
  }

  // save a reconstituted bot
  private void saveRecBot()
  {
    currentBot.reCreateOriginalWizardBot();
    if(saveBot(false, currentBot))
      savedLabel.setText("Bot Saved");
    else
      savedLabel.setText("");
  }

  // move a category up
  private void moveCatUp()
  {
    BWizardLimbOptions l = (BWizardLimbOptions) catList.getSelectedValue();
    int index =  catList.getSelectedIndex();
    if (l != null)
    {
      currentBot.movePlaceInListTo(l, index - 1);
      if (index > 0)
        catList.setSelectedIndex(index - 1);
      catList.repaint();
    }
  }

  // move a category down
  private void moveCatDown()
  {
    BWizardLimbOptions l = (BWizardLimbOptions) catList.getSelectedValue();
    int index =  catList.getSelectedIndex();
    if (l != null)
    {
      currentBot.movePlaceInListTo(l, index + 1);
      if (index < currentBot.getLimbOptions().size() - 1)
         catList.setSelectedIndex(index + 1);
      catList.repaint();
    }
  }

  // add a category
  private void addCat()
  {
    if(currentBot != null) {
      BWizardLimbOptions l = new BWizardLimbOptions(new Vector());
      Vector loadVector = currentBot.getLimbOptions();
      loadVector.add(l);
      loadOptionCategories();
      catList.setSelectedIndex(loadVector.size() - 1);
      catField.requestFocus();
    }
  }

  // remove a category
  private void remCat()
  {
    if(currentBot != null) {
      Vector loadVector = currentBot.getLimbOptions();
      loadVector.remove((BWizardLimbOptions)catList.getSelectedValue());
      loadOptionCategories();
    }
  }

  // move a category up
  private void moveCatBlockUp()
  {
    BWizardBlockOptions b = (BWizardBlockOptions) blockCatList.getSelectedValue();
    int index =  blockCatList.getSelectedIndex();
    if (b != null)
    {
      currentBot.moveBlockPlaceInListTo(b, index - 1);
      if (index > 0)
        blockCatList.setSelectedIndex(index - 1);
      blockCatList.repaint();
    }
  }

  // move a category down
  private void moveCatBlockDn()
  {
    BWizardBlockOptions l = (BWizardBlockOptions) blockCatList.getSelectedValue();
    int index =  blockCatList.getSelectedIndex();
    if (l != null)
    {
      currentBot.moveBlockPlaceInListTo(l, index + 1);
      if (index < currentBot.getBlockOptions().size() - 1)
         blockCatList.setSelectedIndex(index + 1);
      blockCatList.repaint();
    }
  }

  // add a category
  private void addCatBlock()
  {
    BDebug.print("BWizEditor - Got to the place!");
    if(currentBot != null) {
      BWizardBlockOptions l = new BWizardBlockOptions(new Vector());

      if(currentBot.getBlockOptions() == null)
        currentBot.setBlockOptions(new Vector());

      Vector loadVector = currentBot.getBlockOptions();
      loadVector.add(l);
      //loadOptionCategories();
      blockCatList.setListData(loadVector);
      blockCatList.setSelectedIndex(loadVector.size() - 1);
      blockCatField.requestFocus();
    }
  }

  // remove a category
  private void remCatBlock()
  {
    if(currentBot != null) {
      Vector loadVector = currentBot.getBlockOptions();
      loadVector.remove((BWizardBlockOptions)blockCatList.getSelectedValue());
      loadOptionCategories();
    }
  }

  // add a block
  private void addBlock()
  {

    String  blockPath = BGlobal.BLOCKPATH + "/blocks/";
    String [] suffix = new String[] {BGlobal.BLOCKSUFFIX};
    File startFilePath = new File(blockPath);
    JFileChooser chooser = new JFileChooser(startFilePath);
    BFileFilter filter = new BFileFilter(suffix,blockPath,true);

    chooser.setFileFilter(filter);
    chooser.setSelectedFile(startFilePath);
    chooser.setDialogTitle("Load Block");

    int option = chooser.showSaveDialog(this);

    if (option == JFileChooser.APPROVE_OPTION)
    {
      blockPath = chooser.getSelectedFile().getPath();

      BAIBlock block = BAIBlock.loadFromFile(blockPath);

      BWizardBlockOptions b = (BWizardBlockOptions)blockCatList.getSelectedValue();
      b.addBlock(block);
      Vector loadVector = b.getBlocks();
      blockList.setListData(loadVector);
    }
  }

  public void remBlock()
  {
    BAIBlock b = (BAIBlock) blockList.getSelectedValue();
    BWizardBlockOptions category = (BWizardBlockOptions) blockCatList.getSelectedValue();
    if(b != null)
    {
      category.removeBlock(b);
      Vector loadVector = category.getBlocks();
      blockList.setListData(loadVector);
    }
  }

  // add a limb to a category
  private void addLimb()
  {
    BComponent selectedC = ((BShape3D)bot3dCanvas.getLastSelected()).getComponent();
    BWizardLimb newLimb = new BWizardLimb(selectedC);
    BWizardLimbOptions l = (BWizardLimbOptions)catList.getSelectedValue() ;
    l.addLimb(newLimb);
    bot3dCanvas.removeComponent(selectedC);
    Vector loadVector = l.getLimbs();
    limbList.setListData(loadVector);
    bot3dCanvas.setCursor(new Cursor(Cursor.HAND_CURSOR));
  }

  // remove a limb from a category
  private void remLimb()
  {
    BWizardLimb l = (BWizardLimb) limbList.getSelectedValue();
    BWizardLimbOptions category = (BWizardLimbOptions) catList.getSelectedValue();
    if ( l != null)
    {
      bot3dCanvas.removeLimb(l);
      category.removeLimb(l);
      Vector loadVector = category.getLimbs();
      limbList.setListData(loadVector);
    }
    bot3dCanvas.setCursor(new Cursor(Cursor.HAND_CURSOR));
  }

  // loads a bot
  private  void loadBot(boolean create)
  {
     // BOT LOADING
    if(loadBotFromFile(!create)) {
      BDebug.print ("bot loaded from file ");

      if (currentBot != null)
      {
        if (create)
          currentBot.convertToWizardTemplate();
        BDebug.print ("bot loaded converted ");

        loadBotIntoPanel();
        BDebug.print ("bot loaded loadedIntoPanel ");

        loadOptionCategories();
        BDebug.print ("bot loaded loadedIntoCategories ");
      }

      BDebug.print ("BBotMoveList LOAD botMoveList size "  + currentBot.getMoveList().size()  );
    }
    else
     savedLabel.setText("");
  }


  // initialize lists
  void loadOptionCategories()
  {
     Vector loadVector = currentBot.getLimbOptions();

     catList.setListData(loadVector);

     if(currentBot.getBlockOptions() == null)
       currentBot.setBlockOptions(new Vector());

     Vector blockLoadVector = currentBot.getBlockOptions();

     blockCatList.setListData(blockLoadVector);

     limbField.setText("");
     limbArea.setText("");

     blockCatField.setText("");
     blockDescArea.setText("");

     savedLabel.setText("Wizard Loaded");
  }

  // add the bot to the 3D view
  public void loadBotIntoPanel()
  {
    BComponentTree componentTree = currentBot.getComponentTree();
    ///botTree.setModel((TreeModel) componentTree);
    bot3dCanvas.removeBot();
    // Load the Bot canvas
    bot3dCanvas.addLimb(currentBot.getChassis());
    bot3dCanvas.setCursor(new Cursor(Cursor.HAND_CURSOR));
  }


  // class for loading bots
  class BotLoader extends Thread {

         boolean create;
         BotLoader( boolean create)
         {
          this.create = create;
          this.setPriority(Thread.MAX_PRIORITY);
         }

         public void run()
         {
          BDebug.print ("BotLoader Thread Started ");
          loadBot(create);

          //bot3dCanvas.startRenderer();

          bot3dCanvas.setCursor(new Cursor(Cursor.HAND_CURSOR));
          catList.setSelectedIndex(0);
          blockCatList.setSelectedIndex(0);

          if (!addedCanvas)
          {
            addedCanvas = true;
            // add(v3dPane);

          }
        }
     }

  // attempts to load a bot from file - returns false if load fails
  public boolean loadBotFromFile(boolean isWiz)
  {
        boolean success = true;

        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR )  );

        String  botPath = BGlobal.WIZARDPATH + "wizardbots";

        // Create the File Chooser
        String[] suffix ;

        if (isWiz)
         suffix = new String[] {BGlobal.WIZSUFFIX.substring(1,BGlobal.WIZSUFFIX.length())};
        else
          suffix = new String[] {BGlobal.BOTSUFFIX.substring(1,BGlobal.BOTSUFFIX.length())};

        BFileFilter filter = new BFileFilter(suffix,botPath,true);

        File startFilePath = new File(botPath);
        JFileChooser chooser = new JFileChooser(startFilePath);
        chooser.setFileFilter(filter);
        chooser.setSelectedFile(startFilePath);
        chooser.setDialogTitle("Load Bot Wizard Bot");

        int option = chooser.showSaveDialog(this);

        if (option == JFileChooser.APPROVE_OPTION)
        {
          botPath = chooser.getSelectedFile().getPath();
          BWizardTemplateBot bot;

          bot = (BWizardTemplateBot)BBot.loadFromFile(botPath) ;

          if (bot != null)
            currentBot = bot;
          else {
            BDebug.print ("BOT NOT LOADED");
            success = false;
          }
        }
        else
          success = false;
      setCursor(Cursor.getDefaultCursor() );
      return success;
  }


  // trys to save a wizard as either a normal wizard or a reconstituted bot
  // returns false if the save process fails
  private boolean saveBot(boolean isWiz, BBot botToSave)
  {

   // BDebug.print ("BBotMoveList SAVE botMoveList size "  + currentBot.getMoveList().size()  );
    boolean success = true;

    if (currentBot != null)
    {
      String botPath;

      if (isWiz)
        botPath = BGlobal.WIZARDPATH + "wizardbots";
      else
        botPath = BGlobal.WIZARDPATH + "wizardbots";


      // Create the File Chooser
      String[] suffix ;

      if (isWiz)
        suffix = new String[] {BGlobal.WIZSUFFIX.substring(1,BGlobal.WIZSUFFIX.length())};
      else
        suffix = new String[] {BGlobal.BOTSUFFIX.substring(1,BGlobal.BOTSUFFIX.length())};

      BFileFilter filter = new BFileFilter(suffix,botPath,true);

      File startFilePath = new File(botPath);
      JFileChooser chooser = new JFileChooser(startFilePath);
      chooser.setFileFilter(filter);
      chooser.setSelectedFile(startFilePath);
      chooser.setDialogTitle("Save Wizard Bot");

      int option = chooser.showSaveDialog(this);

      if (option == JFileChooser.APPROVE_OPTION)
      {
        botPath = chooser.getSelectedFile().getPath();
        if (isWiz)
          ((BWizardTemplateBot)botToSave).saveWizardToFile(botPath);
        else
        {
          try
          {
            botToSave.saveToFile(botPath);
          }
          catch (Exception e)
          {
            BDebug.print("BWizEditor.botToSave.saveToFile " + e.getMessage());
            success = false;
          }
        }
      }
      else
        success = false;
    }
    else
      success = false;

    return success;
  }



   private static JFrame currentInstance;

    static public void main(String[] args)
  {
    try
    {

      BGlobal.init();


      // Instantiate Applcation Frame

      //JWindow testW = new JWindow()
      JFrame testW = new JFrame("Wizard Editor")
      {
         protected void processWindowEvent(WindowEvent e)
        {

                super.processWindowEvent(e);
                if (e.getID() == WindowEvent.WINDOW_CLOSING)
                {
                        //BSound.close();
                        //saveBot(true);
                        System.exit(0);
                }
        }
      };

      currentInstance = testW;

      testW.setSize(new Dimension(1024,610));
      testW.setResizable(false);

      BWizEditor b = new BWizEditor();
      BTextures.setListener(testW);

      testW.getContentPane().add(b) ;
      testW.setVisible(true);

    }
    catch (Throwable t)
    {
    }
  }


}
