package roboforge.net.client;

import roboforge.net.*;
import java.security.PublicKey;


public class BRequestHeader extends BMessageHeader
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;

  
  // Member variables...
  // -------------------------------------------------------------

  protected String user;
    // ID of the user that originated this request.

  protected String pass;
    // Password of the user that originated this request.

  protected float clientVersion;
    // The version of Client Software that is sending this request

  // protected PublicKey key;
    // Public key to use when replying to this request.



  // Constructor...
  // -------------------------------------------------------------

  public BRequestHeader
  (
    String type,
    String user,
    String pass
    // PublicKey key
  )
  {
    super(REQ, type);
    this.user = user;
    this.pass = pass;
    clientVersion = roboforge.BGlobal.APP_VERSION;
    // this.key  = key;
  }



  // Accessor methods...
  // -------------------------------------------------------------

  public String toString()
  {
    StringBuffer result
      = new StringBuffer(super.toString());
    
    result.append(", ");
    result.append(user);
    result.append(", ");
    result.append(pass);
    
    return result.toString();
  }
  
  public void setUser(String user)
    { this.user = user; }

  public String getUser()
    { return user; }

  public void setPass(String pass)
    { this.pass = pass; }

  public String getPass()
    { return pass; }

  public float getClientVersion()
    { return clientVersion; }

  /*
  public void setPublicKey(PublicKey key)
    { this.key  = key; }

  public PublicKey getPublicKey()
    { return key; }
  */

}