package roboforge.net.data;

import roboforge.util.data.*;


public class BChallengeRoomData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BChallengeRoomData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.CHALLENGE_ROOM; }


  // Status codes...
  // -------------------------------------------------------------
  public static int SIMULATION_ACCURACY_LOW     = 0;
  public static int SIMULATION_ACCURACY_MEDIUM  = 1;
  public static int SIMULATION_ACCURACY_HIGH    = 2;

  // Data fields...
  // -------------------------------------------------------------

  public String roomName;
  public String roomDescription;
  public int maxNumberOfParticipants;
  public boolean isPassworded;
  public String arena;
  public float maxEntryCost;
  public float maxFightTime;
  public int simulationSpeed;
  // See status codes
  public String password;
  public int currentNoOfPeople;

  
  
  // Accessor methods...
  // -------------------------------------------------------------

  
}
