package roboforge.net.data;

import roboforge.BBot;
import roboforge.util.data.*;

import java.io.*;
import java.util.zip.*;

public class BCreateChallengeData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BCreateChallengeData(long challengerAccountID,BBot bot, String password, long challengeRoomID, long challengedAccountID)
  {
    super(challengerAccountID);
    botName = bot.getName();
    challengerBot = getBotData(bot);
    this.password = password;
    this.challengeRoomID = challengeRoomID;
    this.challengedAccountID = challengedAccountID;
  }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.CR_CREATE_CHALLENGE; }


  // Status codes...
  // -------------------------------------------------------------

  // Data fields...
  // -------------------------------------------------------------

  public byte[] challengerBot;
  public String password;
  public long challengeRoomID;
  public long challengedAccountID;
  // The account ID of the person challenged
  public String botName;

  // Accessor methods...
  // -------------------------------------------------------------


  // Implementation methods...
  // -------------------------------------------------------------

  protected byte[] getBotData(BBot bot)
  {
    try
    {
      ByteArrayOutputStream bytes =
        new ByteArrayOutputStream();

      GZIPOutputStream zip =
        new GZIPOutputStream(bytes);
          
      ObjectOutputStream out = 
        new ObjectOutputStream(zip);

      out.writeObject(bot);
      out.close();
    
      byte[] result =
        bytes.toByteArray();

      return result;
    }
    catch (Exception e)
      { throw new RuntimeException(""+ e); }
  }
}
