package roboforge.net.data;


import java.io.*;
import roboforge.util.data.*;
import roboforge.*;



public class BDemoPatchData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BDemoPatchData(long id) throws Exception
    {
      super(id);
      // Read in the Jar and store it in a byteArray
      FileInputStream fIS = new FileInputStream("D:/RoboForge/rf.jar");

      // Open a file stream to process the image data
      ByteArrayOutputStream l_fileOutStream = new ByteArrayOutputStream();

      // Read from the jar data input stream, and write to the file output stream
      byte[] l_buffer = new byte[512]; // buffer holding bytes to be transferred
      int l_nbytes = 0;  // Number of bytes read
      while ((l_nbytes = fIS.read(l_buffer)) != -1) // Read from BLOB stream
        l_fileOutStream.write(l_buffer,0,l_nbytes); // Write to file stream

      jarBytes = l_fileOutStream.toByteArray();

      fIS.close();

      //BDebug.print("Size of jarBytes: " + jarBytes.length);


      // Read in the roboforge bmp and store in a byteArray
      fIS = new FileInputStream("D:/RoboForge/roboforge.bmp");

      // Open a file stream to process the image data
      l_fileOutStream = new ByteArrayOutputStream();

      // Read from the jar data input stream, and write to the file output stream
      l_buffer = new byte[512]; // buffer holding bytes to be transferred
      l_nbytes = 0;  // Number of bytes read
      while ((l_nbytes = fIS.read(l_buffer)) != -1) // Read from BLOB stream
        l_fileOutStream.write(l_buffer,0,l_nbytes); // Write to file stream

      bmpBytes = l_fileOutStream.toByteArray();

      fIS.close();


      // Read in the roboforge AI help and store in a byteArray
      fIS = new FileInputStream("D:/RoboForge/ai.swf");

      // Open a file stream to process the image data
      l_fileOutStream = new ByteArrayOutputStream();

      // Read from the jar data input stream, and write to the file output stream
      l_buffer = new byte[512]; // buffer holding bytes to be transferred
      l_nbytes = 0;  // Number of bytes read
      while ((l_nbytes = fIS.read(l_buffer)) != -1) // Read from BLOB stream
        l_fileOutStream.write(l_buffer,0,l_nbytes); // Write to file stream

      helpBytes = l_fileOutStream.toByteArray();

      fIS.close();

      //BDebug.print("Size of bmpBytes: " + bmpBytes.length);

    }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.DEMO_PATCH; }


  // Status codes...
  // -------------------------------------------------------------


  // Data fields...
  // -------------------------------------------------------------
  private byte[] jarBytes;
  private byte[] bmpBytes;
  private byte[] helpBytes;

  private byte[] splashScreenBytes;
  // Accessor methods...
  // -------------------------------------------------------------

  public void writeDemoPatch() throws Exception
  {
    File dirFile = new File(BGlobal.SYSTEMPATH + "patch/roboforge/");
    if (!dirFile.exists())
    {
      dirFile.mkdirs();
    }

    ByteArrayInputStream in2 = new ByteArrayInputStream(jarBytes);

    FileOutputStream fos = new FileOutputStream(BGlobal.SYSTEMPATH + "patch/roboforge/rf.jar");
    BufferedOutputStream bos = new BufferedOutputStream(fos);

    // Read from the input stream, and write to the output stream
    byte[] l_buffer = new byte[512]; // buffer holding bytes to be transferred
    int l_nbytes = 0;  // Number of bytes read
    while ((l_nbytes = in2.read(l_buffer)) != -1) // Read from InputStream stream
      bos.write(l_buffer,0,l_nbytes); // Write to output stream

    bos.flush();
    bos.close();

    in2.close();

    System.out.println("Patched the Jar");

    in2 = new ByteArrayInputStream(bmpBytes);

    fos = new FileOutputStream(BGlobal.SYSTEMPATH + "roboforge.bmp");
    bos = new BufferedOutputStream(fos);

    // Read from the input stream, and write to the output stream
    l_buffer = new byte[512]; // buffer holding bytes to be transferred
    l_nbytes = 0;  // Number of bytes read
    while ((l_nbytes = in2.read(l_buffer)) != -1) // Read from InputStream stream
      bos.write(l_buffer,0,l_nbytes); // Write to output stream

    bos.flush();
    bos.close();

    in2.close();

    System.out.println("Patched the BMP");

    in2 = new ByteArrayInputStream(helpBytes);

    fos = new FileOutputStream(BGlobal.HELPPATH + "ai.swf");
    bos = new BufferedOutputStream(fos);

    // Read from the input stream, and write to the output stream
    l_buffer = new byte[512]; // buffer holding bytes to be transferred
    l_nbytes = 0;  // Number of bytes read
    while ((l_nbytes = in2.read(l_buffer)) != -1) // Read from InputStream stream
      bos.write(l_buffer,0,l_nbytes); // Write to output stream

    bos.flush();
    bos.close();

    in2.close();

    System.out.println("Patched the HELP AI");

    //Change the version number and save it away
    BDebug.print("Old Version No: " + BGlobal.APP_VERSION);
    BGlobal.APP_VERSION = 1.1f;
    BGlobal tempG = new BGlobal();
    tempG.saveToFile();
    BDebug.print("New Version No: " + BGlobal.APP_VERSION);

  }
}