package roboforge.net.data;

import roboforge.util.data.*;
import roboforge.*;
import java.io.*;


public class BPatchData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BPatchData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.PATCH; }


  // Data fields...
  // -------------------------------------------------------------

  public float versionID;
  public String patchBlurb;
  public String patchName;
  public int directoryStripLength;
  public int deleteDirectoryStripLength;
  public int itemsInPatch;
  //public int countOfPatches;
  public String[] filesToDelete;

  public byte[] patch;

  //public boolean isJ3DUpdated;
  

  public void SaveToFile (String fileName)
  {
    try
    {
      FileOutputStream fout = new FileOutputStream(fileName);
      ObjectOutputStream out = new ObjectOutputStream(fout);
      out.writeObject(this);
      out.close();
      System.out.println(this.toString() +"Save completed");
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
    }
  }

  public static BPatchData loadFromFile(String filename)
  {
    BPatchData newIn = null;
    //BDebug.print("BPatchData.loadFromFile: Loading...");

    try
    {
      FileInputStream fin = new FileInputStream(filename);
      ObjectInputStream in = new ObjectInputStream(fin);
      newIn = (BPatchData)in.readObject();
      in.close();

      //BDebug.print("BPatchData.loadFromFile: Load completed");

    }

    catch (Exception e)
    {
      BDebug.print("BPatchData.loadFromFile: BPatchData Load failed :" + e.getMessage());
    }

    return newIn;
  }

} 