package roboforge.net.services;

import roboforge.BDebug;
import roboforge.net.*;
import roboforge.net.sockets.*;

import java.io.*;
import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;



public class BDESService extends BAbstractDataService
{
 
  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;

  
  // Member variables...
  // -----------------------------------------------------------

  protected transient Key    key;
  protected transient byte[] iv;


  // Constructors...
  // -----------------------------------------------------------

  public BDESService()
  {
    super();
    // BDebug.print("BDESService.init(): key = "+ key);
  }
  
  
  // Implementation methods...
  // -----------------------------------------------------------

  public BSocket getSocket(BSocket s) throws IOException
  { 
    // BDebug.print("BDESService.getSocket(): key = "+ key);
      
    BDESSocket socket = new BDESSocket(s); 
    
    socket.setKey(key);
    socket.setInitVector(iv);
    
    return socket;
  }
  
  public String toString()
    { return "BDESService"; }
 

  
  // Target methods...
  // -----------------------------------------------------------

  public void inform(BServiceInfo info)
  {
    if (key != null)
      // Bail out if we already have a DES key & IV.
      return;
    
    if (info instanceof BTarget)
    {
      BTarget target = 
        (BTarget) info;

      key = target.getSymmetricKey();
      iv  = target.getSymmetricIV();
    }
  }
    
  /*
  public void read(BTarget target)
  {
    if (key == null)
    {
      key = target.getSymmetricKey();
      iv  = target.getSymmetricIV();
    }
  }
    
  public void write(BTarget target)
  {
    Key k = target.getSymmetricKey();
      
    if (k == null)
    {
      target.setSymmetricKey(key);
      target.setSymmetricIV(iv);
    }
  }
  */
  
  
}
