package roboforge.net.services;

import roboforge.net.*;
import roboforge.net.sockets.*;

import java.io.IOException;
import java.io.Serializable;



public interface BDataService extends Serializable
{

  public BSocket getSocket(BSocket s) throws IOException;
    // Returns a socket that applies this
    // data service to all traffic.

  public void inform(BServiceInfo info);
    // Inform this service that something important
    // has happened. Service is responsible for
    // updating its internal state appropriately.

  public void configure(BPresentationHeader header);
    // Configures the given presentation header to
    // use this data service when decoded.

  /*
  public void read(BTarget target);
    // Read information from the specified target.
    
  public void write(BTarget target);
    // Write information to the specified target.
  */
    
}