package roboforge.net.services;

import roboforge.net.*;
import roboforge.net.sockets.*;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;



public class BServiceSet implements BDataService
{
  
  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Member variables...
  // -----------------------------------------------------------
  
  protected ArrayList services;

  
  // Constructor...
  // -----------------------------------------------------------

  public BServiceSet()
    { services = new ArrayList(); }

  
  // Implementaton methods...
  // -----------------------------------------------------------
  
  public BSocket getSocket(BSocket s) throws IOException
  {
    int last = services.size() - 1;
    for (int i=last; i>=0; i--)
      s = get(i).getSocket(s);
    
    return s;
  }
  
  public void configure(BPresentationHeader header)
  {
    int n = services.size();
    for (int i=0; i<n; i++)
      get(i).configure(header);
  }
  
  public void inform(BServiceInfo info)
  {
    int n = services.size();
    for (int i=0; i<n; i++)
      get(i).inform(info);
  }
  
  /*
  public void read(BTarget target)
  {
    int n = services.size();
    for (int i=0; i<n; i++)
      get(i).read(target);
  }
  
  public void write(BTarget target)
  {
    int n = services.size();
    for (int i=0; i<n; i++)
      get(i).write(target);
  }
  */

  
  // Accessor methods...
  // -----------------------------------------------------------

  public void add(BDataService service)
  { 
    if (service == null) return;
    services.add(service); 
  }

  public void push(BDataService service)
  { 
    if (service == null) return;
    services.add(0, service); 
  }
  
  public BDataService get(int i)
    { return (BDataService) services.get(i); }
  
  public int size()
    { return services.size(); }
  
  public Iterator iterator()
    { return services.iterator(); }
  

  public String toString()
  { 
    StringBuffer result =
      new StringBuffer("BServiceSet [");
    
    int n = services.size();
    int l = n - 1;
    
    for (int i=0; i<n; i++)
    {
      result.append(services.get(i).toString());
      if (i != l) result.append(" ");
    }
    
    result.append("]");
    
    return result.toString(); 
  }
  
}
