package roboforge.net.sockets;

import roboforge.BDebug;
import roboforge.net.*;
import roboforge.util.io.*;

import java.io.*;



public class BCountSocket extends BFilterSocket
{

  // Member variables...
  // -----------------------------------------------------------

  protected BCountInputStream  in;
  protected BCountOutputStream out;


  // Constructor...
  // -----------------------------------------------------------

  public BCountSocket(BSocket socket)
    { super(socket); }


  // Interface methods...
  // -----------------------------------------------------------

  public InputStream filter(InputStream in) throws IOException
  {
    if (this.in == null)
      this.in = new BCountInputStream(in);
    
    return this.in;
  }

  public OutputStream filter(OutputStream out) throws IOException
  {
    if (this.out == null)
      this.out = new BCountOutputStream(out);
    
    return this.out;
  }

  public void flush() throws IOException
  {
    if (out != null)
      out.flush();
    
    super.flush();
  }
  
  public void close() throws IOException
  {
    if (in  != null) in.close();
    if (out != null) out.close();
    super.close();
  }


  // Interface methods...
  // -------------------------------------------------------------
  
  public long getInputCount()
  {
    if (in != null)
      return in.getCount();
    else
      return 0;
  }
  
  public long getOutputCount()
  {
    if (out != null)
      return out.getCount();
    else
      return 0;
  }
  
  public long getTotalCount()
    { return getInputCount() + getOutputCount(); }
}
