package roboforge.particles;

public interface BParticleAspect
{

  // A BParticleAspect is an 'aspect' (subsystem) of a
  // particle, for example the particle's physics.
  // Each aspect is periodically updated by the particle.

  public void start(BParticle p);
    // Initialize this aspect wrt. particle p.

  public void update(BParticle p, float t, float dt);
    // Update this aspect wrt. particle p.

  public void stop(BParticle p);
    // Stop this aspect wrt. particle p.

}
