package roboforge.particles;

public interface BSystemAspect
{

  // A BSystemAspect is an 'aspect' (subsystem) of a
  // particle system, for example the system's physics.
  // Each aspect is periodically updated by the particle system.

  public void start();
    // Initialize this subsystem.

  public void update(float t, float dt);
    // Update this subsystem.

  public void stop();
    // Stop this subsystem.


  public BParticleAspect createParticleAspect(BParticle p)
    throws BParticleSystemException;


}