package roboforge.particles.forces;

import javax.vecmath.*;
import roboforge.particles.*;


public class BConstantForce implements BParticleForce
{
  // BConstantForce applies a constant force vector to particles.

  protected Vector3f force = new Vector3f();


  public BConstantForce()
    { }

  public BConstantForce(Vector3f f)
    { force.set(f); }

  public void setForce(Vector3f f)
  	{ force.set(f); }
    
  public void apply(BParticle p, float t, Vector3f f)
    { f.add(force, f); }

  public void update(float t)
    { /* Do nothing. */ }

}