package roboforge.particles.forms;

import roboforge.BGlobal;
import roboforge.particles.*;

import javax.vecmath.*;
import javax.media.j3d.*;




public class BParticleFormLine implements BParticleForm
{

  protected LineArray lines;
    // Shared LineArray object for a group of particles.

  protected int index;
    // Index of this particle within LineArray.



  public BParticleFormLine(LineArray ls, int index)
  {
    this.lines = ls;
    this.index = index;
  }


  public void start(BParticle p)
  {
    lines.setCoordinate(index,   p.p);
    lines.setCoordinate(index+1, p.p);
  }

  public void update(BParticle p, float t, float dt)
  {
    lines.setCoordinate(index,   p.p);
    lines.setCoordinate(index+1, p.oldp);
  }

  public void stop(BParticle p)
    { setColor(BGlobal.INVISIBLE_4F); }


  protected static Color4f scratch
    = new Color4f();


  public void setColor(Color4f c)
  {
    scratch.set(c.x, c.y, c.z, 0f);

    lines.setColor(index, c);
    lines.setColor(index+1, scratch);
  }


  public void setTexture(Texture t)
    { /* Not applicable. */ }

  public void setSize(float s)
    { /* Not applicable. */ }

  public void setAdditive(boolean isAdditive)
    { /* TODO: Implement? */ }


}