package roboforge.particles.forms;

import roboforge.BDebug;

import roboforge.particles.*;
import javax.media.j3d.*;


public abstract class BSystemFormAbstract implements BSystemForm
{

  // Constants...
  // -------------------------------------------------------------

  public static final boolean ADDITIVE = true;
    // Specifies additive blending be used.

  public static final boolean SUBTRACTIVE = false;
    // Specifies subtractive blending be used.



  // Members...
  // -------------------------------------------------------------

  protected boolean isAdditive;
    // Whether this form uses additive blending.



  // Constructors...
  // -------------------------------------------------------------

  public BSystemFormAbstract()
    { this(ADDITIVE); }

  public BSystemFormAbstract(boolean isAdditive)
    { setAdditive(isAdditive); }


  // Accessor Methods...
  // -------------------------------------------------------------

  public void setAdditive(boolean isAdditive)
    { this.isAdditive = isAdditive; }

  public boolean isAdditive()
    { return isAdditive; }



  // BSystemAspect implementation...
  // -------------------------------------------------------------

  public void start()
    { }

  public void update(float t, float dt)
    { }

  public void stop()
    { }


  public BParticleAspect createParticleAspect(BParticle p)
    throws BParticleSystemException
  {
    BParticleForm form = createForm(p);
    p.setForm(form);
    return form;
  }

}
