package roboforge.particles.physics;

import roboforge.particles.*;
import roboforge.particles.forces.*;

import javax.vecmath.*;



public class BSystemPhysicsForces implements BSystemPhysics
{

  // Members...
  // -------------------------------------------------------------

  protected BParticleForce forces;
    // The forces that are applied to a particle.

  protected BPhysicsForces physics;
    // The physics that are applied to a particle.


  // Constructors...
  // -------------------------------------------------------------

  public BSystemPhysicsForces()
    { this(null); }

  public BSystemPhysicsForces(BParticleForce f)
  {
    physics = new BPhysicsForces();
    setForces(f);
  }


  // Accessors...
  // -------------------------------------------------------------

  public void setForces(BParticleForce f)
  {
    this.forces = f;
    physics.setForces(f);
  }

  public BParticleForce getForces()
    { return forces; }


  // Methods...
  // -------------------------------------------------------------

  public void start()
    { }

  public void update(float t, float dt)
  {
    if (forces != null)
      forces.update(t);
  }

  public void stop()
    { }


  public BParticleAspect createParticleAspect(BParticle p)
    throws BParticleSystemException
    { return physics; }


}