package roboforge.sound;


//import java.io.*;

import roboforge.*;


public class BDependantSound extends BSound
{

  private boolean continuePlaying = false;
  private BSound myEndSound;

  public BDependantSound()
  {
  }

  public BDependantSound(String locator, int type)
  // the Contructor
  // Dont use this, use getSound()
  { super(locator, type);   }


  public static BSound getSound(String fileName)
  {
      return getSound(fileName, 0,SOUND_TYPE_FOREGROUND );
  }

  public void chainSound(BSound chainedSound)
  {
    if (myEndSound != null)
      super.chainSound(chainedSound);
    else
      myEndSound = chainedSound;

  }



  public static BSound getSound(String fileName, int loopTimesnew, int soundTypeNew)
  // The static getSound method.
  // Use this to create sounds
  {

   if ( (staticMixer == null) || !BGlobal.USE_SOUND)
   {
     return new BDependantSound();
   }


   try
    {

      // check Cache

      //File tempF = new File(fileName);
      BDependantSound tempS = new BDependantSound(fileName, soundTypeNew);
      tempS.loopTimes = loopTimesnew;
      return tempS;


    }
    catch (Exception e)
    {
        BDebug.print("BDependantSound.getSound ERROR "  + e.getMessage()
                                         + " in file :: " +  fileName);

    }


     return new BDependantSound();

  }


  private static int STOP_SLEEP = 100; // ms

  class SoundStopper extends Thread
  {
    public SoundStopper()
    {}

    public void run()
    {

      while(continuePlaying)
      {
        continuePlaying = false;

        try
        {
          Thread.sleep(STOP_SLEEP);
        }
        catch(Exception e) { e.printStackTrace();}



      }

      if (myEndSound != null)
        myEndSound.play();
        
      stopSound();



    }


  }


   public void stopSound()
   { stop(); }

   public void play()
   {
    if (isRunning() )
      continuePlaying = true;
    else
    {
      continuePlaying = true;
      super.play();
      SoundStopper s = new SoundStopper();
      s.start();


    }

   }



}