package roboforge.sound;

//import java.net.URL;
//import javax.sound.sampled.*;
//import java.io.File;
//import java.util.Vector;

import roboforge.*;
import roboforge.animation.*;


public class BFadingSound extends BSound
{

  private float fadeInTime = 0;  // ms
  private float fadeOutTime = 0; // ms
  private BFadingAnimation fader = new BFadingAnimation();

  public BFadingSound()
  {  }

  public BFadingSound (String filename, int type)
  { super(filename, type); }

  public static BFadingSound getFadingSound(String fileName, int loopTimesnew, int soundTypeNew, int fadeInTime)
  {
    return getFadingSound( fileName,  loopTimesnew,  soundTypeNew,  fadeInTime,  fadeInTime);

  }

  public static BFadingSound getFadingSound(String fileName, int loopTimesnew, int soundTypeNew, int fadeInTime, int fadeOutTime)
  {
    

   if ( (staticMixer == null) || !BGlobal.USE_SOUND)
   {

      //BDebug.print("BSound.getSound ERROR BSound.init has NOT BEEN CALLED!!!!!");
      return new BFadingSound();
   }


   try
    {

      //File tempF = new File(fileName);
      BFadingSound tempS = new BFadingSound(fileName, soundTypeNew);
      tempS.loopTimes = loopTimesnew;
      tempS.fadeInTime = fadeInTime;
      tempS.fadeOutTime = fadeOutTime;
      return tempS;

     }
     catch (Exception e)
     {
        System.out.println("BFadingSound.getCachedSound ERROR "  + e.getMessage()
                                         + " in file :: " +  fileName);
     }


     return new BFadingSound();

  }


  public void fadeIn(BAnimator a)
  {
    fader.setFadeOut(false);
    a.add(fader);

  }

  public void fadeOut(BAnimator a)
  {
    fader.setFadeOut(true);
    a.add(fader);

  }

  public void play()
  {
    setVolumeRatio(1);
    super.play();
  }


  class BFadingAnimation implements BAnimation
  {
    long startTime;
    boolean fadeOut = false;
    float startedRatio = 0;

    public void start()
    {
      //BDebug.print("BFadingAnimation start called fadeOut " + fadeOut);

      startedRatio = getVolumeRatio();

      //if (fadeOut)
      //  setVolumeRatio(1);
      //else
      if (!fadeOut)
      {
        if (!BFadingSound.this.isRunning())
        {
          startedRatio = 0;
          setVolumeRatio(0);
          BFadingSound.super.play();
        }

      }

      startTime = System.currentTimeMillis();
    }


    public void setFadeOut(boolean b)
    {
      fadeOut = b;
    }

    public void stop()
    {


    }

    public boolean animate()
    {
      long time = System.currentTimeMillis();
      long delta = time - startTime;


      if (delta > fadeInTime)
      {
        //BDebug.print ("BFadingSound.reachedMax ratio 1");
       // BDebug.print("BFadingAnimation reachedMax fadeOut" + fadeOut);

        if (fadeOut)
        {
           BFadingSound.this.stop();
          //setVolumeRatio(0);

        }
        else
          setVolumeRatio(1);

        return false;
      }
      else
      {
        //BDebug.print("BFadingAnimation Animate fadeOut" + fadeOut);

        // BDebug.print ("BFadingSound.fadeIn delta" + delta);
        //  BDebug.print ("BFadingSound.fadeIn fadeInTime" + fadeInTime);
        float ratio;

        if (fadeOut)
        {

          ratio = 1f - ((float)delta / fadeOutTime);
          if (startedRatio > ratio)
            setVolumeRatio(ratio);

        }
        else
        {

          ratio = (float)delta / fadeInTime;
          if (startedRatio < ratio)
            setVolumeRatio(ratio);

        }


        return true;

      }


    }



  }




} 