package roboforge.ui;

import roboforge.ui.components.*;

import java.util.*;
import roboforge.BComponent;
import javax.swing.table.*;
import javax.swing.*;

public class BComponentAttributeViewer extends BScrollPane
{

// -------------------------------------------------------------
  // Inner class: component attribute viewer...
  // -------------------------------------------------------------

    protected BTable table      = new BTable();
    protected Vector headings   = new Vector(2);
    protected Vector data       = null;

    protected AttributeModel model;


    public BComponentAttributeViewer(BUIResources res, String key)
    {
      super(res, key);

      headings.add("Attribute");
      headings.add("Value");

      setBorder(null);
      setViewportView(table);
      setViewportBorder(null);
      setOpaque(true);

      setVerticalScrollBarPolicy(VERTICAL_SCROLLBAR_ALWAYS);
      table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);

      setComponent(null);
    }

    public void setComponent(BComponent c)
    {
      if (c != null)
      {
        data  = c.getAttributeStrings();
        model = new AttributeModel(data, headings);

        JTableHeader header = table.getTableHeader();
        header.setReorderingAllowed(false);
      }
      else
        model = new AttributeModel(headings, 0);

      table.setModel(model);
    }

    protected class AttributeModel extends DefaultTableModel
    {
      public AttributeModel(Vector header, int rows)
        { super(header, rows); }

      public AttributeModel(Vector data, Vector header)
        { super(data, header); }

      public boolean isCellEditable(int row, int col)
        { return false; }
    }



} 