package roboforge.ui;

import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.ui.components.*;
import roboforge.ui.events.*;
import roboforge.ui.layers.*;

import javax.swing.*;


public class BSystemPanel extends BBoxLayer
{


  // Class variables...
  // -------------------------------------------------------------

  protected static BUIColorScheme colors = BGlobal.colors;
    // Color scheme.


    
  // Member variables...
  // -------------------------------------------------------------

  protected BSystemScreen parent = null;
    // Reference to parent screen (for callbacks.)

  protected String name;
    // The name of this client panel.



  // Constructor.
  // -------------------------------------------------------------

  public BSystemPanel(BSystemScreen parent, String name)
  {
    super(BBoxPanel.X_AXIS);

    this.parent = parent;
    this.name = name;

    setBackground(colors.getDarkestShade());
  }


  // Activation methods...
  // -------------------------------------------------------------

  public void onActivate()
  {
    super.onActivate();
    parent.setStatus(name+ " panel activated.");
  }

  public void onClose()
  {
    parent = null;
    super.onClose();
  }


  
  // Layer methods...
  // -------------------------------------------------------------

  public void addTo(JComponent holder)
  {
    super.addTo(holder);
    setVisible(true);
  }

  public void removeFrom(JComponent holder)
  {
    setVisible(false);
    super.removeFrom(holder);
  }



  // Accessor methods...
  // -------------------------------------------------------------

  public boolean isFocusCycleRoot()
    { return true; }

  public String getName()
    { return name; }


  public void setStatus(String text)
    { parent.setStatus(text); }

  public String getStatus()
    { return parent.getStatus(); }

  public void setWorking(boolean isWorking)
    { parent.setWorking(isWorking);}

  public void setBusy(boolean isBusy)
    { parent.setBusy(isBusy);}

  public void setBusyWorking(boolean b)
    { parent.setBusyWorking(b);}

}
