package roboforge.ui.action;

import roboforge.ui.components.*;

import java.awt.event.*;
import javax.swing.*;


public abstract class BAction extends AbstractAction
{

  public BAction()
  {
    super();
    initializeUI(null, null);
  }

  public BAction(String name)
  {
    super(name);
    initializeUI(null, null);
  }

  public BAction(String name, Icon icon)
  {
    super(name, icon);
    initializeUI(null, null);
  }

  public BAction(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }


  public void perform()
  {
    ActionEvent event =
      new ActionEvent(this, ActionEvent.ACTION_PERFORMED, null);

    actionPerformed(event);
  }


  public void initializeUI(BUIResources res, String key)
  {
    if (res != null)
    {
      Icon icon = (Icon) res.get(key+ ".icon");
      if (icon != null)
        setIcon(icon);

      String name = (String) res.get(key+ ".name");
      if (name != null)
        setName(name);
      String tooltip = (String) res.get(key+ ".tooltip");
      if (tooltip != null)
        setShortDescription(tooltip);
      KeyStroke stroke = (KeyStroke) res.get(key+ ".accelerator");
      if (stroke != null)
        setAcceleratorKey(stroke);
    }
  }

  
  public String toString()
    { return getName(); }
  

  public void setIcon(Icon icon)
    { putValue(Action.SMALL_ICON, icon); }

  public void setName(String name)
    { putValue(Action.NAME, name); }

  public void setShortDescription(String desc)
    { putValue(Action.SHORT_DESCRIPTION, desc); }

  public void setLongDescription(String desc)
    { putValue(Action.LONG_DESCRIPTION, desc); }

  public void setAcceleratorKey(KeyStroke key)
    { putValue(Action.ACCELERATOR_KEY, key); }

  public void setMnemonic(int key)
    { putValue(Action.MNEMONIC_KEY, new Integer(key)); }

  public void setCommandKey(String desc)
    { putValue(Action.ACTION_COMMAND_KEY, desc); }



  public Icon getIcon()
    { return (Icon) getValue(Action.SMALL_ICON); }

  public String getName()
    { return (String) getValue(Action.NAME); }

  public String getShortDescription()
    { return (String) getValue(Action.SHORT_DESCRIPTION); }

  public String getLongDescription()
    { return (String) getValue(Action.LONG_DESCRIPTION); }

  public KeyStroke getAcceleratorKey()
    { return (KeyStroke) getValue(Action.ACCELERATOR_KEY); }

  public int getMnemonic()
    { return ((Integer) getValue(Action.MNEMONIC_KEY)).intValue(); }

  public String getCommandKey()
    { return (String) getValue(Action.ACTION_COMMAND_KEY); }

}

