package roboforge.ui.ai;


import roboforge.ai.*;
import roboforge.ai.decisions.*;

import roboforge.BGlobal;
import roboforge.BDebug;

import roboforge.ai.decisions.*;
import roboforge.ui.components.BLabel;
import roboforge.ui.components.BCompoundIcon;
import roboforge.ui.components.BUIResources;

import roboforge.util.graphics.*;

import java.awt.Color;
import java.awt.Component;

import javax.swing.Icon;
import javax.swing.JTree;
import javax.swing.tree.*;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.awt.event.*;



public class BDisplayOnlyDecisionTree extends BDecisionTree
{

     public BDisplayOnlyDecisionTree(BRootNode root)
      {
        super();
        setRoot(root);

        ui = new BAITreeUI();
        setUI ( ui);
        renderer = new BDecisionTreeRenderer();
        renderer.setHighlightErrors(false);
        
        setCellRenderer(renderer);
        setRowHeight (BDecisionTreeRenderer.CELLHEIGHT);


        this.addMouseListener(new TreeClickListener());
        vetoListener = new VeotoListener();
        this.addTreeWillExpandListener(vetoListener);



        //this.setEnabled(false);
     }


  public void dragGestureRecognized(DragGestureEvent e)
  {
      // override to stop all drags
  }




  // inner classes


    protected class TreeClickListener extends MouseAdapter
  {
    public void mouseClicked(MouseEvent e)
    {
      if (e.getClickCount() == 2)
          {
            TreePath selectedPath = getSelectionPath();
            BDecisionTreeNode selected = null;

            if (selectedPath != null)
              selected =  (BDecisionTreeNode)selectedPath.getLastPathComponent();

             if (selected == null)
              return;

            selected.setClosed( !selected.isClosed()  );
            ((BDecisionTreeModel)getModel()).notifyTree();


          }
    }

  }


  /*

  protected class BDisplayOnlyRenderer extends BDecisionTreeRenderer
  {
      public BDisplayOnlyRenderer()
        { super(); }

      public Component getTreeCellRendererComponent
      (
        JTree tree, Object value,
        boolean isSelected, boolean expanded,
	    	boolean leaf, int row, boolean hasFocus
      )
      {

        BDecisionTreeNode node =
          (BDecisionTreeNode) value;

        BDecisionTreeNode parent =
          (BDecisionTreeNode) node.getParent();

        String name = node.getName();

        if (showText)
          setText(name);
        else
          setText("");

        BDecisionTreeIcon nodeIcon;
        nodeIcon = (BDecisionTreeIcon)node.getIcon();
        Color textColor = getTextNonSelectionColor();

        setForeground(textColor);

        nodeIcon.setClosed(node.isClosed());

        if (parent instanceof BDecisionNode)
        {
          int i = parent.getIndex(node);
          boolean groupNotExpanded = true;

         // if(node instanceof BGroupNode)
            groupNotExpanded = node.isClosed();
         // else
         //   groupNotExpanded = false;

          switch(i)
          {
            case 0:
            if(leaf || groupNotExpanded)
              compound.setFirstIcon(yes_normal);
            else
              compound.setFirstIcon(yes_normal2);
            break;

            case 1:
            if(leaf || groupNotExpanded)
              compound.setFirstIcon(no_normal);
            else
              compound.setFirstIcon(no_normal2);
            break;
          }

          compound.setSecondIcon(nodeIcon);
          setIcon(compound);
      }
      else
        setIcon(nodeIcon);

  	  this.selected = isSelected;

      if (showText)
        this.setPreferredSize(d);
      else
        this.setPreferredSize(null);


      return this;
	}



  }
        */
  
} 