package roboforge.ui.ai;

import roboforge.ai.*;
import roboforge.ai.expressions.*;
import roboforge.ai.expressions.parser.*;
import roboforge.ai.values.*;

import roboforge.ui.components.*;
import roboforge.util.parser.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;


public class BExpressionPad extends BTextArea
{
  BDecisionTreeAI ai;


  public BExpressionPad()
    { this(null, null); }

  public BExpressionPad(BUIResources res, String key)
  {
    super(res, key);
    setLineWrap(true);
    setWrapStyleWord(true);
    setBorder(new EmptyBorder(5, 5, 5, 5));
  }

  public void setAI(BDecisionTreeAI ai)
    { this.ai = ai;}


  public BExpression getExpression()
  {

    BExpression e;

    if (ai == null)
      return null;

    BExpressionParser parser = ai.getParser();

    String text = getText();

    try
      { e = parser.parse(text); }
    catch
      ( BParseException ex )
      { e = null; }

    return e;
  }

  public void setExpression(BExpression e)
  {
    if (e != null)
      setText(e.toString());
    else
      setText("");
  }

  public void paste(String item)
  {
    int pos = getCaretPosition();
    int n   = item.length();

    boolean addSpace;

    try
      { addSpace = (pos > 0) && !getText(pos-1, 1).equals(" "); }
    catch (Exception e)
      { addSpace = false; }

    replaceSelection(addSpace ? (" "+ item) : item);
    requestFocus();
  }

}
