package roboforge.ui.ai;

import roboforge.ui.components.HSBImageIcon;

/*
  BSimpleNumberData
  holds the data required for a simple number:
  this is the same as for a simple decision except
  that it has two extra values - min and max
  used only for numerical type decisions
*/

public class BSimpleNumberData extends BSimpleDecisionData
{

  private double min;
  private double max;
  private String units;

  // constructor
  public BSimpleNumberData(String title, HSBImageIcon image, String [] options, double min, double max, String units)
  {
    super(title, image, options);

    this.min = min;
    this.max = max;
    this.units = units;
  }

  // returns the minimum selectable value
  protected double getMin()
  {
    return min;
  }

  // returns the maximum selectable value
  protected double getMax()
  {
    return max;
  }

  // returns the units that the data is represented as
  protected String getUnits()
  {
    return units;
  }
}
