package roboforge.ui.components;

import roboforge.ui.components.text.*;


public class BFloatField extends BGuardedTextField
{

  // Constructor.
  // -------------------------------------------------------------

  public BFloatField(BUIResources res, String key)
  {
    super(res, key);
    setGuard(new BFloatGuard());
  }

  public BFloatField()
  { 
    super(); 
    setGuard(new BFloatGuard());
  }

  public BFloatField(double value)
  {
    this();
    setValue(value);
  }

  public BFloatField(float value)
  {
    this();
    setValue(value);
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public float getFloatValue()
  {
    try
      { return Float.parseFloat(getText()); }
    catch (NumberFormatException e)
      { return 0.0f; }
  }

  public double getDoubleValue()
  {
    try
      { return Double.parseDouble(getText()); }
    catch (NumberFormatException e)
      { return 0.0; }
  }

  public void setValue(float i)
    { setText(Float.toString(i)); }

  public void setValue(double i)
    { setText(Double.toString(i)); }

}