package roboforge.ui.components;

import roboforge.BDebug;
import roboforge.ui.BApplication;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import java.applet.Applet;
  // TODO: Remove!

public class BOKCancelDialog extends BSystemDialog
{
  protected boolean showOK;
  protected boolean showCancel;

  protected String  OKName;
  protected String  cancelName;

  protected boolean result = false;
  protected boolean resultSet = false;


  // UI Resources...
  // -------------------------------------------------------------

  protected BUIResources res = new BUIResources( new Object[]
    { "this.size",        new Dimension(300, 260) });


  // Constructor...
  // -------------------------------------------------------------

  public BOKCancelDialog
  (
    String title,

    boolean showOK,
    boolean showCancel,

    String OKName,
    String cancelName
  )
  {
    super(title, true);

    initializeUI(res, "this");

    this.showOK = showOK;
    this.showCancel = showCancel;

    this.OKName = OKName;
    this.cancelName = cancelName;

    res.cleanse();
    res = null;
  }

  public boolean getResult()
    { return result; }

  public boolean getUserSelectedOption()
    { return resultSet; }


  public void setOKDefault()
    { ((OKCancelClient) content.client).setOKDefault();  }

  public void setCancelDefault()
    { ((OKCancelClient) content.client).setCancelDefault();  }



  protected class OKCancelClient extends SystemDialogClient
  {

    // UI Resources...
    // -------------------------------------------------------------

    protected BUIResources res = new BUIResources( new Object[]
    {
      "OK.size",     new Dimension(BUTTON_WIDTH, 30),
      "cancel.size", new Dimension(BUTTON_WIDTH, 30),
    });


    // Visual elements...
    // -------------------------------------------------------------

    protected BButton OK        = null;
    protected BButton cancel    = null;

    public OKCancelClient()
    {
      super(BoxLayout.Y_AXIS);

      if (showCancel)
      {
        cancel = new BButton(res, "cancel");
        cancel.setText(cancelName);
        setCancelDefault();
      }

      if (showOK)
      {
        OK = new BButton(res, "OK");
        OK.setText(OKName);
        setOKDefault();
      }

      layoutOKCancelChildren();
      configOKCancelChildren();
    }

    protected void layoutOKCancelChildren()
    {
      if (showOK)
        addButton(OK);
      if (showCancel)
        addButton(cancel);
    }

    protected void configOKCancelChildren()
    {
      if (showOK)
        OK.addActionListener(new OKListener());
      if (showCancel)
        cancel.addActionListener(new CancelListener());
    }

    public void setOKDefault()
      { setDefaultFocus(OK);  }

    public void setCancelDefault()
      { setDefaultFocus(cancel); }


    protected class OKListener implements ActionListener
    {
      public void actionPerformed(ActionEvent e)
        { onOKPressed(e); }
    }

    protected class CancelListener implements ActionListener
    {
      public void actionPerformed(ActionEvent e)
        { onCancelPressed(e); }
    }


    protected void onOKPressed(ActionEvent e)
    {
      result = true;
      resultSet = true;
      BApplication.hideDialog(BOKCancelDialog.this);
    }

    protected void onCancelPressed(ActionEvent e)
    {
      result = false;
      resultSet = true;
      BApplication.hideDialog(BOKCancelDialog.this);
    }

    protected void onClosePressed(ActionEvent e)
    {
      result = false;
      super.onClosePressed(e);
    }


  }
}

