package roboforge.ui.components;

import java.awt.Component;
import javax.swing.*;

public class BScrollPane extends JScrollPane
{

  // Constructors.
  // -------------------------------------------------------------

  public BScrollPane(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }

  public BScrollPane(BUIResources res, String key, Component c)
  {
    super(c);
    initializeUI(res, key);
  }

  public BScrollPane()
    { super(); }

  public BScrollPane(Component c)
    { super(c); }


  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    if (res != null)
      res.initComponent(this, key);
  }


  public void setEnabled(boolean enabled)
  {
    super.setEnabled(enabled);

    synchronized (getTreeLock())
    {
      Component[] kids = getComponents();
      for (int i=0; i<kids.length; i++)
        kids[i].setEnabled(enabled);
    }
  }

}
