package roboforge.ui.components.tree;

import java.awt.Component;
import javax.swing.JTree;
import javax.swing.tree.*;



public class BDelegatingCellRenderer implements TreeCellRenderer
{

  // Constructors...
  // -------------------------------------------------------------

  public BDelegatingCellRenderer()
    { super(); }


  // Accessor methods...
  // -------------------------------------------------------------

  public Component getTreeCellRendererComponent
  (
    JTree tree, Object value,
    boolean isSelected, boolean expanded,
		boolean leaf, int row, boolean hasFocus
  )
  {
    if (!(value instanceof BTreeCellDelegate))
      throw new IllegalArgumentException(
        "BDelegatingRenderer.getTreeCellRendererComponent(): "+
        "value is not an instance of BTreeCellDelegate.");

    BTreeCellDelegate delegate =
      (BTreeCellDelegate) value;

    TreeCellRenderer renderer =
      delegate.getRenderer();

    return renderer.getTreeCellRendererComponent
      (tree, value, isSelected, expanded, leaf, row, hasFocus);
	}


}