package roboforge.ui.console;

import roboforge.BDebug;

import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;


public class BConsoleContainer extends BConsoleComponent
{

  protected static final double CHILD_Z_SEPERATOR = 0.01;


  protected ArrayList kids
    = new ArrayList();

  protected OrderedGroup group
    = new OrderedGroup();

  public BConsoleContainer()
  {
    super();

    group.setCapability(Group.ALLOW_CHILDREN_WRITE);
    group.setCapability(Group.ALLOW_CHILDREN_EXTEND);
    // group.setCapability(Group.ALLOW_CHILDREN_READ);

    locTransformGroup.addChild(group);
  }


  public void add(BConsoleComponent c)
  {
    kids.add(c);
    group.addChild(c);

    c.setParent(this);
  }

  public void remove(BConsoleComponent c)
  {
    if (c.isRemoveable())
    {
      c.detach();
      kids.remove(c);
      c.setParent(null);
    }
  }

  public void removeAll()
  {
    BConsoleComponent c;

    int n = kids.size();

    for (int i=(n-1); i>=0; i--)
    {
      c = (BConsoleComponent) kids.get(i);
      remove(c);
    }
  }


  protected void transformChildLocationVector(BConsoleComponent child, Vector3d v)
  {
    int index = kids.indexOf(child);
    if (index != -1)
      v.z = index * CHILD_Z_SEPERATOR;
  }

}