package roboforge.ui.dnd;

import java.awt.datatransfer.*;
import java.io.*;

public class ObjectSelection implements Transferable, ClipboardOwner
{

  // Class variables...
  // -------------------------------------------------------------
  
  protected static final DataFlavor OBJECT = 
    createObjectFlavor();
  
  
  // Member variables...
  // -------------------------------------------------------------

  protected DataFlavor[] flavors = { OBJECT };
  protected Object data;

  
  // Constructor...
  // -------------------------------------------------------------

  public ObjectSelection(Object data)
    { this.data   = data; }

  
  // Accessor methods...
  // -------------------------------------------------------------

  public synchronized DataFlavor[] getTransferDataFlavors()
    { return flavors; }

  public boolean isDataFlavorSupported(DataFlavor flavor)
    {	return (flavor.equals(OBJECT)); }

  public synchronized Object getTransferData(DataFlavor flavor)
    throws UnsupportedFlavorException, IOException
  {
	  if (flavor.equals(OBJECT))
	    return (Object) data;
	  else
	    throw new UnsupportedFlavorException(flavor);
  }

  public void lostOwnership(Clipboard clipboard, Transferable contents)
    { }

  public String toString()
    { return "ObjectSelection["+ data+ "]"; }

  

  // Support methods...
  // -------------------------------------------------------------

  public static DataFlavor createObjectFlavor()
  {
  	try
      { return new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType); }
    catch (Exception e)
      { return null; }
  }
  
}



