package roboforge.ui.fusion;

import roboforge.ui.components.HSBImageIcon;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.Border;

import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;


public class FusionFilledLabelUI extends FusionLabelUI
{
  // Shared UI object
  private final static FusionFilledLabelUI labelUI = new FusionFilledLabelUI();

  protected Color  disabledFillColor = null;
  protected float  fillRoundness = 0.25f;
  protected Insets fillInsets = null;
  protected Border border   = null;

  public FusionFilledLabelUI()
  {
    super();
  }

  public static ComponentUI createUI(JComponent c) {
    return labelUI;
  }

  protected void installDefaults(JLabel c)
  {
    super.installDefaults(c);

    String pp = "FilledLabel.";

    this.fillRoundness  = ((Float) UIManager.get(pp+ "fillRoundness")).floatValue();
    this.fillInsets     = UIManager.getInsets(pp+ "fillInsets");

    this.disabledColor = UIManager.getColor(pp+ "disabledColor");
    this.disabledFillColor = UIManager.getColor(pp+ "disabledFillColor");

    // this.iconColor      = UIManager.getColor(pp+ "iconColor");

    this.border         = UIManager.getBorder(pp+ "border");
    c.setBorder(border);
  }

  public void paint(Graphics g, JComponent c)
  {
    Graphics2D g2D = (Graphics2D) g;
    g2D.addRenderingHints(hints);

    Dimension d = c.getSize();

    int x = fillInsets.left;
    int y = fillInsets.top;
    int w = d.width  - fillInsets.left - fillInsets.right;
    int h = d.height - fillInsets.top  - fillInsets.bottom;

    int arcsize = Math.round(fillRoundness * Math.min(w, h));

    if (c.isEnabled())
      g2D.setColor(c.getBackground());
    else
      g2D.setColor(disabledFillColor);

    g2D.fillRoundRect(x, y, w, h, arcsize, arcsize);

    super.paint(g, c);
  }

}
