package roboforge.ui.fusion;

import roboforge.BGlobal;
import roboforge.sound.*;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

import javax.swing.JComponent;


public class FusionPropertySound implements PropertyChangeListener
{
  protected final String property;
  protected final BSound sound;

  public FusionPropertySound(String property, String sound)
  {
    this.property  = property;
    this.sound = BSound.getSound(
      BGlobal.SOUNDPATH+ "interface/"+ sound);
  }

  public void install(JComponent c)
    { c.addPropertyChangeListener(property, this); }

  public void propertyChange(PropertyChangeEvent e)
  { 
    if (!sound.isRunning())
      sound.play(); 
  }
}
