package roboforge.ui.modes;

import roboforge.BComponent;
import roboforge.BGlobal;
import roboforge.ui.*;
import roboforge.ui.components.BUIResources;
import roboforge.util.graphics.*;

import java.awt.Cursor;
import java.awt.event.MouseEvent;
import java.beans.PropertyChangeListener;
import javax.swing.event.SwingPropertyChangeSupport;


public class BModeAppearancePick extends BModePick
{

  // Class variables...
  // -------------------------------------------------------------

  private static final Cursor CURSOR =
    BGraphics.getCursor("eyedropper_cursor.gif", 0, 30);


  // Internal Variables.
  // -------------------------------------------------------------

  protected SwingPropertyChangeSupport propertyManager;


  // Constructor.
  // -------------------------------------------------------------

  public BModeAppearancePick(B3DCanvas canvas)
  {
    super(canvas);
    cursor = CURSOR;

    // Initialize property manager...
    propertyManager = new SwingPropertyChangeSupport(this);
  }

  // Activation methods.
  // -------------------------------------------------------------


  // Property change listeners
  // -------------------------------------------------------------

  public void addPropertyChangeListener(PropertyChangeListener listener)
    { propertyManager.addPropertyChangeListener(listener); }

  public void removePropertyChangeListener(PropertyChangeListener listener)
    { propertyManager.removePropertyChangeListener(listener); }


  // Picking methods.
  // -------------------------------------------------------------

  protected void onPickComponent(BComponent c, MouseEvent e)
  {
    // Tell interested parties about the change in appearance.
    if (c != null)
      propertyManager.firePropertyChange("appearancePick", null, c.getAppearance());
  }
} 