package roboforge.ui.modes;

import roboforge.BComponent;
import roboforge.BConnectPoint;
import roboforge.BDebug;
import roboforge.BGlobal;

import roboforge.ui.*;
import roboforge.ui.components.BUIResources;
import roboforge.util.graphics.*;

import java.awt.Cursor;
import java.awt.event.MouseEvent;
import javax.media.j3d.*;
import javax.vecmath.*;

public class BModeComponentStudy extends BModeKeyedMulti
{

  // Constants.
  // -------------------------------------------------------------

  protected static final double ROT_FACTOR = 0.02;


  // Constructor.
  // -------------------------------------------------------------

  public BModeComponentStudy(B3DCanvas canvas)
  {
    super();

    BModeViewRot   rot = new BModeViewRot(canvas, ROT_FACTOR);
    BModeViewZoom zoom = new BModeViewZoom(canvas);

    setRightMouseMode(rot);
    setAltMode(rot);
    setShiftMode(zoom);
    setDefaultMode(new BModePickConnectPt(canvas));

    zoom.setClosestZDistance(canvas.getViewTranslationMin());
    zoom.setFurthestZDistance(canvas.getViewTranslationMax());
  }

 
  protected class BModePickConnectPt extends BModePick
  {

    // Constructor...
    // -------------------------------------------------------------
    
    public BModePickConnectPt(B3DCanvas canvas)
      { super(canvas); }

    
    // Activation methods...
    // -------------------------------------------------------------
    
    public void onActivate()
    {
      super.onActivate();

      // Enable drag n' drop...
   //   canvas.setDnDEnabled(true);
    }

    public void onDeactivate()
    {
      // Disable drag n' drop...
    //  canvas.setDnDEnabled(false);
      
      super.onDeactivate();
    }

    
    // Picking methods.
    // -------------------------------------------------------------

    protected void onPickConnectPt(BConnectPoint c, MouseEvent e)
      { canvas.setSelectedConnectPt(c); }
  }


}




