package roboforge.ui.modes;

import roboforge.BComponent;
import roboforge.BConnectPoint;
import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.BZone;

import roboforge.ui.*;
import roboforge.ui.components.BUIResources;

import java.awt.Cursor;
import java.awt.event.*;
import java.util.HashMap;
import javax.swing.*;




public class BModeContextMenu extends BModeSelect
{

  // Member variables...
  // -------------------------------------------------------------

  protected JPopupMenu menu_connect   = new JPopupMenu();
  protected JPopupMenu menu_component = new JPopupMenu();

  protected HashMap items             = new HashMap();
  

  // Constructor...
  // -------------------------------------------------------------

  public BModeContextMenu(B3DCanvas canvas)
    { super(canvas); }


  // Picking methods.
  // -------------------------------------------------------------

  protected void onPickComponent(BComponent c, MouseEvent e)
  {
    boolean hasMenuItems =
      menu_component.getComponentCount() > 0;

    if (hasMenuItems)
    {
      super.onPickComponent(c, e);

      if (e != null)
        menu_component.show(canvas, e.getX(), e.getY());
    }
  }

  protected void onPickConnectPt(BConnectPoint c, MouseEvent e)
  {
    boolean hasMenuItems =
      menu_connect.getComponentCount() > 0;

    if (hasMenuItems)
    {
      super.onPickConnectPt(c, e);

      if (e != null)
        menu_connect.show(canvas, e.getX(), e.getY());
    }
  }

  protected void onPickNothing(MouseEvent e)
  { 
    boolean hasMenuItems =
      (menu_component.getComponentCount() > 0) ||
      (menu_connect.getComponentCount()   > 0);

    if (hasMenuItems)
      super.onPickNothing(e);
  }
  


  // Accessor methods...
  // -------------------------------------------------------------

  public void addConnectPtAction(Action a)
    { addAction(a, menu_connect); }
  
  public void addComponentAction(Action a)
    { addAction(a, menu_component); }
  
  public void removeConnectPtAction(Action a)
    { removeAction(a, menu_connect); }

  public void removeComponentAction(Action a)
    { removeAction(a, menu_component); }
  
  
  protected void addAction(Action a, JPopupMenu menu)
  {
    JMenuItem item = 
      new JMenuItem(a);
    
    menu.add(item); 
    items.put(a, item);
  }
  
  protected void removeAction(Action a, JPopupMenu menu)
  {
    JMenuItem item = 
      (JMenuItem) items.remove(a);
    
    menu.remove(item); 
  }
  
}
