package roboforge.ui.modes;

import roboforge.BDebug;
import roboforge.ui.*;

import java.awt.event.MouseEvent;

public class BModeKeyedMulti extends BModeMulti
{

  // Internal variables...
  // -------------------------------------------------------------

  protected BModeMouse altMode         = null;
  protected BModeMouse ctrlMode        = null;
  protected BModeMouse shiftMode       = null;
  protected BModeMouse rightMode       = null;


  // Constructor...
  // -------------------------------------------------------------

  public BModeKeyedMulti()
    { super(); }

  public BModeKeyedMulti(BModeMouse defaultMode)
    { super(defaultMode); }

  public BModeKeyedMulti
  (
    BModeMouse d,
    BModeMouse a,
    BModeMouse c,
    BModeMouse s
  )
  {
    super(d);
    if (a != null) setAltMode(a);
    if (c != null) setCtrlMode(a);
    if (s != null) setShiftMode(a);
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public void setAltMode(BModeMouse m)
  {
    altMode = m;
    m.setSubMode(true);
  }

  public void setCtrlMode(BModeMouse m)
  {
    ctrlMode = m;
    m.setSubMode(true);
  }

  public void setShiftMode(BModeMouse m)
  {
    shiftMode = m;
    m.setSubMode(true);
  }

  public void setDefaultMode(BModeMouse m)
  {
    defaultMode = m;
    m.setSubMode(true);

    if (currentSubMode == null)
      currentSubMode = defaultMode;
  }

  public void setRightMouseMode(BModeMouse m)
  {
    rightMode = m;
    m.setSubMode(true);
  }


  // Activation methods...
  // -------------------------------------------------------------

  public void onClose()
  {
    if (altMode != null)
      altMode.requestClose();

    if (ctrlMode != null)
      ctrlMode.requestClose();

    if (shiftMode != null)
      shiftMode.requestClose();

    if (rightMode != null)
      rightMode.requestClose();

    super.onClose();
  }


  // Mode mapping method...
  // -------------------------------------------------------------

  protected BModeMouse getModeForEvent(MouseEvent e)
  {
    if (e.isAltDown() && (altMode != null))
      return altMode;
    else if (e.isControlDown() && (ctrlMode  != null))
      return ctrlMode;
    else if (e.isShiftDown()   && (shiftMode != null))
      return shiftMode;
    else if (e.isMetaDown()    && (rightMode != null))
      return rightMode;
    else
      return defaultMode;
  }

}
