package roboforge.ui.modes;

import roboforge.ui.components.BUIResources;
import roboforge.ui.B3DCanvas;

import java.awt.Cursor;
import java.awt.event.MouseEvent;
import javax.media.j3d.*;

import com.sun.j3d.utils.picking.*;
import roboforge.BDebug;
// import com.sun.j3d.utils.behaviors.picking.*;


public class BModePickMulti extends BModeMulti
{

  // Internal variables.
  // -------------------------------------------------------------

  protected PickCanvas pickCanvas;
    // protected PickObject pickObject  = null;
    // Object used to do picking within the scene.

  protected BModePick pickAnyMode;
    // The mode when something is picked.

  protected BModeMouse pickNoneMode;
    // The mode when nothing is picked.



  // Activation methods...
  // -------------------------------------------------------------

  public void onClose()
  {
    if (pickAnyMode != null)
      pickAnyMode.requestClose();

    if (pickNoneMode != null)
      pickNoneMode.requestClose();

    super.onClose();
  }



  // Constructor.
  // -------------------------------------------------------------

  public BModePickMulti(B3DCanvas canvas)
  {
    super();

    pickCanvas = new PickCanvas(canvas, canvas.getPickGroup());
    pickCanvas.setMode(PickCanvas.GEOMETRY);
    //pickCanvas.setMode(PickCanvas.GEOMETRY_INTERSECT_INFO);

    pickCanvas.setTolerance(0f);
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public void setPickAnyMode(BModePick m)
  {
    pickAnyMode = m;
    m.setSubMode(true);
  }

  public void setPickNoneMode(BModeMouse m)
  {
    pickNoneMode = m;
    m.setSubMode(true);
  }




  // Mode mapping method...
  // -------------------------------------------------------------

  protected BModeMouse getModeForEvent(MouseEvent e)
  {
   // BDebug.print(pickCanvas + " being used for picking " );

    pickCanvas.setShapeLocation(e);
    PickResult picked = pickCanvas.pickClosest();

    Shape3D pickedShape = (picked == null) ?
      null : (Shape3D) picked.getObject();

    /*
   	pickedShape = (Shape3D)
      pickObject.pickNode(
        pickObject.pickClosest(e.getX(), e.getY(), PickObject.USE_GEOMETRY),
        PickObject.SHAPE3D
      );
    */

    if (pickedShape != null)
    {
      pickAnyMode.setPickedShape(pickedShape);
      return pickAnyMode;
    }
    else
      return pickNoneMode;
  }


}