package roboforge.util.graphics;

import roboforge.BDebug;
import roboforge.util.BSoftCache;

import java.awt.Image;


public class BImageCache
{

  // Singleton instance.
  // -------------------------------------------------------------

  private static BImageCache instance;


  // Class variables...
  // -------------------------------------------------------------

  protected final static int NUM_IMAGES_RETAINED = 0;
    // The number of images to retain, regardless of memory usage.




  // Member variables...
  // -------------------------------------------------------------

  protected BSoftCache cache;
    // Cache to hold the images.


  // Constructors...
  // -------------------------------------------------------------

  public BImageCache()
  {
    cache = new BSoftCache(NUM_IMAGES_RETAINED);
  }


  // Class methods...
  // -------------------------------------------------------------

  public static BImageCache getSharedInstance()
  {
    if (instance == null)
      instance = new BImageCache();

    return instance;
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public Image lookup(String name)
  {
    Image image =
      (Image) cache.get(name);

    if (image == null)
      image = BGraphics.getImage(name);
      cache.put(name, image);

    return image;
  }

  public void retainMRU(int size)
    { cache.retainMRU(size); }

  public void retainAll()
    { cache.retainAll(); }

  public void retainNone()
    { cache.retainNone(); }

}
