package roboforge.util.text;

import roboforge.BDebug;

public class BDictionaryTreeNode
{
  char myChar;
  private static char A_INDEX = 'a';

  private static final char CAPITAL_START_INDEX = 'A';
  private static final char CAPITAL_END_INDEX = 'Z';
  private static final char CAPITAL_DIFF = 'a' - 'A';

  private int depth;

  BDictionaryTreeNode[] children;
  BDictionaryTreeNode parent;
  boolean isWord;


  private static char[] r_3 = { 'c', 'a', 't'};

  private static char[] r_4_1 = { 't', 'a', 'x', 'i'};
  private static char[] r_4_2 = { 'c', 'a', 'k', 'e'};
  private static char[] r_4_3 = { 'n', 'i', 'c', 'e'};
  private static char[] r_4_4 = { 'l', 'o', 'a', 'f'};
  private static char[] r_4_5 = { 'e', 'd', 'g', 'e'};

  private static char[] r_5 = { 'p', 'e', 't', 'a', 'l'};
  private static char[] r_6 = { 'f', 'l', 'o', 'w','e','r'};
  private static char[] r_7 = { 'c', 'a', 'r', 't','o','o', 'n'};
  private static char[] r_8 = { 'I', 'a', 'm', 'S','i','l', 'l','y'};
  private static char[] r_10 = { 'p', 'o', 't', 't','y','m', 'o','u', 't','h'};


  public BDictionaryTreeNode(String word)
  // pre :: word needs lower cased

  {
    children = new BDictionaryTreeNode[26];
    depth = 0;

    myChar = word.charAt(0);
    if (word.length() == 1)
      setIsWord(true);
    else
    {
      setIsWord(false);

      char nextChar = word.charAt(1);
      addChild( nextChar - A_INDEX, new BDictionaryTreeNode (word.substring(1) ));

      //children[nextChar - A_INDEX] = new BDictionaryTreeNode (word.substring(1) );


    }

  }

  private static boolean isCapital(char c)
  {
    return ( c >=  CAPITAL_START_INDEX ) && ( c <= CAPITAL_END_INDEX );

  }

  public static char toLower(char c)
  {
    if ( isCapital(c) )
      return (char)(c +  CAPITAL_DIFF);
    else
      return c;
  }

  public void add(String word)
  //pre word is lower cased
  {
   // BDebug.print ("BDictionaryNode.add : " + word );

    if (word.length() == 1)
      setIsWord(true);
    else
    {
      char nextChar = toLower(word.charAt(1));

      if ( children[nextChar - A_INDEX] != null)
        children[nextChar - A_INDEX].add(word.substring(1));
      else
        addChild(nextChar - A_INDEX, new  BDictionaryTreeNode(word.substring(1) ) );

        //children[nextChar - A_INDEX] = new  BDictionaryTreeNode(word.substring(1)) ;

    }

  }


    public void addChild(int index, BDictionaryTreeNode node)
    {
      node.setParent(this);
      children[index] = node ;

    }

    public void setParent(BDictionaryTreeNode parent)
    {
      this.parent = parent;

    }

    public  BDictionaryTreeNode getParent()
      { return parent; }


    public void printWords()
    {
     // BDebug.print ("BDictionaryTreeNode printWords called for " + myChar );
      
      if (isWord)
      {
        String word = "" + myChar;

        BDictionaryTreeNode current = getParent();

        while( current!= null )
        {
         // BDebug.print ("printWords getParent called for " + current.getChar() );

          word = current.getChar() + word;
          current = current.getParent();
        }
        BDebug.print (word);

      }

      for (int i = children.length - 1 ; i >=0; i-- )
      {
        if ( children[i] != null )
          children[i].printWords();
      }


    }



    public char getChar()
      { return myChar; }


    protected int getDepth()
    {
      int cDepth = 1;

      BDictionaryTreeNode current = getParent();

      while( current!= null )
      {
        cDepth++;
        current =  current.getParent();
      }
      return cDepth;

    }

    protected void defaultReplace(char[] string, int index)
    {
      index = index - 1;
      string[index ] = '*';

      BDictionaryTreeNode current = getParent();

      while( current!= null )
      {
        index--;
        string[index] = 'X';
        current =  current.getParent();
      }

    }

   protected void replace(char[] string, int index)
   {
      if (depth == 0)
        depth = getDepth();

     //BDebug.print("BDecisiontreeNode replace depth" + depth);

     if ( depth == 3)
      System.arraycopy(r_3, 0, string, index - 3,3);
     else if ( depth == 4)
     {
      double r = Math.random();

      if (r < 0.2)
        System.arraycopy(r_4_1, 0, string, index - 4,4);
      else if (r < 0.4)
        System.arraycopy(r_4_2, 0, string, index - 4,4);
      else if (r < 0.6)
        System.arraycopy(r_4_3, 0, string, index - 4,4);
      else if (r < 0.8)
        System.arraycopy(r_4_4, 0, string, index - 4,4);
      else
        System.arraycopy(r_4_5, 0, string, index - 4,4);



     }


     else if ( depth == 5)
      System.arraycopy(r_5, 0, string, index - 5,5);
     else if ( depth == 6)
      System.arraycopy(r_6, 0, string, index - 6,6);
     else if ( depth == 7)
      System.arraycopy(r_7, 0, string, index - 7,7);
     else if ( depth == 8)
      System.arraycopy(r_8, 0, string, index - 8,8);
     else if ( depth == 10)
      System.arraycopy(r_10, 0, string, index - 10,10);
     else
      defaultReplace(string,index);

   }


   public boolean isAlpha(char c)
  {
    return (c >= 'a' && c <= 'z')  || (c >= 'A' && c <= 'Z');
  }


  protected void setIsWord (boolean b)
  {
    isWord = b;


  }
   public void filter(char[] string, int index)
   {
      //BDebug.print("filter called for " + myChar + "  :: index " + index);

      if (isWord)
      {
          replace(string, index);
          return;
      }

      if (index >= string.length)
        return;
      else
      {
       // BDebug.print("filter nextChar " + toLower(string[index ]) );

          char nextChar =  toLower(string[index]);

          if (!isAlpha(nextChar) )
            return;
          if (children[nextChar - A_INDEX] == null)
            return;
          else
          {
            children[nextChar - A_INDEX].filter(string, index +1);
          }


      }



   }


}