package roboforge;

import com.sun.j3d.loaders.Scene;
import com.sun.j3d.loaders.vrml97.VrmlLoader;
import java.util.*;
import java.io.File;
import javax.media.j3d.*;
import com.sun.j3d.loaders.SceneBase;
import roboforge.util.text.*;

public class B3dShapeManager
{
  private static VrmlLoader f;

  //private static Vector scenes;
  //private static Vector filenames;
  private static Hashtable scenes = new Hashtable();

  public B3dShapeManager()
  {
  }


  private static Scene s = null;

  public static Scene getScene( String structure3DFileName )
  {
    // ensure Lower Case
    structure3DFileName = BStrings.convertToFilePath(structure3DFileName);
    //BDebug.print ("B3dShapeManager.getScene " + structure3DFileName);

    //BDebug.seedTimer();
    //String suffix =  structure3DFileName.substring( structure3DFileName.length()-4, structure3DFileName.length());

    // check cache
    if (scenes.containsKey(structure3DFileName) )
    {
     // BDebug.print("scene Found in Cache " + structure3DFileName);
      return (Scene )scenes.get(structure3DFileName);
    }


    String j3dFileName = structure3DFileName.substring(0, structure3DFileName.length()-4);
    j3dFileName = j3dFileName + BGlobal.J3DSUFFIX;
    //BDebug.print("Checking existance of " + j3dFileName);
    File tester = new File(j3dFileName);

    try
    {

      if (tester.exists() )
      {

        // load
        BranchGroup sceneBG = SceneGraphSerializer.Serialize.load( j3dFileName );
        s = new SceneBase() ;
        ((SceneBase)s).setSceneGroup(sceneBG) ;

        // cache
        scenes.put(structure3DFileName, s);


      }
      else
      {
        if (f == null)
          f= new VrmlLoader();

        s = f.load( structure3DFileName);
        scenes.put(structure3DFileName, s);


      }



    }
    catch (Exception e) {BDebug.print("B3dShapeManager.getScene. ERROR LOADING VRML FILE  " + e.getMessage() );}




    return s;

  }


  public static boolean saveBranchGroup(String name, BranchGroup toSave )
  {
    try
    {
      BranchGroup newGroup = new BranchGroup();

      convertShapes (toSave, newGroup);

      SceneGraphSerializer.Serialize.save( name,newGroup );
      return true;
    }
    catch (Exception e) { return false ; }

  }


   public static void clear()
   {
    clear(false);
   }

    public static void clear(boolean nullifyLoader)
  {
    BDebug.print ("BShape3DManager.clear() activated ");
    scenes.clear();

    s = null;

    if (nullifyLoader)
    {
      f = null;

    }
  }



protected static void convertShapes ( Node oldBranch, Group newBranch)
{

  if ( oldBranch instanceof Group )
  {
        Group currentGroup = (Group) oldBranch;

        for (Enumeration e = currentGroup.getAllChildren(); e.hasMoreElements();)
        {
                Node newGroup =(Node)e.nextElement();

                if ( (newGroup instanceof TransformGroup)   )
                {
                        TransformGroup oldTrans = (TransformGroup) newGroup;
                        Transform3D tempTrans = new Transform3D();
                        oldTrans.getTransform(tempTrans);
                        TransformGroup newTrans = new TransformGroup( tempTrans);

                        convertShapes(oldTrans,  newTrans );
                        newBranch.addChild(newTrans);

                }
                else
                     convertShapes(newGroup,  newBranch );

        }   // loop
  }   // if
  else  if ( (oldBranch instanceof Shape3D )  )
  {
    Shape3D tempS = (Shape3D)oldBranch;
    Shape3D tempB  = new Shape3D( tempS.getGeometry());
    newBranch.addChild( tempB );

  }




}



}