package roboforge;

import java.util.*;
import java.awt.*;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.behaviors.mouse.*;
//import com.sun.j3d.utils.geometry.Cylinder;
//import com.sun.j3d.utils.geometry.Primitive;
//import com.sun.j3d.utils.image.*;
import javax.vecmath.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.universe.*;
import javax.swing.tree.*;
//import java.awt.event.*;
//import java.awt.image.BufferedImage;
//import javax.media.j3d.Raster;
//import sun.awt.windows.*;
//import java.lang.Thread;

import javax.swing.*;


//import com.sun.j3d.utils.geometry.*;

import roboforge.btree.*;
import roboforge.geometry.*;


public class BBotCanvas extends Canvas3D implements BMouseListenerCanvas{

/*
* Description: The Bot Canvas

* Modification History  YLY, 12 Apr 99 - Copied BComponent Canvas and Started Modification
                                16 Apr 99 - First Live Version,
                                21 Apr 99 - Changed Mouse behaviours,
                                29 Apr 99 - Fixed a few memory holes,  Wire frame etc
                                30 Apr 99 - Spring Cleaning
                           AWH, 16 Jan 01 - Added zoom and pan
                                */


   /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
// Universe Nodes
   private SimpleUniverse universe;  // the canvas 3d universe
   private  BranchGroup sceneRootG;
   private TransformGroup scaledScene;
   private BranchGroup scene;

   private BPickHighlightBehavior componentPick;

   TransformGroup navigationTrans;
   private TransformGroup noFloorTrans;
   private TransformGroup zoomGroup;


   private BranchGroup pickGroup;
   private BranchGroup tempLive;

   private BMouseDrag floorBehaviour;

   private TransformGroup arenaRotateGroup;
   private TransformGroup displacementGroup;

   // Universe Appearance
   private Background bg = null;
   //private Color3f ambientColor ;
   private AmbientLight AMB_LIGHT;
   BranchGroup bgGeometry = null;


// zRotate of screen members
//  private TransformGroup zTrans;
//  private static double ZSTEP = 0.15;


// MODES
   private int mode;

   private boolean isConstruction;
   public boolean wireFrameFloor;
   public boolean wireOnRotate;


   private BranchGroup zones = null;
   private boolean rangeDisplayOn = false;


// Selected Appearance
   private String selectedTextureName = null;
   private float selectedShine = BComponent.DEFAULTSHINE;
   private Color selectedColor = BComponent.DEFAULTCOLOR;
   private int selectedColourDepth = BComponent.DEFAULTDEPTH;

   //private Appearance floorAppearance;


 // CONSTANTS
   private static BoundingSphere bounds = BGlobal.INFINITE_BOUNDS;
   static final double BACKCLIPDIST = 1000.0;
   static final double FRONTCLIPDIST = 0.1;


// Cleanup Vectors
   private Vector componentList;
   private Vector shapeList;

// Cursors
  private Cursor paintBucketCursor;
  private Cursor eyeDropperCursor;

// parent
  //private BBotViewerPanel parentPanel;

  //private boolean wait = false;


  private javax.media.j3d.Locale myLocale;



  public BBotCanvas(boolean isConstructionCanvas /* false means isMovesCanvas*/
                        ,JPanel parent , Behavior play)
  {

  super(GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getBestConfiguration(new GraphicsConfigTemplate3D())    );
  //parentPanel = parent;

  isConstruction = isConstructionCanvas;
  wireFrameFloor = false;
  wireOnRotate = true;


  // set the node
  componentList = new Vector();
  shapeList = new Vector();

  setCursor();

  // Root
  sceneRootG = new BranchGroup();
  sceneRootG.setUserData("The Scene Root");
  sceneRootG.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);

  if (play != null)
        sceneRootG.addChild(play);

  // Ambient Light
  //Use Ambient_DirLight instead of AMBIENT COLOUT because this canvas bypasses the USE_DIRLIGHT flag
  AMB_LIGHT = new AmbientLight(BGlobal.AMBIENT_DIRLIGHT);
  AMB_LIGHT.setInfluencingBounds(bounds);
  AMB_LIGHT.setCapability(Light.ALLOW_COLOR_WRITE);
  AMB_LIGHT.setUserData("AMB_LIGHT");

  sceneRootG.addChild(AMB_LIGHT);

  // Create the directional lights
  Vector3f dir = new Vector3f(0f, -1.0f, -0.4f);
  DirectionalLight dirLight = new DirectionalLight(BGlobal.CANVASLIGHT, dir);
  dirLight.setInfluencingBounds(bounds);
  sceneRootG.addChild(dirLight);

  bg = new Background(0.2f, 0.2f, 0.4f);
//  bg = new Background(0.0f, 0.0f, 0.0f);

  bg.setApplicationBounds(bounds);

  //bg.setImage(bgImage);
  sceneRootG.addChild(bg);
  bg.setCapability(Background.ALLOW_GEOMETRY_WRITE);
  bg.setApplicationBounds(bounds);

  //  Mouse Behaviour Transforms
  navigationTrans = new TransformGroup();
  navigationTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
  navigationTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
  navigationTrans.setUserData("navigationTrans (Mouse behaviours)");
  sceneRootG.addChild(navigationTrans);



  scaledScene = new TransformGroup();
  Transform3D t3d = new Transform3D();
  t3d.setScale(BGlobal.CHASSIS_SCALE);
  scaledScene.setTransform(t3d);

  scaledScene.setUserData("scaledScene (scales down) ");
  navigationTrans.addChild(scaledScene);

  scaledScene.addChild(noFloorTrans);


  noFloorTrans = new TransformGroup();
  noFloorTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
  noFloorTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
  noFloorTrans.setUserData("noFloorTrans  (Chassis tilt) (for moves Panel) ");

  scaledScene.addChild(noFloorTrans);    // was scacekScene.addchild

  noFloorTrans.setCapability(Group.ALLOW_CHILDREN_WRITE);
  noFloorTrans.setCapability(Group.ALLOW_CHILDREN_EXTEND);


  if (!isConstruction)
        {

        //theFloor = makeFloor();
        BranchGroup tempLive =   getGrid() ;

        tempLive.setCapability(Group.ALLOW_BOUNDS_READ);
        tempLive.setCapability(Group.ALLOW_CHILDREN_WRITE);
        tempLive.setCapability(BranchGroup.ALLOW_DETACH);
        tempLive.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
        tempLive.setCapability(Group.ALLOW_CHILDREN_EXTEND);

        navigationTrans.addChild(  tempLive    );

         // Create the  behavior node that is independent of the
        if (BGlobal.MOVE_FLOOR )
                {

                BMouseTranslate behavior3 = new BMouseTranslate();
                behavior3.setTransformGroup(noFloorTrans);
                noFloorTrans.addChild(behavior3);
                behavior3.setSchedulingBounds(bounds);

                floorBehaviour = new BMouseDrag(this, isConstructionCanvas, true, false);
                floorBehaviour.setTransformGroup(noFloorTrans);
                noFloorTrans.addChild(floorBehaviour);
                floorBehaviour.setSchedulingBounds(bounds);

                }


        }







  pickGroup = new BranchGroup();

  // PICK BEHAVIOUR
  componentPick = new BPickHighlightBehavior(this, sceneRootG, BGlobal.INFINITE_BOUNDS, true);
  componentPick.setUserData("componentPick pick highlight behaviour ");

  noFloorTrans.addChild(pickGroup);

  pickGroup.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
  pickGroup.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
  pickGroup.setUserData("pickGroup pick highlight behaviour group");


    // movement nodes
  arenaRotateGroup = new TransformGroup();
  arenaRotateGroup.setUserData("Arena Rotate Group (for Moves Panel)");
  arenaRotateGroup.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
  arenaRotateGroup.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);


  displacementGroup = new TransformGroup();
  displacementGroup.setUserData("Arena displacementGroup (for Moves Panel)");

  if (!isConstruction )
  {
        displacementGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        arenaRotateGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
  }

  pickGroup.addChild(displacementGroup);
  displacementGroup.addChild(arenaRotateGroup);


  ViewingPlatform newP = new  ViewingPlatform();
  // Set the universe Transform3D object.
  zoomGroup = newP.getViewPlatformTransform();
  Transform3D transform = new Transform3D();
  zoomGroup.setTransform(transform);
  Viewer newV = new Viewer(this);
  newV.getView().setFrontClipDistance(FRONTCLIPDIST );
  newV.getView().setBackClipDistance(BACKCLIPDIST);


  // Add Mouse Behaviours to the Mouse behaviour node

  //if (isConstruction)
  //{

    // Create the rotate behavior node
    BMouseDrag behavior = new BMouseDrag(this, isConstructionCanvas, false, false);
    behavior.setTransformGroup(navigationTrans);
    navigationTrans.addChild(behavior);

	  // Create the zoom behavior node
	  MouseZoom behavior2 = new MouseZoom();
	  behavior2.setTransformGroup(navigationTrans);
    behavior2.setFactor(5.0);
	  navigationTrans.addChild(behavior2);

	  // Create the translate behavior node
	  MouseTranslate behavior3 = new MouseTranslate();
	  behavior3.setTransformGroup(navigationTrans);
    behavior3.setFactor(2.0);
	  navigationTrans.addChild(behavior3);
  /*
  }
  else
  {
        behavior = new BMouseDrag(this, isConstructionCanvas, false, true);
        behavior.setInvert(true);
        behavior.setTransformGroup(zoomGroup);
        zoomGroup.addChild(behavior);
  } */
  behavior.setSchedulingBounds(bounds);
  behavior2.setSchedulingBounds(bounds);
  behavior3.setSchedulingBounds(bounds);


  // BDebug.printj3D("BbotCanvas: ", sceneRootG);

  universe = new SimpleUniverse(newP, newV);
  universe.addBranchGraph(sceneRootG);
  myLocale = universe.getLocale();


  if (isConstructionCanvas)
        setZoom(BGlobal.STARTZOOM_CONSTRUCTION);
  else
        setZoom(BGlobal.STARTZOOM_MOVES);

// Cursors
  Image cursorImg = getToolkit().createImage(BGlobal.IMAGEPATH + "BBotViewerPanel/eyedropper_cursor.gif");
  eyeDropperCursor = getToolkit().createCustomCursor(cursorImg, new Point(0,31), "Eye Dropper");

  cursorImg = getToolkit().createImage(BGlobal.IMAGEPATH + "BBotViewerPanel/paintbucket_cursor.gif");
  paintBucketCursor = getToolkit().createCustomCursor(cursorImg, new Point(29,29), "Paint Bucket");


  }


  private void setCursor()
  {

  if ( mode == BGlobal.CANVAS_MODE_ORIENTATE )
     setCursor(new Cursor(Cursor.HAND_CURSOR));
  else if( mode == BGlobal.CANVAS_MODE_CONNECTROTATE)
     setCursor(new Cursor(Cursor.HAND_CURSOR));
  else if( mode == BGlobal.CANVAS_MODE_JOINTMOVE )
     setCursor(new Cursor(Cursor.HAND_CURSOR));
  else if (mode == BGlobal.CANVAS_MODE_APPEARANCEPICK)
     setCursor(eyeDropperCursor);
  else if (mode == BGlobal.CANVAS_MODE_APPEARANCESET)
     setCursor(paintBucketCursor);

   }


  protected static final float GRID_SIZE_METERS = 20.0f;
  protected static final int   GRID_MAJOR_LINES = 4;
  protected static final int   GRID_MINOR_LINES = 5;

  public BranchGroup getGrid()
  {
    // Get canvas' UI foreground color...
    //Color canvasFGColor = getForeground();
    //float[] canvasFGComp = canvasFGColor.getColorComponents(null);
    //Color3f fg = new Color3f(canvasFGComp);

    float gridSize =
      (GRID_SIZE_METERS * BGlobal.WORLD_TO_CANVAS_SCALE );

    BPlanarGrid3D grid = new BPlanarGrid3D
    (
      gridSize,
      GRID_MAJOR_LINES,
      GRID_MINOR_LINES,
      BGlobal.WHITE_3F, BGlobal.WHITE_3F
    );

    BranchGroup gridGroup = new BranchGroup();
    gridGroup.setCapability(BranchGroup.ALLOW_DETACH);
    gridGroup.addChild(grid);

    return gridGroup;
  }



  public void setMode (int newMode )
  {



  if ( newMode == BGlobal.CANVAS_MODE_ORIENTATE )
     BDebug.print("BBotCanvas.CANVAS_MODE_ORIENTATE");
  else if( newMode == BGlobal.CANVAS_MODE_CONNECTROTATE)
     BDebug.print("BBotCanvas.MODE_CONNECTROTATE");
  else if( newMode == BGlobal.CANVAS_MODE_JOINTMOVE )
     BDebug.print("BBotCanvas.MODE_JOINTMOVE ");
  else if (newMode == BGlobal.CANVAS_MODE_APPEARANCEPICK)
     BDebug.print("BBotCanvas.MODE_APPEARANCEPICK ");
  else if (newMode == BGlobal.CANVAS_MODE_APPEARANCESET)
     BDebug.print("BBotCanvas.MODE_APPEARANCESET ");
  else if (newMode == BGlobal.CANVAS_MODE_ZONE_SCALE)
     BDebug.print("BBotCanvas.CANVAS_MODE_ZONE_SCALE ");
  else if (newMode == BGlobal.CANVAS_MODE_ZONE_X)
     BDebug.print("BBotCanvas.CANVAS_MODE_ZONE_X ");
  else if (newMode == BGlobal.CANVAS_MODE_ZONE_Y)
     BDebug.print("BBotCanvas.CANVAS_MODE_ZONE_Y ");
  else if (newMode == BGlobal.CANVAS_MODE_ZONE_Z)
     BDebug.print("BBotCanvas.CANVAS_MODE_ZONE_Z ");
  else
  {
         BDebug.print("UNKNOWN MODE, NOT SETTING");
         return;
  }

     mode = newMode;
     setCursor();

  }


  public int getMode()
  {
    return mode;

  }

  //private float  lastZoom  = 0f;

  public void setZoom(float zoom )
  {
     Transform3D transform = new Transform3D();
     //Vector3f length = new Vector3f(0.0f, 0.0f, zoom);
     /*
     Vector3f current = new Vector3f();


     zoomGroup.getTransform(transform);
     transform.get(current);

     float ratio =  length.length() / current.length();

     current.scale(ratio);
     transform.setTranslation(current);   */
     transform.set( new Vector3f(0.0f, 0.0f, zoom) );
     zoomGroup.setTransform(transform);
  }






  public float getZoom()
  {

  Transform3D transform = new Transform3D();
  zoomGroup.getTransform(transform);

  Vector3f transL = new Vector3f();
  transform.get(transL);

  return transL.z;

  }






/*
  public void rotateZ(boolean clockwise)
  {

  try{


     if (clockwise)
      zRotate = zRotate - ZSTEP;
    else
      zRotate = zRotate + ZSTEP;

    Transform3D tempT = new Transform3D();
    tempT.rotZ( zRotate );


    //Transform3D rotZaxis = new Transform3D();
    zTrans.setTransform(tempT);


//   rotZaxis.rotZ(zRotate);
//   rotZaxis.setTranslation(zoom);

   //tg.setTransform(rotZaxis);
   }catch(Exception e) { BDebug.print(" BBotCanvas.zrotate " + e.getMessage()); }

  }

  */

  private BranchGroup createDefaultScene3D()
  {

  // create a simple detachable node
  BranchGroup objRoot = new BranchGroup();
  objRoot.setCapability(BranchGroup.ALLOW_DETACH);
  objRoot.setCapability(BranchGroup.ALLOW_BOUNDS_READ);
  return objRoot;

  }


  public void clearLastSelected()
  {
    componentPick.setLastSelected(null);
  }




  public BHighlightShape getLastSelected()
  {
   return   componentPick.getLastSelected();

  }

/*
public BHighlightShape getLastSelectedHighLightShape()
{
  return  componentPick.getLastSelected();

}
   */
public void setHighLight(BComponent newComponent)
{

  newComponent.setHighlight();
  if ( componentPick.getLastSelected() != null)
    componentPick.getLastSelected().setHighlight(false);

  // Sets the last Selected to a shape that is not in the Scene, but has a parent Component that is in the scene
  // The Parent.setHilight is called
  componentPick.setLastSelected(newComponent.getArbitraryShape())  ;


}


public void addComponent( BComponent child, BComponent parent )
{
// chucked in to implement BSimulation Canvas
  loadComponent(child, parent);

}

public void loadComponent(BComponent newComponent, BComponent parentComponent)
 {
/*

* Description:  Loads the Convas stuff


	* Parameters:
                newComponent MUST HAVE the

	* Results: Displays the component and all their connect piints
* Example:
* Modification History ( Name, Date, Notes ):
                        YLY, 12 Apr 99, Copied from Last BComponentCanvas
*/


   // Clear Scene

 
 try
        {
        setCursor(new Cursor(Cursor.WAIT_CURSOR));

        // place component in clearance in the list
        componentList.add(newComponent);

        // Cache Shapes for disposal (BUG HACK)
        tempLive = newComponent.cloneStructure3D();
        extractShapes(tempLive);
        tempLive.setCapability(Group.ALLOW_CHILDREN_WRITE);
        tempLive.setCapability(BranchGroup.ALLOW_DETACH);
        tempLive.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
        tempLive.setCapability(Group.ALLOW_CHILDREN_EXTEND);
        tempLive.setCapability(Group.ALLOW_BOUNDS_READ);

        // New Live Node



        if (parentComponent == null )
        {

                newComponent.setLiveBotNode(tempLive);

                arenaRotateGroup.addChild(tempLive);
                scene = tempLive;

                if (!isConstruction)
                {
                        ((BChassis)newComponent).setLiveNodes(     displacementGroup ,  arenaRotateGroup);
                        ((BChassis)newComponent).applyArenaPosition();
                        ((BChassis)newComponent).setArenaPosition(0, 0);
                }



        }
        else
        {

                  newComponent.attach(parentComponent,tempLive, isConstruction , false);

                  if ( ( rangeDisplayOn ) && ( newComponent instanceof BSensor))
                      ((BSensor)newComponent).addRangeDisplay();


        }; // ELSE PARENT == NULL

    } catch(Exception e) { BDebug.print("ERROR :BBotCanvas.loadComponent:" + e.getMessage() );  };


    setCursor();

}





 public void setBackgroundImage (String imageName)
/*

* Description: Sets the Background of the Canvas
	* Parameters:  The GIF,
	* Results: displays the image
* Example:

            import com.sun.j3d.utils.image.*;

            TextureLoader loader = new TextureLoader("bgGif.gif" ,new Panel()  );
            ImageComponent2D bgImage = loader.getImage();
            componentCanvas.setBackgroundImage (bgImage);

* Modification History ( Name, Date, Notes ):

*/


 {

 /* TAKEN OUT CAUSE IT LOOKS DUMB

  if (BGlobal.SHOW_BACKGROUND && (bgGeometry  == null) )
  {

    bgGeometry = new BranchGroup();
    Appearance ap = new Appearance();

    //Plane Object
    BComponent back = new BComponent("Floor", BGlobal.PLANEOBJECT);
    back.setColor(BGlobal.FLOORCOLOR);
    back.setTexture(BGlobal.FLOORTEXTURE);

    // Rotate
    Transform3D rotX = new Transform3D();
    rotX.rotX(java.lang.Math.PI / 2.0);

    // translate
    rotX.setTranslation(new Vector3f(0,0,-50f));
    TransformGroup rotXG = new TransformGroup(rotX);
    rotXG.addChild(back.cloneStructure3D(false, false));


    bgGeometry.addChild(rotXG);
    sceneRootG.addChild(bgGeometry);


  }

  */

 }

 public void setAmbientColour ( Color3f newColour)
 {

 AMB_LIGHT.setColor(newColour);
 }


 public void removeBot()
    {
      if (scene != null)
      {
        scene.detach();

        setCursor(new Cursor(Cursor.WAIT_CURSOR));


        //BDebug.print("-----BBotCanvas.removeBot------");
        //BDebug.printFreeMem();




        BComponent current;

        for (int a = 0 ; a < componentList.size() ; a++ )
                {
                current = (BComponent)componentList.get(a);
                current.cleanseLiveNodes();

                }    // for loop

        BShape3D currentS;
        for (int a = 0 ; a < shapeList.size() ; a++ )
                {
                currentS = (BShape3D)shapeList.get(a);
                currentS.setAppearance(null);
                currentS.setGeometry(null);
                currentS.setComponent(null);
                }    // for loop

        componentPick.setLastSelected(null);
        shapeList.removeAllElements();
        componentList.removeAllElements();
        scene = null;

        addZones(null, false);

        System.gc();
        //BDebug.printFreeMem();
        //BDebug.print("-----END:BBotCanvas.removeBot------");

        setCursor();
     }

}


 public void removeComponent  (BComponent theComponent)
 {

 try{

        setCursor(new Cursor(Cursor.WAIT_CURSOR));

        //BDebug.print(shapeList.size());
        //BDebug.print("Before Remove");

        DefaultMutableTreeNode rootNode = theComponent.getTreeNode();
        Enumeration enumerator = rootNode.depthFirstEnumeration();

        while (enumerator.hasMoreElements())
        {
                DefaultMutableTreeNode node = (DefaultMutableTreeNode)enumerator.nextElement();
                removeComponentNode( (BComponent)node.getUserObject() ) ;
        }

        System.gc();
        componentPick.setLastSelected(null);

        setCursor();

    } catch(Exception e) {BDebug.print(" BBotCanvas.removeComponent: Error : " + e.getMessage() );}

 }


private void removeComponentNode(BComponent theComponent)

  {

   try{
        componentList.remove(theComponent);
        theComponent.getLiveNode().detach();
        theComponent.cleanseLiveNodes();
        BShape3D current;

        for (int a = shapeList.size()-1  ; a >= 0 ; a-- )
        {
                current = (BShape3D)shapeList.get(a);


                if (current.getComponent() == theComponent)
                        {


                        current.setAppearance(null);
                        current.setGeometry(null);
                        current.setComponent(null);
                        shapeList.remove(current);

                        }
       }    // for loop


    }catch (Exception e){BDebug.print("BBotCanvas.removeComponentNode ERROR:" + e.getMessage() );};


  }




 public void setWireFrame()
// SETS ALL OBJECTS TO WIREFRAME

{
  if (BGlobal.WIREFRAME_ON_MOVE)
    {

      try{
        BComponent current;

        for (int a = 0 ; a < componentList.size() ; a++ )
                {
                current = (BComponent)componentList.get(a);
                current.setWireFrame();
                }    // for loop






       } catch (Exception e){BDebug.print("BBotCanvas.setWireFrame ERROR: " + e.getMessage() );}

       // parentPanel.getBParent().botChanged();
     }

} //setWireFrame


public void setWireFrame(BComponent theComponent)
// SETS ALL CHILDREN OF THIS TO A WIRE FRAME

{
  try{

    if (BGlobal.WIREFRAME_ON_MOVE)
    {
      DefaultMutableTreeNode rootNode = theComponent.getTreeNode();
      Enumeration enumerator = rootNode.breadthFirstEnumeration();
      while (enumerator.hasMoreElements())
              {
                DefaultMutableTreeNode node = (DefaultMutableTreeNode)enumerator.nextElement();
                ((BComponent)node.getUserObject()).setWireFrame();

               }

     }
   //  parentPanel.getBParent().botChanged();


     } catch (Exception e){BDebug.print("BBotCanvas.setWireFrame ERROR: " + e.getMessage() );}
} //setWireFrame


public void exitWireFrame()
// exits the wire frame
    {

    if (BGlobal.WIREFRAME_ON_MOVE)
    {

      try
        {

        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        BComponent current;
        //Thread.currentThread().setPriority(Thread.MAX_PRIORITY);

        for (int a = 0 ; a < componentList.size() ; a++ )
        {
                current = (BComponent)componentList.get(a);
                current.setNormalAppearance();
        }


        setCursor();





        } catch (Exception e){BDebug.print("BBotCanvas.exitWireFrame.error: " + e.getMessage() );};
      }


      if (getLastSelected() != null )
         if (getLastSelected() instanceof BShape3D)
              ((BShape3D) getLastSelected()).getComponent().setHighlight();


    }



 private void extractShapes ( Node oldBranch )
  {

  if ( oldBranch instanceof Group )
      {
      Group currentGroup = (Group) oldBranch;
      for (Enumeration e = currentGroup.getAllChildren(); e.hasMoreElements();)
          {
           Node newGroup =(Node)e.nextElement();
           extractShapes(newGroup);
           }   // loop
      }   // if
  else if ( (oldBranch instanceof BShape3D )  )
    {
        shapeList.add(oldBranch);
        oldBranch.setCapability(Shape3D.ALLOW_BOUNDS_READ);


     //   BCollision col = new BCollision((BShape3D)oldBranch);
        //col.setSchedulingBounds(bounds);

	      // Add the behavior to the scene graph
	     // tempLive.addChild(col);

    }

  }


 public void modeMethod(BHighlightShape newShape)
 // The Method that performs the action associated with the current Mode
 {



 if  (newShape != null)
 {
   try{





     BShape3D shape = (BShape3D)newShape;

     if ( mode == BGlobal.CANVAS_MODE_APPEARANCEPICK )
        {

        selectedColor = shape.getComponent().getColor();
        selectedShine =  shape.getComponent().getShine();
        selectedTextureName = shape.getComponent().getTextureName();
        selectedColourDepth =  shape.getComponent().getColorDepth();
        refreshSelectedButton();


        }
    else if (mode == BGlobal.CANVAS_MODE_APPEARANCESET)
        {

        shape.getComponent().setNormalAppearance();
        shape.getComponent().setAppearance(selectedTextureName, selectedColor, selectedShine, selectedColourDepth );


       // if ( parentPanel.getBParent() != null)
        //        parentPanel.getBParent().botChanged();

        }
    else if (mode == BGlobal.CANVAS_MODE_JOINTMOVE)
        {

                // If the Mode is Joint the Grab the Nearest Joint and Rotate to the ChassisHull
                BComponent theJoint = shape.getComponent();
                if (!(theJoint instanceof BJoint))
                        {

                        DefaultMutableTreeNode theNode = theJoint.getTreeNode();
                        //Enumeration path = theNode.pathFromAncestorEnumeration(theNode.getRoot());


                             for (Enumeration e = theNode.pathFromAncestorEnumeration(theNode.getRoot()); e.hasMoreElements() ;)
                                {

                                DefaultMutableTreeNode tempN =(DefaultMutableTreeNode)e.nextElement();
                                BComponent tempC = (BComponent)tempN.getUserObject();
                                if (tempC instanceof BJoint)
                                        theJoint = tempC;

                                }
                        }

                if ((theJoint.getComponentType() == BJoint.COMPONENT_TYPE))
                {
                        theJoint.getArbitraryShape().setActiveArea();
                        componentPick.pick(theJoint.getArbitraryShape());

                }

        }
    else
        {
        if (shape.setActiveArea())
                componentPick.pick(newShape);
        }

     }catch(Exception e) { BDebug.print("BBotCanvas.modeMethod ERROR: " + e.getMessage() ); };



     }



 } // modeMethod

 public void refreshSelectedButton()
 {

      //  parentPanel.appButton.repaint();

 }

 public String getSelectedTextureName()
 {

 return selectedTextureName;

 }

 public int getSelectedColorDepth()
 {
  return selectedColourDepth;
 }

 public void setSelectedColorDepth (int newDepth)
 {
 selectedColourDepth = newDepth;

 }
 public Color getSelectedColor()
 {

 return selectedColor;

 }

 public void setSelectedTextureName(String s)
 {

 selectedTextureName = s;

 }

 public void setSelectedColor(Color c)
 {

 selectedColor = c;

 }

  public float getSelectedShine()
 {

 return selectedShine;

 }

 public void setSelectedShine(float f)
 {

 selectedShine = f;

 }


 public void clearCanvasRotation()
 {
    Matrix3f id = new Matrix3f();
    id.setIdentity();

    Transform3D currentT = new Transform3D();
    navigationTrans.getTransform(currentT);

    currentT.setRotation(id);

    navigationTrans.setTransform(currentT);

 }


 public void translate(int dx, int dy)

 {
        double x_Translation_factor = .4;
        double y_Translation_factor = .4;

        Transform3D currXform = new  Transform3D();
        Transform3D transformX = new  Transform3D();
        Vector3d translation = new Vector3d();

        navigationTrans.getTransform(currXform);

        translation.x = dx*x_Translation_factor;
	      translation.y = -dy*y_Translation_factor;

        transformX.set(translation);
        currXform.mul(transformX, currXform);

        navigationTrans.setTransform(currXform);

 }




public  double getFloorX()
  {

  if (floorBehaviour == null)
    return 0.0;
  else
    return floorBehaviour.getX();


  }

public  double getFloorY()
  {

  if (floorBehaviour == null)
    return 0.0;
  else
    return floorBehaviour.getY();


  }


public void setFloorOrientation(double x, double y)
 {

 try{
        floorBehaviour.set_ABS(x,y);
     } catch (Exception e) { BDebug.print ("BBotCanvas.setFloorOrientation ERROR: " + e.getMessage() );}
 }


public TransformGroup getChassisOrientationGroup()
{
  return noFloorTrans;

}


public TransformGroup getNavigationNode()
{
  return navigationTrans;
}




public void setFloorHeight(float newHeight)
  {
    Vector3f translV = new Vector3f(0,newHeight,0);
    Transform3D currentT = new Transform3D();
    noFloorTrans.getTransform(currentT);

    currentT.setTranslation(translV);
    noFloorTrans.setTransform(currentT);



  }




public  Matrix4f getCanvasOrientation()
  {


  Matrix4f tempM = new Matrix4f();
  try{
        Transform3D theTransform = new Transform3D();
        navigationTrans.getTransform(theTransform);
        theTransform.get(tempM);
        } catch (Exception e) { BDebug.print ("BBotCanvas.getCanvasOrientation ERROR: " + e.getMessage() );}
  return tempM;


  }


public void setCanvasOrientation(Matrix4f newOrient)
 {

 try{
        Transform3D newT = new Transform3D();
        newT.set(newOrient);
        navigationTrans.setTransform(newT);
     } catch (Exception e) { BDebug.print ("BBotCanvas.setCanvasOrientation ERROR: " + e.getMessage() );}
 }


public void addZones(BranchGroup theZones, boolean toAdd)
// if toAdd is true then add, else remove
 {
   try{
        if (toAdd)
        {
                noFloorTrans.addChild(theZones);
                zones = theZones;
        }
        else
        {

                if (zones != null)
                        zones.detach();
               // if (parentPanel.activeZonesDialog != null)
                  //  parentPanel.activeZonesDialog.close();
                zones = null;
        }
      } catch (Exception e) { BDebug.print ("BBotCanvas.addZones ERROR: " + e.getMessage() );}


 }



 public void postSwap()
 {

    //BDebug.printTime("renderTine");
    //BDebug.seedTimer();

 }


 public void addLimb(BComponent baseComponent, BComponent parentComponent)
 // to add limb that is not part of a bot
 {
    loadComponent( baseComponent, parentComponent);

    DefaultMutableTreeNode d = baseComponent.getTreeNode();
    Enumeration enumerator = d.children();


    while (enumerator.hasMoreElements())
    {
      DefaultMutableTreeNode node = (DefaultMutableTreeNode)enumerator.nextElement();
      BComponent component = (BComponent)node.getUserObject();
      addLimb(component);
    }



 }


 public void addLimb(BComponent baseComponent)
 // to add a limb that is already part of the bot
 {

    DefaultMutableTreeNode d = baseComponent.getTreeNode();
    Enumeration enumerator = d.breadthFirstEnumeration();

    while (enumerator.hasMoreElements())
    {
      BComponentNode node = (BComponentNode)enumerator.nextElement();
      BComponent component = node.getComponent();
      DefaultMutableTreeNode parentNode = (BComponentNode)node.getParent();
      if (parentNode == null)
      {
        loadComponent(component,null);
      }
      else
      {
        BComponent parent = (BComponent)parentNode.getUserObject();
        loadComponent(component,parent);
      }

    }

 }


 /*  resume later
 public Image getOrthogonalImage(int x, int y)
 {
    BufferedImage botImage = new BufferedImage(x, y, BufferedImage.TYPE_3BYTE_BGR );

    int centreX = x / 2;
    int centreY = y / 2;


    //clearCanvasRotation();
    
    Graphics2D g = (Graphics2D)botImage.getGraphics();
    //g.drawString("hello", 20, 20);
    float xMax = 0;
    float xMin = 0;

    float yMax = 0;
    float yMin = 0;

    Vector theRects = new Vector();
    Transform3D localV = new Transform3D();

    for (int i=0; i<shapeList.size(); i++ )
    {
      BShape3D s = (BShape3D) shapeList.get(i);

      s.getLocalToVworld(localV);

      Vector3f pA = new Vector3f( s.getBoundingBox().pA );
      Vector3f pB = new Vector3f( s.getBoundingBox().pB );

      //BDebug.print("Before" + pA);
      //localV.setScale(1.0);
      localV.transform(pA);
      localV.transform(pB);

      BDebug.print("After pA" + s.getComponent() + " " + pA.y);
      BDebug.print("After pB" + s.getComponent() + " " + pB.y);
      //BDebug.print(pA);
      pA.scale(50f);
      pB.scale(50f);



      Polygon thePoly = new Polygon();
      thePoly.addPoint(centreX +(int)pA.x  , centreY - (int)pA.y ) ;
      thePoly.addPoint(centreX +(int)pA.x ,  centreY - (int)pB.y ) ;
      thePoly.addPoint(centreX +(int)pB.x , centreY - (int)pB.y  ) ;
      thePoly.addPoint(centreX +(int)pB.x  ,centreY - (int)pA.y  ) ;



      g.drawPolygon(thePoly);
    }






    return  botImage;

 }     */



  public void  preRender()
 {

  // try
  // {
      //while ( BGlobal.SKIP_RENDER )
       // {
      //     BDebug.print ("BBotCanvas Skipping Render :");
      //     Thread.currentThread().sleep(100);
      //  }


  // BDebug.print("BBotCanvas.preRender");


   //}catch (Exception e) {BDebug.print ("BBotCanvas.preRender.ERROR " + e.getMessage() ); }



 }



// public void paint(java.awt.Graphics g)
 //{
 // super.paint(g);
//  BDebug.print("BBotCanvas.Paint");
 //}


 public void takeSnapshot()
 {
  // do nothing
 }
   public void waitForFrame()
 {


  // do nothing

 }



  public javax.media.j3d.Locale getLocale3d()
  {
    return myLocale;

  }

}







