package roboforge;

import java.security.*;
//import javax.crypto.Cipher;
//import iaik.utils.CryptoUtils;
//import iaik.security.provider.IAIK;
import java.util.*;
import java.io.*;

/*

* Description:
  Holds an encrypted object
* Example:
* Modification History ( Name, Date, Notes ):
  Created HSC, 23-November-1999

*/

public class BEncryptedObject implements Serializable
{


  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
int objectByteSize;
  Vector bArrayVector = new Vector();

  
  public BEncryptedObject(Object objectIn, PublicKey pubKey)
  {

    try
    {
      // Having turned the Object into a byte array
      byte[] bArray = SServerAccess.objectToByteArray(objectIn);
      objectByteSize = bArray.length;

      Vector bArrayTempStore = new Vector();

      int count = 0;
      int arraySize = 0;

      while(count < objectByteSize)
      {

        arraySize++;
        bArrayTempStore.addElement(new Byte(bArray[count]));

        if (arraySize == 100)
        {
          // Time to encrypt and add to bArrayVector
          bArrayVector.addElement(SServerAccess.encrypt(vectorOfIntegersToByteArray(bArrayTempStore),pubKey));
          bArrayTempStore.clear();
          arraySize = 0;
        }

        count++;
      }

      if (arraySize != 100)
      {
        // Encrypt and add whatever is in bArrayVector
        // First need to transfer all contents to bArrayTempStore.length length byte array
        bArrayVector.addElement(SServerAccess.encrypt(vectorOfIntegersToByteArray(bArrayTempStore),pubKey));
      }
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
    }
  }
  public byte[] getDecryptedObjectArray (PrivateKey prvKey)
  {
    byte[] objectArray = new byte[objectByteSize];
    try
    {
      // Loop through all the members of the encrypted object vector
      // decrypting them and adding them to the return array

      int currentPositionInArray = 0;
      for (int i=0;i<bArrayVector.size();i++)
      {
        byte[] decryptedArray = SServerAccess.decrypt((byte[])bArrayVector.elementAt(i),prvKey);
        System.arraycopy(decryptedArray,0,objectArray,currentPositionInArray,decryptedArray.length);
        currentPositionInArray = currentPositionInArray + decryptedArray.length;
      }
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
    }

    return objectArray;
  }

  private byte[] vectorOfIntegersToByteArray (Vector vectorIn)
  {
    // Takes a Vector of Integers and returns a byte array of integers
    byte[] byteArray = new byte[vectorIn.size()];

    // Loop through the Vector adding each element to the byte array
    for (int i=0;i<vectorIn.size();i++)
    {
      byteArray[i] = ((Byte)vectorIn.elementAt(i)).byteValue();
    }
    return byteArray;

  }

  public Object getDecryptedObject(PrivateKey prvKey)
  {
    // Turn the bytes back into an object
    Object returnObject = null;
    try
    {
      //BDebug.print("Starting Decryption");
      ByteArrayInputStream byteIS = new ByteArrayInputStream(getDecryptedObjectArray(prvKey));
      ObjectInputStream in = new ObjectInputStream(byteIS);
      returnObject = (Object)in.readObject();
      //BDebug.print("Ending Decryption");
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
    }

    return returnObject;
  }

}