package roboforge;

public class BHoverChassis extends BChassis
// all forms of floating chassis
{

  static final long serialVersionUID = -1;
  
  private float height = 2f * BGlobal.WORLD_TO_CANVAS_SCALE; // canvas units

  public BHoverChassis (String nameIn, String filename)
  {
      super(nameIn, filename);
  }

  public float calculateHeight( )
  {
    //BDebug.print("BHoverChassis calculateHeight returning " + height);
    
    return height;
  }

  public void setHeightInWorldUnits(float height)
  {
    this.height = height * BGlobal.WORLD_TO_CANVAS_SCALE;
  }

  public float getHeightInWorldUnits()
  {
    return height * BGlobal.CANVAS_TO_WORLD_SCALE;
  }


  public void upgrade()
 {
    BHoverChassis upgradeTwin =   (BHoverChassis)BComponent.loadFromFile( BGlobal.CHASSISPATH+getComponentFilePath(), false );
    super.upgrade(upgradeTwin);
    this.height = upgradeTwin.height;


 }

 protected float getDisplaceFriction()
 {
    return BPhysics.DISPLACE_FRICTION * 1.5f;
 }

 public boolean isHover()
    { return true; }




}