package roboforge;

//import java.util.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;


public class BMoveRadar extends JButton
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
BBotCanvas activeCanvas;
  Image canvasShadow;
  private Image glow;
  private static float GLOW_ALPHA = 0.7f;
  private int glowX;
  private int glowY;

  private int lastX;
  private int lastY;

  static private int GLOWDIFF = 100;

  private static Image mask;


  public BMoveRadar(BBotCanvas newActiveCanvas, int width, int height)
  {
    this( newActiveCanvas,  width,  height, width / 2, height / 2);

    mask =  getToolkit().createImage(BGlobal.IMAGEPATH + "BBotViewerPanel/MovesRadarMask.gif");


  }


  public BMoveRadar(BBotCanvas newActiveCanvas, int width, int height, int startX, int startY)
  {
  activeCanvas = newActiveCanvas;

  glow = getToolkit().getImage(BGlobal.IMAGEPATH + "BBotViewerPanel/GreenGlow.jpg");
  this.setSize(width, height);
  this.setToolTipText("Move Component");

  Image cursorImg = getToolkit().createImage(BGlobal.IMAGEPATH + "BBotViewerPanel/move_Cursor.gif");
  setCursor(getToolkit().createCustomCursor(cursorImg, new Point(16,16), "Move"));

  glowX =startX;
  glowY =startY;

  activeCanvas.translate(glowX - width / 2,glowY - height / 2);


  this.addMouseMotionListener(new MouseMotionListener()
        {

        public void mouseDragged(MouseEvent e)
                {

                int x = e.getX();
                int y = e.getY();

                int dx = lastX - x;
                int dy = lastY - y;

                int oldGlowX = glowX;
                int oldGlowY = glowY;

                glowX = java.lang.Math.max( java.lang.Math.min(glowX - dx, getWidth())   , 0    );
                glowY = java.lang.Math.max( java.lang.Math.min(glowY - dy, getHeight())   , 0    );

                int glow_dx = oldGlowX - glowX;
                int glow_dy = oldGlowY - glowY;

                lastX = x;
                lastY = y;

                activeCanvas.translate(-glow_dx,-glow_dy);
                repaint();

                }

        public void mouseMoved(MouseEvent e)
                {


                lastX = e.getX();
                lastY = e.getY();
                }



        });


   this.addMouseListener(
   new MouseListener()
   {
     public void mouseClicked(MouseEvent e){}
     public void mouseEntered(MouseEvent e){}
     public void mouseExited(MouseEvent e){}

     public void mousePressed(MouseEvent e)
     {
      activeCanvas.setWireFrame();
     }

     public void mouseReleased(MouseEvent e)
     {
      activeCanvas.exitWireFrame();
      Thread.yield();
     }

    }
  );




  }


  public void setBGShadow(Image canvasBG)
  {
   canvasShadow =  canvasBG;
   repaint();


  }

  public void paint(Graphics g)
  {


  Graphics2D g2 = (Graphics2D) g;

  if (canvasShadow != null)
        g2.drawImage(canvasShadow,0,0,getWidth(), getHeight(), this);

  AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, GLOW_ALPHA);
  g2.setComposite(ac);
  g2.drawImage(glow,glowX - GLOWDIFF,glowY - GLOWDIFF, this);

  g2.setComposite(AlphaComposite.SrcOver  );
  g2.drawImage(mask,0,0,this);





  }




}