package roboforge;


import javax.media.j3d.*;
import com.sun.j3d.utils.behaviors.picking.*;
//import java.util.*;
//import java.awt.*;
//import java.awt.Event;
//import java.awt.AWTEvent;
//import java.awt.event.MouseEvent;
//import javax.vecmath.*;



public class BPickHighlightBehavior extends PickMouseBehavior {
 /*
  * Description: Class For picking Java3D objects, Currently Only used for picking connect points but will
                  be extended when we implement bot

* Modification History ( Name, Date, Notes ):
                        YLY, 31 mar 99,
*/


// Stores last shape click so that we can reset its highlight
private BHighlightShape oldShape = null;
private BMouseListenerCanvas parentCanvas = null;
private boolean deselectOldSelected;



public BPickHighlightBehavior(BMouseListenerCanvas canvas, BranchGroup root, Bounds bounds, boolean deselectOldSelectednew) {
/*

* Description: Creates New Pick Behaviour,
	* Parameters: root is the root of all the objects that you wish to pick
	* Results: Creates new object
* Example:

              new PickHighlightBehavior(this,
                                        attachNode,
                                        new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000.0));

* Modification History ( Name, Date, Notes ):
                            YLY, 31-Mar-98, Creation

*/

      super((Canvas3D)canvas, root, BGlobal.INFINITE_BOUNDS);
      this.setSchedulingBounds(bounds);
      deselectOldSelected = deselectOldSelectednew;
      root.addChild(this);

     // if (canvas instanceof BBotCanvas)
      parentCanvas = canvas;



}


public void updateScene(int xpos, int ypos)
{
  /*

* Description: This function is automatically called when a pick event is recieved
	* Parameters: x,y are the x, y of the mouse
	* Results: updates the scene
  * Example:  I suppose you could call this for an automatic pick

* Modification History ( Name, Date, Notes ):
                            YLY, 31-Mar-98, Creation

*/



	BHighlightShape shape;

// get shape
 	shape = (BHighlightShape) pickScene.pickNode(pickScene.pickClosest(xpos, ypos,
                                                PickObject.USE_GEOMETRY),
					        PickObject.SHAPE3D);



//	if (  (shape != oldShape) || ( parentCanvas.getMode() == BBotCanvas.MODE_JOINTMOVE ) )
//                {

                if (shape == null)
                        {

                         if (deselectOldSelected)
                          if   (shape != oldShape)
                                {
                                if (oldShape!= null)
 	                                oldShape.setHighlight(false);
                                oldShape = shape;
                                }

                        }    // shape = null;
                else
                        {   // Change the graphic


                        
                       // messy hack code to get zones working

                        if ( (shape instanceof BZoneShape) )
                        {
                           pick(shape);
                        }
                        else if (parentCanvas != null)
                                parentCanvas.modeMethod(shape);
                        else if (shape.setActiveArea())
                                pick(shape);



                        }


//	        } // shape != oldShape
   } //update scene


   public void pick(BHighlightShape shape)
   {
   if (oldShape!= null)
        oldShape.setHighlight(false);
   oldShape = shape;
   shape.setHighlight(true);

   }


   public BHighlightShape getLastSelected()
   {
   return oldShape;
   }

   public void setLastSelected(BHighlightShape newShape)
   {
   oldShape = newShape;
   }


}

