package roboforge;

//import roboforge.BDebug;

import java.util.*;
//import java.awt.event.*;
import javax.swing.event.*;
import javax.media.j3d.Behavior;
import javax.media.j3d.WakeupOnElapsedFrames;
//import javax.vecmath.*;
//import javax.media.j3d.*;

public class BSimulationBehaviour extends Behavior

// Runs the simulation.
// Must be added to a active arena3d Canvas, after creation.
// This is so we can wakeup on each frame render.  (j3d rebuilds the node.bounds on every frame render, so for collisions to be accurate, each
// sim cycle must follow a j3d render cycle

{


        WakeupOnElapsedFrames wFrame;
        //WakeupOnElapsedTime wFrame;
        //private boolean play = false;
        private ChangeListener listener;
        private boolean isRunningSim = false;
        private BSimulation simulation;
        private boolean stopBattle = false;
        private boolean paused = false;

        private ChangeEvent change = new ChangeEvent(this);



        public BSimulationBehaviour()
        // ADD TO A CANVAS3D AFTER CREATION
        {
          isRunningSim = false;
          setSchedulingBounds( BGlobal.INFINITE_BOUNDS );
          wFrame  = new WakeupOnElapsedFrames(0);
          //wFrame  = new WakeupOnElapsedTime(30);

        }

        public void addChangeListener( ChangeListener newListener )
        {
          listener = newListener;
        }

        public void initialize()
        {
                // Set the start time
                //BDebug.print ("BSimBehaviour initialize called ");
                wakeupOn(wFrame);
                this.setEnable(false);
                isRunningSim = false;
        }

        public void start(BSimulation newSim)
        // PRE :: The Simulation has already been initialised, with all bots/ items added

        {
               stopBattle = false;
               simulation = newSim;

               this.setEnable(true);
               isRunningSim = true;
               simulation.startBattle();



        }

        public boolean isRunningSimulation()
        {
          return  isRunningSim;
        }


        public void stopNextLoop()
        {

          // flick boolean, so the behavour stops next loop
          stopBattle = true;


        }

        private void stop()
        {

                this.setEnable(false);
                simulation.stopBattle();
                isRunningSim = false;
                simulation = null;

                if (listener != null)
                  listener.stateChanged(change);

                //arena3dCanvas.clear();
                //opponentBot = null;

        }



        public float getElapsedSimTime()
          { return simulation.getElapsedTime(); }

        public void setPaused(boolean paused)
        { this.paused = paused; }

        public void processStimulus(Enumeration criteria)
        {
           //BDebug.print("BSimulatonBehavior.processStimulus().");

           if(!paused)
           {
             isRunningSim = simulation.runBattleSlice();

             if (!isRunningSim  || stopBattle    )
               stop();
             else
             {
               if (listener != null)
                 listener.stateChanged(change);
             }
           }
           wakeupOn(wFrame);
        }


        // end of BPlayerBahaviour Class
}