package roboforge;

import javax.swing.*;
import java.io.*;
import java.awt.*;

/*

* Description:
  Creates a JList object with a custom cell renderer
  that displays the texture images along with their name(minus the type
  suffix).

* Example:
* Modification History ( Name, Date, Notes )
  HSC, 13 April 1999


*/

public class BTextureList extends JList
{ 
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
private String[] titles;
  private ImageIcon[] textureImage;
  private File[] files;

  public BTextureList( )
  {




   this.setCellRenderer(new TextureCellRenderer());

  }


  public void loadDir(String path)
  {
        // Load the textures
    File file = new File(path);

    // Set the first title to be no texture.



    String[] tempTitles = file.list(new BFileNameFilter());

    titles = new String[tempTitles.length+1];

    titles[0] = "No Texture    ";
    // Build up the List putting a dummy texture at position 0 for no texture
    for(int i = 0;i< tempTitles.length; i++)
    {
      titles[i+1] = tempTitles[i];
    }

    textureImage = new ImageIcon[titles.length];

    //ImageIcon iIcon = new ImageIcon();
    ImageIcon iIcon = new ImageIcon(BGlobal.TEXTUREPATH + "internal/NoT.gif");
    textureImage[0] = iIcon;
    textureImage[0].setImage(textureImage[0].getImage().getScaledInstance(40,40,Image.SCALE_SMOOTH));

    // Loop through the string building up the titles and image
    // arrays.
    for(int i = 1;i < titles.length; i++)
    {

       //BDebug.print (path+ titles[i]);
       textureImage[i] = new ImageIcon(path+ "/" + titles[i] );

      // Scale the image to a set size.
      textureImage[i].setImage(textureImage[i].getImage().getScaledInstance(40,40,Image.SCALE_SMOOTH));
    }

        // Define and add the texture List
    this.setListData(titles);
    //this.setCellRenderer(new TextureCellRenderer());

  }





  // Inner class TextureCellRenderer
    class TextureCellRenderer extends JLabel implements ListCellRenderer
    {
        /**
		 * 
		 */
		private static final long serialVersionUID = -1L;
		Color highlightColor = new Color(0, 0, 128);

        TextureCellRenderer() {
            setOpaque(true);
        }
        public Component getListCellRendererComponent(
            JList list,
            Object value,
            int index,
            boolean isSelected,
            boolean cellHasFocus)
        {
            //  If this is the selection value request from a combo box
            //  then find out the current selected index from the list.
            if (index == -1) {
                int selected = list.getSelectedIndex();
                if (selected == -1)
                    return this;
                else
                    index = selected;
            }
            // Remove the suffix from what is displayed in the List Box
            // Note Only changes what is displayed not what is stored.
            String title = titles[index];
            title = title.substring(0,title.length()-BGlobal.IMAGESUFFIX.length());

            setText(" " + title);
            setIcon(textureImage[index]);
            if(isSelected) {
                setBackground(highlightColor);
                setForeground(Color.white);
            } else {
                setBackground(Color.white);
                setForeground(Color.black);
            }
            return this;
        }
     }
}