package roboforge;

//: BTheme.java

import javax.swing.plaf.metal.*;
import javax.swing.plaf.*;
//import javax.swing.*;
import java.awt.*;

/*
 * Created to override the default Metal Theme Colors of Metal LAF
 */

public class BTheme extends DefaultMetalTheme {

    // Std Metal Blue
    //private final ColorUIResource primary1 = new ColorUIResource(102, 102, 153);
    //private final ColorUIResource primary2 = new ColorUIResource(153, 153, 204);
    //private final ColorUIResource primary3 = new ColorUIResource(204, 204, 255);

    // BGlobal Theme
    private final ColorUIResource primary1 = new ColorUIResource(BGlobal.PRIMARY1);
    private final ColorUIResource primary2 = new ColorUIResource(BGlobal.PRIMARY2);
    private final ColorUIResource primary3 = new ColorUIResource(BGlobal.PRIMARY3);

    //Grey
    //private final ColorUIResource secondary1 = new ColorUIResource(102, 102, 102);
    //private final ColorUIResource secondary2 = new ColorUIResource(153, 153, 153);
    //private final ColorUIResource secondary3 = new ColorUIResource(204, 204, 204);

    // BGlobal Theme
    private final ColorUIResource secondary1 = new ColorUIResource(BGlobal.SECONDARY1);
    private final ColorUIResource secondary2 = new ColorUIResource(BGlobal.SECONDARY2);
    private final ColorUIResource secondary3 = new ColorUIResource(BGlobal.SECONDARY3);

    private FontUIResource controlFont;
    private FontUIResource systemFont;
    private FontUIResource userFont;
    private FontUIResource smallFont;

    public String getName() { return "Steel"; }

    public BTheme() {

      try {
        controlFont = new FontUIResource(Font.getFont("swing.plaf.metal.controlFont", new Font("Dialog", Font.BOLD, 12)));
        systemFont = new FontUIResource(Font.getFont("swing.plaf.metal.systemFont", new Font("Dialog", Font.PLAIN, 12)));
        userFont = new FontUIResource(Font.getFont("swing.plaf.metal.userFont", new Font("Dialog", Font.PLAIN, 12)));
        smallFont = new FontUIResource(Font.getFont("swing.plaf.metal.smallFont", new Font("Dialog", Font.PLAIN, 10)));
      } catch (Exception e) {
        controlFont = new FontUIResource("Dialog", Font.BOLD, 12);
        systemFont =  new FontUIResource("Dialog", Font.PLAIN, 12);
        userFont =  new FontUIResource("Dialog", Font.PLAIN, 12);
        smallFont = new FontUIResource("Dialog", Font.PLAIN, 10);
      }
    }

    protected ColorUIResource getPrimary1() { return primary1; }
    protected ColorUIResource getPrimary2() { return primary2; }
    protected ColorUIResource getPrimary3() { return primary3; }

    protected ColorUIResource getSecondary1() { return secondary1; }
    protected ColorUIResource getSecondary2() { return secondary2; }
    protected ColorUIResource getSecondary3() { return secondary3; }

    //protected ColorUIResource getBlack() { return new ColorUIResource(0,0,134); }
    //protected ColorUIResource getWhite() { return secondary2; }
    protected ColorUIResource getBlack() { return new ColorUIResource(BGlobal.BLACK); }
    // the white was not white, so I changes it to WAS_WHITE
    protected ColorUIResource getWhite() { return new ColorUIResource(BGlobal.WAS_WHITE); }

    public FontUIResource getControlTextFont() { return controlFont;}
    public FontUIResource getSystemTextFont() { return systemFont;}
    public FontUIResource getUserTextFont() { return userFont;}
    public FontUIResource getMenuTextFont() { return controlFont;}
    public FontUIResource getWindowTitleFont() { return controlFont;}
    public FontUIResource getSubTextFont() { return smallFont;}


    //public void setPrimary1(Color color) { primary1 = new ColorUIResource(color); }
    //public void setPrimary2(Color color) { primary2 = new ColorUIResource(color); }
    //public void setPrimary3(Color color) { primary3 = new ColorUIResource(color); }
}
