package roboforge;

//: BTimer.java

import roboforge.util.timing.*;


public class BTimer {

/*
DJG - Used for timing stuff
// DJG June 2001 - Changed to use BClock
*/

  private String name;
  public int counter = 0;    // Number of times started
  private double totalTime = 0d;  // Time in Millisecs
  private double thisTimeStart = 0d; // time started

  public BTimer(String nameIn)
  {
    name = nameIn;
    counter = 0;
    totalTime = 0d;
  }

  public void reset()
  {
    counter = 0;
    totalTime = 0d;
  }

  public void start()
  {
    counter += 1;
    thisTimeStart = BClock.time(); // Note: Time in Seconds
  }

  public void stop()
  {
    totalTime += (BClock.time() - thisTimeStart);
    //BDebug.print("Timer: Start="+thisTimeStart+" Current="+System.currentTimeMillis());
    thisTimeStart = BClock.time(); // Just in Case Stop is called again
  }

  public double getTotalTime()
  {
    return totalTime;
  }

  public String printRatio(float ratio)
  {

    int calcRatio =  (int) ((totalTime / ratio) * 100);
    //BDebug.print("ratio="+calcRatio+" = "+totalTime+" / "+ratio);
    return name + " time ratio " +  ( ((float)calcRatio) / 100  );

  }

  public String toString()
  {

    

      int min = (int) (totalTime / 60);
      int sec =  (int) (totalTime  - (min * 60));
      int ms =  (int) ((totalTime  - (min * 60) - sec) * 1000) ;



    return "Timer: "+name +
            " - Min :" + min + " sec:" + sec + " ms:" + ms;

  }

  public String pctOf(double totalIn)
  {
    int pct = (int) ((totalTime/totalIn)*100d);
    return  pct+" %";
  }

}///:~
