package roboforge;
import java.util.*;



public class BWeapon extends BComponent
/*

* Description:
  A child of BComponent which can be transformed.

* Example:
* Modification History ( Name, Date, Notes ):
  HSC, 25-March-1999

*/

{
  static final long serialVersionUID = -1L;

  public float strikingMass;        // (KG)
  private float damageBonus;    // Damage units per KG/M/S (Mass * Velocity)
  public int damageResistance = 0;    // Resistance to ALL Damage
                                      // % (0 - 100) like BShielding

  public static String COMPONENT_TYPE = "Weapon";
  public static final float WEAPON_DAM_MAX_MUTIPLIER = 3;

  public String getComponentType()
  { return COMPONENT_TYPE; }


  public float getDamageBonus()
  { return damageBonus ; }

  public void setDamageBonus( float damB)
  { damageBonus = damB ; }



  public BWeapon (String nameIn, String filename)
  {
      super(nameIn, filename);
  }

  public void upgrade()
  {

    BWeapon upgradeTwin =  (BWeapon)BComponent.loadFromFile( BGlobal.COMPONENTPATH+getComponentFilePath(), false );
    super.upgrade(upgradeTwin);

    strikingMass = upgradeTwin.strikingMass;
    damageBonus = upgradeTwin.damageBonus;
    damageResistance = upgradeTwin.damageResistance;

  }

  public Vector getAttributeStrings()
 // returns a Vector of tuples  (heading, value )
 // 2-d Vector
 {

  Vector theList = super.getAttributeStrings();

  Vector tempV;

  tempV = new Vector(2);
  tempV.add("Striking mass");
  tempV.add(strikingMass + " kg");
  tempV.trimToSize();
  theList.add(tempV);

  tempV = new Vector(2);
  tempV.add("damage bonus ");
  tempV.add("+"+ BPhysics.round(damageBonus * 100.0f, 1)+ "%");
  tempV.trimToSize();
  theList.add(tempV);

  tempV = new Vector(2);
  tempV.add("resistance");
  tempV.add(BPhysics.round(damageResistance,1) + "%");
  tempV.trimToSize();
  theList.add(tempV);

  return theList;


  }

  //public static final int DAM_THRESHOLD = 5;

  public float resistDamage(float dam )
  {
    float resist =  ((float)(100 - damageResistance ))   /  100f  ;
    float resistedDam = dam * resist;

    if (resistedDam < DAM_THRESHOLD)
      resistedDam = 0;

    //BDebug.print("BWeapon: BaseDam="+dam+" resist="+resist+" health="+getHealthCurrent()+" resistDam="+resistedDam);

    // DJG July 2001
    // Change in philosophy to avoid confusion
    if ( resistedDam >= getHealthCurrent() )
      return getHealthCurrent();
    else
      return  resistedDam;

  }

  public float applyDamage(float dam )
  {
    //BDebug.print ("BWeapon.applyDamage inertia " + dam );
    return dam += dam * damageBonus;

    //BDebug.print ("BWeapon.applyDamage damageBonus+ " + damageBonus );
    //float resist =  ((float)(100 - damageResistance ))   /  100f  ;

    //BDebug.print ("BWeapon.applyDamage damageResistance+ " + damageResistance );
    //BDebug.print ("BWeapon.applyDamage resist+ " + resist );
    //float cap =  this.getDamageMax()  * WEAPON_DAM_MAX_MUTIPLIER;

    //getBot().setArenaComments( getName() + " damageBonus  cap" + cap  );
    //return java.lang.Math.min(cap , dam );

  }


}


