package roboforge;

import javax.media.j3d.*;
import javax.vecmath.*;
//import java.awt.Color;
//import java.awt.event.*;
//import java.util.*;


public class BWheel extends BAutoRotateJoint

{
  static final long serialVersionUID = -8909240944029165682L;
  private float radius;  // IN CANVAS UNITS
  private transient boolean hasJumped = false;

  public BWheel(String nameIn, String filename)
  {
    super(nameIn, filename);
    hasJumped = false;
  }

  public float guessVolume()
  {

  float volume = super.guessVolume();
  radius = ( vMaxY - vMinY ) / 2 ;

  return volume;
  }

  public float getRadiusInCanvasUnits()
  {
    return  radius;
  }

  public float getRadius()
  {
    return  radius * BGlobal.CANVAS_TO_WORLD_SCALE;
  }

  private static Vector3f move_Distance = new Vector3f();

  public boolean move(BJointPosition endPosition, float timeSlice, float power , float maxVelocityMutiplier, boolean deccelerate)
  { return false; }

  
 public  boolean move( float timeSlice, float power)
 {
    if (hasJumped)
    {
     // BDebug.print("hasJumped called ");
      hasJumped = false;
      prevVWorld.set(currentVWorld);
    }

    move_Distance.sub(currentVWorld, prevVWorld);
    move(move_Distance);
    return false;
  }


  private static Transform3D move_t = new Transform3D();
  private static Vector3f move_wheelPos = new Vector3f();
  private static Matrix3f move_rotOfJoint = new Matrix3f();
  private static Vector3f move_directionTester = new Vector3f();
  private static Vector3f move_directionCross = new Vector3f();
  private static Vector3f move_yAxis = new Vector3f(0,1f,0);




  public void move(Vector3f physicalMove)
  {
        physicalMove.y = 0;
       // BDebug.print (getName()+  "physicalMove " + physicalMove );

        float surfaceA = physicalMove.length();

        getLiveNode().getLocalToVworld(move_t);
        //move_t.get(move_wheelPos);

        // INVERT , WE WILL USE THIS INVERTED MATRIX TO CONVERT OTHER Nodes into
        // a virtual space where the joint is the centre of the universe
        move_t.invert();

        // get only the rotational component  of the Joint's Transform
        move_t.get(move_rotOfJoint);

        // convert vector to joint space
        move_rotOfJoint.transform(physicalMove);

       // BDebug.print (getName()+  "transposed " + physicalMove );

        // project into plane of movement
        if (axisOfRotation.x != 0)
          physicalMove.x = 0;
        else if (axisOfRotation.z != 0)
          physicalMove.z = 0;
        else
          BDebug.print("BWheel ASSERTION FAILURE axisOFRotaion cannot be Y");

        physicalMove.y = 0;

        //BDebug.print (getName()+  "zoroed " + physicalMove );


        move_yAxis.x = 0f;
        move_yAxis.y = 1f;
        move_yAxis.z = 0f;
        move_rotOfJoint.transform(move_yAxis);


        move_directionTester.add(move_yAxis, physicalMove);

        //BDebug.print (getName()+  "move_directionTester " + move_directionTester );
        //BDebug.print (getName()+  "move_yAxis " + move_yAxis );

        move_directionCross.cross( move_directionTester, move_yAxis);

        int direction;

        if (axisOfRotation.x == 1)
        {
                if (move_directionCross.x > 0.0f )
                        direction = -1;
                else if (move_directionCross.x < 0.0f)
                        direction = 1;
                else
                        direction = 0;

        }
        else if (axisOfRotation.x == -1)
        {
                if (move_directionCross.x > 0.0f )
                        direction = 1;
                else if (move_directionCross.x < 0.0f)
                        direction = -1;
                else
                        direction = 0;

        }
        else
        {
                if (move_directionCross.z > 0.0f )
                        direction = -1;
                else if (move_directionCross.z < 0.0f)
                        direction = 1 ;
                else
                        direction = 0;

        }

       float deltaDistance = surfaceA / getRadiusInCanvasUnits();
       //BDebug.print (getName()+  "deltaDistance " + deltaDistance );
      // BDebug.print (getName()+  "old Position " + currentPosition );



       //setPreviousJointPosition(currentPosition);
      // BDebug.print (getName()+  "currentPosition.getAngle() + ( (float)direction * deltaDistance)" + currentPosition.getAngle() + ( (float)direction * deltaDistance) );

       currentPosition.setAngle(currentPosition.getAngle() + ( (float)direction * deltaDistance) );
      // BDebug.print (getName()+  "new Position " + currentPosition );

       applyTransform();



  }

  public void setJumped()
  {
    hasJumped = true;
  }



  public boolean mouseMove(int x, int y, int x_last, int y_last, boolean useDefaultJointPosition)
  {

    return false;

  }

   public void setJointPosition(BJointPosition newP)
  {
    super.setJointPosition(newP) ;
    //BDebug.print ( "BWheel setJointPosition called" );
    hasJumped = true;
  };




  public void initForArena(BChassis theChassis, BBot owner)
  {
    super.initForArena(theChassis, owner);
    hasJumped = true;

  }

  public  float getResultantPosition ( Vector3f momentum, BComponent collidedComponent, BJointPosition newMove)
  {
    return 0f;
  }

 

}