package roboforge;

import java.io.*;

//import roboforge.ai.*;
import roboforge.ai.values.*;
import roboforge.ai.memory.*;
import java.util.*;
//import javax.swing.text.*;

public class BWizardMemoryOptions implements Serializable
{

  static final long serialVersionUID = -1L;

  private BMemoryItem item;
  String[] options;
  private String description;

  public BWizardMemoryOptions(BMemoryItem item)
  { this.item = item; }

  public BMemoryItem getItem()
  { return item;}

  public String getDescription()
  { return description; }

  public  void setDescription(String description)
  {  this.description = description; }

  //YLY 2 Tokenizing functions  until the full enumeration ui is finished
  public void setOptions(String optionsIn)
  {
    Vector stateOptions = new Vector();

    StringTokenizer stringList = new StringTokenizer(optionsIn, ",");
    while (stringList.hasMoreTokens())
    {
      String token = stringList.nextToken().trim();
      stateOptions.add(token);
    }

    options = new String[stateOptions.size()];

    for (int i = 0; i < stateOptions.size(); i++ )
      options[i] = (String) stateOptions.get(i);

  }

  public String getTokenizedOptions()
  {
    String theString = new String("");

    if (options != null)
    {

      for (int i = 0; i < options.length; i++ )
        theString = theString + options[i] + ",";

      if (theString.length() != 0 )
        theString = theString.substring(0, theString.length() -1 );
    }

    return theString;
  }

  public Vector getOptionsVector()
  {
    if (options == null)
      return new Vector();
      
    Vector tempV = new Vector(options.length);
    for (int i = 0; i < options.length; i++ )
        tempV.add(options[i]);

    return tempV;

  }

  public void setValue(String defaultV)
  {
    BValue value = item.getInitialValue();

    if (value instanceof BString)
    {
      BString str = (BString) value;
      str.setValue(defaultV);
    }
    else if (value instanceof BNumber)
    {
      BNumber str = (BNumber) value;
      str.setValue(Double.parseDouble (defaultV) );
    }

  }


  public String toString()
  { return item + "";}

  public boolean equals(Object o)
  {
    boolean y = false;

    if (o instanceof BWizardMemoryOptions)
    {
      BWizardMemoryOptions m = (BWizardMemoryOptions) o;
      y = (m.item == this.item);
    }

    return y;


  }

}