package roboforge;

import java.io.*;
public class SBattleRecording implements Serializable
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
/* 

  * Description:
    Holds a requested battle recording (as array of Bytes) and
    any permitted related stats

  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 6-December-1999

  */

  private byte[] battleRecording;
  private byte[] battleStats;
  int botStatsIsFor;

  public SBattleRecording(byte[] battleRecordingIn, byte[] byteBattleStatsIn, int botStatsIsForIn )
  {
    battleRecording = battleRecordingIn;
    battleStats = byteBattleStatsIn;
    botStatsIsFor = botStatsIsForIn;
  }

  public byte[] getBattleRecordingBytes() throws Exception
  {
    try
    {
      return SServerAccess.gzipInflateArray(battleRecording);
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception(e.getMessage());
    }
  }

  public byte[] getBattleStatsBytes() throws Exception
  {
    try
    {
      // Don't do the inflate if there aren't any stats
      if (battleStats != null)
        return SServerAccess.gzipInflateArray(battleStats);
      else
        return battleStats;
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception(e.getMessage());
    }
  }
} 