package roboforge;

import java.util.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class SControllerServlet extends HttpServlet {

  private SLoginBean jdbcBean;

  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);

    try
    {
      jdbcBean = new SLoginBean();
    }
    catch (Exception e)
    {
      System.err.println("Error: SControllerServlet: init: " + e.getMessage());
    }
  }

  public void destroy()
  {
    // Destroy the connection pool
    jdbcBean.destroy();
  }
  public void doPost
       (HttpServletRequest req, HttpServletResponse res)
      throws ServletException, IOException {

    HttpSession session = req.getSession(false);


    if (session == null)
    {
      res.sendRedirect("/jsp/login.jsp");
    }
    else
    {
      String login = (String)session.getAttribute("login");

      if (login == null)

        res.sendRedirect("/jsp/login.jsp");
    }

    ServletContext sc = getServletContext();
    String action = req.getParameter("action");

    System.out.println("The Request IS: " + action);

    String url;

    if (action.equals("LOGOK"))
    {
      url="/jsp/index.jsp";
    }
    else if (action.equals("LOGFAIL"))
    {
      url="/jsp/login_failed.htm";
    }
    else if (action.equals("CPENDF"))
    {
      url="/jsp/create_pending_acc.jsp";
    }
    else if (action.equals("CPEND"))
    {
      url="/jsp/create_pending_result.jsp";
    }
    else if (action.equals("LOCACC"))
    {
      url="/jsp/locate_accounts.jsp";
    }
    else if (action.equals("FINDACC"))
    {
      url="/jsp/accounts.jsp";
    }
    else if (action.equals("LOCTRANS"))
    {
      url="/jsp/locate_transactions.jsp";
    }
    else if (action.equals("FINDTRANS"))
    {
      url="/jsp/transactions.jsp";
    }
    else if (action.equals("UPDTRANS"))
    {
      // Update the transaction using the Update Transaction Bean
      System.out.println("Transaction ID: " + req.getParameter("id"));

      url="/jsp/updatefailed.htm";

      try
      {
        SUpdateTransBean updTransBean = new SUpdateTransBean();
        updTransBean.setId(req.getParameter("id"));
        if (updTransBean.isUpdated())
          url="/jsp/updateok.htm";
        else
          url="/jsp/updatefailed.htm";
      }
      catch (Exception e)
      {
        System.out.print("Exception:" + e.getMessage());
      }

    }
    else if (action.equals("DISPSALES"))
    {
      url="/jsp/disp_sales.jsp";
    }
    else if (action.equals("INDEX"))
    {
      url="/jsp/index.jsp";
    }
    else
    {
      url="/jsp/error.htm";
    }

    System.out.println("URL: >" + url + "<");
    RequestDispatcher rd = sc.getRequestDispatcher(url);
    rd.forward(req, res);

    return;

  }
  
  public void doGet
       (HttpServletRequest req, HttpServletResponse res)
      throws ServletException, IOException {
    doPost(req, res);
  }
}
