package roboforge;

import java.sql.*;
import java.io.*;
import java.util.*;

public class SDisplayAccBean extends SJDBCBean
{

  private String sql;
  private Statement statement;
  private ResultSet rs;

  private String id;
  private String name;
  private String email;
  private String logID;
  private String designerName;
  private String dwnCnt; // Download count
  private String winBal;
  private String currBal;
  private String wpID;
  private String accWUT; // Accounts with unprocessed transactions


  private String returnHTML;
  private String regKey;

  public SDisplayAccBean() throws Exception
  {
    super();
  }

  public void setId(String id)
  {
    this.id   = id;
  }

  public void setName(String name)
  {
    this.name   = name;
  }

  public void setEmail(String email)
  {
    this.email  = email.toLowerCase();
  }

  public void setLogID(String logID)
  {
    this.logID   = logID;
  }

  public void setDesignerName(String designerName)
  {
    this.designerName   = designerName;
  }

  public void setDwnCnt(String dwnCnt)
  {
    this.dwnCnt   = dwnCnt;
  }

  public void setWinBal(String winBal)
  {
    this.winBal   = winBal;
  }

  public void setCurrBal(String currBal)
  {
    this.currBal   = currBal;
  }

  public void setWpID(String wpID)
  {
    this.wpID   = wpID;
  }

    public void setAccWUT(String accWUT)
  {
    this.accWUT   = accWUT;
  }


  public String getReturnHTML()
  {

    Connection con = null;
    String returnHTML = "";
    try
    {
      con = this.getConnection();

      // Determine if we have a request for a WP id

      if ((wpID != null && !wpID.equals("null")))
      {
        // Request Involves a WP id
        sql = "SELECT * FROM ACCOUNT a, TRANSACTION t";
        sql += " WHERE t.account_id = a.id AND t.wp_ref = " + wpID;
      }
      else if (accWUT != null && !accWUT.equals("null"))
      {
        // Request Finding Unprocessed transactions
        sql = "SELECT * FROM ACCOUNT a, TRANSACTION t";
        sql += " WHERE t.account_id = a.id AND t.status = 'U'";

      }
      else
      {
        // Request Doesn't involve a WP id
        sql = "SELECT * FROM ACCOUNT a";
        sql += " WHERE a.id IS NOT NULL";
        //Above line isn't necessary for the result but aids the following
        //SQL building code
      }


      if (id != null && !id.equals("null"))
        sql += " AND a.id = " + id;
      if (name != null && !name.equals("null"))
        sql += " AND a.name LIKE '" + name + "'";
      if (email != null && !email.equals("null"))
        sql += " AND a.email LIKE '" + email + "'";
      if (logID != null && !logID.equals("null"))
        sql += " AND a.loginid LIKE '" + logID + "'";
      if (designerName != null && !designerName.equals("null"))
        sql += " AND a.designer_name LIKE '" + designerName + "'";
      if (dwnCnt != null && !dwnCnt.equals("null"))
        sql += " AND a.download_count = " + dwnCnt;
      if (winBal != null && !winBal.equals("null"))
        sql += " AND a.winnings_balance = " + winBal;
      if (currBal != null && !currBal.equals("null"))
        sql += " AND a.current_balance = " + currBal;

      System.out.println(sql);

      statement = con.createStatement();
      rs = statement.executeQuery(sql);

      while (rs.next())
      {

        long accountID        = rs.getLong("id");
        String status         = rs.getString("status");
        String name           = rs.getString("name");
        String email          = rs.getString("email");
        String loginID        = rs.getString("loginid");
        String designerName   = rs.getString("designer_name");
        int downloadCount     = rs.getInt("download_count");
        float winningsBal     = rs.getFloat("winnings_balance");
        float currentBal      = rs.getFloat("current_balance");
        String address        = rs.getString("address1");
        String postCode       = rs.getString("post_code");
        String country        = rs.getString("country");
        String regKey         = rs.getString("registration_key");

        // Build up the returnHTML
        returnHTML += "<form name=\"form1\" method=\"post\" action=\"server.rftournaments.com/servlets/roboforge.SControllerServlet?request=FINDACC\">";
        returnHTML += "<table width=\"400\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\">";
        returnHTML += "<tr bgcolor=\"#FF9933\">";
        returnHTML += "<td colspan=\"8\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\"><b>Account ID: " + accountID + "</b></font></td>";
	      returnHTML += "</tr>";
        returnHTML += "<tr>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Status</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"status\" value=\"" + status + "\"></td>";
	      returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Name</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"name\" value=\"" + name + "\"></td>";
	      returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Email</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"email\" value=\"" + email + "\"></td>";
	      returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Login ID</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"loginID\" value=\"" + loginID + "\"></td>";
	      returnHTML += "</tr>";
        returnHTML += "<tr>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Designer Name</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"designerName\" value=\"" + designerName + "\"></td>";
	      returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Download Count</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"dwnCnt\" value=\"" + downloadCount + "\"></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">WinningsBalance</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"wngBal\" value=\"" + winningsBal + "\"></td>";
	      returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Current Balance</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"currBal\" value=\"" + currentBal + "\"></td>";
        returnHTML += "</tr>";
	      returnHTML += "<tr>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Address</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"wngBal\" value=\"" + address + "\"></td>";
	      returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Post Code</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"currBal\" value=\"" + postCode + "\"></td>";
   	    returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Country</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"wngBal\" value=\"" + country + "\"></td>";
	      returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">Reg.Key</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"currBal\" value=\"" + regKey + "\">";
        returnHTML += "</td>";
        returnHTML += "</tr>";
  	    returnHTML += "<tr>";
        returnHTML += "<td bgcolor=\"#CCCCCC\" colspan=\"7\">&nbsp; </td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"submit\" name=\"Find\" value=\"Update a/c\"></td>";
	      returnHTML += "</tr>";
        returnHTML += "</table>";
        returnHTML += "</form>";
      }

      rs.close();
      statement.close();

      return returnHTML;
    }
    catch (Exception e)
    {
      System.err.println("Error: SLoginBean: " + e.getMessage());
    }
    finally
    {
      if (con != null)
        this.freeConnection(con);
    }

    return returnHTML;

  }
}