package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.util.Properties;



public class SForgotPassword extends SHttpServletJXGB
{

  String emailTemplate;
  //Initialize global variables
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);

    emailTemplate     = "Here is your RoboForge login information:\n\n";
    emailTemplate    += "LoginID: [LOG]\n";
    emailTemplate    += "Password: [PASS]\n";
    emailTemplate    += "RegistrationKey: [REG]\n";
  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException
  {
    doPost(request, response);
  }
  
  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {

    Connection con = null;
    String email = "";

    Statement statement = null;
    ResultSet rs = null;
    String sql = "";


    try
    {

     // Code to track down the null parameter bug
      if (request == null)
      {
        System.err.println("Error: SForgotPassword: Request is NULL");
        response.sendRedirect("http://www.roboforge.net/forgoterr.htm");
        return;
      }
      else
      {
        if (request.getParameter("EMAIL")== null )
        {
          // This condition will most likely be reached if a
          // search Robot attempts to link to www.roboforge.net/Servlets/SPreRegisterServlet
          // Get them to contact roboforge
          System.err.println("Error: SForgotPassword: NULL EMAIL ");
          response.sendRedirect("http://www.roboforge.net/forgoterr.htm");
          return;
        }
      }

      if ((request.getParameter("EMAIL").equals("")))
      {
        // An empty string for either the login or password get them to reenter
        System.err.println("Error: SForgotPassword: Empty EMAIL ");
        response.sendRedirect("http://www.roboforge.net/forgoterr.htm");
        return;
      }

      email = SServerAccess.parseString(request.getParameter("EMAIL"));
      email = email.trim().toLowerCase();

      // Find Account
      sql = "SELECT loginid, password, registration_key FROM ACCOUNT WHERE LOWER(email) = LOWER('" + email + "')";
      sql += " AND password IS NOT NULL"; 
      con = getDatabaseConnection();

      statement = con.createStatement();
      rs = statement.executeQuery(sql);

      if (rs.next())
      {
        String loginID    = rs.getString("loginid");
        String password   = rs.getString("password");
        String regKey     = rs.getString("registration_key");

        rs.close();
        statement.close();

        String emailText = emailTemplate;

        // Generate the response email
        int loc = emailText.indexOf("[LOG]");
        emailText = emailText.substring(0,loc) + loginID + emailText.substring(loc+5,emailText.length());

        loc = emailText.indexOf("[PASS]");
        emailText = emailText.substring(0,loc) + password + emailText.substring(loc+6,emailText.length());

        loc = emailText.indexOf("[REG]");
        emailText = emailText.substring(0,loc) + regKey + emailText.substring(loc+5,emailText.length());

        // Send the email
        System.err.println("About to send the email to: " + email);
        new SMTPBean("mail-int.clearfield.com", 25, "rforge@roboforge.com", email, "RoboForge Login Details", emailText);
        System.err.println("Sent the email to: " + email);

        response.sendRedirect("http://www.roboforge.net/forgotok.htm");

        return;
      }
      else
      {
        System.err.println("Error: SForgotPassword: Couldn't find email: " + email);
        rs.close();
        statement.close();

        response.sendRedirect("http://www.roboforge.net/forgoterr.htm");
        return;
      }

    }
    catch (Exception e)
    {
      System.err.println("Error SForgotPassword.doPost: "+ e.getMessage());

      System.out.println("SQL :" + sql);
      response.sendRedirect("http://www.roboforge.net/forgoterr.htm");
      return;

    }
    finally
    {
      try
      {
        if (con!= null)
        {
          myBroker.freeConnection(con);
        }

        if (rs != null)
          rs.close();
        if (statement != null)
          statement.close();

      }
      catch(Exception e3)
      {
        System.err.println("Error SForgotPassword.myBroker.freeConnection: "+e3.getMessage());
      }
    }
  }
  private Connection getDatabaseConnection()
  {
    Connection con = null;
    try
    {
      con = myBroker.getConnection();
    }

    catch (Exception sqle)
    {
      System.err.println("Error SForgotPassword.getDatabaseConnection: " + sqle.getMessage());
    }
  return con;
  }
  //Get Servlet information
  public String getServletInfo()
  {
    return "roboforge.SForgotPassword Information";
  }
}