package roboforge;

/**
 * Database Global Broker Superclass.
 * @version 1.0.0 7/28/99
 * @author Marc A. Mnich
 */


import java.sql.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import sun.misc.*;
import java.util.*;

/**
 * Creates a two-tier database connection pool that can be shared
 * by many servlets through inheritance.
 * @version 1.0.0 7/28/99
 * @author Marc A. Mnich
 */
public class SHttpServletJXGB extends HttpServlet
{

  protected static SDbConnectionBroker myBroker;

  
  public void destroy()
  {
    myBroker.destroy();
  }


  public void init (ServletConfig config) throws ServletException
  {
    super.init(config);

	  if(myBroker == null)
    { // Only created by first servlet to call
	    //Properties p = new Properties();
	    try
      {
        // Load removed as now variables accessed via BGlobal
		    //p.load(new FileInputStream("D:/GameStuff/SetupFiles/SJXGBconfig.txt"));
        /*
		    String dbDriver = (String) p.get("dbDriver");
		    String dbServer = (String) p.get("dbServer");
		    String dbLogin  = (String) p.get("dbLogin");
		    String dbPassword = (String) p.get("dbPassword");
		    int minConns   = Integer.parseInt((String) p.get("minConns"));
		    int maxConns   = Integer.parseInt((String) p.get("maxConns"));
		    String logFileString = (String) p.get("logFileString");
		    double maxConnTime = (new Double((String)p.get("maxConnTime"))).doubleValue();
        */
        String dbDriver = SGlobal.dbDriver;
		    String dbServer = SGlobal.dbServer;
		    String dbLogin  = SGlobal.dbLogin;
		    String dbPassword = SGlobal.dbPassword;
		    int minConns   = SGlobal.minConns;
		    int maxConns   = SGlobal.maxConns;
		    String logFileString = SGlobal.logFileString;
		    double maxConnTime = SGlobal.maxConnTime;

        myBroker = new
		    SDbConnectionBroker(dbDriver,dbServer,dbLogin,dbPassword,minConns,maxConns,logFileString,maxConnTime);
	    }
	    catch (FileNotFoundException f)
      {
      }
	    catch (IOException e)
      {
      }
	  }
  }
}


