//--------------------------------------------------------------------------------------------------
// Copyright (c) 1996-1999 Inprise Corporation. All Rights Reserved.
//--------------------------------------------------------------------------------------------------

package roboforge;

import java.io.InputStream;
import java.io.IOException;
import java.io.ByteArrayInputStream;

/**
 * This class is a wrapper around ByteArrayInputStream.
 * The DataSet package need access to the byte array itself when resolving.
 *
 * @author  Jens Ole Lauridsen
 * @version 1.01 8/26/97
 * @see     java.io.ByteArrayInputStream
 */
public class SInputStreamToByteArray extends ByteArrayInputStream
{
  public SInputStreamToByteArray(byte buf[]) {
    super(buf);
  }
  public SInputStreamToByteArray(byte buf[], int offset, int length) {
    super(buf, offset, length);
  }

  public byte[] getBytes() {
    return buf;
  }

  static public byte[] getBytes(InputStream stream) throws IOException {
    SInputStreamToByteArray buffer;
    if (stream instanceof SInputStreamToByteArray) {
      buffer = (SInputStreamToByteArray)stream;
      return buffer.getBytes();
    }
    else {
      byte[] buf = new byte[stream.available()];
      stream.read(buf);
      return buf;
    }
  }
}
