package roboforge;

/**
 * A simple extension of the java.lang.Exception class designed
 * to report all the possible exceptions during a typical
 * SMTP session using the SMTPBean.
 */
public class SMTPException extends Exception {
	
	/**
	 * Contains the message associated with this error
	 */
	private String message;
	
	/**
	 * Creates a new SMTPException with the given message.
	 */
	public SMTPException(String message) {
		this.message = message;
	}
	
	/**
	 * Returns the message associated with this exception.
	 *<p>
	 * @return
	 * An instance of java.lang.String
	 */
	public String getMessage() {
		return message;
	}
}
