package roboforge;

import java.io.*;

public class SPatchInfo implements Serializable
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
/* 

  * Description:
    Holds information relating to a specific patch
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 15-November-1999

  */

  public String patchBlurb;
  public String patchName;
  public int directoryStripLength;
  public boolean restart;
  public int itemsInPatch;
  public int countOfPatches; // The number of Patches to be applied (including this patch)

  public SPatchInfo(String patchBlurbIn, String patchNameIn, int directoryStripLengthIn, boolean restartIn, int itemsInPatchIn)
  {
    patchBlurb = patchBlurbIn;
    patchName = patchNameIn;
    directoryStripLength = directoryStripLengthIn;
    restart = restartIn;
    itemsInPatch = itemsInPatchIn;
  }

  public void SaveToFile (String fileName)
  {
    try
    {
      FileOutputStream fout = new FileOutputStream(fileName);
      ObjectOutputStream out = new ObjectOutputStream(fout);
      out.writeObject(this);
      out.close();
      System.out.println(this.toString() +"Save completed");
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
    }
  }

  public static SPatchInfo loadFromFile(String filename)
  {
    SPatchInfo newIn = null;
    BDebug.print("SPatch.loadFromFile: Loading...");

    try
    {
      FileInputStream fin = new FileInputStream(filename);
      ObjectInputStream in = new ObjectInputStream(fin);
      newIn = (SPatchInfo)in.readObject();
      in.close();

      BDebug.print("SPatchInfo.loadFromFile: Bot Load completed");

    }

    catch (Exception e)
    {
      BDebug.print("SPatchInfo.loadFromFile: PatchInfo Load failed ::" + e.getMessage());
    }

    return newIn;
  }

} 