package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.util.Properties;

// *** IMPORTANT ***
// If any of the SQL is changed in this class the change must also be implemented in the
// STransferReg Class

// 9/08/00 Class to enable the robo wars people to register

public class SPreRegisterRW extends SHttpServletJXGB
{

  //Initialize global variables
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);
  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException
  {
    doPost(request, response);
  }
  
  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {
    // Taken out 4/07/00 As now doing redirect again
    //response.setStatus(HttpServletResponse.SC_MOVED_PERMANENTLY);

    Connection con = null;
    String name = "";
    String email = "";
    String gCard = "";

    try
    {
      // Code to track down the null parameter bug
      if (request == null)
      {
        System.err.println("*** Request is NULL");
        response.sendRedirect("http://www.roboforge.net/error.htm");
        return;
      }
      else
      {
        if (request.getParameter("OCCUPATION")== null)
        {
          // This condition will most likely be reached if a
          // search Robot attempts to link to www.roboforge.net/Servlets/SPreRegisterServlet
          System.err.println("*** OCCUPATION is NULL");
          response.sendRedirect("http://www.roboforge.net/error.htm");
          return;
        }
      }

      boolean submissionOK;

      if ((request.getParameter("EMAIL").equals("")|| (request.getParameter("FNAME").equals(""))
        || (request.getParameter("LNAME").equals("")) || (request.getParameter("COUNTRY").equals(""))
        || (request.getParameter("DMETHOD").equals("")) || (request.getParameter("GPLATFORM").equals(""))
        || (request.getParameter("NOTIFY").equals("")) || (request.getParameter("LIKE").equals(""))
        || (request.getParameter("HEAR").equals("")) || (request.getParameter("DRAW").equals(""))
        ))
      {
        // Client wants to register however they haven't entered all the fields required.
        submissionOK = false;
      }
      else if ((((String)request.getParameter("BETA")).equals("YES")) && ((request.getParameter("AGE").equals("")) || (request.getParameter("SEX").equals(""))
        || (request.getParameter("OCCUPATION").equals("")) || (request.getParameter("CPU").equals(""))
        || (request.getParameter("SPEED").equals("")) || (request.getParameter("RAM").equals(""))
        || (request.getParameter("OPSYS").equals("")) || (request.getParameter("GCARD").equals(""))))
      {
        // Client wants to be a Beta tester however they haven't entered all the fields required for the Beta tester information
        submissionOK = false;
      }
      else
      {
        submissionOK = true;
      }

      if (submissionOK)
      {

        
        name = request.getParameter("FNAME") + " " + request.getParameter("LNAME");
        email = request.getParameter("EMAIL");
        gCard = request.getParameter("GCARD");

        // Determine if the email address already exists in the database
        con = getDatabaseConnection();

        // Fixup any quotations from the strings to make them Oracle safe
        name = SServerAccess.parseString(name);
        email = SServerAccess.parseString(email);
        gCard = SServerAccess.parseString(gCard);

        // Test to see if the names are too long and if so truncate them to the max allowed length
        if (name.length()>50)
          name = name.substring(0,50);

        if (email.length()>200)
          email = email.substring(0,200);

        if (gCard.length()>30)
          gCard = gCard.substring(0,30);

        if (con != null)
        {
          // Turn off autocommit so we can rollback in the event of any errors
          con.setAutoCommit(false);

          // Check to see if the email address exists for an OPEN account
          Statement statement = con.createStatement();
          String sql = "SELECT id FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  request.getParameter("EMAIL") + "')";
          sql += " AND status = 'OPEN'";
          ResultSet rs = statement.executeQuery(sql);
          if (rs.next())
          {
            // OPEN account already exists so redirect them to
            // error page
            statement.close();
            rs.close();
            response.sendRedirect("http://www.roboforge.net/subexst.htm");
            return;

          }

          statement.close();
          rs.close();

          statement = con.createStatement();
          sql = "SELECT id FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  request.getParameter("EMAIL") + "')";
          rs = statement.executeQuery(sql);
          
          if (!rs.next())
          {
            // Account doesn't exist so build Insert Statement
            sql = "INSERT INTO ACCOUNT (email,name,country,d_method,g_platform,notify,m_like,hear,beta,draw,age,sex,occupation,cpu,speed,ram,opsys,g_card,status)";
            sql = sql + " VALUES (LOWER('" + email + "'),'" + name + "'";
            sql = sql + ",'" + request.getParameter("COUNTRY") + "','" + request.getParameter("DMETHOD") + "','"+ request.getParameter("GPLATFORM") + "'";
            sql = sql + ",'" + request.getParameter("NOTIFY") + "','" + request.getParameter("LIKE") + "','"+ request.getParameter("HEAR") + "'";
            sql = sql + ",'" + request.getParameter("BETA") + "','" + request.getParameter("DRAW") + "','"+ request.getParameter("AGE") + "','"+ request.getParameter("SEX") + "'";
            sql = sql + ",'" + request.getParameter("OCCUPATION") + "','" + request.getParameter("CPU") + "','"+ request.getParameter("SPEED") + "'";
            sql = sql + ",'" + request.getParameter("RAM") + "','" + request.getParameter("OPSYS") + "','"+ gCard + "'";
            sql = sql + ",'P')";
          }
          else
          {
            // Account already exists so build Update statement
            int accountID = rs.getInt("id");

            sql = "UPDATE ACCOUNT";
            sql = sql + " SET email = LOWER('" + email + "'),name = '" + name + "'";
            sql = sql + ",country = '" + request.getParameter("COUNTRY") + "',d_method = '" + request.getParameter("DMETHOD") + "'";
            sql = sql + ",g_platform = '" + request.getParameter("GPLATFORM") + "',notify = '" + request.getParameter("NOTIFY") + "'";
            sql = sql + ",m_like = '" + request.getParameter("LIKE") + "',hear = '" + request.getParameter("HEAR") + "'";
            sql = sql + ",beta = '" + request.getParameter("BETA") + "',draw = '" + request.getParameter("DRAW") + "',age = '" + request.getParameter("AGE") + "'";
            sql = sql + ",sex = '" + request.getParameter("SEX") + "',occupation = '" + request.getParameter("OCCUPATION") + "'";
            sql = sql + ",cpu = '" + request.getParameter("CPU") + "',speed = '" + request.getParameter("SPEED") + "'";
            sql = sql + ",ram = '" + request.getParameter("RAM") + "',opsys = '" + request.getParameter("OPSYS") + "'";
            sql = sql + ",g_card = '" + gCard + "'";
            sql = sql + " WHERE id = " + accountID;
          }
          // Added additional close statements HSC 19/4/2000

          rs.close();
          statement.close();

          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();

          con.commit();
          con.setAutoCommit(true);

          // %% Use the following method in the future to redirect the browser
          // Need to change this to be the correct website once live ie roboforge etc
          //response.sendRedirect("\\\\EDGE/Edge/Website/Main/subok.htm");

          //response.setHeader("Location","/subok.htm");
          response.sendRedirect("http://www.roboforge.net/subok.htm");
          return;
          //response.sendRedirect(SGlobal.WEB_PAGE_LOCATION + "/subok.htm");
          //response.sendRedirect("http://server.roboforge.com/subok.htm");

        }
        else
        {
          // Null connection so write the Pre Registration Data to a File
          FileOutputStream fileOS = new FileOutputStream(SGlobal.OFFLINE_PRE_REG_FILES+ request.getParameter("EMAIL")+".txt");
          Properties prop = new Properties();
          prop.setProperty("EMAIL",email);
          prop.setProperty("NAME",name);
          prop.setProperty("DMETHOD",request.getParameter("DMETHOD"));
          prop.setProperty("COUNTRY",request.getParameter("COUNTRY"));
          prop.setProperty("DRAW",request.getParameter("DRAW"));
          prop.setProperty("GPLATFORM",request.getParameter("GPLATFORM"));
          prop.setProperty("NOTIFY",request.getParameter("NOTIFY"));
          prop.setProperty("LIKE",request.getParameter("LIKE"));
          prop.setProperty("HEAR",request.getParameter("HEAR"));
          prop.setProperty("BETA",request.getParameter("BETA"));
          prop.setProperty("AGE",request.getParameter("AGE"));
          prop.setProperty("SEX",request.getParameter("SEX"));
          prop.setProperty("OCCUPATION",request.getParameter("OCCUPATION"));
          prop.setProperty("CPU",request.getParameter("CPU"));
          prop.setProperty("SPEED",request.getParameter("SPEED"));
          prop.setProperty("RAM",request.getParameter("RAM"));
          prop.setProperty("OPSYS",request.getParameter("OPSYS"));
          prop.setProperty("GCARD",gCard);
          prop.store(fileOS,"Off Line");

          // %% Use the following method in the future to redirect the browser
          // Need to change this to be the correct website once live ie roboforge etc
          //response.sendRedirect("\\\\EDGE/Edge/Website/Main/subok.htm");

          //response.setHeader("Location","/subok.htm");

          response.sendRedirect("http://www.roboforge.net/subok.htm");
          return;

          //response.sendRedirect(SGlobal.WEB_PAGE_LOCATION +"/subok.htm");
          //response.sendRedirect("http://server.roboforge.com/subok.htm");

        }
      }
      else
      {
        // %% Use the following method in the future to redirect the browser
        // Need to change this to be the correct website once live ie roboforge etc
        //response.sendRedirect("\\\\EDGE/Edge/Website/Main/suberr.htm");
        //response.sendRedirect(SGlobal.WEB_PAGE_LOCATION +"/suberr.htm");

        response.sendRedirect("http://www.roboforge.net/suberr.htm");
        //response.setHeader("Location","/suberr.htm");
        return;
        //response.sendRedirect("http://server.roboforge.com/suberr.htm");

      }
    }
    catch (Exception e)
    {
      System.err.println("Error SPreRegisterRW.doPost: "+ e.getMessage());
      try
      {
        if (con != null)
          con.rollback();
      }
      catch (Exception e2)
      {
        System.err.println("Error SPreRegisterRW.doPost.rollback: " + e2.getMessage());
      }

      if (e.getMessage().substring(0,3).equals("ORA"))
      {
        // An Oracle Error so output to file
        FileOutputStream fileOS = new FileOutputStream(SGlobal.OFFLINE_PRE_REG_FILES+ request.getParameter("EMAIL")+".txt");
        Properties prop = new Properties();
        prop.setProperty("EMAIL",email);
        prop.setProperty("NAME",name);
        prop.setProperty("DMETHOD",request.getParameter("DMETHOD"));
        prop.setProperty("COUNTRY",request.getParameter("COUNTRY"));
        prop.setProperty("DRAW",request.getParameter("DRAW"));
        prop.setProperty("GPLATFORM",request.getParameter("GPLATFORM"));
        prop.setProperty("NOTIFY",request.getParameter("NOTIFY"));
        prop.setProperty("LIKE",request.getParameter("LIKE"));
        prop.setProperty("HEAR",request.getParameter("HEAR"));
        prop.setProperty("BETA",request.getParameter("BETA"));
        prop.setProperty("AGE",request.getParameter("AGE"));
        prop.setProperty("SEX",request.getParameter("SEX"));
        prop.setProperty("OCCUPATION",request.getParameter("OCCUPATION"));
        prop.setProperty("CPU",request.getParameter("CPU"));
        prop.setProperty("SPEED",request.getParameter("SPEED"));
        prop.setProperty("RAM",request.getParameter("RAM"));
        prop.setProperty("OPSYS",request.getParameter("OPSYS"));
        prop.setProperty("GCARD",gCard);
        prop.store(fileOS,"Off Line");

        //response.sendRedirect ("\\\\EDGE/Edge/Website/Mainsubok.htm");
        //response.sendRedirect(SGlobal.WEB_PAGE_LOCATION +"/subok.htm");
        response.sendRedirect("http://www.roboforge.net/subok.htm");
        //response.setHeader("Location","/subok.htm");
        return;
        //response.sendRedirect("http://server.roboforge.com/subok.htm");

      }
      else
      {
        //response.sendRedirect("\\\\EDGE/Edge/Website/Main/error.htm");
        //response.sendRedirect(SGlobal.WEB_PAGE_LOCATION +"/error.htm");
        response.sendRedirect("http://www.roboforge.net/error.htm");
        //response.setHeader("Location","/error.htm");
        return;
        //response.sendRedirect("http://server.roboforge.com/error.htm");
      }

    }
    finally
    {
      try
      {
        if (con!= null)
        {
          myBroker.freeConnection(con);
        }

      }
      catch(Exception e3)
      {
        System.err.println("Error SPreRegisterRW.myBroker.freeConnection: "+e3.getMessage());
      }
    }


  }
  private Connection getDatabaseConnection()
  {
    Connection con = null;
    try
    {
      con = myBroker.getConnection();  
      /*
      Class.forName ("oracle.jdbc.driver.OracleDriver");
      con = DriverManager.getConnection("jdbc:oracle:thin:@hugh:1521:edge", "edge", "edge");
      */
      //Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      //con = DriverManager.getConnection("jdbc:odbc:Testy");
    }

    catch (Exception sqle)
    {
      System.err.println("Error SPreRegisterRW.getDatabaseConnection: " + sqle.getMessage());
    }
  return con;
  }
  //Get Servlet information
  public String getServletInfo()
  {
    return "roboforge.SPreRegisterServlet Information";
  }
}
