package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.util.Properties;
import java.math.*;

/*
  This Servlet process all the callback requests from WorldPay
  Updating the Database as per response
*/

public class SQW57UT4Servlet extends SHttpServletJXGB
{

  //Initialize global variables

  // Sales Download HTM
  String sDLHTM = "";
  String errorHTM = "";
  String cancelHTM = "";
  String payOKHTM = "";
  String emailDL = "";
  String emailCD = "";
  String emailDLP = "";
  String emailCDP = "";
  String demoBuyOK = "";
  // Demo OK Buy Web Page

  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);

    try
    {
      // Load the HTML for the WP Callback
      BufferedReader br =
        new BufferedReader(new FileReader("D:/Roboforge/salesdownload.htm"));

      String s = new String();
      while ((s = br.readLine()) != null)
        sDLHTM += s + "\n";
      br.close();

      // Load the HTML for the purchase download
      br = new BufferedReader(new FileReader("D:/Roboforge/saleerror.htm"));

      s = new String();
      while ((s = br.readLine()) != null)
        errorHTM += s + "\n";
      br.close();

      // Load the HTML for the cancel payment
      br = new BufferedReader(new FileReader("D:/Roboforge/salecancel.htm"));

      s = new String();
      while ((s = br.readLine()) != null)
        cancelHTM += s + "\n";
      br.close();

      // Load the HTML for a successful payment
      br = new BufferedReader(new FileReader("D:/Roboforge/pmntok.htm"));

      s = new String();
      while ((s = br.readLine()) != null)
        payOKHTM += s + "\n";
      br.close();

      // Load the HTML for a successful demo payment
      br = new BufferedReader(new FileReader("D:/Roboforge/demosaleok.htm"));

      s = new String();
      while ((s = br.readLine()) != null)
        demoBuyOK += s + "\n";
      br.close();

      // Load the text for the purchase download
      br = new BufferedReader(new FileReader("D:/Roboforge/saleconfirm.txt"));

      s = new String();
      while ((s = br.readLine()) != null)
        emailDL += s + "\n";
      br.close();

      // Load the text for the purchase CD
      br = new BufferedReader(new FileReader("D:/Roboforge/saleconfirmCD.txt"));

      s = new String();
      while ((s = br.readLine()) != null)
        emailCD += s + "\n";
      br.close();

      // Load the text for the Pre Order purchase
      br = new BufferedReader(new FileReader("D:/Roboforge/saleconfirmP.txt"));

      s = new String();
      while ((s = br.readLine()) != null)
        emailDLP += s + "\n";
      br.close();


      // Load the text fot the Pre Order CD purchase
      br = new BufferedReader(new FileReader("D:/Roboforge/saleconfirmCDP.txt"));

      s = new String();
      while ((s = br.readLine()) != null)
        emailCDP += s + "\n";
      br.close();




      /*DataInputStream in =
        new DataInputStream(
          new BufferedInputStream(
            new FileInputStream("D:/Roboforge/salesdownload.htm")));

      String s = new String();
      while ((s = in.readLine()) != null)
        sDLHTM += s + "\n";
      in.close();*/

      //System.out.println(sDLHTM);
    }
    catch (Exception e)
    {
      System.out.println("Error: " + e.getMessage());
    }


  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException
  {
    doPost(request, response);
  }
  
  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {

    Connection con = null;
    String ref = null;
    long accountID = 0;

    Statement statement = null;
    ResultSet rs = null;

    String sql = null;

    PrintWriter out;

    int loc;


    try
    {

      // Ensure that the request isn't null
      if (request == null)
      {
        System.err.println("Error processing Order - Null request");
        out = response.getWriter();
        out.println(errorHTM);
        out.close();
        return;
      }



      if (request.getParameter("transStatus")!= null)
      {
        if (!request.getParameter("transStatus").equals("Y"))
        {
          System.err.println("Error processing Order - Cancelled Payment: ref: " + ref);
          out = response.getWriter();
          out.println(cancelHTM);
          out.close();
          return;
        }
      }
      else
      {
        // Null transStatus
        System.err.println("Error processing Order - Null transStatus");
        out = response.getWriter();
        out.println(errorHTM);
        out.close();
        return;
      }

      // Check to see if the password isn't null
      if (request.getParameter("callbackPW")== null)
      {
          System.err.println("Error processing Order - Null callbackPW");
          out = response.getWriter();
          out.println(errorHTM);
          out.close();
          return;
      }
      else
      {
        // See if the password matches
        if (!(request.getParameter("callbackPW").equals(SGlobal.authPWCallBack)))
        {
          System.err.println("Error processing Order - Invalid password: " + request.getParameter("callbackPW"));
          out = response.getWriter();
          out.println(errorHTM);
          out.close();
          return;
        }
      }

      // Check to see that the cartID isn't null
      if (request.getParameter("cartId")== null)
      {
          System.err.println("Error processing Order - Null cartId");
          out = response.getWriter();
          out.println(errorHTM);
          out.close();
          return;
      }

      ref = request.getParameter("cartId");


      if (request.getParameter("M_ACCTID")!= null)
      {
          accountID = new Long(request.getParameter("M_ACCTID")).longValue();
      }


      // Check to see that the transStatus isn't null
      if (request.getParameter("transStatus")== null)
      {
          System.err.println("Error processing Order - Null transStatus: ref: " + ref);
          out = response.getWriter();
          out.println(errorHTM);
          out.close();
          return;
      }

      con = getDatabaseConnection();
      con.setAutoCommit(false);

      String email = SServerAccess.parseString(request.getParameter("email"));
      String regKey;
      String status;

      String name = "";
      String address = "";
      String postcode = "";
      String country = "";
      BigDecimal amount;
      BigDecimal productAmount;
      boolean sendMail = true;
      long transId;

      if (request.getParameter("name")!= null)
        name = SServerAccess.parseString(request.getParameter("name"));

      if (request.getParameter("address")!= null)
        address = SServerAccess.parseString(request.getParameter("address"));

      if (request.getParameter("postcode")!= null)
        postcode = SServerAccess.parseString(request.getParameter("postcode"));

      if (request.getParameter("country")!= null)
        country = SServerAccess.parseString(request.getParameter("country"));

      amount = new BigDecimal(request.getParameter("amount"));
      transId = new Long(request.getParameter("transId")).longValue();


      // Process the response as per the ref
      if (ref.equals("RF01")  || ref.equals("CD01") || ref.equals("RF03")  || ref.equals("CD02") || ref.equals("RF04") || ref.equals("CD03"))
      {
        if (request.getParameter("email")==null)
        {
          System.err.println("Error processing Order - Null Email: ref: " + ref);
          out = response.getWriter();
          out.println(errorHTM);
          out.close();
          return;
        }

        // Find the purchase amount from the Database
        sql = "SELECT price FROM PRODUCT WHERE id = '" + ref + "'";
        statement = con.createStatement();
        rs = statement.executeQuery(sql);

        if (rs.next())
        {
          productAmount = rs.getBigDecimal("price");

          if (amount.compareTo(productAmount) == -1)
          {
            // Order amount less than product amount, possibly hacked HTML code
            System.err.println("Order amount less than product amount: " + ref);
            sendMail = false;
          }
        }
        else
        {
          // Couldn't find the ProductCode
          System.err.println("Couldn't Find Product Code For: " + ref);
          productAmount = amount;
        }

        rs.close();
        statement.close();


        String type;
        String desc;

        if (ref.equals("RF01") || ref.equals("RF03") || ref.equals("RF04"))
        {
          type = "PURCH";
          desc = "Purchase RoboForge Download";
        }
        else
        {
          type = "PURCH";
          desc = "Purchase RoboForge CD";
        }

        sql = "SELECT id, registration_key, status FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  email + "')";
        statement = con.createStatement();

        rs = statement.executeQuery(sql);

        if (rs.next())
        {

          // Account already exists

          accountID = rs.getLong("id");
          regKey = rs.getString("registration_key");
          status = rs.getString("status");

          rs.close();
          statement.close();

          if (status.equals("OPEN") && regKey != null)
          {
            // We don't need to do anything as the client already has
            // an active account and they are simply ordering
            // another copy of RoboForge

            System.err.println("Customer: " + accountID + " Ordered ANOTHER copy of: " + ref);
          }
          else
          {
            // Set the account to pending and create the RegKey
            sql = "UPDATE ACCOUNT";
            sql += " SET status = 'P', registration_key = getRegKey,";
            sql += " name = '" + name + "', address1 = '" + address +"',";
            sql += " post_code = '" + postcode + "', country = '" + country +"'";
            sql += " WHERE id = " + accountID;

            statement = con.createStatement();
            statement.executeUpdate(sql);
            statement.close();
          }

        }
        else
        {
          // Account doesn't exist so create it

          sql = "INSERT INTO ACCOUNT (email,name,address1,post_code,country,status,registration_key)";
          sql += " VALUES (LOWER('" + email + "'),'" + name + "','" + address + "',";
          sql += " '" + postcode + "','" + country +"','P', getRegKey)";

          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();
        }

        // Need to get and set the accountID and regKey
        sql = "SELECT id, registration_key FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  email + "')";
        statement = con.createStatement();
        rs = statement.executeQuery(sql);
        rs.next();

        accountID = rs.getLong("id");
        regKey = rs.getString("registration_key");
        rs.close();
        statement.close();


        sql = "INSERT INTO TRANSACTION (account_id, type, details, amount, status,account_from,ref, wp_ref)";
        sql += "VALUES (" + accountID + ",'" + type + "','" + desc + "',-" + productAmount + ",'C','C','" + ref + "'," + transId + ")";

        statement = con.createStatement();
        statement.executeUpdate(sql);
        statement.close();

        sql = "INSERT INTO TRANSACTION (account_id, type, details, amount, status,account_from,wp_ref)";
        sql += "VALUES (" + accountID + ",'PYMNT','WorldPay Payment'," + amount + ",'C','C'," + transId + ")";

        statement = con.createStatement();
        statement.executeUpdate(sql);
        statement.close();

        // Add the difference between the amounts to the account
        sql = "UPDATE ACCOUNT SET current_balance = nvl(current_balance,0) +" + (amount.subtract(productAmount));
        sql += " WHERE id = " + accountID;
        statement = con.createStatement();
        statement.executeUpdate(sql);
        statement.close();

        
        con.commit();
        con.setAutoCommit(true);


        if (sendMail)
        {
          // Send the Email after Parsing

          String emailText;

          if (ref.equals("RF01") || ref.equals("RF04"))
            emailText = emailDL;
          else if (ref.equals("RF03"))
            emailText = emailDLP;
          else if (ref.equals("CD02"))
            emailText = emailCDP;
          else
            emailText = emailCD;

          loc = emailText.indexOf("[WP_REF]");
          emailText = emailText.substring(0,loc) + transId + emailText.substring(loc+8,emailText.length());

          loc = emailText.indexOf("[EMAIL]");
          emailText = emailText.substring(0,loc) + email + emailText.substring(loc+7,emailText.length());

          loc = emailText.indexOf("[REGKEY]");
          emailText = emailText.substring(0,loc) + regKey + emailText.substring(loc+8,emailText.length());

          if (ref.equals("CD01") || ref.equals("CD02") || ref.equals("CD03"))
          {
            // They've ordered the CD so need to put in the shipping address
            String shipAdd = address;
            shipAdd = address + "\n" + postcode;

            if (request.getParameter("countryString") != null)
            {
              shipAdd += "\n" + request.getParameter("countryString");
            }

            loc = emailText.indexOf("[ADDR]");
            emailText = emailText.substring(0,loc) + shipAdd + emailText.substring(loc+6,emailText.length());

          }

          System.err.println("About to send the email to: " + email);
          new SMTPBean("mail-int.clearfield.com", 25, "rforge@roboforge.com", email, "RoboForge Order Confirmation", emailText);
          System.err.println("Sent the email to: " + email);


          if (ref.equals("CD01") || ref.equals("CD03"))
          {
            // It's a CD so send a mail to Mike
            emailText = "NAME: " + name + " " + emailText;
            System.err.println("About to send the email to: nzlyoung@hotmail.com");
            new SMTPBean("mail-int.clearfield.com", 25, "rforge@roboforge.com", "nzlyoung@hotmail.com", "CD TO GO DON", emailText);
            System.err.println("Sent the email to: nzlyoung@hotmail.com");

          }


          // Return the HTML page after Parsing

          String rText;

          if (ref.equals("CD03") || ref.equals("RF04"))
           rText = demoBuyOK;
          else
            rText = sDLHTM;

          loc = rText.indexOf("[EMAIL]");
          rText = rText.substring(0,loc) + email + rText.substring(loc+7,rText.length());

          loc = rText.indexOf("[REGKEY]");
          rText = rText.substring(0,loc) + regKey + rText.substring(loc+8,rText.length());

          out = response.getWriter();
          out.println(rText);
          out.close();
          return;
        }
        else
        {
          // Badness as probably hacked the email
          out = response.getWriter();
          out.println(errorHTM);
          out.close();
          return;
        }

      } // RF01 or CD01
      else if (ref.equals("WPSJ")  || ref.equals("WPFP"))
      {

        if (accountID == 0)
        {
          System.err.println("NULL Account ID Attempting to locate account through email...");

          if (request.getParameter("email")==null)
          {
            System.err.println("NULL Account ID and EMAIL - Can't assign WP transId :" + transId + " to Account");
            out = response.getWriter();
            out.println(errorHTM);
            out.close();
            return;
          }

          // Attempt to locate the Account via Email
          sql = "SELECT id FROM ACCOUNT WHERE LOWER(email) = LOWER('" + email + "')";
          statement = con.createStatement();
          rs = statement.executeQuery(sql);

          if (rs.next())
          {
            // Located the accountID
            rs.close();
            statement.close();

            accountID = rs.getLong("id");
          }
          else
          {
            rs.close();
            statement.close();

            System.err.println("NULL Account ID and unable to locate account through Email: " + email + " - Can't assign WP transId :" + transId + " to Account");
            out = response.getWriter();
            out.println(errorHTM);
            out.close();
            return;
          }

        }

        if (ref.equals("WPFP"))
        {
          // We need to get and store the FPID
          if (request.getParameter("futurePayId")==null)
          {
            System.err.println("Sent a WPFP Request without a FuturePay ID");
            System.err.println("AccountID: " + accountID);
            System.err.println("Ref: " + ref);
            System.err.println("WP_Ref: " + transId);
            System.err.println("Amount: " + amount);

            out = response.getWriter();
            out.println(errorHTM);
            out.close();
            return;
          }

          long fpID = new Long(request.getParameter("futurePayId")).longValue();

          // Create the Transaction

          sql = "INSERT INTO TRANSACTION (account_id, type, details, amount, status,account_from,ref, wp_ref)";
          sql += "VALUES (" + accountID + ",'PYMNT','WorldPay Payment'," + amount + ",'C','C','" + ref + "'," + transId + ")";
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();

          // Add the amount to the account and Update the Future Pay ID
          sql = "UPDATE ACCOUNT SET current_balance = nvl(current_balance,0) +" + amount;
          sql += ", wp_id = " + fpID + " WHERE id = " + accountID;
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();
        }
        else
        {
          // Ref must be WPSJ

          // Create the Transaction
          sql = "INSERT INTO TRANSACTION (account_id, type, details, amount, status,account_from,ref, wp_ref)";
          sql += "VALUES (" + accountID + ",'PYMNT','WorldPay Payment'," + amount + ",'C','C','" + ref + "'," + transId + ")";
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();

          // Add the amount to the account
          sql = "UPDATE ACCOUNT SET current_balance = nvl(current_balance,0) +" + amount;
          sql += " WHERE id = " + accountID;
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();
        }

        con.commit();
        con.setAutoCommit(true);

        out = response.getWriter();
        out.println(payOKHTM);
        out.close();
        return;

      } // "WPSJ" OR "WPFP"
      else
      {
        // Unknown request
        System.err.println("Sent an Unknown Request of Type:" + ref);
        System.err.println("WP_Ref: " + transId);
        System.err.println("Amount: " + amount);        
        System.err.println("AccountID: " + accountID);
        out = response.getWriter();
        out.println(errorHTM);
        out.close();
        return;
      }

    }
    catch (Exception e)
    {
      System.err.println("Error SQW57UT4Servlet.doPost: SQL: "+ sql + " Error: " + e.getMessage());
      out = response.getWriter();
      out.println(errorHTM);
      out.close();
      try
      {
        if (con != null)
        {
          con.rollback();
          con.setAutoCommit(true);
        }
      }
      catch (Exception e2)
      {
        System.err.println("Error SQW57UT4Servlet.doPost.rollback: " + e2.getMessage());
      }

      return;


    }
    finally
    {
      try
      {
        if (con!= null)
        {
          myBroker.freeConnection(con);
        }

        if (rs != null)
        {
          rs.close();
        }

        if (statement != null)
        {
          statement.close();
        }
      }
      catch(Exception e3)
      {
        System.err.println("Error SQW57UT4Servlet.myBroker.freeConnection: "+e3.getMessage());
      }
    }
  }
  private Connection getDatabaseConnection()
  {
    Connection con = null;
    try
    {
      con = myBroker.getConnection();
    }

    catch (Exception sqle)
    {
      System.err.println("Error SQW57UT4Servlet.getDatabaseConnection: " + sqle.getMessage());
    }
  return con;
  }
  //Get Servlet information
  public String getServletInfo()
  {
    return "roboforge.SQW57UT4Servlet Information";
  }
}