package roboforge;

//import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.util.zip.*;
//import javax.swing.ProgressMonitorInputStream;
import javax.swing.*;
import java.security.*;
import javax.crypto.Cipher;
//import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;
import roboforge.net.*;
import roboforge.util.io.*;
import iaik.security.rsa.*;
public class SServerAccess
{

  public SServerAccess()
  {
  }

  public static String parseString (String stringToParse)
  {
    // Changes a string into a form that is acceptable for insertion into Oracle8i
    //BDebug.print("IN: " + stringToParse);
    // For now replace every single quote with double quotes
    int found = 0;
    while (found != -1)
    {
      found = stringToParse.indexOf("'",found);
      if (found != -1)
      {
        // Add in the extra single quote
        String string1 = stringToParse.substring(0,found+1);
        String string2 = stringToParse.substring(found+1);
        stringToParse =  string1 + "'" + string2;
        found = found + 2;
      }
    }
    //BDebug.print("OUT: " + stringToParse);
    return stringToParse;
  }
  public static SResponseWrapper getServerResponse (BRequestDescriptor requestDescriptor, Object requestDetailIn) throws ServerResponseException
  {

   SResponseWrapper responseWrapper = null;
   long size = 0;

    try
    {
      // Read in and Define the Server Public Key
      ObjectInputStream in1 = new ObjectInputStream(new FileInputStream(BGlobal.PUBLIC_KEY_SERVER));
      PublicKey serverPubKey = (PublicKey)in1.readObject();

      // Read in and Define the Client Private Key
      //ObjectInputStream in11 = new ObjectInputStream(new FileInputStream(BGlobal.PRIVATE_KEY_CLIENT));
      // Taken out as this class no longer used and needed to get the class to compile 
      ObjectInputStream in11 = null;
      PrivateKey clientPrvKey = (PrivateKey)in11.readObject();


      // %% Currently this is a little kludgy - might need to pass in if the opbject is going to be zipped or encrypted
      // currently just assuming that BRequestDescriptor encrypts and zips everything

      // **** New way of Handling Requests Involving two objects

      // First find out the size of the object to be pushed up

      if (requestDetailIn != null)
      {

        // Translate object for transmission
        requestDetailIn = SServerAccess.processObjectForTransmission(requestDetailIn,requestDescriptor.isEncrypted(),requestDescriptor.isZipped(),serverPubKey);

        BCountDisposeOutputStream cdos = new BCountDisposeOutputStream();
        ObjectOutputStream oos = new ObjectOutputStream(cdos);

        oos.writeObject(requestDetailIn);
        oos.flush();
        oos.close();

        size = cdos.getByteCount();
        /*
        if (requestDetailIn instanceof byte[])
        {

          // The object is already in the form of a byte array so we don't have to convert it to a byte array
          // just need to cast and count
          byte[] objByte = (byte[])requestDetailIn;
          size = objByte.length;
        }
        else
        {
          byte[] objByte = objectToByteArray(requestDetailIn);
          size = objByte.length;
        }*/
      }
      else
      {
        // Have a null object ie no object so set the size to 0
        size = 0;
      }

      requestDescriptor.setSize(size);

      //  Turn into a BEncryptedObject
      BEncryptedObject encDesc = new BEncryptedObject(requestDescriptor,serverPubKey);

      // Zip the header
      byte[] zippedHeaderBytes = gzipDeflateArray(objectToByteArray(encDesc));

      URL url = new URL(requestDescriptor.getURL());
      BDebug.print ("Opening Connection");
      URLConnection con = url.openConnection();
      con.setUseCaches(false);
      con.setRequestProperty("CONTENT_TYPE","application/octet-stream");
      con.setDoInput(true);
      con.setDoOutput(true);

      BDebug.print ("Sending object up stream");
      //CountOutputStream os = new CountOutputStream(con.getOutputStream());

      BCountOutputStream dos = new BCountOutputStream(con.getOutputStream());
      ObjectOutputStream os = new ObjectOutputStream(dos);



      os.writeObject(zippedHeaderBytes);

      if (size > 1)
      {
        dos.resetCount();
        BDebug.print ("Size of object to send: " + size);
        BDebug.print ("Bytes Processed before send: " + dos.getCount());
        // We have an object to push up
        os.writeObject(requestDetailIn);
        BDebug.print ("Bytes Processed after write: " + dos.getCount());
      }

      // Neither objects actually sent until the os.close method is called - strange
      os.flush();
      BDebug.print ("Bytes Processed After Flush: " + dos.getCount());
      os.close();
      BDebug.print ("Bytes Processed After Close: " + dos.getCount());

      BCountInputStream cis = new BCountInputStream(con.getInputStream());
      ObjectInputStream is = new ObjectInputStream(cis);

      BDebug.print ("Getting object back");

      BResponseDescriptor responseDescriptor = (BResponseDescriptor)is.readObject();

      Object responseObject = null;

      if (responseDescriptor.getSize() != 0)
      {
        cis.resetCount();
        BDebug.print ("Size of object to get: " + responseDescriptor.getSize());
        BDebug.print ("Bytes Processed before get: " + cis.getCount());
        // A following object in the pipe so get it
        responseObject = is.readObject();
        BDebug.print ("Bytes Processed after read: " + cis.getCount());

        // Translate it
        responseObject = SServerAccess.processObjectAfterTransmission(responseObject,responseDescriptor.isEncrypted(),responseDescriptor.isZipped(),clientPrvKey);
      }

      responseWrapper = new SResponseWrapper(responseDescriptor.getType(),responseObject);

    }
    catch (MalformedURLException mue)
    {
      BDebug.print(mue.getMessage());
      throw new ServerResponseException(" URL Exception");
    }
    catch (IOException e1)
    {
      BDebug.print(e1.getMessage());
      throw new ServerResponseException(" IO Exception");
    }
    catch (Exception ex)
    {
      BDebug.print(ex.getMessage());
      throw new ServerResponseException(" General Exception");
    }

    return responseWrapper;
  }


public static void push (URLConnection connection, Object value) throws PushException
  {
    try
    {
      //ByteArrayOutputStream bOS = new ByteArrayOutputStream();
      //ObjectOutputStream OS = new ObjectOutputStream(bOS);
      //OS.writeObject(value);
      //BDebug.print("Size of Object: " + bOS.size());


      connection.setUseCaches(false);
      connection.setRequestProperty("CONTENT_TYPE","application/octet-stream");
      connection.setDoInput(true);
      connection.setDoOutput(true);

      //bOS.writeTo(connection.getOutputStream());
      //bOS.flush();
      //bOS.close();

      //ObjectOutputStream os = new ObjectOutputStream(connection.getOutputStream());

      GZIPOutputStream zos = new GZIPOutputStream(connection.getOutputStream());
      BDebug.print ("Sending object up stream");
      ObjectOutputStream os = new ObjectOutputStream(zos);
      os.writeObject(value);
      //os.write(bOS.toByteArray(),0,255);

      os.flush();
      os.close();
    }
    catch (IOException e)
    {
      BDebug.print(e.getMessage());
      throw new PushException("IO Exception");
    }
    catch (Exception ex)
    {
      BDebug.print(ex.getMessage());
      throw new PushException("General Exception");
    }
  }


public static SResponseWrapper pull(URLConnection connection) throws PullException
  {
    SResponseWrapper response = null;

  try
    {
      GZIPInputStream zis = new GZIPInputStream(connection.getInputStream());

      //ProgressMonitorInputStream monitor = new ProgressMonitorInputStream (this,"Test",connection.getInputStream());

      //monitor.getProgressMonitor().setMillisToPopup(1);
      //monitor.getProgressMonitor().setMillisToDecideToPopup(0);

      //ObjectInputStream is = new ObjectInputStream(connection.getInputStream());
      ObjectInputStream is = new ObjectInputStream(zis);
      //ObjectInputStream is = new ObjectInputStream(monitor);

      BDebug.print ("Getting object back");

      response = (SResponseWrapper)is.readObject();
      is.close();
    }
    catch (IOException e)
    {
      BDebug.print(e.getMessage());
      throw new PullException("IO Exception");
    }
    catch (ClassNotFoundException ce)
    {
      BDebug.print(ce.getMessage());
      throw new PullException("Class Not Found Exception");
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new PullException("General Exception");
    }

    return response;
  }
 public static SResponseWrapper pullAutoPatch(URLConnection connection) throws PullException
  {
    // Used for returning a zipped upgrade file, as the object is already zipped
    // we don't bother with a zipped stream

    SResponseWrapper response = null;

  try
    {
      //ProgressMonitorInputStream progressMonitorInputStream = new ProgressMonitorInputStream(new JPanel(), "Hello",connection.getInputStream());
      //ObjectInputStream is = new ObjectInputStream(connection.getInputStream());
      ObjectInputStream is = new ObjectInputStream(connection.getInputStream());

      BDebug.print ("Getting autopatch object back");

      response = (SResponseWrapper)is.readObject();
      is.close();

    }
    catch (IOException e)
    {
      BDebug.print(e.getMessage());
      throw new PullException("IO Exception");
    }
    catch (ClassNotFoundException ce)
    {
      BDebug.print(ce.getMessage());
      throw new PullException("Class Not Found Exception");
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new PullException("General Exception");
    }

    return response;
  }
  public static void Upgrade (String loginID, String password,JPanel panel, PublicKey clientPubKey) throws UpgradeException
  {
    boolean restart = false;

    try
    {
      BRequestDescriptor reqDesc = new BRequestDescriptor("AUT",loginID,password,clientPubKey,BGlobal.URLSGATEWAY);
      SResponseWrapper responseWrapper = getServerResponse(reqDesc,new Float(BGlobal.APP_VERSION));
      while (responseWrapper.getResponseType() != null)
      {
        if (responseWrapper.getResponseType().equals("AUT"))
        {
          // All is ok
          Vector response = (Vector)responseWrapper.getResponseObject();

          byte[] byteZippedArray = (byte[])response.elementAt(0);
          ByteArrayInputStream bAIS = new ByteArrayInputStream(byteZippedArray);

          SPatchInfo patchInfo = (SPatchInfo)response.elementAt(2);
          restart = patchInfo.restart;


          // Extract the files
          CheckedInputStream csumi = new CheckedInputStream(bAIS, new Adler32());
          ZipInputStream in2 = new ZipInputStream(new BufferedInputStream(csumi));
          ZipEntry ze;
          System.out.println("Checksum: " +csumi.getChecksum().getValue());
          while((ze = in2.getNextEntry()) != null)
          {

           int x;

            // Replace the Start Directory with the BGlobal start directory for the individuals machine



            // Get the remainder of the string past the start directory
            String remainder = ze.getName().substring(patchInfo.directoryStripLength);

            //%% Possibly Need this code to convert all \'s to /'s in the String remainder
            remainder = remainder.replace('\\','/');

            BDebug.print("Remainder: " + remainder);

            // %% Change back to below for install
            //String fileAndPath = BGlobal.SYSTEMPATH  + remainder;
            String fileAndPath = "y:/Source/TestAutoPatch/"  + remainder;
            BDebug.print("Path And File: " + fileAndPath);

            // Need to make the directory if it doesn't exist
            // Strip off the file to get the directory path

            int finalDirLoc = 0;
            // Loop backwards through the string until the first '/' is encountered
            for (int i = fileAndPath.length()-1;i>0;i--)
            {
              char c = fileAndPath.charAt(i);
              BDebug.print(c);
              if (c=='/')
              {
                finalDirLoc = i;
                break;
              }
            }

            String dir = fileAndPath.substring(0,finalDirLoc);
            BDebug.print("Directory to create: " + dir);

            //Check to see if the Directory exists
            File dirFile = new File(dir);
            if (!dirFile.exists())
            {
              // Make the directory(ies)
              dirFile.mkdirs();
            }

            // So now the directory(ies) should always exist so we can now just write the file

            FileOutputStream fos = new FileOutputStream(fileAndPath);

            while((x = in2.read()) != -1)
            {
              //System.out.write(x);
              fos.write(x);
            }
            fos.flush();
            fos.close();
          }
          in2.close();

          // Change the version number and save it away
          BDebug.print("Old Version No: " + BGlobal.APP_VERSION);
          BGlobal.APP_VERSION = ((Float)response.elementAt(1)).floatValue();
          BGlobal tempG = new BGlobal();
          tempG.saveToFile();
          BDebug.print("New Version No: " + BGlobal.APP_VERSION);

          if (restart)
          {
            // If the patch applied requires a restart then jump out of the while loop
            // and apply the restart
            break;
          }

        }
        else if (responseWrapper.getResponseType().equals("ERR"))
        {
          throw new UpgradeException((String)responseWrapper.getResponseObject());
        }
        else
        {
          throw new UpgradeException("Unknown Response Type");
        }
        reqDesc = new BRequestDescriptor("AUT",loginID,password,clientPubKey,BGlobal.URLSGATEWAY);
        responseWrapper = getServerResponse(reqDesc,new Float(BGlobal.APP_VERSION));
      }

      if (restart)
      {
        // %% Put the restart code here
        // If a patch needs a restart then it will jump out of the patching loop and restart the application
      }
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new UpgradeException(e.getMessage());
    }
  }

  public static byte[] encrypt (byte[] byteArrayToEncrypt,PublicKey rsa_pub)
  {
    try
    {
      // SetUp IAIK as the security provider
      IAIK.addAsProvider(false);

      // Set up the Cipher for Encrypt

      Cipher rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding");
      rsa.init(Cipher.ENCRYPT_MODE, rsa_pub);


      // Encrypt the byte array
      return rsa.doFinal(byteArrayToEncrypt);
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new RuntimeException();
    }
  }

  public static byte[] decrypt (byte[] byteArray, PrivateKey privKey)
  {
    try
    {
      // First set up the Cipher object in decrypt mode
      Cipher rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding");
      rsa.init(Cipher.DECRYPT_MODE, privKey);

      return rsa.doFinal(byteArray);
    }
    catch (Exception e)
    {
      System.err.println(e.getMessage());
      return null;
    }

  }

  public static byte[] objectToByteArray (Object objectIn) throws Exception
  {
    // Turn the object into a stream of bytes
    ByteArrayOutputStream byteArrayOS = new ByteArrayOutputStream();

    try
    {
      ObjectOutputStream o1 = new ObjectOutputStream(byteArrayOS);
      o1.writeObject(objectIn);
      o1.close();
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception(e.getMessage());
    }

    // Turn the object into an array of bytes
    return byteArrayOS.toByteArray();
  }


  public static Object processObjectForTransmission (Object object, boolean encrypted, boolean zipped, PublicKey pubKey) throws Exception
  {
    // Takes an object and encrypts  and or deflates it
    // Returns the length of the object

    try
    {
      if (zipped && encrypted)
      {
        // Encrypt the object
        BEncryptedObject encryptedObject = new BEncryptedObject(object,pubKey);

        // Turn the encryptedObject into a byte array and zip it
        byte[] encZippedArrayObject = SServerAccess.gzipDeflateArray(SServerAccess.objectToByteArray(encryptedObject));

        // Cast to object
        object = (Object)encZippedArrayObject;
      }
      else if (zipped && !encrypted)
      {
        // Deflate the object
        byte[] zippedArrayObject = SServerAccess.gzipDeflateArray(SServerAccess.objectToByteArray(object));

        // Turn the zipped byte array into an Object
        object = (Object)zippedArrayObject;
      }
      else if (!zipped && encrypted)
      {
        // Encrypt the object
        BEncryptedObject encryptedObject = new BEncryptedObject(object,pubKey);

        // Turn the BEncrypted Object into an Object
        object =  (Object)encryptedObject;
      }
      else
      {
        // Object to be zipped or encrypted so don't do anything
      }

      return object;

    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception(e.getMessage());
    }



  }

  public static Object processObjectAfterTransmission(Object object, boolean encrypted, boolean zipped, PrivateKey prvKey) throws Exception
  {
    // Takes an object and decrypts and or inflates it

    try
    {
        if (zipped && encrypted)
        {
          // Inflate the object and decrypt it
          byte[] objectBytes = SServerAccess.gzipInflateArray((byte[])object);

          // Turn the byte array into a BEncryptedObject
          BEncryptedObject encryptedObject = (BEncryptedObject)SServerAccess.byteArrayToObject(objectBytes);

          // Turn the BEncrypted Object into an Object
          object =  (Object)encryptedObject.getDecryptedObject(prvKey);
        }
        else if (zipped && !encrypted)
        {
          // Inflate the object and decrypt it
          byte[] objectBytes = SServerAccess.gzipInflateArray((byte[])object);

          // Turn the byte array into an Object
          object = (Object)SServerAccess.byteArrayToObject(objectBytes);
        }
        else if (!zipped && encrypted)
        {
          // Cast the object
          BEncryptedObject encryptedObject = (BEncryptedObject)object;

          // Turn the BEncrypted Object into an Object
          object =  (Object)encryptedObject.getDecryptedObject(prvKey);
        }
        else
        {
          // Object isn't zipped or encrypted so don't do anything
        }

        return object;
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception(e.getMessage());
    }

  }

  public static Object byteArrayToObject (byte[] arrayIn) throws Exception
  {
    // Turn the byte array into an Object ready for casting
    Object object = new Object();

    try
    {

      ByteArrayInputStream byteIS = new ByteArrayInputStream(arrayIn);
      ObjectInputStream in = new ObjectInputStream(byteIS);
      object = (Object)in.readObject();
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception(e.getMessage());
    }

    // Turn the object into an array of bytes
    return object;
  }
  /*public static byte[] generateKeyPair () throws Exception
  {
    // Turn the object into a stream of bytes
    ByteArrayOutputStream byteArrayOS = new ByteArrayOutputStream();

    try
    {
      ObjectOutputStream o1 = new ObjectOutputStream(byteArrayOS);
      o1.writeObject(objectIn);
      o1.close();
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception(e.getMessage());
    }

    // Turn the object into an array of bytes
    return byteArrayOS.toByteArray();
  }*/
  public static byte[] gzipDeflateArray(byte[] arrayToDeflate) throws Exception
  {
      ByteArrayOutputStream zbaos = new ByteArrayOutputStream();
      try
      {
        ByteArrayInputStream instream = new ByteArrayInputStream(arrayToDeflate);
        BufferedOutputStream out = new BufferedOutputStream(new GZIPOutputStream(zbaos));

        int chunk = 4096;
        byte[] buffer = new byte[chunk];
        int length = -1;

        while ((length = instream.read(buffer)) != -1)
        {
          out.write(buffer, 0, length);
        }

        instream.close();
        out.flush();
        out.close();
      }
      catch (Exception e)
      {
        BDebug.print(e.getMessage());
        throw new Exception(e.getMessage());
      }

      return zbaos.toByteArray();
  }
  /*
  public static Vector encryptObject(Object objectToEncrypt) throws Exception
  {
      // Passed an object returns a Vector containing encrypted arrays of bytes
      // Needs to be done this way as the encryption tools only handle 100 bytes at a time

      ByteArrayOutputStream zbaos = new ByteArrayOutputStream();
      try
      {
        ByteArrayInputStream instream = new ByteArrayInputStream(arrayToDeflate);
        BufferedOutputStream out = new BufferedOutputStream(new GZIPOutputStream(zbaos));

        int chunk = 4096;
        byte[] buffer = new byte[chunk];
        int length = -1;

        while ((length = instream.read(buffer)) != -1)
        {
          out.write(buffer, 0, length);
        }

        instream.close();
        out.flush();
        out.close();
      }
      catch (Exception e)
      {
        BDebug.print(e.getMessage());
        throw new Exception(e.getMessage());
      }

      return zbaos.toByteArray();
  } */



  public static byte[] gzipInflateArray(byte[] arrayToInflate) throws Exception
  {
      byte[] inflatedBattleRecording;
      try
      {
        int chunk = 4096;
        byte[] buffer = new byte[chunk];
        int length = -1;

        ByteArrayOutputStream baos = new ByteArrayOutputStream();

        BufferedInputStream in2 = new BufferedInputStream(new GZIPInputStream(new ByteArrayInputStream(arrayToInflate)));
        while ((length = in2.read(buffer)) != -1)
        {
          baos.write(buffer, 0, length);
        }
        in2.close();
        inflatedBattleRecording = baos.toByteArray();
        baos.close();
      }
      catch (Exception e)
      {
        BDebug.print(e.getMessage());
        throw new Exception(e.getMessage());
      }

      return inflatedBattleRecording;
  }

  public static void generateKeys(String keyLocation) throws Exception
  {
     
      try
      {

        //RSAKeyPairGenerator key_gen = RSAKeyPairGenerator.getInstance("RSA");
        RSAKeyPairGenerator key_gen = new RSAKeyPairGenerator();

        key_gen.initialize(1024,SecureRandom.getInstance("SHA1PRNG"));

        KeyPair key_pair = key_gen.generateKeyPair();
        System.out.println("Finished Generating KeyPair");
        RSAPrivateKey rsa_priv = (RSAPrivateKey)key_pair.getPrivate();
        RSAPublicKey rsa_pub = (RSAPublicKey)key_pair.getPublic();

        //Lets Serialize the two keys
        ObjectOutputStream o = new ObjectOutputStream(new
        FileOutputStream(keyLocation+"PubKey.out"));
        o.writeObject(rsa_pub);
        o.flush();
        o.close();

        ObjectOutputStream o1 = new ObjectOutputStream(new
        FileOutputStream(keyLocation+"PrvKey.out"));
        o1.writeObject(rsa_priv);
        o1.flush();
        o1.close();

      }
      catch (Exception e)
      {
        BDebug.print(e.getMessage());
        throw new Exception(e.getMessage());
      }
  }


}

class PushException extends Exception
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
public PushException()
  {
  }
  public PushException(String msg)
  {
    super(msg);
  }
}

class PullException extends Exception
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
public PullException()
  {
  }
  public PullException(String msg)
  {
    super(msg);
  }
}

class ServerResponseException extends Exception
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
public ServerResponseException()
  {
  }
  public ServerResponseException(String msg)
  {
    super(msg);
  }
}

class UpgradeException extends Exception
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
public UpgradeException()
  {
  }
  public UpgradeException(String msg)
  {
    super(msg);
  }
}