package roboforge;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import java.io.*;

public class STournamentClient extends JFrame
{
  JButton jBStart = new JButton();
  JButton jBStop = new JButton();
  JTextField jTInfo = new JTextField();
  String password = "bkd835gbb$*(KJnmcz";

    //Main method
  public static void main(String[] args)
  {
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
    }
    STournamentClient frame = new STournamentClient();

    frame.validate();
    frame.setVisible(true);
  }

  //Construct the frame
  public STournamentClient()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try 
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception 
  {
    jBStart.setText("Start");
    jBStart.setBounds(new Rectangle(28, 40, 114, 30));
    jBStart.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBStart_actionPerformed(e);
      }
    });
    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(466, 300));
    this.setTitle("Tournament Controller Start Stop");
    jBStop.setText("Stop");
    jBStop.setBounds(new Rectangle(195, 41, 122, 30));
    jBStop.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBStop_actionPerformed(e);
      }
    });
    jTInfo.setBounds(new Rectangle(31, 143, 357, 34));
    this.getContentPane().add(jBStart, null);
    this.getContentPane().add(jBStop, null);
    this.getContentPane().add(jTInfo, null);
  }

  private SResponseWrapper getTransferResponse (String transferType, String transferError)
  {

   SResponseWrapper responseWrapper = null;


    try
    {
      // Create the request Wrapper
      // STC = S Tournament Client
      SRequestWrapper requestWrapper = new SRequestWrapper("STC", password, transferType,null,null);

      // Verify Stuff
      URL url = new URL(SGlobal.URLSTOURNAMENTCONTROLLER);
      BDebug.print ("Opening Connection");
      URLConnection con = url.openConnection();

      try
      {
        // Send the Request Up
        push(con,requestWrapper);
      }
      catch (PushException pe)
      {
        BDebug.print(pe.getMessage());
        jTInfo.setText(transferError + " URL Exception");
      }

      try
      {
        // Get the response back
        responseWrapper = pull(con);
      }
      catch (PullException pue)
      {
        BDebug.print(pue.getMessage());
        jTInfo.setText(transferError + " URL Exception");
      }

     }
     catch (MalformedURLException mue)
      {
        BDebug.print(mue.getMessage());
        jTInfo.setText(transferError + " URL Exception");
      }
      catch (IOException e1)
      {
        BDebug.print(e1.getMessage());
       jTInfo.setText(transferError + " URL Exception");
      }
      catch (Exception ex)
      {
        BDebug.print(ex.getMessage());
       jTInfo.setText(transferError + " URL Exception");
      }
      return responseWrapper;
     }

  public void push (URLConnection connection, Object value) throws PushException
  {
    try
    {
      //ByteArrayOutputStream bOS = new ByteArrayOutputStream();
      //ObjectOutputStream OS = new ObjectOutputStream(bOS);
      //OS.writeObject(value);
      //BDebug.print("Size of Object: " + bOS.size());


      connection.setUseCaches(false);
      connection.setRequestProperty("CONTENT_TYPE","application/octet-stream");
      connection.setDoInput(true);
      connection.setDoOutput(true);

      //bOS.writeTo(connection.getOutputStream());
      //bOS.flush();
      //bOS.close();

      ObjectOutputStream os = new ObjectOutputStream(connection.getOutputStream());

      BDebug.print ("Sending object up stream");

      os.writeObject(value);
      os.flush();
      os.close();
    }
    catch (IOException e)
    {
      BDebug.print(e.getMessage());
      throw new PushException("IO Exception");
    }
    catch (Exception ex)
    {
      BDebug.print(ex.getMessage());
      throw new PushException("General Exception");
    }
  }

  public SResponseWrapper pull(URLConnection connection) throws PullException
  {
    SResponseWrapper response = null;

  try
    {
      //ProgressMonitorInputStream monitor = new ProgressMonitorInputStream (this,"Test",connection.getInputStream());

      //monitor.getProgressMonitor().setMillisToPopup(1);
      //monitor.getProgressMonitor().setMillisToDecideToPopup(0);
      ObjectInputStream is = new ObjectInputStream(connection.getInputStream());

      //ObjectInputStream is = new ObjectInputStream(monitor);

      BDebug.print ("Getting object back");

      response = (SResponseWrapper)is.readObject();
      is.close();

    }
    catch (IOException e)
    {
      BDebug.print(e.getMessage());
      throw new PullException("IO Exception");
    }
    catch (ClassNotFoundException ce)
    {
      BDebug.print(ce.getMessage());
      throw new PullException("Class Not Found Exception");
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new PullException("General Exception");
    }

    return response;
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }

  void jBStart_actionPerformed(ActionEvent e)
  {
   // Get the response
   SResponseWrapper responseWrapper = getTransferResponse("STA","Couldn't Start");

   if (responseWrapper.getResponseType().equals("STA"))
    jTInfo.setText("Started");
   else
    jTInfo.setText((String)responseWrapper.getResponseObject());

  }

  void jBStop_actionPerformed(ActionEvent e)
  {
    // Get the response
   SResponseWrapper responseWrapper = getTransferResponse("STO","Couldn't Stop");
   if (responseWrapper.getResponseType().equals("STO"))
    jTInfo.setText("Stopped");
   else
    jTInfo.setText((String)responseWrapper.getResponseObject());

  }
} 