package roboforge.ai.actions;

import roboforge.*;
import java.io.*;


public class BSurrenderAction implements BAction, Serializable
{
  static final long serialVersionUID = -1L;
  
  BBot theBot;

  public BSurrenderAction(BBot theBot)
  {

    this.theBot = theBot;
  }

  public void start()
    { theBot.surrender() ;}


  public boolean execute(float s)
    { return false; }

  public void stop()
    {}

  public boolean conflictsWith(BAction a)
    { return false; }

  public boolean overrides(BAction a)
    { return true; }

  public String getName()
    { return theBot + " surrenders. ";}

  public String toString()
    { return "Surrender";}

  public boolean isValid()
    { return theBot != null; }

}

/*
public interface BAction
{

  // Execution Methods...
  // -------------------------------------------------------------

  public void start();
    // Prepare this action for execution.

  public boolean execute(float s);
    // Execute this action for a number of seconds,
    // indicated by the parameter 's'.

  public void stop();
    // Indicate that this action is stopping.



  // Conflict resolution methods...
  // -------------------------------------------------------------

  public boolean conflictsWith(BAction a);
    // Returns true if this action and 'a' can not be
    // executed simultaneously.

  public boolean overrides(BAction a);
    // Returns true if this action takes precedence over 'a'.

  public String getName();
  // return the name

  public boolean isValid();
  // Is Active


}*/