package roboforge.ai.decisions;

import roboforge.BBot;
import roboforge.BDebug;
import roboforge.BGlobal;

import roboforge.ai.actions.*;
import javax.swing.Icon;


public class BActionNode extends BLeafNode
{

  // Class variables...
  // -------------------------------------------------------------

  protected static Icon icon =
    createTreeIcon("ai/complex_decision_18.gif", BGlobal.colors.getAIActionColor() );

//  protected static Icon selectedIcon =
//    createTreeIcon("ai/complex_decision_18.gif", BGlobal.SELECTED_COLOR,  BGlobal.colors.getAIActionColor());

  
  // Member variables...
  // -------------------------------------------------------------
  
  protected BAction action;
  protected BActor  actor;


  // Constructor.
  // -------------------------------------------------------------

  public BActionNode()
    { super(); }

  public BActionNode(BActor a)
  {
    super();
    this.actor = a;
  }

  public BActionNode(BActor a, BAction b)
  {
    super();
    this.actor  = a;
    this.action = b;
  }
  
  public BActionNode(BActionNode node)
  {
    super(node);
    this.actor  = node.actor;
    this.action = node.action;
  }


  public boolean isValid()
  {
    if (action == null)
      return false;
    else
      return action.isValid();

  }


  // Accessor methods...
  // -------------------------------------------------------------

  protected void setAction(BAction a)
    { this.action = a; }

  protected BAction getAction()
    { return this.action; }

  public void setActor(BActor a)
  {
    this.actor = a;
    if (a == null)
      this.setAction(null);

  }

  public BActor getActor()
    { return this.actor; }


  protected String generateDefaultName()
  {
    if (action == null)
      return "Action";
    else
      return action.toString();
  }
  

  

  // Node visit method...
  // -------------------------------------------------------------

  public void visit()
  {
     if (action != null)
      if (action.isValid())
        if (actor.canAddAction(action))
          actor.addAction(action);
  }


  // State storage / retrieval...
  // -----------------------------------------------------------

  public void setState(Object o)
  {
    super.setState(o);

    ActionNodeState state =
      (ActionNodeState) o;

    this.actor  = state.actor;
    this.action = state.action;
  }

  public Object getState()
    { return new ActionNodeState(this); }

  protected static class ActionNodeState extends DecisionTreeNodeState
  {
    static final long serialVersionUID = -1L;

    protected BActor  actor;
    protected BAction action;

    public ActionNodeState(BActionNode node)
    {
      super(node);
      this.actor  = node.actor;
      this.action = node.action;
    }
  }

  
  // Generic Action icons...
  // -----------------------------------------------------------
  
  public Icon getIcon()
    { return icon; }

  public Icon getSelectedIcon()
    { return icon; }

  public boolean isClosed()
    { return false; }
  
}
