package roboforge.ai.decisions;

import roboforge.BGlobal;
import roboforge.ui.components.HSBImageIcon;
import roboforge.ui.components.*;

import java.util.Enumeration;
import javax.swing.Icon;


public class BGroupNode extends BDecisionTreeNode
{

  // Class variables...
  // -------------------------------------------------------------

  protected static BBorderedIcon icon =
    createTreeIcon("ai/group_18.gif", BGlobal.colors.getAIGroupColor());

  protected boolean closed = false;

//  protected static Icon selectedIcon =
//    createTreeIcon("ai/group_18gif", BGlobal.SELECTED_COLOR, BGlobal.colors.getAIGroupColor());


  // Constructor.
  // -------------------------------------------------------------

  public BGroupNode()
    { super(); }

  public BGroupNode(BGroupNode node)
  {
    super(node);
    this.closed = node.closed;
  }

  public Object clone()
    { return new BGroupNode(this); }



  // Accessor methods...
  // -------------------------------------------------------------

  public boolean canAddChildren()
    { return true; }

  public boolean canRemoveChildren()
    { return true; }

  public Enumeration visitableChildren()
    { return children(); }

  public Icon getSelectedIcon()
  {
    return getIcon();
  }

  protected String generateDefaultName()
    { return ("Group"); }


  public boolean isClosed()
    { return closed; }

  public void setClosed(boolean b )
    { closed = b; }

  public boolean isCloseable()
  	{ return true; }


  public String getDescription()
  { return  "This node type allows you to attach several other nodes to it, which will be processed in sequential order."; }

  public Icon getIcon()
  {
    if (this.getVisited())
      icon.setBorderColor(BGlobal.colors.getLightestShade() );
    else
      icon.setBorderColor( BGlobal.colors.getAIGroupColor() );

    return icon;
  }

  // Visit method..
  // -------------------------------------------------------------

  public void visit()
  {
  }

    // State storage / retrieval...
  // -----------------------------------------------------------

  public void setState(Object o)
  {
    super.setState(o);

    // test for old bots.
    // pre.. feb 2001
    if (o instanceof GroupNodeState)
    {
      GroupNodeState state = (GroupNodeState) o;
      this.closed = state.closed;
    }


  }

  public Object getState()
    { return new GroupNodeState(this); }

  protected static class GroupNodeState  extends DecisionTreeNodeState
  {
    static final long serialVersionUID = -1L;
    boolean closed;

    public GroupNodeState(BGroupNode node)
    {
      super(node);
      this.closed = node.closed;

    }
  }



}
