package roboforge.ai.decisions;

import java.util.Enumeration;

import javax.swing.Icon;
import javax.swing.tree.MutableTreeNode;
import roboforge.btree.*;



public class BNOPNode extends BDecisionTreeNode
{

  protected static Icon icon = createTreeIcon(null, null);


  // Constructor.
  // -------------------------------------------------------------

  public BNOPNode()
    { super(); }

  public BNOPNode(BNOPNode node)
    { super(node); }

  public Object clone()
    { return new BNOPNode(this); }
    

  // Visit method.
  // -------------------------------------------------------------

  public void visit()
    { }

  public Enumeration visitableChildren()
    { return EMPTY_ENUMERATION; }


  // Child Maintenance methods...
  // -------------------------------------------------------------

  public boolean canAddChildren()
    { return true; }

  public boolean isRemoveable()
    { return false; }

  public void add(MutableTreeNode child)
    { replaceMyselfWith(child); }

  public void insert(MutableTreeNode child, int index)
    { replaceMyselfWith(child); }


  protected void replaceMyselfWith(MutableTreeNode node)
  {
    BTreeNode parent =
      (BTreeNode) getParent();

    int index = parent.getIndex(this);

    ((BTreeNode)parent).replaceChild(this, node);
  }


  public boolean isClosed()
    { return false; }




  // Accessor methods...
  // -------------------------------------------------------------

  public Icon getIcon()
    { return icon; }

  public Icon getSelectedIcon()
    { return icon; }


}