package roboforge.ai.decisions;

import roboforge.BBot;
import roboforge.BGlobal;

import roboforge.ai.actions.*;
import roboforge.ui.components.HSBImageIcon;

import javax.swing.Icon;


public class BOrientActionNode extends BActionNode
{

  // Class variables...
  // -------------------------------------------------------------

  protected static Icon icon =
    createTreeIcon("ai/orient_18.gif", BGlobal.colors.getAIActionColor());

  //protected static Icon selectedIcon =
  //  createTreeIcon("ai/orient_18.gif", BGlobal.SELECTED_COLOR, BGlobal.colors.getAIActionColor());


  // Constructor.
  // -------------------------------------------------------------

  public BOrientActionNode()
    { super(); }

  public BOrientActionNode(BBot bot)
  {
    super(bot);
    this.action = new BOrientAction(bot);
  }

  public BOrientActionNode(BOrientActionNode node)
  {
    super(node);
    this.action = new BOrientAction( (BOrientAction) node.getAction() );

  }

  public Object clone()
    { return new BOrientActionNode(this); }



  public void setActor(BActor a)
  {
    //if (a != null)
    //super.setActor(a);

    actor = a;
   ((BOrientAction)action).setBot( (BBot) a) ;

  }

  // Accessor functions
  // -------------------------------------------------------------

  public void setOrientAction(BOrientAction o)
  {
    this.action = o;
    setDefaultName();
  }

  public BOrientAction getOrientAction()
    { return (BOrientAction) action; }

  public Icon getIcon()
    { return icon; }

  public Icon getSelectedIcon()
    { return getIcon(); }

  protected String generateDefaultName()
  {
    if (action == null)
      return "Orient";
    else
      return action.toString();
  }
}
