package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BMinus extends BNumericBinaryOp
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  public BMinus()
    { super(); }

  public BMinus(BMinus o)
    { super(o); }

  public BMinus(BExpression l, BExpression r)
    { super(l, r); }

  public Object clone()
    { return new BMinus(this); }

  public BValue combine(BValue l, BValue r)
  {
    if (l.isNumber() && r.isNumber())
    {
      double result =
        ((BNumber) l).getValue() -
        ((BNumber) r).getValue();

      value.setValue(result);
      return value;
    }
    else
      return BValue.UNDEFINED;
  }

  public String getName()
    { return "-"; }
}