package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BNot extends BUnaryOp
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;


  protected transient BBoolean value;

  public BNot()
    { super(); }

  public BNot(BNot o)
    { super(o); }

  public BNot(BExpression operand)
    { super(operand); }

  public Object clone()
    { return new BNot(this); }

  public void init()
    { value = new BBoolean(); super.init(); }


  public BValue apply(BValue o)
  {
    if (o.isBoolean())
    {
      boolean result = !((BBoolean) o).getValue();

      value.setValue(result);
      return value;
    }
    else
      return BValue.UNDEFINED;
  }

  protected int applyType(int o)
  {
    if (o == BType.BOOLEAN)
      return BType.BOOLEAN;
    else
      return BType.UNDEFINED;
  }

  public String getName()
    { return "not"; }
}