package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BNotEquals extends BBooleanBinaryOp
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  public BNotEquals()
    { super(); }

  public BNotEquals(BNotEquals o)
    { super(o); }

  public BNotEquals(BExpression l, BExpression r)
    { super(l, r); }

  public Object clone()
    { return new BNotEquals(this); }

  public BValue combine(BValue l, BValue r)
  {
    boolean result;

    if (l.isCompatible(r))
      result = !l.equals(r);
    else
      return BValue.UNDEFINED;

    value.setValue(result);
    return value;
  }

  protected int combineType(int l, int r)
    { return (l == r) ? BType.BOOLEAN : BType.UNDEFINED; }

  public String getName()
    { return "!="; }

}