package roboforge.animation;

import roboforge.*;


public class BArenaAnimator  extends Bj3dFrameElapsedAnimator
{
  BArenaCanvas arenaCanvas;
  private boolean stopWhenEmpty = false;

  public BArenaAnimator(BArenaCanvas arenaCanvas, boolean autoActive)
  {
    super(arenaCanvas, autoActive);
    this.arenaCanvas = arenaCanvas;
  }

  public void start()
  {

    super.start();
    stopWhenEmpty = false;
    arenaCanvas.addBehavior(playerLoop);

  }

  public void stop()
  {

    //BDebug.print ( "BArenaAnimator.stop() called ");
    super.stop();
    arenaCanvas.removeBehavior(playerLoop);

  }


  public void stopWhenEmpty()
  {
    stopWhenEmpty = true;
  }

  public boolean animate()
  {
    boolean result =
      super.animate();

    if (stopWhenEmpty)
      if (getSize() == 0)
        { stop(); return false; }

    return result;
  }

  public void cleanse()
  {
    stop();
    arenaCanvas = null;

    super.cleanse();
  }


} 