package roboforge.animation.alpha.map;


public class BPeriodicMap implements BAlphaMap
{

  // BPeriodicMap divides time into segments,
  // then passes each segment on to a child map.


  protected BAlphaMap map;
    // The child map, used to map each segment.


  protected float period;
    // The map's period, in seconds.



  public BPeriodicMap(BAlphaMap map, float period)
  {
    setPeriodMap(map);
    setPeriod(period);
  }



  public void setPeriodMap(BAlphaMap map)
  {
    // Check map exists...
    if (map == null)
      throw new IllegalArgumentException("Can't have a null child map.");

    this.map = map;
  }

  public void setPeriod(float period)
  {
    // Check period parameter...
    if (period <= 0)
      throw new IllegalArgumentException("Period must be > 0 seconds.");

    this.period = period;
  }


  public float alpha(float t)
  {
    // Normalize t...
    t = t % period;

    // Return child's mapping...
    return map.alpha(t);
  }

  public boolean isValidTime(float t)
    { return true; }


}


