package roboforge.animation.animation;

import roboforge.animation.*;

import roboforge.util.graphics.*;

import java.awt.*;


public abstract class BColorCycler implements BAnimation
{
    int t;
    int deltat = 4;
    int cycleRange = 100;
    Color base;
    Color highlight;
    public Color thisCyclesColor;

    protected float mix;
    protected float cycletValue;

  public BColorCycler(Color base, Color highlight, int deltaT, int cycleRange)
  {
    this.base = base;
    this.highlight = highlight;
    this.deltat = deltaT;
    this.cycleRange = cycleRange;

  }

  protected void calculateMixtValue()
  {
      mix = (float)(t % cycleRange) / (float)cycleRange;
  }

  public float getMixtValue()
    { return mix; }

  public float getCycletValue()
  { return cycletValue;}


  public boolean animate()
  {
      t +=deltat;

      calculateMixtValue();
      //mix = (float)java.lang.Math.sin(mix);

      Color first;
      Color second;

      if ( ( (t / cycleRange) % 2) == 0)
      {
        first = base;
        second = highlight;
        cycletValue = 1f - mix;
      }
      else
      {
          second = base;
          first = highlight;
          cycletValue = mix;

      }

      thisCyclesColor = BColors.blendHSB(first, second, mix);

      return true;

    }



}


/*
  private class LimbGlowAnimation implements BAnimation
  {

    int t;
    int deltat = 4;
    int cycleRange = 100;
    BComponent[] limbComponents;
    Color base = Color.black;
    Color highlight = BGlobal.HIGHLIGHT_COLOR;

    float minMix = 0.2f;
    float maxMix = 1f - minMix;
    //BranchGroup lightBG = new BranchGroup();

    public LimbGlowAnimation(BLimb limb)
    {
      Vector tempV = new Vector();
      Enumeration e = limb.getBreathComponents();

      while (e.hasMoreElements() )
        tempV.add(e.nextElement() );

      limbComponents = new BComponent[tempV.size() ];

      for (int i = 0; i < tempV.size(); i++)
        limbComponents[i] = ((BComponentNode)tempV.get(i)).getComponent();

    }

    public boolean animate()
    {
      t +=deltat;
      float mix = (float)(t % cycleRange) / (float)cycleRange;

      if (mix < minMix)
        mix = minMix;
      else if (mix > maxMix)
        mix = maxMix;

      mix = (float)java.lang.Math.sin(mix);

      float transparency;

      Color first;
      Color second;

      if ( ( (t / cycleRange) % 2) == 0)
      {
        first = base;
        second = highlight;
        transparency = 1f - mix;
      }
      else
      {
          second = base;
          first = highlight;
          transparency = mix;


      }


      Color newColor = BColors.blendHSB(first, second, mix);
      //limb.getBaseComponent().displayColor(newColor);

      for (int i = 0; i < limbComponents.length; i++)
      {
        if (limbComponents[i].isLive() )
        {
          limbComponents[i].displayColor(newColor);
          limbComponents[i].setTransparency(transparency, false);
        }
      }
      return true;




    }

    public void start() {}

    public void stop()
    {
      //lightBG.detach();
    }
    */