package roboforge.animation.animation.b3d;

import roboforge.*;
import roboforge.animation.*;
import roboforge.util.timing.*;


public class BFadeBotAnimation implements BAnimation
{

	public static final int FADE_IN					= +1;
  public static final int FADE_OUT				= -1;

  private static float DEFAULT_FADE_TIME 	= 2f;

  protected float fadeStart;
  protected float fadeTime;

  protected BBot  bot;
  protected int		type;



  public BFadeBotAnimation(BBot bot)
    { this(bot, DEFAULT_FADE_TIME, FADE_OUT); }

  public BFadeBotAnimation(BBot bot, float t)
  	{ this(bot, t, FADE_OUT); }

  public BFadeBotAnimation(BBot bot, float t, int type)
  {
    this.fadeTime = t;
    this.bot 			= bot;
    this.type 		= type;
  }


  public void start()
  {
    fadeStart = (float) BClock.time();
  }

  public boolean animate()
  {
    float deltaT = (float) BClock.time() - fadeStart;
    float alpha  = deltaT / fadeTime;

    if (type == FADE_IN)
    	alpha = 1f - alpha;

    if ((alpha >= 1f) && (type == FADE_OUT))
	    { bot.setTransparency(1f); return false; }

    if ((alpha <= 0f) && (type == FADE_IN))
	    { bot.restoreTransparency(); return false; }

    bot.setTransparency(alpha);
    return true;
  }

  public void stop()
	  { }

}