package roboforge.arenaSystems;

import roboforge.sound.*;
import roboforge.animation.*;
import roboforge.BGlobal;

public class BAmbientSound implements BArenaSystem
{

  boolean active = false;
  BAnimator animator;

  BFadingSound ambientLoop;
  BSound randomSound;
  private float randomFrequency = 0.002f;


  public BAmbientSound(BAnimator animator, String ambientName, String randomName )
  {
    this.animator = animator;

    ambientLoop = BFadingSound.getFadingSound(BGlobal.SOUNDPATH  + ambientName, BSound.LOOP_CONTINUOUSLY, BSound.SOUND_TYPE_BACKGROUND, 2000 );

    if (randomName != null)
      randomSound = BSound.getSound(BGlobal.SOUNDPATH  + randomName, 0,BSound.SOUND_TYPE_BACKGROUND);
    else
      randomSound = new BSound();

    randomSound.setPriority(BSound.PRIORITY_MIN);
    
  }


  /*
    // start propcessing events
  public void start();

  // handle this event
  public void processEvent(BArenaEvent event);

  // stop
  public void stop();

  //called every battle time slice
  //executes cycke dependant internal structures
  public void executeActions();      */

  public void start()
  {
    if (!active )
    {
      ambientLoop.fadeIn(animator);
      active = true;
    }
  }

  public void stop()
  {
    ambientLoop.fadeOut(animator);
    randomSound.stop();
    active = false;
  }

  public void processEvent(BArenaEvent event)
    {};

  public void executeActions()
  {
    if ( Math.random() < randomFrequency )
      randomSound.play();

  };


}