package roboforge.geometry;

import javax.vecmath.*;
import java.util.*;
import javax.media.j3d.*;

import roboforge.*;



public class BLine extends Shape3D
  {

   public BLine(Vector3f alignVector )
   {
    this( alignVector, 10.0);

   }



   public BLine(Vector3f alignVector, double size )


  {

    this(new Point3d(alignVector.x * size, alignVector.y * size, alignVector.z * size),  new Point3d(-alignVector.x * size, -alignVector.y * size, -alignVector.z * size) );
  }

   public BLine(Point3d a, Point3d b )
  {
	  super();

	  LineArray line = new LineArray(2, LineArray.COORDINATES);

	  Point3d verts[] = new Point3d[2];


	  verts[0] = a;
	  verts[1] = b;

	  line.setCoordinates(0, verts);
          setGeometry(line);

    this.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);


  }


  public void cleanse()
  {
    this.setAppearance(null);
  }

  /*
  protected void finalize() throws Throwable
  {
    BDebug.print ( "BLine.finalize called" );
  }  */






  } // END LINE CLASS
