package roboforge.net;


public abstract class BNetworkStack
{
  
  // Member variables...
  // -------------------------------------------------------------

  protected BPresentationLayer presentation;
  protected BTransportLayer    transport;
  
  
  // Constructor...
  // -------------------------------------------------------------
  
  public BNetworkStack() throws BNetException
  {
    transport    = createTransportLayer();
    presentation = createPresentationLayer();
  }
  
  
  // Accessor methods...
  // -------------------------------------------------------------

  public BPresentationLayer getPresentationLayer() 
    { return presentation; }

  public BTransportLayer getTransportLayer()
    { return transport; }

  
  // Abstract methods...
  // -------------------------------------------------------------
  
  protected abstract BPresentationLayer createPresentationLayer()
    throws BNetException;
    
  protected abstract BTransportLayer createTransportLayer()
    throws BNetException;
  
}
