package roboforge.net;

import roboforge.BDebug;
import roboforge.net.services.*;

import java.io.*;
import java.security.*;



public class BTarget implements BServiceInfo, Serializable
{

  protected PublicKey   publicKey;
  protected Key         symmetricKey;
  protected byte[]      symmetricIV;


  public BTarget() throws BNetException
    { }

  public BTarget(PublicKey key) throws BNetException
    { this.publicKey = key; }

  public BTarget(String keyFile) throws BNetException
    { setPublicKey(keyFile); }


  
  public void setPublicKey(PublicKey key)
    { this.publicKey = key; }

  public PublicKey getPublicKey()
    { return publicKey; }
  
  public void setSymmetricKey(Key key)
    { this.symmetricKey = key; }

  public Key getSymmetricKey()
    { return symmetricKey; }

  public void setSymmetricIV(byte[] iv)
    { this.symmetricIV = iv; }

  public byte[] getSymmetricIV()
    { return symmetricIV; }
  
  
  
  protected void setPublicKey(String keyFile) throws BNetException
  {
    try
    {
      FileInputStream f =
        new FileInputStream(keyFile);

      ObjectInputStream in =
        new ObjectInputStream(f);

      publicKey = (PublicKey)
        in.readObject();
    }
    catch (IOException e)
      { throw new BNetException("Could not load Public key: "+ keyFile); }
    catch (ClassNotFoundException e)
      { throw new BNetException("Could not deserialize Public key."); }
  }
  
  
  
}