package roboforge.net.client;

import roboforge.BDebug;
import roboforge.BGlobal;

import roboforge.net.*;
import roboforge.net.services.*;
import roboforge.net.sockets.*;
import roboforge.util.io.BIOUtils;

import java.io.*;




public class BClientPresentation extends BAbstractPresentation
{

  // Constructor...
  // -----------------------------------------------------------

  // Key no longer passed as not needed for client
  public BClientPresentation(BClientStack stack) throws BNetException
    { super(stack /*, BGlobal.PRIVATE_KEY_CLIENT*/); }
  
  
  
  // Implementation methods...
  // -------------------------------------------------------------
  
  protected void sendSecurityHeader(BTarget target, BSocket socket) 
    throws IOException
  {
    BRSASocket secure =
      new BRSASocket(socket);
    
    BObjectSocket out =
      new BObjectSocket(secure);
    
    secure.setEncryptionKey(target.getPublicKey());
    
    out.write(target.getSymmetricKey());
    out.write(target.getSymmetricIV());
  }
  
  protected void receiveSecurityHeader(BTarget target, BSocket socket)
    throws IOException
    { /* Do nothing, since server sends us no security header. */ }
  

  protected void inform(BTransmission t, String s)
    { t.inform(new BMonitorInfo(s)); }

  protected void inform(BTransmission t, long in, long out)
    { t.inform(new BMonitorInfo(in, out)); }

} 