package roboforge.net.data;

import roboforge.util.data.*;
import roboforge.advertising.*;
import roboforge.*;

import java.io.*;
import java.util.zip.*;

public class BAdvertData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BAdvertData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.ADVERT; }


  // Status codes...
  // -------------------------------------------------------------



  // Data fields...
  // -------------------------------------------------------------
  public long tournamentID;
  private byte[] advert;
  
  
  // Accessor methods...
  // -------------------------------------------------------------

  public void setAdvert(BAdvert add)
  {
   // Zip and store the BAdvert object into a byte array

   try
   {
      ByteArrayOutputStream bytes =
        new ByteArrayOutputStream();

      GZIPOutputStream zip =
        new GZIPOutputStream(bytes);

      ObjectOutputStream out =
        new ObjectOutputStream(zip);

      out.writeObject(add);
      out.close();

      advert = bytes.toByteArray();
   }
   catch (Exception e)
   {
      BDebug.print("Exception: " + e.getMessage());
   }

  }

  public BAdvert getAdvert()
  {
   // Return the inflated BAdvert Object

   BAdvert add = null;
   try
   {
      byte[] advertBytesUnziped = SServerAccess.gzipInflateArray(advert);
      ByteArrayInputStream byteIS = new ByteArrayInputStream(advertBytesUnziped);
      ObjectInputStream in = new ObjectInputStream(byteIS);
      add = (BAdvert)in.readObject();
   }
   catch (Exception e)
   {
      BDebug.print("Exception: " + e.getMessage());
   }

    return add;
  }

  public byte[] getAdvertArray()
  {
    return advert;
  }


  public void setAdvertArray( byte[] advert)
  {
    this.advert = advert;
  }


}