package roboforge.net.data;

import roboforge.util.data.*;


public class BCRWrapperData extends BAbstractAtom
{
  // A wrapper for data exchanged between challenge rooms
  // and clients



  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BCRWrapperData(long id)
    { super(id); }


  // Status codes...
  // -------------------------------------------------------------

  public static final int ALL_CHALLENGE_ROOMS  = 0;
  public static final int SPECIFIED_CHALLENGE_ROOM = 1;
  public static final int TO_ACCOUNT = 2;


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.CR_WRAPPER; }


  public BAbstractAtom challengeData;

  public String password;
  // The password for the challenge room
  // Null if not set/required

  public int destination = this.SPECIFIED_CHALLENGE_ROOM;
  // See status codes for destination of this object
  // deterimes what the id code relates to.
  // This id code only relates to the transfer of data between
  // clients and challenge rooms.

  public Long accountID;
  public Long challengeRoomID;
}
