package roboforge.net.server;

import roboforge.BDebug;
import roboforge.BGlobal;

import roboforge.net.*;
import roboforge.net.client.*;
import roboforge.net.data.*;
import roboforge.net.services.*;
import roboforge.net.sockets.*;


import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;


public class BLoopbackServlet extends HttpServlet
{

  protected BServerStack stack;


  //Initialize global variables
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);

    // BDebug.print("user.dir:  "+ System.getProperty("user.dir"));
    // BDebug.print("user.home: "+ System.getProperty("user.home"));
    
    // BDebug.print("Init()");
    BGlobal.init();

    try
      { stack = new BServerStack(); }
    catch (BNetException e)
      { throw new ServletException("Could not init net-stack: "+ e); }

    // BDebug.print("Init Done.");
  }


  //Service the request
  public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {
    // BDebug.print("Servicing request...");

    try
    {

      BDebug.seedTimer();
      
      BClientTarget client =
        new BClientTarget(request, response);

      BRequest req =
        stack.receive(client);

      BDebug.printTime("Received request: "+ req);
      BDebug.seedTimer();
      
      BMessage answer;

      BRequestHeader header =
        req.getRequestHeader();

      String type = header.getType();

      BServiceSet services = 
        new BServiceSet();

      
      if (type.equals("LOG"))
        { answer = BMessage.ACK("LOG", new BIdentData(100)); }
      else if (type.equals("ECHO"))
      { 
        answer = BMessage.ACK("ECHO", req.getData()); 

        // services.add(new BZipService());
        // services.add(new BDESService());
      }
      else
        { answer = BMessage.NAK(type); }

      stack.send(client, answer, services);

      BDebug.printTime("Sent message: "+ answer);
      
    }
    catch (Exception e)
      { System.out.println("ERROR: "+ e); }

  }



  //Get Servlet information
  public String getServletInfo()
    { return "roboforge.net.server.BLoopackServlet Information"; }
} 