package roboforge.net.sockets;

import roboforge.BDebug;
import roboforge.net.*;

import java.io.*;
import java.security.*;
import javax.crypto.*;

import iaik.security.provider.IAIK;



public abstract class BCipherSocket extends BFilterSocket
{

  // Member variables...
  // -----------------------------------------------------------
  
  protected CipherInputStream  in;
  protected CipherOutputStream out;

  
  // Constructor...
  // -----------------------------------------------------------

  public BCipherSocket(BSocket socket)
  {
    super(socket);
    IAIK.addAsProvider(false);
  }


  // Interface methods...
  // -----------------------------------------------------------

  public InputStream filter(InputStream i) throws IOException
  {
    if (in == null)
      in = new CipherInputStream(i, getInputCipher());
    
    return in;
  }

  public OutputStream filter(OutputStream o) throws IOException
  {
    if (out == null)
      out = new CipherOutputStream(o, getOutputCipher());
    
    return out;
  }

  // Abstract methods...
  // -----------------------------------------------------------

  protected abstract Cipher getInputCipher()  throws IOException;
  protected abstract Cipher getOutputCipher() throws IOException;
  
  
  
  // Interface methods...
  // -----------------------------------------------------------

  public void flush() throws IOException
  {
    if (out != null)
      out.flush();
    
    super.flush();
  }
  
  public void close() throws IOException
  { 
    if (in  != null) in.close(); 
    if (out != null) out.close(); 
    
    super.close();
  }
  
  
}