package roboforge.net.sockets;

import roboforge.BDebug;
import java.io.*;


public class BObjectSocket extends BFilterSocket
{

  // Member variables...
  // -----------------------------------------------------------

  protected ObjectInputStream  in;
  protected ObjectOutputStream out;

  
  // Constructors...
  // -----------------------------------------------------------

  public BObjectSocket(BSocket socket)
    { super(socket); }

  public BObjectSocket()
    { super(); }
  
  
  
  // Interface methods...
  // -----------------------------------------------------------

  public void flush() throws IOException
  {
    if (out != null)
      out.flush();
    
    super.flush();
  }

  
  // Implementation methods...
  // -----------------------------------------------------------

  protected InputStream filter(InputStream i) throws IOException
  { 
    if (in == null)
     in = new ObjectInputStream(i); 
    
    return in;
  }
  
  protected OutputStream filter(OutputStream o) throws IOException
  { 
    if (out == null)
     out = new ObjectOutputStream(o); 
    
    return out;
  }
  
  
  
  // Accessor methods...
  // -----------------------------------------------------------

  public Object read() throws IOException, ClassNotFoundException
  {
    if (in == null)
      if (socket != null)
        filter(socket.getInputStream());
    
    return in.readObject();
  }
  
  public void write(Object o) throws IOException
    { write(o, true); }
  
  public void write(Object o, boolean flush) throws IOException
  {
    if (out == null)
      if (socket != null)
        filter(socket.getOutputStream());

    out.writeObject(o);
    
    if (flush)
      flush();
  }

  public void close() throws IOException
  { 
    if (in  != null) in.close(); 
    if (out != null) out.close(); 
    
    super.close();
  }
  
  
}
