package roboforge.net.sockets;

import roboforge.net.*;

import java.io.*;
import java.util.zip.*;



public class BZipSocket extends BFilterSocket
{

  // Member variables...
  // -----------------------------------------------------------
  
  protected GZIPInputStream  in;
  protected GZIPOutputStream out;

  
  // Constructor...
  // -----------------------------------------------------------

  public BZipSocket(BSocket socket)
    { super(socket); }



  // Interface methods...
  // -----------------------------------------------------------

  public InputStream filter(InputStream in) throws IOException
  {
    if (this.in == null)
      this.in = new GZIPInputStream(in);

    return this.in;
  }

  public OutputStream filter(OutputStream out) throws IOException
  {
    if (this.out == null)
      this.out = new GZIPOutputStream(out);

    return this.out;
  }
  
  public void flush() throws IOException
  {
    if (out != null)
    {
      out.finish();
      out.flush();
    }
    
    super.flush();
  }

  public void close() throws IOException
  { 
    if (in  != null) in.close(); 
    if (out != null) out.close(); 
    
    super.close();
  }
  
} 