package roboforge.particles.forces;

import javax.vecmath.*;
import roboforge.particles.*;


public class BGravityForce implements BParticleForce
{
  // BGravityForce applies gravitational force to particles.

  protected static final Vector3f G
    = new Vector3f(0f, -9.807f, 0f);

  protected Vector3f gravity
    = new Vector3f();


  public BGravityForce()
    { this(G); }

  public BGravityForce(Vector3f v)
    { gravity.set(v); }


  public void apply(BParticle p, float t, Vector3f f)
    { f.scaleAdd(p.m, gravity, f); }

  public void update(float t)
    { /* Do nothing. */ }

}