package roboforge.particles.forces;

import roboforge.BDebug;
import roboforge.math.*;
import roboforge.particles.*;

import javax.vecmath.*;


public class BRandomForce implements BParticleForce
{
  // BRandomForce applies a random force to particles.

  protected Vector3f base
    = new Vector3f();

  protected Vector3f variance
    = new Vector3f();

  protected Vector3f force
    = new Vector3f();


  public BRandomForce()
    { }

  public BRandomForce(Vector3f base, Vector3f variance)
  {
    this.base.set(base);
    this.variance.set(variance);
  }

  public void apply(BParticle p, float t, Vector3f f)
    { f.add(force); }

  public void update(float t)
    { BMath3D.randomize(base, variance, force); }


  public void setBase(Vector3f base)
    { this.base.set(base); }

  public void setVariance(Vector3f variance)
    { this.variance.set(variance); }

}