package roboforge.particles.forms;

import roboforge.particles.*;
import javax.vecmath.*;
import javax.media.j3d.*;


public class BSystemFormPoint extends BSystemFormGeomArray
{

  // Members...
  // -------------------------------------------------------------

  protected PointArray points;


  // Constructor...
  // -------------------------------------------------------------

  public BSystemFormPoint(BranchGroup parent, int n)
    { super(parent, n); }


  // Methods...
  // -------------------------------------------------------------

  protected GeometryArray createGeometry()
  {
    points = new PointArray(
      n,
      PointArray.COORDINATES |
      PointArray.COLOR_4);

    points.setCapability(PointArray.ALLOW_COORDINATE_WRITE);
    points.setCapability(PointArray.ALLOW_COLOR_WRITE);

    return points;
  }


  public BParticleForm createForm(BParticle p)
    throws BParticleSystemException
  {
    if (used >= n)
      throw new BParticleSystemException(
        "Can't create appearance for particle: "+ p);

    return new BParticleFormPoint(points, used++);
  }



}