package roboforge.particles.forms;

import roboforge.BRenderer;
import roboforge.BRenderable;
import roboforge.particles.*;

import javax.media.j3d.GraphicsContext3D;
import javax.media.j3d.Transform3D;



public abstract class BSystemFormRenderable
  extends
    BSystemFormAbstract
  implements
    BRenderable
{

  // Members...
  // -------------------------------------------------------------

  protected BRenderer renderer;
    // The renderer used to display this form.

  protected Transform3D camera;
    // The renderer's camera transform; updated
    // once per particle-system update.



  // Constructor...
  // -------------------------------------------------------------

  public BSystemFormRenderable(BRenderer renderer, boolean isAdditive)
  {
    super(isAdditive);

    // Remember the renderer...
    this.renderer = renderer;

    // Create a camera tranform holder...
    camera = new Transform3D();
  }


  // Accessor Methods...
  // -------------------------------------------------------------

  public Transform3D getCameraTransform3D()
    { return camera; }


  // Abstract Methods...
  // -------------------------------------------------------------

  public abstract void render(GraphicsContext3D g);
    // Render this particle-system form.



  // BSystemAspect implementation...
  // -------------------------------------------------------------

  public void start()
    { renderer.addRenderable(this); }

  public void update(float t, float dt)
    { renderer.getCameraTransform(camera); }

  public void stop()
    { renderer.removeRenderable(this); }


}