package roboforge.sound;

import javax.media.j3d.*;
import javax.vecmath.*;
//import java.util.*;

import roboforge.*;

public class BPointSound3D extends BSound
{

  Node node3D;

  // creation methods
  public BPointSound3D()
    {super();}
    
  public BPointSound3D(String filename,  int type, Node node3D)
  {
    super(filename, type );
    this.node3D = node3D;

  }

  public static BPointSound3D getPoint3DSound(String fileName, Node node3D)
  {
    return  BPointSound3D.getPoint3DSound(fileName, 0, SOUND_TYPE_FOREGROUND, node3D);
  }


  public static BPointSound3D getPoint3DSound(String fileName, int loopTimesnew, int soundTypeNew, Node node3D)
  {

    if ( (staticMixer == null) || !BGlobal.USE_SOUND)
      return new BPointSound3D();

    BPointSound3D tempS = new BPointSound3D(fileName, soundTypeNew, node3D);
    tempS.loopTimes = loopTimesnew;
    return tempS;

  }

  // Point Sound Methods
  private static Point3f updatePos  = new Point3f();
  private static Transform3D updateTran  = new Transform3D();
  private static Vector3f updateVec  = new Vector3f();

  public void update (Point3f posOfView )
  {
    if (node3D.isLive() )
    {
      node3D.getLocalToVworld(updateTran);
      updateTran.get(updateVec);
      updatePos.set(updateVec);

      float distance = BPhysics.distanceBetween( updatePos, posOfView);
      attenuate(distance);
    }
    else
      this.stop();
  }


  private static float MAX_DISTANCE = 10f;
  private void attenuate(float distance)
  {
    if (distance > MAX_DISTANCE)
    {
      if (this.isRunning())
        this.stop();
    }
    else
    {
      if (!this.isRunning() )
        this.play();

      float gainRatio = (MAX_DISTANCE - distance) / MAX_DISTANCE;
      this.setVolumeRatio(gainRatio);

    }


  }


}

