package roboforge.sound;

import roboforge.BGlobal;



public class BSoundSystem
{

  
  // Accessor methods.
  // -------------------------------------------------------------
  
  public static void start()
    { BSound.init(); }
    
  public static void stop()
    { BSound.close(); }
  
  

  // Factory methods.
  // -------------------------------------------------------------
  
  public static BSound getUISound(String name)
    { return BSound.getSound(BGlobal.SOUNDPATH+ "interface/"+ name,0, BSound.SOUND_TYPE_INTERFACE); }

  
  // Muting methods.
  // -------------------------------------------------------------
  
  public static void setMuted(boolean isMuted)
    { BGlobal.USE_SOUND = !isMuted; }
    
  public static boolean isMuted()
    { return !BGlobal.USE_SOUND; }


  // FG/BG Volume methods.
  // -------------------------------------------------------------
  
  public static void setFGVolume(float percent)
  {
    if ((percent < 0) || (percent > 100))
      throw new IllegalArgumentException(
        "percentage not in range [0.. 100]");
    
    float min  = BSound.FOREGROUND_SOUND_MIN;
    float max  = BSound.FOREGROUND_SOUND_MAX;

    BGlobal.FOREGROUND_SOUND_VOLUME =
      min + (percent * (max-min));
  }
  

  public static void setBGVolume(float percent)
  {
    if ((percent < 0) || (percent > 100))
      throw new IllegalArgumentException(
        "percentage not in range [0.. 100]");
    
    float min  = BSound.BACKGROUND_SOUND_MIN;
    float max  = BSound.BACKGROUND_SOUND_MAX;

    BGlobal.BACKGROUND_SOUND_VOLUME = 
      min + (percent * (max-min));
  }
  
}
