package roboforge.ui;

import roboforge.BBot;
import roboforge.BChassis;
import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.BProgressMonitorable;
import roboforge.BWizardTemplateBot;

import roboforge.attributes.*;

import roboforge.ui.action.*;
import roboforge.ui.components.*;
import roboforge.ui.components.border.*;
import roboforge.ui.events.*;
import roboforge.ui.layers.*;
import roboforge.ui.net.*;

import roboforge.util.graphics.*;
import roboforge.util.io.*;
import roboforge.util.processors.*;
import roboforge.util.text.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.Font;
import java.io.*;
import java.awt.image.*;

import roboforge.animation.*;

import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.image.PixelGrabber;
import java.awt.geom.AffineTransform;

import roboforge.sound.*;

public class BCreditsScreen extends BSystemScreen {

  String backgroundicon = "background_credits.jpg";

    final int START_X = 265;
    final int START_Y = 100;
    final int MARGIN  = 30;
    final int SIZE    = 70;
    final int GAP     = MARGIN + SIZE;

    final int STARTX = 265;
    final int STARTY = 100;

    final int FRAMES = 20;

  protected BUIResources res = new BUIResources( new Object[]
  {

    "titleIcon.icon",             BIconCache.getHSB("logo_icon.gif"),
    "titleLabel.icon",            BIconCache.getHSB("main_title.gif"),

    "background.icon",            BGraphics.getHSBIcon(backgroundicon),
    "background.foreground",      colors.getMidShade(),
    "background.bounds",          new Rectangle(0, 1, 800, 450),

  });


  // Visual elements ...
  // -------------------------------------------------------------

  protected CLabel background;

  ImageIcon darrenIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/darren.gif");
  ImageIcon hughIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/hugh.gif");
  ImageIcon youngIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/young.gif");
  ImageIcon jamesIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/james.gif");
  ImageIcon lindenIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/linden.gif");
  ImageIcon aryanIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/aryan.gif");
  ImageIcon andrewIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/andrew.gif");
  ImageIcon steveIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/steve.gif");
  ImageIcon mikeIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/mike.gif");
  ImageIcon hoobaIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/hoobajooba.gif");

  ImageIcon holeIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/hole.gif");
  ImageIcon emptyIcon = new ImageIcon(BGlobal.IMAGEPATH + "ui/characatures/empty.gif");

  HSBImageIcon backIcon = new HSBImageIcon(BGlobal.IMAGEPATH + "ui/background_credits.jpg", BGlobal.UI_BASE_COLOR);

  Image darrenImage = darrenIcon.getImage();
  Image hughImage = hughIcon.getImage();
  Image youngImage = youngIcon.getImage();
  Image jamesImage = jamesIcon.getImage();
  Image lindenImage = lindenIcon.getImage();
  Image aryanImage = aryanIcon.getImage();
  Image andrewImage = andrewIcon.getImage();
  Image steveImage = steveIcon.getImage();
  Image mikeImage = mikeIcon.getImage();
  Image hoobaImage = hoobaIcon.getImage();

  Image holeImage = holeIcon.getImage();
  Image emptyImage = emptyIcon.getImage();

  Image backImage = backIcon.getImage();

  Face f1;
  Face f2;
  Face f3;
  Face f4;
  Face f5;     /// the faces
  Face f6;
  Face f7;
  Face f8;
  Face f9;

  NameList thankNames;  // thankyou names

  Gallery gallery = new Gallery();  // the shooting gallery

  int [] backPixels = new int[800 * 450];

  Bitmap i1, i2, i3, i4, i5, i6, i7, i8, i9;

  BufferedImage bImage = new BufferedImage(800, 500, BufferedImage.TYPE_INT_ARGB);

  AffineTransform trans = new AffineTransform();

  BSleepingThreadAnimator timerAnimator = new BSleepingThreadAnimator(5, true);
  DotAnimation dotAni = new DotAnimation();
  int offset = 0;
  float rot = 0;

  int phase = 0;

  BSound music;
  BSound shot;
  BSound hit;
  BSound woosh;

  BSound strike;

  Cursor cross = new Cursor(Cursor.CROSSHAIR_CURSOR);

  public BCreditsScreen()
  {
    super(true);

    timerAnimator.setThreadPriority(Thread.MIN_PRIORITY);

    i1 = new Bitmap(convertToPoints(darrenImage), STARTX, STARTY);
    i2 = new Bitmap(convertToPoints(hughImage), STARTX+GAP, STARTY);
    i3 = new Bitmap(convertToPoints(youngImage), STARTX+GAP*2, STARTY);
    i4 = new Bitmap(convertToPoints(jamesImage), STARTX, STARTY+GAP);
    i5 = new Bitmap(convertToPoints(lindenImage), STARTX+GAP, STARTY+GAP);
    i6 = new Bitmap(convertToPoints(aryanImage), STARTX+GAP*2, STARTY+GAP);
    i7 = new Bitmap(convertToPoints(andrewImage), STARTX, STARTY+GAP*2);
    i8 = new Bitmap(convertToPoints(steveImage), STARTX+GAP, STARTY+GAP*2);
    i9 = new Bitmap(convertToPoints(mikeImage), STARTX+GAP*2, STARTY+GAP*2);

    f1 = new Face(darrenImage, i1.xOffset, i1.yOffset, "Darren Green");
    f2 = new Face(hughImage, i2.xOffset, i2.yOffset, "Hugh Calveley");
    f3 = new Face(youngImage, i3.xOffset, i3.yOffset, "Young Ly");
    f4 = new Face(jamesImage, i4.xOffset, i4.yOffset, "James Stewart");
    f5 = new Face(lindenImage, i5.xOffset, i5.yOffset, "Linden Kirkby");
    f6 = new Face(aryanImage, i6.xOffset, i6.yOffset, "Aryan DeSallis Gill");
    f7 = new Face(andrewImage, i7.xOffset, i7.yOffset, "Andrew Higgins");
    f8 = new Face(steveImage, i8.xOffset, i8.yOffset, "Steve Salmond");
    f9 = new Face(mikeImage, i9.xOffset, i9.yOffset, "Mike Ward");

    Vector names = new Vector();

    names.add("The RoboForge Team would like to thank the following people:");
    names.add("");
    names.add("Paul Byrne");
    names.add("Peter Calveley");
    names.add("Kelvin Chung");
    names.add("Pat Costigan");
    names.add("Ken Disson");
    names.add("Jason Harris");
    names.add("Grant Hughson");
    names.add("Brett Hutley");
    names.add("Tania Hutley");
    names.add("Jeff Kesselman");
    names.add("Ben Kimpton");
    names.add("Jessica Le Gros");
    names.add("Ying Ly");
    names.add("Bruce McNamara");
    names.add("Warwick Mahon");
    names.add("Dean Minifie");
    names.add("Andre Morrell");
    names.add("Ollie Powell");
    names.add("Paul Shadbolt");

    thankNames = new NameList(names);

    gallery.addTopFace();
    gallery.addBottomFace();
    background = new CLabel(res, "background");

    try {
      PixelGrabber pg = new PixelGrabber(backImage, 0, 0, 800, 450, backPixels, 0, 800);
      pg.grabPixels();
    }
    catch (InterruptedException e){}

    bImage.setRGB(0,0, 800, 450, backPixels, 0, 800);

    layoutCreditsScreenChildren();
    configCreditsScreenChildren();

    timerAnimator.add(dotAni);

    music = BSound.getSound(BGlobal.SOUNDPATH + "/interface/credits.wav", BSound.LOOP_CONTINUOUSLY, BSound.SOUND_TYPE_BACKGROUND);
    shot =  BSound.getSound(BGlobal.SOUNDPATH + "/explosions/fireworks.wav", 0, BSound.SOUND_TYPE_FOREGROUND);
    hit =   BSound.getSound(BGlobal.SOUNDPATH + "/collisions/chink.wav", 0, BSound.SOUND_TYPE_FOREGROUND);
    strike =BSound.getSound(BGlobal.SOUNDPATH + "/collisions/clashsolid.wav", 0, BSound.SOUND_TYPE_FOREGROUND);
    woosh = BSound.getSound(BGlobal.SOUNDPATH + "/arena/deadlock.wav", 0, BSound.SOUND_TYPE_FOREGROUND);
    music.play();

    res.cleanse();
    res = null;
  }

  // convert the image to an array of colored points
  static BIO observer = new BIO();
  protected ImagePoint [] convertToPoints(Image i)
  {
    int x = 0;
    int y = 0;

    int wid = i.getWidth(observer);
    int hei = i.getHeight(observer);

    int pix [] = new int[wid * hei];

    Vector p = new Vector();

    try {
      PixelGrabber pg = new PixelGrabber(i, 0, 0, wid, hei, pix, 0, wid);
      pg.grabPixels();
    }
    catch (InterruptedException e){}

    for(int j = 0; j < pix.length; j++)
    {
      Color c = new Color(pix[j]);

      double randAng = (Math.random() * 180);
      double randDis = (Math.random() * 1000) - 500;

      double startX = 35 + (randDis * Math.sin(Math.toRadians(randAng)));
      double startY = 35 + (randDis * Math.cos(Math.toRadians(randAng)));

      double randAcc = (Math.random() * 30);

      if( (c.getRed() != 60)  &&  (c.getGreen() != 60)  &&  (c.getBlue() != 76) )
        p.add( new ImagePoint(pix[j], x, y, (int)startX, (int)startY, (float)randAcc) );
      x++;
      if(x >= wid)
      {
        y++;
        x = 0;
      }
    }

    ImagePoint [] ip = new ImagePoint[p.size()];

    for (int k = 0; k < p.size(); k++)
      ip[k] = (ImagePoint)p.elementAt(k);

    return ip;
  }

  // image observer (not used, but required by some methods)
  public static class BIO implements ImageObserver
  {
    public BIO()
    {}

    public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height)
    {return false;}
  }


  protected void layoutCreditsScreenChildren()
  {
    titleIcon.setIcon(res.getIcon("titleIcon.icon"));
    titleLabel.setIcon(res.getIcon("titleLabel.icon"));

    body.setLayout(null);
    body.addOnTop(background);
  }

  public void paint(Graphics g)
  {
    super.paint(g);

  }

  protected void configCreditsScreenChildren()
  {
  }

  public void onDeactivate()
  {

    super.onDeactivate();
  }

  public void onClose()
  {
    super.onClose();
    // stop the animation
    BDebug.print("BCreditsScreen - stopping the music");
    timerAnimator.remove(dotAni);
    timerAnimator.stop();

    // stop the sound effects
    music.stop();
    hit.stop();
    shot.stop();
    strike.stop();
    woosh.stop();

    background.removeMouseListener(gallery);

    BGlobal.clearAllHardCaches();
  }

  public void onActivate()
  {
    super.onActivate();
  }

  //////////////////////////////////////////////////////////////////////////////
  //
  //  class for storing dots
  //
  class ImagePoint
  {
    int rgb;            // the color
    float x;            // the dest x
    float y;            // the dest y
    float currentX;     // current x
    float currentY;     // current y
    float factorX;      // speed x
    float factorY;      // speed y

    float velocity = 0; // velocity used in the exit phase of the animation
    float accel;        // acceleration (exit phase)

    int waits;

    public ImagePoint(int rgb, float x, float y, float currentX, float currentY, float accel)
    {
      this.rgb = rgb;// new Color(rgb);
      this.x = x;    // + 365;
      this.y = y;    // + 200;
      this.currentX = currentX;
      this.currentY = currentY;
      factorX = (this.x - currentX) / FRAMES;
      factorY = (this.y - currentY) / FRAMES;
      factorX += Math.random() * factorX;
      factorY += Math.random() * factorY;
      this.accel = 20 + accel;

      waits = (int)(Math.random() * 20);
    }

    // accessors
    public int getRGB()
    { return rgb; }
    public float getX()
    { return x; }
    public float getY()
    { return y; }

    public float getCurrentX()
    { return currentX; }
    public float getCurrentY()
    { return currentY; }
    public void setCurrentX(float c)
    { currentX = c; }
    public void setCurrentY(float c)
    { currentY = c; }
    public float getFactorX()
    { return factorX; }
    public float getFactorY()
    { return factorY; }
  }

  //////////////////////////////////////////////////////////////////////////////
  //
  //  a bitmapped image
  //
  class Bitmap {

    ImagePoint [] bits;
    ImagePoint [] oldBits;
    int xOffset;
    int yOffset;

    int frames = 0;

    boolean allGone = false;
    boolean paintFace = true;
    boolean startNext = false;
    boolean starting = true;

    public Bitmap(ImagePoint [] bits, int xOffset, int yOffset)
    {
      this.bits = bits;
      this.oldBits = new ImagePoint[bits.length];
      this.xOffset = xOffset;
      this.yOffset = yOffset;

      for(int i = 0; i < bits.length; i++)
      {
        oldBits[i] = new ImagePoint(0,0,0,0,0,0);
      }
    }

    // paints the dots for the start phase
    public void paintStartPhase()
    {
      int oldCount = 0;
      for(int i = 0; i < bits.length; i++)
      {

        bits[i].setCurrentX(bits[i].getCurrentX() + bits[i].getFactorX());
        bits[i].setCurrentY(bits[i].getCurrentY() + bits[i].getFactorY());

        float cx = bits[i].getCurrentX();
        float cy = bits[i].getCurrentY();

        float dx = bits[i].getX();
        float dy = bits[i].getY();

        float fx = bits[i].getFactorX();
        float fy = bits[i].getFactorY();

        if( (fx <= 0 && cx <= dx) || (fx >= 0 && cx >= dx) )
          bits[i].setCurrentX(dx);
        if( (fy <= 0 && cy <= dy) || (fy >= 0 && cy >= dy) )
          bits[i].setCurrentY(dy);

        int xPos = (int)bits[i].getCurrentX() + xOffset;
        int yPos = (int)bits[i].getCurrentY() + yOffset;

        bImage.setRGB((int)oldBits[i].x, (int)oldBits[i].y, backPixels[ ((int)oldBits[i].y * 800) + (int)oldBits[i].x ] );

        if(xPos >= 0 && xPos < 800 && yPos >= 0 && yPos < 450)
        {
          oldBits[oldCount].x = xPos;
          oldBits[oldCount].y = yPos;
          oldCount++;
          bImage.setRGB(xPos, yPos, bits[i].getRGB());
        }
      }
      frames++;
      if(frames == FRAMES)
        strike.play();

    }

    // paints the dots exting the screen
    public void paintExitPhase()
    {
      int oldCount = 0;
      allGone = true;
      paintFace = false;
      int stillOn = 0;

      if(starting)
      {
        woosh.play();
        starting = false;
      }
      for(int i = 0; i < bits.length; i++)
      {

        if(bits[i].waits <= 0)
        {
          bits[i].setCurrentX(bits[i].getCurrentX() + bits[i].velocity);
          bits[i].velocity += bits[i].accel;
        }
        else bits[i].waits--;

        if(bits[i].getCurrentX() < 800)
        {
          stillOn++;
          allGone = false;
        }
        int xPos = (int)bits[i].getCurrentX() + xOffset;
        int yPos = (int)bits[i].getCurrentY() + yOffset;

        bImage.setRGB((int)oldBits[i].x, (int)oldBits[i].y, backPixels[ ((int)oldBits[i].y * 800) + (int)oldBits[i].x ] );

        if(xPos >= 0 && xPos < 800 && yPos >= 0 && yPos < 450)
        {
          oldBits[oldCount].x = xPos;
          oldBits[oldCount].y = yPos;
          oldCount++;
          bImage.setRGB(xPos, yPos, bits[i].getRGB());
        }
      }
      if(stillOn < 1200)
        startNext = true;
    }
  }

  //////////////////////////////////////////////////////////////////////////////
  //
  // class for animating
  //
  class DotAnimation implements BAnimation
  {
    public void start(){
    }
    public void stop(){
    }

    public boolean animate()
    {
      background.repaint();
      return true;
    }
  }

  //////////////////////////////////////////////////////////////////////////////
  //
  // contains a list of names and the current locations
  //
  class NameList
  {
    Vector names;
    int yPos = 500;

    int endPos;

    boolean allGone = false;

    public NameList(Vector names)
    {
      this.names = names;
      endPos = yPos + (names.size() - 1) * 40;
    }

    public void paintNames(Graphics2D g)
    {
      for (int i = 0; i < names.size(); i++)
      {
        g.setColor(BGlobal.colors.getMidShade());

        if(i == 0)
          g.setFont(new Font(null, Font.BOLD, 22));
        else
          g.setFont(new Font(null, Font.BOLD, 16));
        int inc = g.getFontMetrics().stringWidth((String)names.elementAt(i));
        g.drawString((String)names.elementAt(i), 400 - (inc / 2), yPos + i * 40);
      }
      yPos -= 2;
      endPos = yPos + (names.size() - 1) * 40;
      if(endPos < 0)
        allGone = true;
    }
  }

  //////////////////////////////////////////////////////////////////////////////
  //
  // represents the faces moving along the rows
  //
  class Gallery implements MouseListener
  {
    Vector top;
    Vector bottom;

    Vector holes;

    int topSpeed = 10;
    int bottomSpeed = -5;

    int topY = 145;
    int bottomY = 230;

    int shotX = -1;
    int shotY = -1;


    public Gallery()
    {
      top = new Vector();
      bottom = new Vector();
      holes = new Vector();
    }

    public void paintRows(Graphics2D g2)
    {
      Face recent = (Face)top.elementAt(top.size()-1);
      if(recent.xOffset > -70)
        addTopFace();

      recent = (Face)bottom.elementAt(bottom.size()-1);
      if(recent.xOffset < 870)
        addBottomFace();

      for(int i = holes.size() - 1; i >= 0 ; i--)
        ((Face)holes.elementAt(i)).paint(g2);

      for(int i = top.size() - 1; i >=0 ; i--)
      {
        Face f = (Face)top.elementAt(i);
        f.paint(g2);
        f.xOffset += topSpeed;

        if(shotX > f.xOffset && shotX < f.xOffset+70 && shotY > topY && shotY < topY+70)
        {
          if(!f.hides)
          {
            f.xOffset = 900;
            hit.play();
          }
          else
            f.setHidden();
        }
        if(f.xOffset > 800)
        {
          top.remove(f);
          f = null;
        }
      }
      for(int i = bottom.size() - 1; i >= 0 ; i--)
      {
        Face f = (Face)bottom.elementAt(i);
        f.paint(g2);
        f.xOffset += bottomSpeed;

        if(shotX > f.xOffset && shotX < f.xOffset+70 && shotY > bottomY && shotY < bottomY+70)
        {
          if(!f.hides)
          {
            f.xOffset = -100;
            hit.play();
          }
          else
          {
            f.setHidden();
          }
        }
        if(f.xOffset < -70)
        {
          bottom.remove(f);
          f = null;
        }
      }
      shotX = -1;
      shotY = -1;
    }

    public void addTopFace()
    {
      int faceNum = (int)(Math.random() * 10);
      if(faceNum == 0)
        top.add(new Face(darrenImage, -210, topY, ""));
      else if(faceNum == 1)
        top.add(new Face(hughImage, -210, topY, ""));
      else if(faceNum == 2)
        top.add(new Face(youngImage, -210, topY, ""));
      else if(faceNum == 3)
        top.add(new Face(jamesImage, -210, topY, ""));
      else if(faceNum == 4)
        top.add(new Face(lindenImage, -210, topY, ""));
      else if(faceNum == 5)
        top.add(new Face(aryanImage, -210, topY, ""));
      else if(faceNum == 6)
        top.add(new Face(andrewImage, -210, topY, "hooba"));
      else if(faceNum == 7)
        top.add(new Face(steveImage, -210, topY, ""));
      else if(faceNum == 8)
        top.add(new Face(mikeImage, -210, topY, ""));
      else if(faceNum == 9)
        top.add(new Face(hoobaImage, -210, topY, "hooba"));
    }
    public void addBottomFace()
    {
      int faceNum = (int)(Math.random() * 10);
      if(faceNum == 0)
        bottom.add(new Face(darrenImage, 1010, bottomY, ""));
      else if(faceNum == 1)
        bottom.add(new Face(hughImage, 1010, bottomY, ""));
      else if(faceNum == 2)
        bottom.add(new Face(youngImage, 1010, bottomY, ""));
      else if(faceNum == 3)
        bottom.add(new Face(jamesImage, 1010, bottomY, ""));
      else if(faceNum == 4)
        bottom.add(new Face(lindenImage, 1010, bottomY, ""));
      else if(faceNum == 5)
        bottom.add(new Face(aryanImage, 1010, bottomY, ""));
      else if(faceNum == 6)
        bottom.add(new Face(andrewImage, 1010, bottomY, "hooba"));
      else if(faceNum == 7)
        bottom.add(new Face(steveImage, 1010, bottomY, ""));
      else if(faceNum == 8)
        bottom.add(new Face(mikeImage, 1010, bottomY, ""));
      else if(faceNum == 9)
        bottom.add(new Face(hoobaImage, 1010, bottomY, "hooba"));
    }

    public void mouseEntered(MouseEvent e){}
    public void mouseExited(MouseEvent e){}
    public void mouseClicked(MouseEvent e){}
    public void mousePressed(MouseEvent e)
    {
      shot.play();

      shotX = e.getX();
      shotY = e.getY();

      if(holes.size() > 10)
        holes.removeElementAt(0);
      holes.add(new Face(holeImage, shotX - 6, shotY - 6, ""));
    }
    public void mouseReleased(MouseEvent e){}

 }

  //////////////////////////////////////////////////////////////////////////////
  //
  // overwrites the label with the background image to enable image processing
  //
  class CLabel extends BLabel
  {
    public CLabel(BUIResources res, String s)
    {
      super(res, s);
      setDoubleBuffered(false);
    }

    public void paint(Graphics g)
    {
      Graphics2D g2 = (Graphics2D)g;

      // bring the faces in
      if(phase == 0)
        animateStartPhase();

      // move the faces out
      if(phase == 1)
        animateExitPhase();

      g2.drawImage(bImage, null, 0, 0);

      // display the scrolling thankyou
      if(phase == 2)
        animateThankPhase(g2);

      // if the phase is right - show the faces solid
      if(phase == 0 || phase == 1)
        showFaces(g2);

      // phase 3 - draw the shooting gallery!
      if(phase == 3)
        drawShoot(g2);
    }

    // bring on the faces one by one
    public void animateStartPhase()
    {
      if(i1.frames <= FRAMES)
        i1.paintStartPhase();
      else if (i2.frames <= FRAMES)
        i2.paintStartPhase();
      else if (i3.frames <= FRAMES)
        i3.paintStartPhase();
      else if (i4.frames <= FRAMES)
        i4.paintStartPhase();
      else if (i5.frames <= FRAMES)
        i5.paintStartPhase();
      else if (i6.frames <= FRAMES)
        i6.paintStartPhase();
      else if (i7.frames <= FRAMES)
        i7.paintStartPhase();
      else if (i8.frames <= FRAMES)
        i8.paintStartPhase();
      else if (i9.frames <= FRAMES)
        i9.paintStartPhase();
    }

    // remove the faces similarly
    public void animateExitPhase()
    {
      if(i1.allGone == false)
        i1.paintExitPhase();
      if (i2.allGone == false && i1.startNext)
        i2.paintExitPhase();
      if (i3.allGone == false && i2.startNext)
        i3.paintExitPhase();
      if (i4.allGone == false && i3.startNext)
        i4.paintExitPhase();
      if (i5.allGone == false && i4.startNext)
        i5.paintExitPhase();
      if (i6.allGone == false && i5.startNext)
        i6.paintExitPhase();
      if (i7.allGone == false && i6.startNext)
        i7.paintExitPhase();
      if (i8.allGone == false && i7.startNext)
        i8.paintExitPhase();
      if (i9.allGone == false && i8.startNext)
        i9.paintExitPhase();
      if(i9.allGone)
        phase = 2;
   }

   // draw the scrolling names
   public void animateThankPhase(Graphics2D g2)
   {
     thankNames.paintNames(g2);
     if(thankNames.allGone)
     {
       phase = 3;
       this.setCursor(cross);
       this.addMouseListener(gallery);
     }
   }

   // draw the faces solid
   public void showFaces(Graphics2D g2)
   {
     if(i1.frames > FRAMES && i1.paintFace)
       f1.paint(g2);
     if(i2.frames > FRAMES && i2.paintFace)
       f2.paint(g2);
     if(i3.frames > FRAMES && i3.paintFace)
       f3.paint(g2);
     if(i4.frames > FRAMES && i4.paintFace)
       f4.paint(g2);
     if(i5.frames > FRAMES && i5.paintFace)
       f5.paint(g2);
     if(i6.frames > FRAMES && i6.paintFace)
       f6.paint(g2);
     if(i7.frames > FRAMES && i7.paintFace)
       f7.paint(g2);
     if(i8.frames > FRAMES && i8.paintFace)
       f8.paint(g2);
     if(i9.frames > FRAMES && i9.paintFace)
     {
       f9.paint(g2);
       phase = 1;
     }
   }

   // draw the shooting gallery
   public void drawShoot(Graphics2D g2)
   {
     gallery.paintRows(g2);
     g2.fillRect(0, 210, 800, 5);
     g2.fillRect(0, 295, 800, 5);
   }
 }

  // used for drawing a face and name as a single image
  class Face
  {
    Image image;
    int xOffset;
    int yOffset;
    String name;
    AffineTransform trans;

    int hideCount = 0;

    boolean hides = false;
    boolean hidden = false;

    public Face(Image image, int xOffset, int yOffset, String name)
    {
      this.image = image;
      this.xOffset = xOffset;
      this.yOffset = yOffset;
      if(name.equals("hooba"))
      {
        hides = true;
        this.name = "";
      }
      else
        this.name = name;
      trans = new AffineTransform();
    }

    public void setHidden()
    {
      hidden = true;
      hideCount = 15;
    }

    public void paint(Graphics2D g)
    {
      trans.setToIdentity();
      trans.translate(xOffset, yOffset);

      if(hidden)
        g.drawImage(emptyImage, trans, null);
      else
        g.drawImage(image, trans, null);

      g.setColor(BGlobal.colors.getMidShade());

      g.setFont(new Font(null, Font.PLAIN, 10));
      int inc = g.getFontMetrics().stringWidth(name);
      g.drawString(name, xOffset + 35 - (inc / 2), yOffset + 79);
      if(hideCount > 0)
      {
        hideCount--;
        if(hideCount == 0)
          hidden = false;
      }
    }
  }
}
