package roboforge.ui.ai;

import roboforge.BBot;
import roboforge.BDebug;

import roboforge.ai.BDecisionTreeAI;
import roboforge.ui.components.*;
import roboforge.ai.decisions.*;
import roboforge.ai.expressions.*;
import roboforge.ai.memory.*;


import roboforge.ai.expressions.parser.*;
import roboforge.util.parser.*;


public class BDecisionNodePanel extends BAINodePanel
{

  // Class variables...
  // -------------------------------------------------------------

  protected static BAINodePanel instance = null;
    // A single instance of this panel type.
    // Returned by getInstance().


  // Member variables...
  // -------------------------------------------------------------

  protected BDecisionNode node;


  // Visual elements...
  // -------------------------------------------------------------

  protected BTextField name = new BTextField();


  // Visual elements...
  // -------------------------------------------------------------

  protected BExpressionBuilder builder =
    new BExpressionBuilder();


  // Constructor.
  // -------------------------------------------------------------

  public BDecisionNodePanel()
  {
    super("decision");

    layoutPanelChildren();
    configPanelChildren();
  }

  protected void layoutPanelChildren()
  {
    addLinear(new BLabel("Description: "), name );
    //addHGlued(new BLabel("Description: "));
    //addTinyMargin();
    //addHGlued(name);

    addMargin();
    add(builder);
  }

  protected void configPanelChildren()
  {
    name.addActionListener(updateListener);
    name.setToolTipText("(optional) Write brief description of your decision here.");
  }


  // Activation methods...
  // -------------------------------------------------------------

  public void onClose()
  {
    instance = null;
    super.onClose();
  }
  
  
  // Accessor methods...
  // -------------------------------------------------------------

  public BDecisionTreeNode getNode()
    { return node; }

  public static BAINodePanel getInstance()
  {
    if (instance == null)
      instance = new BDecisionNodePanel();

    return instance;
  }

  public static void clearInstance()
    { instance = null; }


  public void setAI(BDecisionTreeAI ai)
  {
    super.setAI(ai);
    builder.setAI(ai);
  }


  // UI methods...
  // -------------------------------------------------------------

  public void setPanelFromNode(BDecisionTreeNode n)
  {
    updateListener.setEnabled(false);

    // HACK: Gets World states to update...
    if (ai != null)
      setAI(ai);

    this.node = (BDecisionNode) n;
    builder.setExpression(node.getQuestion());
    name.setText(node.getName(false));

    updateListener.setEnabled(true);
  }

  protected void setNodeFromPanel()
  {
    if (node != null)
    {
      BDebug.print("BDecisionNodePanel ai " + this.getAI() );
      node.setQuestion(builder.getExpression());

      String trimmed = name.getText().trim();

      if (!trimmed.equals(""))
        node.setName(trimmed);
      else
        node.setName(null);
    }
  }

}