package roboforge.ui.ai;

import roboforge.ai.BDecisionTreeAI;
import roboforge.ai.decisions.*;
import roboforge.ui.components.*;

public class BRootNodePanel extends BAINodePanel
{

  // Class variables...
  // -------------------------------------------------------------

  protected static BAINodePanel instance = null;
    // A single instance of this panel type.
    // Returned by getInstance().


  // Member variables...
  // -------------------------------------------------------------

  protected BRootNode node;
  protected BMultiLabel mLabel = new BMultiLabel();


  // Constructor.
  // -------------------------------------------------------------

  public BRootNodePanel()
  {
    super("start");

    layoutRootPanelChildren();
    configRootPanelChildren();


  }

  protected void layoutRootPanelChildren()
  {
    addMargin();
    add(mLabel);
    addGlue();
  }

  protected void configRootPanelChildren()
  {
    mLabel.setText("This is the starting point for your robot's AI. At this point your robot scans the environment with it's sensors and checks its own status. All information about the enemy robot, the environment, and your robot is updated. When the AI has been processed to the end, it restarts back here.");
  }


  // Activation methods...
  // -------------------------------------------------------------

  public void onClose()
  {
    instance = null;
    super.onClose();
  }

  public static void clearInstance()
    { instance = null; }

  
  // Accessor methods...
  // -------------------------------------------------------------

  public BDecisionTreeNode getNode()
    { return node; }

  public static BAINodePanel getInstance()
  {
    if (instance == null)
      instance = new BRootNodePanel();

    return instance;
  }

  // UI methods...
  // -------------------------------------------------------------

  protected void setPanelFromNode(BDecisionTreeNode n)
    { this.node = (BRootNode) n; }

  protected void setNodeFromPanel()
    { }

}