package roboforge.ui.components;

import roboforge.util.graphics.*;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;



public class BAnimatedIconLabel extends BAnimatedLabel
{

  // Class variables...
  // -------------------------------------------------------------

  protected static final Toolkit toolkit =
    Toolkit.getDefaultToolkit();



  // Member variables...
  // -------------------------------------------------------------

  protected Icon[] icons;
  protected int    index;



  // Constructors...
  // -------------------------------------------------------------

  public BAnimatedIconLabel()
    { super(); }

  public BAnimatedIconLabel(BUIResources res, String key)
    { super(res, key); }



  // Implementation methods...
  // -------------------------------------------------------------

  protected void setHSBIcon(HSBImageIcon icon)
    { /* Override, to prevent disabledIcon setting. */ }



  // Accessor methods...
  // -------------------------------------------------------------

  public void setIcon(Icon icon)
    // Assumes horizontal strip, square tiles.
  {
    if (icon == null)
      return;

    if (!(icon instanceof ImageIcon))
      throw new IllegalArgumentException(
        "BAnimatedLabel only accepts ImageIcons.");

    Image image = ((ImageIcon) icon).getImage();

    int x       = 0;
    int width   = image.getWidth(null);
    int height  = image.getHeight(null);
    int tiles   = width / height;
    int size    = height;


    BufferedImage buf = 
      new BufferedImage(width, height,
        BufferedImage.TYPE_INT_ARGB);
    
    BGraphics.copyImage(image, buf);

    /*  
    ImageProducer source =
      image.getSource();
    */

    icons = new Icon[tiles];

    for (int i=0; i<tiles; i++)
    {
      BufferedImage crop =
        buf.getSubimage(x, 0, size, size);
      
      /*
      CropImageFilter filter =
        new CropImageFilter(x, 0, size, size);

      Image crop = toolkit.createImage(
        new FilteredImageSource(source, filter));
      */

      icons[i] = new ImageIcon(crop);

      x += size;
    }

  }


  // Animation method...
  // -------------------------------------------------------------

  public void animation()
  {
    if (icons != null)
    {
      index++;
      if (index >= icons.length)
        index = 0;

      super.setIcon(icons[index]);
    }
  }


}