package roboforge.ui.components;

import roboforge.ui.BNamedIconic;

import java.awt.*;
import javax.swing.*;


public class BNamedIconicListCellRenderer extends JLabel
  implements ListCellRenderer
{
  protected Color unselected;
  protected Color selected;

  public BNamedIconicListCellRenderer()
  {
    super();
    unselected = getForeground();
    selected   = Color.white;
  }

  public Component getListCellRendererComponent(
    JList list,
    Object value,            // value to display
    int index,               // cell index
    boolean isSelected,      // is the cell selected
    boolean cellHasFocus)    // the list and the cell have the focus
  {
    if (value instanceof BNamedIconic)
    {
      BNamedIconic o = (BNamedIconic) value;

      setText(o.getName());
      setIcon(isSelected ? o.getSelectedIcon() : o.getIcon());
      setForeground(isSelected ? selected : unselected);

      return this;
    }
    else
      throw new IllegalArgumentException
        ("not a BNamedIconic: "+ value);
  }

} 