package roboforge.ui.components;

import roboforge.BGlobal;

import java.awt.Dimension;
import javax.swing.*;


public class BSlider extends JSlider
{

  // Constructors.
  // -------------------------------------------------------------

  public BSlider(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }

  public BSlider()
    { this(null, null); }


  public void initializeUI(BUIResources res, String key)
  {
    setPaintLabels(true);
    setPaintTicks(true);
    setSnapToTicks(true);

    if (res != null)
    {
      res.initComponent(this, key);

      int min = res.getInt(key+ ".min");
      setMinimum(min);

      int max = res.getInt(key+ ".max");
      setMaximum(max);

      int value = res.getInt(key+ ".value");
      setValue(value);

      Boolean ticks = (Boolean) res.get(key+ ".ticks");
      if (ticks != null)
        setPaintTicks(ticks.booleanValue());

      Boolean labels = (Boolean) res.get(key+ ".labels");
      if (labels != null)
        setPaintLabels(labels.booleanValue());

      Boolean snap = (Boolean) res.get(key+ ".snap");
      if (snap != null)
        setSnapToTicks(snap.booleanValue());

      int majorSpacing = res.getInt(key+ ".majorSpacing");
      if (majorSpacing > 0)
        setMajorTickSpacing(majorSpacing);

      int minorSpacing = res.getInt(key+ ".minorSpacing");
      if (minorSpacing > 0)
        setMinorTickSpacing(minorSpacing);
    }
  }

} 