package roboforge.ui.components;

import roboforge.BGlobal;
import roboforge.ui.components.table.*;
import roboforge.util.processors.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.JTable;
import javax.swing.KeyStroke;
import javax.swing.table.*;

public class BTable extends JTable
{

  // Internal variables...
  // -------------------------------------------------------------

  protected static final KeyStroke DELETE =
    KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0);

  protected boolean rowsDeleteable = false;


  // Constructors...
  // -------------------------------------------------------------

  public BTable(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }

  public BTable()
    { this((BUIResources) null, (String) null); }

  public BTable(TableModel m)
  {
    this((BUIResources) null, (String) null);
    setModel(m);
  }


  public BTable(Object[][] data, Object[] columnNames)
  {
    this((BUIResources) null, (String) null);

    BTableModel model =
      new BTableModel(data, columnNames);

    setModel(model);
  }


  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    setOpaque(true);
    setRowHeight(20);
    
    if (res != null)
      res.initComponent(this, key);
  }

}
