package roboforge.ui.components;

//import roboforge.BGlobal;

import java.awt.*;

import javax.swing.Icon;
import javax.swing.JToggleButton;
import javax.swing.AbstractButton;


public class BToggleButton extends JToggleButton
{

  // Member variables...
  // -------------------------------------------------------------

  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;


private static final String uiClassID = "ToggleButtonUI";


  protected boolean isShowingText = true;
  

  // Constructors...
  // -------------------------------------------------------------

  public BToggleButton(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }

  public BToggleButton()
    { this(null, null); }



  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    setOpaque(false);

    if (res != null)
    {
      res.initComponent((AbstractButton) this, key);
    
      Boolean showText =
        (Boolean) res.get(key+ ".showText");
      
      if (showText != null)
        setShowingText(showText.booleanValue());
    }

    // Set centered alignment, for correct BoxLayout display...
    setAlignmentX(Component.CENTER_ALIGNMENT);
    setAlignmentY(Component.CENTER_ALIGNMENT);
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public String getUIClassID() 
    { return uiClassID; }
  
  public void setShowingText(boolean s)
  {
    this.isShowingText = s;
    
    if (!isShowingText)
      super.setText(null);
  }
  
  public boolean isShowingText()
    { return isShowingText; }
  
  public void setText(String text)
  { 
    if (isShowingText)
      super.setText(text);
  }


  public void setIcon(Icon icon)
  {
    super.setIcon(icon);

    if (icon instanceof HSBImageIcon)
      setDisabledIcon(icon);
  }
}