package roboforge.ui.components;

import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

public class BTranslucentIcon extends ImageIcon
{
  /*
  protected static Toolkit toolkit = Toolkit.getDefaultToolkit();

  protected Image image = null;
  protected String description;
  */
  protected float opacity = 1.0f;
  protected int w = 0;
  protected int h = 0;

  // protected ImageObserver imageObserver = null;

  public BTranslucentIcon (String fileName, int w, int h )
    { this(fileName, w, h, 1.0f); };

  public BTranslucentIcon (Image image, int w, int h )
    { this(image, w, h, 1.0f); };


  public BTranslucentIcon
  (
    String fileName,
    int w, int h,
    float opacity
  )
  {
    super(fileName);
    this.w = w;
    this.h = h;
    this.opacity = opacity;
  }

  public BTranslucentIcon
  (
    Image image,
    int w, int h,
    float opacity
  )
  {
    super(image);
    this.w = w;
    this.h = h;
    this.opacity = opacity;
  }


  public void setOpacity(float opacity)
    { this.opacity = opacity; }

  public float getOpacity()
    { return opacity; }

  public int getIconWidth()
    { return w; }

  public int getIconHeight()
    { return h; }

  public void setIconWidth(int w)
    { this.w = w; }

  public void setIconHeight(int h)
    { this.h = h; }


  /*
  public void setImageObserver(ImageObserver o)
    { this.imageObserver = o; }
  */

  public synchronized void paintIcon
    (Component c, Graphics g, int x, int y)
  {
    Graphics2D g2d = (Graphics2D) g;

    if (opacity < 1.0f)
    {
      AlphaComposite ac = AlphaComposite.getInstance(
        AlphaComposite.SRC_OVER,
        opacity);

      g2d.setComposite(ac);
    }

    g2d.drawImage(getImage(), x, y, w, h, c);
  }

}