package roboforge.ui.components.text;



public class BCharacterGuard extends BAbstractGuard
{
  
  protected boolean[] isValidChar;


  // Constructor.
  // -------------------------------------------------------------

  public BCharacterGuard(String validChars)
    { setValidChars(validChars); }

  
  // Interface methods...
  // -------------------------------------------------------------
  
  protected boolean isValidChar(char c, int i)
    { return isValidChar[c]; }
  
  
  // Accessor methods...
  // -------------------------------------------------------------

  public String getValidChars()
  {
    String s = "";

    for (int i=0; i<255; i++)
      if (isValidChar[i])
        s += (char) i;

    return s;
  }

  public void setValidChars(String f)
  {
    initializeValidChars();
    addValidChars(f);
  }

  public void addValidChar(char c)
    { isValidChar[(int) c] = true; }

  public void addValidChars(String f)
  {
    char[] chars = f.toCharArray();
    int n = chars.length;

    for (int i=0; i<n; i++)
      isValidChar[(int) chars[i]] = true;
  }

  public void addValidChars(int low, int high)
  {
    for (int i=low; i<=high; i++)
      isValidChar[i] = true;
  }


  // Init. helper methods...
  // -------------------------------------------------------------

  protected void initializeValidChars()
  {
    isValidChar = new boolean[256];

    for (int i=0; i<255; i++)
      isValidChar[i] = false;
  }

}
