package roboforge.ui.components.tree;

import java.awt.Component;
import javax.swing.*;
import javax.swing.tree.*;


public class BTreeCellRenderer extends DefaultTreeCellRenderer
{

  public BTreeCellRenderer()
    { super(); }

  public Component getTreeCellRendererComponent
  (
    JTree tree, Object value,
    boolean isSelected, boolean expanded,
		boolean leaf, int row, boolean hasFocus
  )
  {
    if (!(value instanceof BTreeCellRenderable))
      throw new IllegalArgumentException(
        "BTreeCellRenderer.getTreeCellRendererComponent(): "+
        "value is not an instance of BTreeCellRenderable.");

    BTreeCellRenderable cell =
      (BTreeCellRenderable) value;

    setText(cell.getName());

    if (isSelected)
    {
      setIcon(cell.getSelectedIcon());
      setForeground(getTextSelectionColor());
    }
    else
    {
      setIcon(cell.getIcon());
      setForeground(getTextNonSelectionColor());
    }

    return this;
	}

}

