package roboforge.ui.console;

import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.geometry.BRectangle3D;

import java.awt.image.BufferedImage;

import javax.media.j3d.*;
import javax.vecmath.*;


public class BConsoleImage extends BConsoleRectangle
{

  private Texture2D texture;


  public BConsoleImage(Texture texture)
  {
    super();
    setTexture(texture);
  }

  public BConsoleImage(BufferedImage image)
  {
    super();
    setImage(image);
  }

  public BConsoleImage()
  {
    super();
  }


  public void setTexture(Texture t)
  {
    appearance.setTexture(t);

    setSize(
      t.getImage(0).getWidth(),
      t.getImage(0).getHeight());


  }

  public void setTexturePortion(BTexturePortion p)
  {
    appearance.setTexture(p.getTexture());

    setSize(p.getWidth(), p.getHeight());

    rectangle = p.getRectangle();
    rectangle.setAppearance(appearance);

    setGeometry(rectangle);
  }


  public void setImage(BufferedImage image)
  {

// HACK To fix Bug in j3d1.2.1beta1 which prevented textures from being updated
// recreating the whole texture every time

//    if (texture == null)
//    {
      texture =
        new Texture2D(Texture.BASE_LEVEL, Texture.RGBA, image.getWidth(), image.getHeight() );
      ImageComponent2D ic =
        new ImageComponent2D(ImageComponent.FORMAT_RGBA, image);
      texture.setImage(0, ic);
      texture.setMagFilter(Texture.BASE_LEVEL_LINEAR   );
      texture.setMinFilter(Texture.BASE_LEVEL_LINEAR  );


      setTexture(texture);

//    }
//    else
//    {
     // ((ImageComponent2D)texture.getImage(0)).set(image);


//    }

  }



}
