package roboforge.ui.events;

import java.awt.Component;
//import java.awt.Event;
import java.awt.event.*;

public class BMouseRelayListener extends MouseAdapter
  implements MouseMotionListener
{
  protected Component target = null;
  protected int sourceX;
  protected int sourceY;
  protected boolean relayEnabled;

  public BMouseRelayListener(Component source, Component target)
  {
    this.sourceX = source.getX();
    this.sourceY = source.getY();
    this.target  = target;

    relayEnabled = true;
  }

  public void setRelayEnabled(boolean e)
    { this.relayEnabled = e; }

  public void mousePressed(MouseEvent e)
    { relayEvent(e); }

  public void mouseClicked(MouseEvent e)
    { relayEvent(e); }

  public void mouseEntered(MouseEvent e)
    { relayEvent(e); }

  public void mouseExited(MouseEvent e)
    { relayEvent(e); }

  public void mouseDragged(MouseEvent e)
    { relayEvent(e); }

  public void mouseMoved(MouseEvent e)
    { relayEvent(e); }

  protected void relayEvent(MouseEvent e)
  {
    if (relayEnabled)
    {
      MouseEvent me = new MouseEvent
      (
        target,
        e.getID(),
        e.getWhen(),
        e.getModifiers(),
        e.getX()+ sourceX,
        e.getY()+ sourceY,
        e.getClickCount(),
        e.isPopupTrigger()
      );

      target.dispatchEvent(me);
    }
  }

  public void generateEvent(int id, int x, int y)
  {
    if (relayEnabled)
    {
      MouseEvent me = new MouseEvent
      (
        target,
        id,
        System.currentTimeMillis(),
        0,
        x + sourceX,
        y + sourceY,
        1,
        false
      );

      target.dispatchEvent(me);
    }
  }
}
