package roboforge.ui.fusion;

import roboforge.BGlobal;

import java.awt.*;

import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import javax.swing.border.*;

public class FusionComboBoxUI extends BasicComboBoxUI
{
  protected Color buttonBackground = null;
  protected Color buttonForeground = null;
  protected Color buttonHighlight  = null;
  protected Border buttonBorder    = null;

  public static ComponentUI createUI(JComponent c)
    { return new FusionComboBoxUI(); }

  public void installDefaults()
  {
    String pp = "ComboBox.";

    buttonBackground  = UIManager.getColor(pp+ "buttonBackground");
    buttonForeground  = UIManager.getColor(pp+ "buttonForeground");
    buttonHighlight   = UIManager.getColor(pp+ "buttonHighlight");
    buttonBorder      = UIManager.getBorder(pp+ "buttonBorder");

    super.installDefaults();
  }

  public void installComponents()
  {
    super.installComponents();
    arrowButton.setBorder(buttonBorder);
  }

  protected JButton createArrowButton()
  {
    return new FusionArrowButton
    (
      BasicArrowButton.SOUTH,
      buttonBackground,
      buttonForeground,
      buttonHighlight
    );
  }

  // protected ComboBoxEditor createEditor()
  //   { return new BTextField(); }

  protected ListCellRenderer createRenderer() {
    return new FusionListCellRenderer();
  }

  protected ComboPopup createPopup()
  {
    BasicComboPopup popup = new FusionComboPopup( comboBox );
    popup.getAccessibleContext().setAccessibleParent(comboBox);
    return popup;
  }

  /*
  protected class FusionComboPopup extends BasicComboPopup
  {
    public FusionComboPopup(JComboBox comboBox)
      { super(comboBox); }

    protected void configurePopup()
    {
      super.configurePopup();
      setBorder( BorderFactory.createLineBorder(
        BGlobal.colors.getDarkerShade() ));
    }
  }
  */
}