package roboforge.ui.layers;

import roboforge.BGhost;
import roboforge.BGhostable;

import roboforge.ui.components.*;
import roboforge.ui.events.*;

import javax.swing.*;



public class BBoxLayer extends BBoxPanel
  implements BLayer, BGhost
{


  // Member variables...
  // -------------------------------------------------------------

  protected BActivationSupport activation
    = new BActivationSupport(this);



  // Constructors...
  // -------------------------------------------------------------

  public BBoxLayer(BUIResources res, String key, int axis)
  {
    super(res, key, axis);
    setOpaque(true);
  }

  public BBoxLayer(int axis)
    { this(null, null, axis); }



  // Layer methods...
  // -------------------------------------------------------------

  public void addTo(JComponent holder)
    { holder.add(this); }

  public void removeFrom(JComponent holder)
    { holder.remove(this); }
  
  
  
  // Ghosting methods...
  // -------------------------------------------------------------
  
  public BGhost createGhost()
    { return this; }
  
  public Object resurrect()
    { return this; }
  
  public void banish()
    { requestClose(); }


  
  // Activation methods...
  // -------------------------------------------------------------

  public boolean isActive()
    { return activation.isActive(); }

  public boolean isClosed()
    { return activation.isClosed(); }

  public void requestActivate()
    { activation.requestActivate(); }

  public void requestDeactivate()
    { activation.requestDeactivate(); }

  public void requestClose()
    { activation.requestClose(); }

  public void onActivate()
    { activation.fireActivate(); }

  public void onDeactivate()
    { activation.fireDeactivate(); }

  public void onClose()
  {
    activation.fireClose();
    super.onClose();
  }
    
  public void addActivationListener(BActivationListener l)
    { activation.addActivationListener(l); }

  public void removeActivationListener(BActivationListener l)
    { activation.addActivationListener(l); }



  // Accessor methods...
  // -------------------------------------------------------------

  public boolean isAlwaysOnTop()
    { return false; }


}
