package roboforge.ui.modes;

import roboforge.ui.components.BModeButton;

import java.util.Enumeration;
import javax.swing.ButtonGroup;
import javax.swing.ButtonModel;


public class BModeButtonGroup extends ButtonGroup
{
  protected BModeManager manager;

  public BModeButtonGroup(BModeManager manager)
  {
    super();
    this.manager = manager;
  }

  public void setSelectedFromManager()
  {
    Enumeration e = getElements();

    BMode selected =
      manager.getSelectedMode();

    while (e.hasMoreElements())
    {
      BModeButton b = (BModeButton) e.nextElement();

      if ((b.getMode() == selected) && b.isEnabled())
      {
        b.setSelected(true);
        return;
      }
    }

    deselect();

    // manager.setSelectedMode(null);
  }

  public void deselect()
  {
    Enumeration e = getElements();

    while (e.hasMoreElements())
    {
      BModeButton b =
        (BModeButton) e.nextElement();

      if (b.isSelected())
      {
        remove(b);
        b.setSelected(false);
        add(b);

        return;
      }
    }
  }
}

