package roboforge.ui.modes;

import roboforge.BComponent;
import roboforge.BGlobal;
import roboforge.ui.*;
//import roboforge.ui.components.BUIResources;
import roboforge.util.graphics.*;
import roboforge.sound.*;

import java.awt.Cursor;
import java.awt.event.MouseEvent;

//import javax.media.j3d.*;
import javax.vecmath.*;

public class BModeConnectRot extends BModeManipulator
{

  // Class variables...
  // -------------------------------------------------------------

  public final static String NAME = "Component Rotate";


  // Internal variables.
  // -------------------------------------------------------------



  private transient BDependantSound moveSound;


 

  protected Cursor jointRotateCursor = BGraphics.getCursor("limb_rot_cursor.gif", 16, 16);

  // Constructor.
  // -------------------------------------------------------------

  public BModeConnectRot(B3DBotCanvas canvas)
  {
    super(canvas);
    moveSound = (BDependantSound)BDependantSound.getSound(BGlobal.SOUNDPATH + "interface/componentrotate.wav" , 0, BSound.SOUND_TYPE_INTERFACE );
    moveSound.reset();


  }


  // Activation methods.
  // -------------------------------------------------------------

  public void onActivate()
  {
    super.onActivate();
    BComponent c = canvas.getSelectedComponent();

    if (c != null)
      onPickComponent(c, null);
  }
  

  // Mouse-event methods.
  // -------------------------------------------------------------

  public void mousePressed(MouseEvent e)
  {
    super.mousePressed(e);
    canvas.setCursor(jointRotateCursor);
  }

  public void mouseDragged(MouseEvent e)
  {
    super.mouseDragged(e);

    BComponent c = canvas.getSelectedComponent();

    if (c != null)
      if (!c.getChassisLock())
      {
        rotateConnect(c, dx, dy);
        moveSound.play();
      }
  }

  public void mouseReleased(MouseEvent e)
  {
    super.mouseReleased(e);
    canvas.setCursor(Cursor.getDefaultCursor());
  }



  private void rotateConnect(BComponent c, int dx, int dy)
  // Only rotates around the connect point
  // This method should be moved to BComponent

  {
    c.rotateConnect(dx, dy);
  }

  protected void onPickComponent(BComponent c, MouseEvent e)
  {
    Color3f selectColor = null;

    if (c != null)
      // Determine selection color.
      selectColor = c.getChassisLock() ?
        BGlobal.LOCKED_COLOR_3F :
        BGlobal.SELECTED_COLOR_3F;

    canvas.setSelectedComponent(c, true, true, false, false, selectColor);
  }
}
