package roboforge.ui.net;

import roboforge.BGlobal;

import roboforge.ui.components.tree.*;

import roboforge.net.data.*;
import roboforge.util.data.*;
import roboforge.util.graphics.*;

import java.awt.Color;
import javax.swing.*;



public class BFightDataNode extends BDataNode
{

  // The piece of data that this node represents.
  protected BDataAtom data;

  // true if the fight that this node represents has been downloaded
  protected boolean downloaded;

  // true if the fight that this node represents has been nominated by anyone
  protected boolean nominated;

  // the icons specific to a fight node
  Icon downloadedIcon =  BIconCache.getHSB("net_fight_icon.gif");
  Icon notDownloadedIcon =  BIconCache.getHSB("net_fight_icon2.gif");
  Icon downloadedIconSel =  BIconCache.getHSB("net_fight_icon.gif", Color.white);
  Icon notDownloadedIconSel =  BIconCache.getHSB("net_fight_icon2.gif", Color.white);


  // Constructor...
  // -------------------------------------------------------------

  public BFightDataNode(String name)
  {
    super(name);
  }

  public BFightDataNode(BDataAtom data)
  {
    super(data);
  }

  // sets this node to 'downloaded' status
  public void setDownloaded(boolean downloaded)
  {
    this.downloaded = downloaded;
  }

  // sets the nominated status of this node
  public void setNominated(boolean nominated)
  {
    this.nominated = nominated;
  }


  // Accessor methods...
  // -------------------------------------------------------------
  public String getName()
  {
    return super.getName();
  }

  // returns true if the fight has been nominated
  public boolean isNominated()
  {
    return nominated;
  }


  public Icon getIcon()
  {
    if (downloaded)
      return downloadedIcon;
    else
      return notDownloadedIcon;
  }

  public Icon getSelectedIcon()
  {
    if (downloaded)
      return downloadedIconSel;
    else
      return notDownloadedIconSel;
  }


  // Dummy root-data class...
  // -------------------------------------------------------------

  protected static class BRootData extends BAbstractAtom
  {
    protected String name;

    public BRootData(String name)
    { 
      super(0);
      this.name = name; 
    }
    
    public int getType() 
      { return -1; } 
    
    public String toString()
      { return name; }
  }
}