package roboforge.util.data;

import java.io.Serializable;


public abstract class BAbstractAtom
  implements BDataAtom, Serializable
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Member variables...
  // -------------------------------------------------------------

  protected Long ID;
    // Identifier for this atom.
    // Must be unique within the given type.




  // Constructor...
  // -------------------------------------------------------------

  public BAbstractAtom(long id)
    { setID(id); }

  public BAbstractAtom(Long id)
    { this.ID = id; }

  
  // Interface methods...
  // -------------------------------------------------------------

  public void store(BDatabase db)
  {
    int type = getType();
    
    BDataStore store = 
      db.get(type);
    
    if (store != null)
      store.put(this);
  }


  // Abstract methods...
  // -------------------------------------------------------------
  
  public abstract int getType();
  

  // Accessor methods...
  // -------------------------------------------------------------

  public void setID(long id)
    { this.ID = new Long(id); }

  public void setID(Long id)
    { this.ID = id; }

  public long getID()
    { return ID.longValue(); }

  public Long getIDLong()
    { return ID; }

}