package roboforge.util.io;

import java.io.*;


public class BBasicFilter
  implements BExtensionFilter
{
  protected String[] exts;

  public BBasicFilter()
    { this.exts = null; }

  public BBasicFilter(String ext)
  {
    exts = new String[1];
    exts[0] = ext;
  }

  public BBasicFilter(String[] exts)
    { this.exts = exts; }

  public boolean accept(File dir, String name)
  {
    if (exts == null)
      return true;

    for (int i=0; i<exts.length; i++)
      if (name.endsWith(exts[i]))
        return true;

    return false;
  }

  public String toDisplayable(String name)
  {
    if (exts == null)
      return name;

    int index;

    for (int i=0; i<exts.length; i++)
    {
      index = name.lastIndexOf(exts[i]);
      if (index != -1)
        return name.substring(0, index);
    }

    return name;
  }

  public String toFilename(String displayable)
    { return displayable; }


  public void addExtension(String ext)
  {
    String[] single = new String[1];
    single[0] = ext;

    addExtension(single);
  }

  public void addExtension(String[] fil)
  {
    if (exts == null)
      exts = fil;
    else
    {
      String[] old = exts;

      int n = old.length+ fil.length;
      exts = new String[n];

      for (int i=0; i<old.length; i++)
        exts[i] = old[i];

      int i = old.length;
      for (int j=0; j<fil.length; j++)
        exts[i] = fil[j];

      old = null;
    }
  }

  public void removeExtension(String ext)
  {
    // TODO: Implement.
  }

}
