package roboforge.util.io;

import java.io.*;


public class BCountOutputStream extends FilterOutputStream
{
  protected long count;
  
  public BCountOutputStream(OutputStream out) throws IOException
  { 
    super(out); 
    this.count = 0;
  }
  
  public void write(int data) throws IOException
  {
    out.write(data);
    count++;
  }

  public void write(byte b[]) throws IOException 
  {
    out.write(b);
    count += b.length;
  }
  
  public void write(byte b[], int off, int len) throws IOException 
  {
    out.write(b, off, len);
    count += len;
  }

  public long getCount()
    { return count; }

  public void resetCount()
    { count = 0; }
}
