package roboforge.util.parser;

import java.io.Reader;

public interface BLexicalAnalyzer
{

  public void setInput(Reader reader);
    // Sets input for the analyzer to consume.

  public BSymbol nextSymbol() throws BLexicalException;
    // Retrieves the next symbol from input.

  public BSymbol peekSymbol();
    // Looks at the current symbol.

  public void pushSymbol();
    // Places the current symbol back into input,
    // i.e the next call to nextSymbol() will return
    // the current value of peekSymbol().

}
