package roboforge.util.processors;

import java.util.Enumeration;
import java.util.Observable;
import java.util.Observer;
import java.util.Vector;


public class BTaskManager implements Observer
{

  // Member variables...
  // -------------------------------------------------------------

  protected Vector tasks;



  // Constructor...
  // -------------------------------------------------------------

  public BTaskManager()
  {
    tasks = new Vector();
  }


  // Public methods...
  // -------------------------------------------------------------

  public synchronized void submit(BTask task)
  {
    tasks.add(task);

    task.addObserver(this);
    task.start();
  }

  public synchronized void abort(BTask task)
    // Convenience method - calls BTask.stop().
  {
  }

  public synchronized Enumeration getRunningTasks()
    { return tasks.elements(); }


  // Inner classes...
  // -------------------------------------------------------------

  public void update(Observable o, Object arg)
  {
    BTask task = (BTask) o;

    if (task.isComplete())
    {
      synchronized (tasks)
        { tasks.remove(task); }

      task.deleteObserver(this);
    }
  }

}